
(*f1Ek[{w},x,y,z] is k-th one-loop master integral with the transcendental weight w*)

(*one-loop master integrals that can be expressed into GPLs up to weight 3*)
(*w and z in terms of sij,sjk,sik can be found in eq.(3.4) in arXiv:2312.16966*)
(*Note that they are for sij<0,sjk<0, sik>0*)
(*The analytic continuation is needed for other regions, see arXiv:2312.16966*)

oneloopmasterintegralInG={f1E1[{0}, sij, sjk, sik] -> 1, f1E1[{1}, sij, sjk, sik] -> 0, 
 f1E1[{2}, sij, sjk, sik] -> 0, f1E1[{3}, sij, sjk, sik] -> 0, 
 f1E2[{0}, sij, sjk, sik] -> -G[-1, w] + G[-1, z] + G[1, w] - G[1, z], 
 f1E2[{1}, sij, sjk, sik] -> -(G[-1, w]*G[-1, z]) + G[-1, z]*G[1, w] - 
   G[-1, w]*G[1, z] + G[1, w]*G[1, z] + 2*G[-1, w]*G[w^(-1), z] - 
   2*G[1, w]*G[w^(-1), z] - G[-1, -1, w] + G[-1, -1, z] + G[-1, 1, w] - 
   G[-1, 1, z] - G[1, -1, w] + G[1, -1, z] + G[1, 1, w] - G[1, 1, z] - 
   2*G[w^(-1), -1, z] + 2*G[w^(-1), 1, z], f1E2[{2}, sij, sjk, sik] -> 
  (-2*(G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, w] - G[-1, 1, w] + 
      G[1, -1, w] - G[1, 1, w]) - 2*(G[-1, w] - G[1, w])*
     (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w^(-1), z] + G[1, -1, z] + 
      G[1, 1, z] - 2*G[1, w^(-1), z] - 2*G[w^(-1), -1, z] - 
      2*G[w^(-1), 1, z] + 4*G[w^(-1), w^(-1), z]) - 2*G[-1, -1, -1, w] + 
    2*G[-1, -1, -1, z] + 2*G[-1, -1, 1, w] - 2*G[-1, -1, 1, z] - 
    2*G[-1, 1, -1, w] + 2*G[-1, 1, -1, z] + 2*G[-1, 1, 1, w] - 
    2*G[-1, 1, 1, z] - 4*G[-1, w^(-1), -1, z] + 4*G[-1, w^(-1), 1, z] - 
    2*G[1, -1, -1, w] + 2*G[1, -1, -1, z] + 2*G[1, -1, 1, w] - 
    2*G[1, -1, 1, z] - 2*G[1, 1, -1, w] + 2*G[1, 1, -1, z] + 
    2*G[1, 1, 1, w] - 2*G[1, 1, 1, z] - 4*G[1, w^(-1), -1, z] + 
    4*G[1, w^(-1), 1, z] - 4*G[w^(-1), -1, -1, z] + 4*G[w^(-1), -1, 1, z] - 
    4*G[w^(-1), 1, -1, z] + 4*G[w^(-1), 1, 1, z] + 
    8*G[w^(-1), w^(-1), -1, z] - 8*G[w^(-1), w^(-1), 1, z])/2, 
 f1E3[{0}, sij, sjk, sik] -> -G[0, w] + G[0, z], 
 f1E3[{1}, sij, sjk, sik] -> (-Pi^2 - 6*G[0, w]*G[0, z] + 
    12*G[0, w]*G[-w, z] + 6*G[0, 0, w] + 6*G[0, 0, z] - 12*G[-w, 0, z])/6, 
 f1E3[{2}, sij, sjk, sik] -> (Pi^2*G[0, w] - Pi^2*G[0, z] + 2*Pi^2*G[-w, z] + 
    6*G[0, z]*G[0, 0, w] - 12*G[-w, z]*G[0, 0, w] - 6*G[0, w]*G[0, 0, z] + 
    12*G[0, w]*G[0, -w, z] + 12*G[0, w]*G[-w, 0, z] - 
    24*G[0, w]*G[-w, -w, z] - 6*G[0, 0, 0, w] + 6*G[0, 0, 0, z] - 
    12*G[0, -w, 0, z] - 12*G[-w, 0, 0, z] + 24*G[-w, -w, 0, z] - 12*Zeta[3])/
   6, f1E4[{0}, sij, sjk, sik] -> -(G[-1, w]*G[-1, z]) + G[-1, z]*G[1, w] + 
   G[-1, w]*G[1, z] - G[1, w]*G[1, z] + G[-1, -1, w] + G[-1, -1, z] - 
   G[-1, 1, w] - G[-1, 1, z] - G[1, -1, w] - G[1, -1, z] + G[1, 1, w] + 
   G[1, 1, z], f1E4[{1}, sij, sjk, sik] -> -(G[-1, z]*G[-1, -1, w]) + 
   G[1, z]*G[-1, -1, w] - G[-1, w]*G[-1, -1, z] + G[1, w]*G[-1, -1, z] + 
   G[-1, z]*G[-1, 1, w] - G[1, z]*G[-1, 1, w] - G[-1, w]*G[-1, 1, z] + 
   G[1, w]*G[-1, 1, z] + 2*G[-1, w]*G[-1, w^(-1), z] - 
   2*G[1, w]*G[-1, w^(-1), z] - G[-1, z]*G[1, -1, w] + G[1, z]*G[1, -1, w] + 
   G[-1, w]*G[1, -1, z] - G[1, w]*G[1, -1, z] + G[-1, z]*G[1, 1, w] - 
   G[1, z]*G[1, 1, w] + G[-1, w]*G[1, 1, z] - G[1, w]*G[1, 1, z] - 
   2*G[-1, w]*G[1, w^(-1), z] + 2*G[1, w]*G[1, w^(-1), z] + 
   G[-1, -1, -1, w] + G[-1, -1, -1, z] - G[-1, -1, 1, w] - G[-1, -1, 1, z] + 
   G[-1, 1, -1, w] + G[-1, 1, -1, z] - G[-1, 1, 1, w] - G[-1, 1, 1, z] - 
   2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - G[1, -1, -1, w] - 
   G[1, -1, -1, z] + G[1, -1, 1, w] + G[1, -1, 1, z] - G[1, 1, -1, w] - 
   G[1, 1, -1, z] + G[1, 1, 1, w] + G[1, 1, 1, z] + 2*G[1, w^(-1), -1, z] - 
   2*G[1, w^(-1), 1, z], f1E5[{0}, sij, sjk, sik] -> 
  -(G[0, w]*G[0, z]) + G[0, 0, w] + G[0, 0, z], 
 f1E5[{1}, sij, sjk, sik] -> (Pi^2*G[0, w] - Pi^2*G[0, z] + 
    6*G[0, z]*G[0, 0, w] - 6*G[0, w]*G[0, 0, z] + 12*G[0, w]*G[0, -w, z] - 
    6*G[0, 0, 0, w] + 6*G[0, 0, 0, z] - 12*G[0, -w, 0, z] - 18*Zeta[3])/6, 
 f1E6[{0}, sij, sjk, sik] -> -(G[-1, z]*G[0, w]) + G[-1, w]*G[0, z] - 
   G[0, z]*G[1, w] + G[0, w]*G[1, z] - G[-1, 0, w] + G[-1, 0, z] + 
   G[0, -1, w] - G[0, -1, z] - G[0, 1, w] + G[0, 1, z] + G[1, 0, w] - 
   G[1, 0, z], f1E6[{1}, sij, sjk, sik] -> 
  (-(Pi^2*G[-1, w]) - Pi^2*G[-1, z] + Pi^2*G[1, w] + Pi^2*G[1, z] + 
    6*G[0, z]*G[-1, -1, w] - 6*G[(-1 - w)/(-1 + w), z]*G[-1, -1, w] + 
    6*G[(-1 + w)/(1 + w), z]*G[-1, -1, w] - 6*G[(-1 - w)/(-1 + w), z]*
     G[-1, 0, w] + 12*G[-w^(-1), z]*G[-1, 0, w] - 6*G[(-1 + w)/(1 + w), z]*
     G[-1, 0, w] - 6*G[0, w]*G[-1, 0, z] - 6*G[0, z]*G[-1, 1, w] + 
    6*G[(-1 - w)/(-1 + w), z]*G[-1, 1, w] - 6*G[(-1 + w)/(1 + w), z]*
     G[-1, 1, w] + 12*G[0, w]*G[-1, -w, z] + 6*G[(-1 - w)/(-1 + w), z]*
     G[0, -1, w] - 12*G[-w^(-1), z]*G[0, -1, w] + 6*G[(-1 + w)/(1 + w), z]*
     G[0, -1, w] + 6*G[-1, w]*G[0, -1, z] - 6*G[1, w]*G[0, -1, z] + 
    6*G[-1, z]*G[0, 0, w] - 6*G[1, z]*G[0, 0, w] - 
    6*G[(-1 - w)/(-1 + w), z]*G[0, 0, w] + 6*G[(-1 + w)/(1 + w), z]*
     G[0, 0, w] - 6*G[(-1 - w)/(-1 + w), z]*G[0, 1, w] + 
    12*G[-w^(-1), z]*G[0, 1, w] - 6*G[(-1 + w)/(1 + w), z]*G[0, 1, w] + 
    6*G[-1, w]*G[0, 1, z] - 6*G[1, w]*G[0, 1, z] - 
    12*G[-1, w]*G[0, w^(-1), z] + 12*G[1, w]*G[0, w^(-1), z] + 
    6*G[0, z]*G[1, -1, w] + 6*G[(-1 - w)/(-1 + w), z]*G[1, -1, w] - 
    6*G[(-1 + w)/(1 + w), z]*G[1, -1, w] + 6*G[(-1 - w)/(-1 + w), z]*
     G[1, 0, w] - 12*G[-w^(-1), z]*G[1, 0, w] + 6*G[(-1 + w)/(1 + w), z]*
     G[1, 0, w] + 6*G[0, w]*G[1, 0, z] - 6*G[0, z]*G[1, 1, w] - 
    6*G[(-1 - w)/(-1 + w), z]*G[1, 1, w] + 6*G[(-1 + w)/(1 + w), z]*
     G[1, 1, w] - 12*G[0, w]*G[1, -w, z] + 
    6*G[-1, w]*G[(-1 - w)/(-1 + w), -1, z] - 
    6*G[0, w]*G[(-1 - w)/(-1 + w), -1, z] - 
    6*G[1, w]*G[(-1 - w)/(-1 + w), -1, z] + 
    6*G[-1, w]*G[(-1 - w)/(-1 + w), 0, z] + 
    6*G[0, w]*G[(-1 - w)/(-1 + w), 0, z] - 
    6*G[1, w]*G[(-1 - w)/(-1 + w), 0, z] - 
    6*G[-1, w]*G[(-1 - w)/(-1 + w), 1, z] + 
    6*G[0, w]*G[(-1 - w)/(-1 + w), 1, z] + 
    6*G[1, w]*G[(-1 - w)/(-1 + w), 1, z] + 12*G[0, w]*G[-w^(-1), -1, z] - 
    12*G[-1, w]*G[-w^(-1), 0, z] + 12*G[1, w]*G[-w^(-1), 0, z] - 
    12*G[0, w]*G[-w^(-1), 1, z] - 6*G[-1, w]*G[(-1 + w)/(1 + w), -1, z] - 
    6*G[0, w]*G[(-1 + w)/(1 + w), -1, z] + 
    6*G[1, w]*G[(-1 + w)/(1 + w), -1, z] + 
    6*G[-1, w]*G[(-1 + w)/(1 + w), 0, z] - 
    6*G[0, w]*G[(-1 + w)/(1 + w), 0, z] - 
    6*G[1, w]*G[(-1 + w)/(1 + w), 0, z] + 
    6*G[-1, w]*G[(-1 + w)/(1 + w), 1, z] + 
    6*G[0, w]*G[(-1 + w)/(1 + w), 1, z] - 
    6*G[1, w]*G[(-1 + w)/(1 + w), 1, z] - 6*G[-1, -1, -1, w] - 
    6*G[-1, -1, 0, w] + 6*G[-1, -1, 1, w] + 6*G[-1, 0, -1, w] + 
    6*G[-1, 0, 0, z] - 6*G[-1, 0, 1, w] + 6*G[-1, 1, -1, w] + 
    6*G[-1, 1, 0, w] - 6*G[-1, 1, 1, w] - 12*G[-1, -w, 0, z] + 
    6*G[0, -1, -1, w] - 6*G[0, -1, -1, z] - 6*G[0, -1, 1, w] + 
    6*G[0, -1, 1, z] + 6*G[0, 1, -1, w] - 6*G[0, 1, -1, z] - 
    6*G[0, 1, 1, w] + 6*G[0, 1, 1, z] + 12*G[0, w^(-1), -1, z] - 
    12*G[0, w^(-1), 1, z] + 6*G[1, -1, -1, w] - 6*G[1, -1, 0, w] - 
    6*G[1, -1, 1, w] + 6*G[1, 0, -1, w] - 6*G[1, 0, 0, z] - 6*G[1, 0, 1, w] - 
    6*G[1, 1, -1, w] + 6*G[1, 1, 0, w] + 6*G[1, 1, 1, w] + 
    12*G[1, -w, 0, z] - 6*G[(-1 - w)/(-1 + w), -1, -1, z] + 
    6*G[(-1 - w)/(-1 + w), -1, 0, z] + 6*G[(-1 - w)/(-1 + w), -1, 1, z] - 
    6*G[(-1 - w)/(-1 + w), 0, -1, z] - 6*G[(-1 - w)/(-1 + w), 0, 0, z] + 
    6*G[(-1 - w)/(-1 + w), 0, 1, z] + 6*G[(-1 - w)/(-1 + w), 1, -1, z] - 
    6*G[(-1 - w)/(-1 + w), 1, 0, z] - 6*G[(-1 - w)/(-1 + w), 1, 1, z] - 
    12*G[-w^(-1), -1, 0, z] + 12*G[-w^(-1), 0, -1, z] - 
    12*G[-w^(-1), 0, 1, z] + 12*G[-w^(-1), 1, 0, z] + 
    6*G[(-1 + w)/(1 + w), -1, -1, z] + 6*G[(-1 + w)/(1 + w), -1, 0, z] - 
    6*G[(-1 + w)/(1 + w), -1, 1, z] - 6*G[(-1 + w)/(1 + w), 0, -1, z] + 
    6*G[(-1 + w)/(1 + w), 0, 0, z] + 6*G[(-1 + w)/(1 + w), 0, 1, z] - 
    6*G[(-1 + w)/(1 + w), 1, -1, z] - 6*G[(-1 + w)/(1 + w), 1, 0, z] + 
    6*G[(-1 + w)/(1 + w), 1, 1, z])/6
};
