
(*We need to multiply -I*Nc*Qf^4*\[Alpha]^2*\[Alpha]/Pi*Qf^2 for two-loop QED cirrection*)
(*We need to multiply -I*Nc*Qf^4*\[Alpha]^2*\[Alpha]S/Pi*CF for two-loop QCD correction to the quark contribution*)

(*f1Ek[{w},x,y,z] is k-th one-loop master integral with the transcendental weight w*)
(*fEk[{w},x,y,z] is k-th two-loop master integral with the transcendental weight w*)
(*xs=s/mf^2,xt=t/mf^2,xu=u/mf^2*)

sqrtreplace = {sqrt1[xi_] :> Sqrt[(-4 + xi)*xi], 
  sqrt2[xi_] :> Sqrt[(-4 + xi)*xi], 
  sqrt3[xi_, xj_] :> Sqrt[xi*(xi*(-4 + xj) - 4*xj)*xj], 
  sqrt4[xi_, xj_] :> Sqrt[xi*(xi*(-1 + xj)^2 - 4*xj^2)]};

(*one-loop rational coefficients*)

r1L1[xi_, xj_, xk_] := 2*(xi - 4)*(xi*xj - xk^2)/(xj*xk);
r1L2[xi_, xj_, xk_] := -2*((4 - xi)/xi + xi*(xj^3 - 6*xj*xk + xk^3)/(xj^2*xk^2));
r1L3[xi_, xj_, xk_] := (32 xk^2 - xi*xj*(xi^2 + xj^2 - 16*xk))/xk^2;
r1L4[xi_, xj_, xk_] := 2*xi*(xi - 4) (xj - xk)/(xj*xk);
r1L5[xi_, xj_, xk_] := 2*(2 xj*xk (xj - xk) + xi*(xj^3 - xk^3))/(xj^2*xk^2);
r1L6[xi_, xj_, xk_] := 2*(xi^2 + xj^2 - 4 xk)/xk^2;
r1L7[xi_, xj_, xk_] := xi*(4*(xj^2 - xi^2) + xj*(xi^2 + xj^2))/xk^2;
r1L8[xi_, xj_, xk_] := 2*(xi*xj + 2 xk)/xk;
r1L9[xi_, xj_, xk_] := (xi - 4) (xi - xj)/xk;
r1L10[xi_, xj_, xk_] := 1 - 4/xi - 2*xj*xk/xi^2;
r1L11[xi_, xj_, xk_] := 4 - 2*xi - xj*xk + 2*xj*xk*(xj*xk + 4 xi)/xi^2;
r1L12[xi_, xj_, xk_] := r1L11[xi, xj, xk] + (4 xi^2 - 10 xi - 5 xj*xk)/3;

(*two-loop rational coefficients*)

r2L1[xi_, xj_, xk_] := -3 (xj - 4) ((xi - xk - xi*xj)/(xj*(xi - 1)^2 - 4 xi^2) + (xk - xi - xk*xj)/(xj*(xk - 1)^2 - 4 xk^2));
r2L2[xi_, xj_, xk_] := 2/xi + 9/xj + 30/xk + 36/(xi*xj) - 8/(xi*xk) + (20 + xi - 2 xj)/(xi*xk + 4 xj) + (112 + 15 xi + 13 xj)/(2*(xi*xj + 4 xk));
r2L3[xi_, xj_, xk_] := -2*(xi - 4)^2 (xk - xj)^2/((xi*xj + 4 xk) (xi*xk + 4 xj));
r2L4[xi_, xj_, xk_] := 2*(xi - 4)*(xj^2 + xk^2)/(xi*xj*xk);
r2L5[xi_, xj_, xk_] := -1/12*(93/xi + 68/xj + 135/xk + 88/(xi*xj) + 168/(xi*xk) + (116 + 8 xi + 21 xj)/(xi*xj + 4 xk) + (44 + xi + 13 xj)/(xj*xk + 4 xi));
r2L6[xi_, xj_, xk_] := -4 + 4/xj + 4 xj*(xi^3 - 2*xi*xk + xk^3)/(xi^2*xk^2) + (2 + xi + xk*(xj - 3))/(xj*(xk - 1)^2 - 4 xk^2) + (2 + xk + xi (xj - 3))/(xj*(xi - 1)^2 - 4 xi^2) + (16 - 6 xi - 6 xj (xk - 3))/(xk (xj - 1)^2 - 4 xj^2) + (16 - 6 xk - 6 xj (xi - 3))/(xi (xj - 1)^2 - 4 xj^2);
r2L7[xi_, xj_, xk_] := -6 r2L5[xi, xj, xk] - 32 (1/xi + 1/xj + 1/xk);
r2L8[xi_, xj_, xk_] := 8/xi + 8/xj - 34/xk - 88/(xi*xj) - (72 - 9*xk)/(xi*xj + 4 xk);
r2L9[xi_, xj_, xk_] := 37 - 8*xi + ((17 - 9 xi) xi - 8)/xk - 2*(4 + xk)/xj - (xk*(28 + 9 xi) - 4 xi)/(xi*xj + 4 xk) - 2*xi*(1 + xj)/(xi (xj - 1)^2 - 4 xj^2);
r2L10[xi_, xj_, xk_] := 56 + 4*xi*xj*(xi*xj - (xk - 4) xk)/xk^2 + 4*xj*(1 + 2 xi)/(xj (xi - 1)^2 - 4 xi^2) + 4*xi*(1 + 2 xj)/(xi (xj - 1)^2 - 4 xj^2);
r2L11[xi_, xj_, xk_] := 4 (1 - xj) - 2*xi^2/xk - 4 (xi*xk + 4 xk)/(xi*xj + 4 xk);
r2L12[xi_, xj_, xk_] := 4 + 8 (1 + xj)/xi + 8 (xj^2 + 3 xj - 4)/xi^2;
r2L13[xi_, xj_, xk_] := -12 - (108 + 24 xj)/xi^2 + 24 (3 + xj)/xi + 48/xj - 16/xk - 128/(xi*xj) + 36 (4 - xi)/(xi*xj + 4*xk);
r2L14[xi_, xj_, xk_] := 24 - 102/xk + (34 xk - 64)/(xi*xj) + (36 - 48*xi*xj)/xk^2;
r2L15[xi_, xj_, xk_] := 2 + (4 + 4 xj)/xi + 4 (xj^2 + 3 xj - 4)/xi^2;
r2L16[xi_, xj_, xk_] := 38 - 48/xj - (152 - 48 xj)/xi - (48 + 8 xj)/xk + 4 xj^2/xk^2 - 8 xj^2/xi^2 - (4 - 12 xi)/(xj (xi - 1)^2 - 4 xi^2) - (4 + 2 xi - 2 (xj + 1) xk)/(xj (xk - 1)^2 - 4 xk^2) - 8 (4 + 5 xj - 5 xi - 2 xj*xk)/(xk*(xj - 1)^2 - 4 xj^2);
r2L17[xi_, xj_, xk_] := 4*(4 + 8/xj + xj^2/xk^2 + xj^2/xi^2 - (4 (xj - 3) xj)/(xk*xi) - 4 (xj + 2)/(xk (xj - 1)^2 - 4*xj^2) - 4 (xj + 2)/(xi*(xj - 1)^2 - 4 xj^2));
r2L18[xi_, xj_, xk_] := xj (xj - 4) (40/xi + 20/xj - (3*(1 + xk)^2 - 3*xi (3 + xk^2))/(xi*(xj*(xk - 1)^2 - 4 xk^2)) + (3*(xi - 1)^2 (xi + 1))/(xi*(xj*(xi - 1)^2 - 4 xi^2)));
r2L19[xi_, xj_, xk_] := (xj - 4) (2 - 12 xj/xi^2 + 4 (xj - 2)/xi);
r2L20[xi_, xj_, xk_] := -1/6*r2L18[xi, xj, xk] - 8/(3*xi)*(xj - xk) (xj - 4);
r2L21[xi_, xj_, xk_] := 4*(33 - 4 xi + 3 xk + xi*xj - 2 xj^2 - xj*(2*xj + 9)/xi^2 + xj*(4*xj + 19)/xi + (2 xj - 2 xi (xi - xk))/(xj*(xi - 1)^2 - 4 xi^2));
r2L22[xi_, xj_, xk_] := 8 - 2 xk - 6 xj + 2 xk*xj + 6 xj^2 + 4*xj*(xj + 1)^2 (9 + 4 xj)/xk^2 + 4 (xk - xj) (xk - xj + xj*xi)/(xi*(xj - 1)^2 - 4 xj^2) + 4*(9 + xj*(5 xj^2 + 5 xj - 11))/xk;
r2L23[xi_, xj_, xk_] := -264 - 4 xi*(xj - 2) + 8 xj (xj + 3) + 8 (8 xi^2 - 3 xj (1 - xi))/(xj (xi - 1)^2 - 4 xi^2) - 4 xj^4/xk^2 + 4 xj^2 (xj + 14)/xk;
r2L24[xi_, xj_, xk_] := 4 xi*xj*(4 xk + xi*xj)*(2/xk^2 + 3 (xk - 6)/(xi*xj*xk) - (xk - 2 + xi (xj - 1))/(xj*(xj*(xi - 1)^2 - 4 xi^2)) - (xk - 2 + xj (xi - 1))/(xi*(xi*(xj - 1)^2 - 4 xj^2)));
r2L25[xi_, xj_, xk_] := 32 - 16 xk - 8*xi*xj + 64*xi*xj/xk + 16*xi^2*xj^2/xk^2;
r2L26[xi_, xj_, xk_] := 1/3*(28 - 90/xj^2 - 74/xj + (19*xj - 32)/(xi*xk) + 12 (4 - xj)/(xi xj + 4 xk) + 12 (4 - xj)/(xj xk + 4 xi));
r2L27[xi_, xj_, xk_] := (37 + 45/xj - 32/(xi*xj) + (73*(-1 + 2*xj))/xi + (2*(-63 - 175*xj + 40*xj^2))/xi^2 + xk^(-1) - 32/(xi*xk) - (16*(-4 + xi))/(xi*xj + 4*xk))/6;
r2L28[xi_, xj_, xk_] := -45 + (105 - 162*xj)/xi + 3/xj + 32/(xi*xj) + (126 + 350*xj - 48*xj^2)/xi^2 - xk^(-1) + 32/(xi*xk) + (16*(-4 + xi))/(xi*xj + 4*xk);
r2L29[xi_, xj_, xk_] := 8 + 252/xi^2 - 52/xi + 8*(xi - 8)/(xj*xk) + (30*(-4 + xi))/(xi*xj + 4*xk) + (30*(-4 + xi))/(4*xj + xi*xk);
r2L30[xi_, xj_, xk_] := -10 + 29/xi - 32/(xi*xj) + (23 - 20*xk)/xj + 25/xk - 32/(xj*xk) + (8*(-4 + xj))/(xi*xj + 4*xk) + (90 - 52*xk - 40*xk^2)/xj^2;
r2L31[xi_, xj_, xk_] := (-26 + (59 - 52*xj)/xi + 21/xj - 32/(xi*xj) + (90 + 52*xj - 40*xj^2)/xi^2 + 25/xk - 32/(xi*xk) + (8*(-4 + xi))/(xi*xj + 4*xk))/3;

(*++++*)

Mpppp2LM[xs_, xt_, xu_] := Module[{res, perms1, perms2, xi, xj, xk},
   perms1 = {{xs, xt, xu}, {xt, xu, xs}, {xu, xs, xt}};
   perms2 = Join[perms1, {{xt, xs, xu}, {xu, xt, xs}, {xs, xu, xt}}];
   res = 3 - 
     4*Sum[{xi, xj, xk} = 
        perms1[[i]]; (2/xi + 2/xk - 1/xj)*f1E5[{2}, xi, xj, xk] - 
        1/xi^2*fE24[{4}, xi, xj, xk] + 
        2/sqrt3[xi, xj]*((xi*xj + 4 xk)/xk*fE19[{2}, xi, xj, xk] + 
           fE22[{3}, xi, xj, xk]) + 
        1/(2*xi*xj)*(6*fE3[{3}, xi, xj, xk] - fE14[{3}, xk, xi, xj] - 
           4*fE16[{3}, xk, xi, xj] - 8*fE20[{3}, xi, xj, xk] + 
           2*fE15[{2}, xk, xi, xj] f1E3[{1}, xk, xi, xj]), {i, 1, 
        3}];
   res = res + 
     Sum[{xi, xj, xk} = perms2[[i]]; 
      8*fE19[{3}, xi, xj, xk]/sqrt3[xi, xj] - 
       2*(xi - 2)*fE27[{4}, xi, xj, xk]/(sqrt1[xi]*sqrt3[xi, xj]), {i,
        1, 6}];
   res = 4*res;
   Return[res]
];

(*-+++*)
Mmppp2LM[xs_, xt_, xu_] := 
  Module[{res, perms1, perms2, xi, xj, xk},
   perms1 = {{xs, xt, xu}, {xt, xu, xs}, {xu, xs, xt}};
   perms2 = Join[perms1, {{xt, xs, xu}, {xu, xt, xs}, {xs, xu, xt}}];
   res = Sum[{xi, xj, xk} = perms1[[i]]; 
     1/sqrt1[xj]*(2*r1L[{1}, xj, xk, xi] f1E3[{1}, xi, xj, xk] + 
         r2L[{1}, xi, xj, 
           xk]*(f1E3[{2}, xi, xj, xk] - fE15[{2}, xi, xj, xk]/6)) - 
      2*xi*xj/sqrt3[xi, xj] f1E6[{2}, xi, xj, xk] + 
      r2L[{2}, xi, xj, 
        xk]*(fE3[{3}, xi, xj, xk] + 
         f1E3[{1}, xk, xi, xj] fE15[{2}, xk, xi, xj]/3) + 
      r2L[{3}, xi, xj, xk]/sqrt1[xi]*fE5[{3}, xi, xj, xk] + 
      r2L[{4}, xi, xj, xk]/sqrt1[xi] fE13[{4}, xi, xj, xk] + 
      r2L[{5}, xi, xj, xk] fE14[{3}, xi, xj, xk] + 
      r2L[{6}, xi, xj, xk] f1E5[{2}, xi, xj, xk] + 
      r2L[{7}, xi, xj, xk] f1E5[{3}, xi, xj, 
        xk] - (6/xi + 4/xj + 6/xk) fE17[{4}, xi, xj, 
        xk] + (4/xi + 4/xj + 8/xk) (fE21[{4}, xi, xj, xk] - 
         fE24[{4}, xk, xi, xj]/2) + 
      r2L[{10}, xi, xj, xk]/sqrt3[xi, xj] fE19[{2}, xi, xj, 
        xk] - (32 + 16 xi*xj/xk)/sqrt3[xi, xj] fE22[{3}, xi, xj, xk] +
       r2L[{8}, xi, xj, xk]*fE20[{3}, xi, xj, xk], {i, 1, 3}];
   res = res - 
     Sum[{xi, xj, xk} = 
       perms2[[i]]; (4/xi + 6/xj + 6/xk) fE26[{4}, xi, xj, xk] +
       (2/xj - 2/xk) fE29[{4}, xi, xj, xk] - 
       r2L[{9}, xi, xj, xk]/sqrt4[xi, xj] fE18[{3}, xi, xj, 
         xk] - (32 + 16 xi*xj/xk) fE19[{3}, xi, xj, xk]/
         sqrt3[xi, xj] - 
       r2L[{11}, xi, xj, xk]/sqrt3[xi, xj] fE25[{4}, xi, xj, 
         xk] + (2 + xi*xj/xk) 4*(xi - 2)/
         sqrt1[xi] fE27[{4}, xi, xj, xk]/
         sqrt3[xi, xj] - (4*(xi - 2)/xk - 2*xk/xj) fE28[{4}, xi, xj, 
          xk]/sqrt1[xi], {i, 1, 6}];
   Return[res]
];

(*--++*)

Mmmpp2LM[xs_, xt_, xu_] := Module[{res, perms1, xi, xj, xk},
   perms1 = {{xs, xt, xu}, {xt, xu, xs}, {xu, xs, xt}};
   (*the terms that manifest xt,xu symmetry explicitly*)   
   res = 4 + 
     r2L[{12}, xs, xt, 
       xu]*(fE17[{4}, xs, xt, xu] + fE26[{4}, xu, xt, xs]) + 
     r2L[{12}, xs, xu, 
       xt]*(fE17[{4}, xt, xu, xs] + fE26[{4}, xt, xu, xs]) + 
     16/xs^2*fE24[{4}, xs, xt, xu] + 
     8/xs^2*(8 + xs - xt^2 - xu^2) fE21[{4}, xt, xu, xs] + 
     r2L[{15}, xs, xt, 
       xu]*(fE24[{4}, xu, xs, xt] - fE29[{4}, xu, xt, xs]) + 
     r2L[{15}, xs, xu, 
       xt]*(fE24[{4}, xt, xu, xs] - fE29[{4}, xt, xu, xs]) - 
     8/xs^2 (4 + xs + 3 xt - xu^2) (fE26[{4}, xu, xs, xt] + 
        1/2*fE29[{4}, xu, xs, xt]) - 
     8/xs^2 (4 + xs + 3 xu - xt^2) (fE26[{4}, xt, xs, xu] + 
        1/2*fE29[{4}, xt, xs, xu]) + 
     r2L[{16}, xs, xt, xu] f1E5[{2}, xs, xt, xu] + 
     r2L[{16}, xs, xu, xt] f1E5[{2}, xt, xu, xs] + 
     r2L[{17}, xu, xs, xt] f1E5[{2}, xu, xs, xt] + 
     4 (xs^2 + 2*xt*xu)*
      Sum[{xi, xj, xk} = 
        perms1[[i]]; (xj - 4)/(xi*xk) f1E3[{1}, xi, xj, xk]/
         sqrt1[xj], {i, 1, 3}] + 
     r2L[{18}, xs, xt, xu]*f1E3[{2}, xs, xt, xu]/sqrt1[xt] + 
     r2L[{18}, xs, xu, xt]*f1E3[{2}, xt, xu, xs]/sqrt1[xu] - 
     16 xs*(f1E6[{2}, xs, xt, xu]/sqrt3[xs, xt] + 
        f1E6[{2}, xu, xs, xt]/sqrt3[xs, xu]) - 
     8 (2 xs + xt*xu) f1E6[{2}, xt, xu, xs]/sqrt3[xt, xu] - 
     8 xs^2 (xs^2 - 16)/(xs*xt + 4 xu)/(xs*xu + 4 xt) fE5[{3}, xs, xt,
         xu]/sqrt1[xs] + 
     r2L[{19}, xs, xu, xt]*fE13[{4}, xu, xs, xt]/sqrt1[xu] + 
     r2L[{19}, xs, xt, xu]*fE13[{4}, xt, xu, xs]/sqrt1[xt] + 
     r2L[{20}, xs, xt, xu]*fE15[{2}, xs, xt, xu]/sqrt1[xt] + 
     r2L[{20}, xs, xu, xt]*fE15[{2}, xt, xu, xs]/sqrt1[xu] + 
     8*xs*(2 xs + (xs - 4) xt^2)/(xt (xs*xt + 4 xu)) fE18[{3}, xs, xt, xu]/sqrt4[xs, xt] + 
     8*xs*(2 xs + (xs - 4) xu^2)/(xu (xs*xu + 4 xt)) fE18[{3}, xs, xu, xt]/sqrt4[xs, xu] + 
     r2L[{21}, xs, xt, xu] fE18[{3}, xt, xs, xu]/sqrt4[xt, xs] + 
     r2L[{21}, xs, xu, xt] fE18[{3}, xu, xs, xt]/sqrt4[xu, xs] + 
     r2L[{22}, xu, xt, xs] fE18[{3}, xu, xt, xs]/sqrt4[xu, xt] + 
     r2L[{22}, xt, xu, xs] fE18[{3}, xt, xu, xs]/sqrt4[xt, xu] + 
     r2L[{23}, xs, xt, xu] fE19[{2}, xs, xt, xu]/sqrt3[xs, xt] + 
     r2L[{23}, xs, xu, xt] fE19[{2}, xu, xs, xt]/sqrt3[xs, xu] + 
     r2L[{24}, xt, xu, xs] fE19[{2}, xt, xu, xs]/sqrt3[xt, xu] - 
     16 (xs - 2)*(fE19[{3}, xs, xt, xu]/sqrt3[xs, xt] + 
        fE19[{3}, xs, xu, xt]/sqrt3[xs, xu] + 
        fE19[{3}, xt, xs, xu]/sqrt3[xs, xt] + 
        fE19[{3}, xu, xs, xt]/sqrt3[xs, xu]) + 
     16 (xs - 2)*(fE22[{3}, xs, xt, xu]/sqrt3[xs, xt] + 
        fE22[{3}, xu, xs, xt]/sqrt3[xs, xu]) + 
     r2L[{25}, xt, xu, xs]/
       sqrt3[xt, xu]*(fE19[{3}, xt, xu, xs] + fE19[{3}, xu, xt, xs] - 
        fE22[{3}, xt, xu, xs] - (xu - 2)/4*
         fE27[{4}, xu, xt, xs]/sqrt1[xu] - (xt - 2)/4*
         fE27[{4}, xt, xu, xs]/sqrt1[xt]) + 
     16 xs^2/(xs*xt + 4 xu) fE25[{4}, xs, xt, xu]/sqrt3[xs, xt] + 
     16 xs^2/(xs*xu + 4 xt) fE25[{4}, xs, xu, xt]/sqrt3[xs, xu] + 
     4 (xs - 2)^2/
       sqrt1[xs]*(fE27[{4}, xs, xt, xu]/sqrt3[xs, xt] + 
        fE27[{4}, xs, xu, xt]/sqrt3[xs, xu]) + 
     4 (xs - 2) (xt - 2)/sqrt1[xt]*
      fE27[{4}, xt, xs, xu]/sqrt3[xs, xt] + 
     4 (xs - 2) (xu - 2)/sqrt1[xu]*
      fE27[{4}, xu, xs, xt]/sqrt3[xs, xu] + 
     4 (4 xs + 12 xt - xt^3 - xu^2)/xs^2*
      fE28[{4}, xt, xs, xu]/sqrt1[xt] + 
     4 (4 xs + 12 xu - xu^3 - xt^2)/xs^2*
      fE28[{4}, xu, xs, xt]/sqrt1[xu] - 
     2 (xt^2 + xu^2 - 4 xs)/
       xs^2*((xu - 2)*fE28[{4}, xu, xt, xs]/sqrt1[xu] + (xt - 2)*
         fE28[{4}, xt, xu, xs]/sqrt1[xt]);
   
   res = res + (r2L[{13}, xs, xt, xu]*fE20[{3}, xs, xt, xu] + 
       r2L[{13}, xs, xu, xt]*fE20[{3}, xs, xu, xt] + 
       r2L[{14}, xt, xu, 
         xs]*(fE20[{3}, xt, xu, xs] + fE20[{3}, xu, xt, xs]) + 
       r2L[{26}, xu, xs, 
         xt]*(fE14[{3}, xu, xs, xt] - 6 f1E5[{3}, xu, xs, xt]) + 
       r2L[{27}, xs, xt, xu] fE14[{3}, xs, xt, xu] + 
       r2L[{27}, xs, xu, xt] fE14[{3}, xt, xu, xs] + 
       r2L[{28}, xs, xt, xu] f1E5[{3}, xs, xt, xu] + 
       r2L[{28}, xs, xu, xt] f1E5[{3}, xt, xu, xs] + 
       r2L[{29}, xs, xt, 
         xu]*(fE3[{3}, xs, xt, xu] + 
          fE15[{2}, xu, xs, xt] f1E3[{1}, xu, xs, xt]/3) + 
       r2L[{30}, xu, xs, xt]*fE3[{3}, xu, xs, xt] + 
       r2L[{30}, xt, xs, xu] fE3[{3}, xt, xu, xs] + 
       r2L[{31}, xs, xt, xu] fE15[{2}, xs, xt, xu]*
        f1E3[{1}, xs, xt, xu] + 
       r2L[{31}, xs, xu, xt] fE15[{2}, xt, xu, xs]*
        f1E3[{1}, xt, xu, xs]);
   Return[res]
];

(*+-+-*)
Mpmpm2LM = Mmmpp2LM[xu, xt, xs];
(*+--+*)
Mpmmp2LM = Mmmpp2LM[xt, xu, xs];
