(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    283597,       8872]
NotebookOptionsPosition[    281614,       8804]
NotebookOutlinePosition[    282071,       8822]
CellTagsIndexPosition[    282028,       8819]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.919748890570673*^9, 3.919748900388048*^9}}],

Cell[CellGroupData[{

Cell["Two-loop amplitudes", "Section",
 CellChangeTimes->{{3.919749543849774*^9, 3.91974954757899*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<twoloop_amp.wl\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.9197488801878967`*^9, 3.919748884822955*^9}, {
  3.919748968623146*^9, 3.9197489705257673`*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"++", "++"}], "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Mpppp2LM", "[", 
   RowBox[{"xs", ",", "xt", ",", "xu"}], "]"}], "/.", 
  "sqrtreplace"}]], "Input",
 CellChangeTimes->{{3.919749070119787*^9, 3.9197490870462723`*^9}}],

Cell[BoxData[
 RowBox[{"4", " ", 
  RowBox[{"(", 
   RowBox[{"3", "+", 
    FractionBox[
     RowBox[{"8", " ", 
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
     SqrtBox[
      RowBox[{"xs", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"xs", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
         RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
    FractionBox[
     RowBox[{"8", " ", 
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
     SqrtBox[
      RowBox[{"xs", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"xs", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
         RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
    FractionBox[
     RowBox[{"8", " ", 
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
     SqrtBox[
      RowBox[{"xs", " ", "xt", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", "xs"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]], 
    "+", 
    FractionBox[
     RowBox[{"8", " ", 
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
     SqrtBox[
      RowBox[{"xt", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"xt", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
         RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
    FractionBox[
     RowBox[{"8", " ", 
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
     SqrtBox[
      RowBox[{"xs", " ", "xu", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", "xs"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
    "+", 
    FractionBox[
     RowBox[{"8", " ", 
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
     SqrtBox[
      RowBox[{"xt", " ", "xu", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", "xt"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
    "-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
      RowBox[{"fE27", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]}]], "-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
      RowBox[{"fE27", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]}]], "-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
      RowBox[{"fE27", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", 
      SqrtBox[
       RowBox[{"xs", " ", "xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], 
         ")"}]}]]}]], "-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
      RowBox[{"fE27", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", 
      SqrtBox[
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xt", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]}]], "-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
      RowBox[{"fE27", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]], " ", 
      SqrtBox[
       RowBox[{"xs", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], 
         ")"}]}]]}]], "-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
      RowBox[{"fE27", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]], " ", 
      SqrtBox[
       RowBox[{"xt", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xt"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], 
         ")"}]}]]}]], "-", 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["2", "xs"], "-", 
          FractionBox["1", "xt"], "+", 
          FractionBox["2", "xu"]}], ")"}], " ", 
        RowBox[{"f1E5", "[", 
         RowBox[{
          RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}],
        "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["2", "xs"], "+", 
          FractionBox["2", "xt"], "-", 
          FractionBox["1", "xu"]}], ")"}], " ", 
        RowBox[{"f1E5", "[", 
         RowBox[{
          RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}],
        "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "xs"]}], "+", 
          FractionBox["2", "xt"], "+", 
          FractionBox["2", "xu"]}], ")"}], " ", 
        RowBox[{"f1E5", "[", 
         RowBox[{
          RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}],
        "+", 
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"xs", " ", "xt"}], "+", 
               RowBox[{"4", " ", "xu"}]}], ")"}], " ", 
             RowBox[{"fE19", "[", 
              RowBox[{
               RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
              "]"}]}], "xu"], "+", 
           RowBox[{"fE22", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
            "]"}]}], ")"}]}], 
        SqrtBox[
         RowBox[{"xs", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"xs", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
            RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"4", " ", "xs"}], "+", 
               RowBox[{"xt", " ", "xu"}]}], ")"}], " ", 
             RowBox[{"fE19", "[", 
              RowBox[{
               RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
              "]"}]}], "xs"], "+", 
           RowBox[{"fE22", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
            "]"}]}], ")"}]}], 
        SqrtBox[
         RowBox[{"xt", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"xt", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
            RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"4", " ", "xt"}], "+", 
               RowBox[{"xs", " ", "xu"}]}], ")"}], " ", 
             RowBox[{"fE19", "[", 
              RowBox[{
               RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
              "]"}]}], "xt"], "+", 
           RowBox[{"fE22", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
            "]"}]}], ")"}]}], 
        SqrtBox[
         RowBox[{"xs", " ", "xu", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", "xs"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], 
           ")"}]}]]], "-", 
       FractionBox[
        RowBox[{"fE24", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
        SuperscriptBox["xs", "2"]], "-", 
       FractionBox[
        RowBox[{"fE24", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
        SuperscriptBox["xt", "2"]], "-", 
       FractionBox[
        RowBox[{"fE24", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
        SuperscriptBox["xu", "2"]], "+", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"2", " ", "xs", " ", "xt"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"fE14", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
            "]"}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"f1E3", "[", 
            RowBox[{
             RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
            "]"}], " ", 
           RowBox[{"fE15", "[", 
            RowBox[{
             RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
            "]"}]}], "-", 
          RowBox[{"4", " ", 
           RowBox[{"fE16", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
            "]"}]}], "-", 
          RowBox[{"8", " ", 
           RowBox[{"fE20", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
            "]"}]}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"fE3", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
            "]"}]}]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"2", " ", "xt", " ", "xu"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"fE14", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
            "]"}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"f1E3", "[", 
            RowBox[{
             RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
            "]"}], " ", 
           RowBox[{"fE15", "[", 
            RowBox[{
             RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
            "]"}]}], "-", 
          RowBox[{"4", " ", 
           RowBox[{"fE16", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
            "]"}]}], "-", 
          RowBox[{"8", " ", 
           RowBox[{"fE20", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
            "]"}]}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"fE3", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
            "]"}]}]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"2", " ", "xs", " ", "xu"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"fE14", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
            "]"}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"f1E3", "[", 
            RowBox[{
             RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
            "]"}], " ", 
           RowBox[{"fE15", "[", 
            RowBox[{
             RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
            "]"}]}], "-", 
          RowBox[{"4", " ", 
           RowBox[{"fE16", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
            "]"}]}], "-", 
          RowBox[{"8", " ", 
           RowBox[{"fE20", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
            "]"}]}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"fE3", "[", 
            RowBox[{
             RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
            "]"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.919749072614923*^9, 3.9197490877019787`*^9}, 
   3.9197494236237497`*^9}]
}, Closed]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"-", 
   RowBox[{"++", "+"}]}], "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Mmppp2LM", "[", 
   RowBox[{"xs", ",", "xt", ",", "xu"}], "]"}], "/.", 
  "sqrtreplace"}]], "Input",
 CellChangeTimes->{{3.9197494747768908`*^9, 3.919749475081518*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"2", " ", "xs", " ", "xt", " ", 
     RowBox[{"f1E6", "[", 
      RowBox[{
       RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]]}], "-", 
  FractionBox[
   RowBox[{"2", " ", "xt", " ", "xu", " ", 
    RowBox[{"f1E6", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "-", 
  FractionBox[
   RowBox[{"2", " ", "xs", " ", "xu", " ", 
    RowBox[{"f1E6", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["6", "xs"], "+", 
     FractionBox["4", "xt"], "+", 
     FractionBox["6", "xu"]}], ")"}], " ", 
   RowBox[{"fE17", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["6", "xs"], "+", 
     FractionBox["6", "xt"], "+", 
     FractionBox["4", "xu"]}], ")"}], " ", 
   RowBox[{"fE17", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", "xs"], "+", 
     FractionBox["6", "xt"], "+", 
     FractionBox["6", "xu"]}], ")"}], " ", 
   RowBox[{"fE17", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xs", " ", "xt"}], "xu"]}], ")"}], " ", 
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xs", " ", "xu"}], "xt"]}], ")"}], " ", 
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xs", " ", "xt"}], "xu"]}], ")"}], " ", 
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xt", " ", "xu"}], "xs"]}], ")"}], " ", 
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xs", " ", "xu"}], "xt"]}], ")"}], " ", 
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xt", " ", "xu"}], "xs"]}], ")"}], " ", 
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xt"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xs", " ", "xt"}], "xu"]}], ")"}], " ", 
    RowBox[{"fE22", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xt", " ", "xu"}], "xs"]}], ")"}], " ", 
    RowBox[{"fE22", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"32", "+", 
      FractionBox[
       RowBox[{"16", " ", "xs", " ", "xu"}], "xt"]}], ")"}], " ", 
    RowBox[{"fE22", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["8", "xs"], "+", 
     FractionBox["4", "xt"], "+", 
     FractionBox["4", "xu"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE21", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"fE24", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}]}],
     ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", "xs"], "+", 
     FractionBox["8", "xt"], "+", 
     FractionBox["4", "xu"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE21", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"fE24", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}]}],
     ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", "xs"], "+", 
     FractionBox["4", "xt"], "+", 
     FractionBox["8", "xu"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE21", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"fE24", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}]}],
     ")"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", "xs"], "+", 
     FractionBox["6", "xt"], "+", 
     FractionBox["6", "xu"]}], ")"}], " ", 
   RowBox[{"fE26", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", "xs"], "+", 
     FractionBox["6", "xt"], "+", 
     FractionBox["6", "xu"]}], ")"}], " ", 
   RowBox[{"fE26", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["6", "xs"], "+", 
     FractionBox["4", "xt"], "+", 
     FractionBox["6", "xu"]}], ")"}], " ", 
   RowBox[{"fE26", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["6", "xs"], "+", 
     FractionBox["4", "xt"], "+", 
     FractionBox["6", "xu"]}], ")"}], " ", 
   RowBox[{"fE26", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["6", "xs"], "+", 
     FractionBox["6", "xt"], "+", 
     FractionBox["4", "xu"]}], ")"}], " ", 
   RowBox[{"fE26", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["6", "xs"], "+", 
     FractionBox["6", "xt"], "+", 
     FractionBox["4", "xu"]}], ")"}], " ", 
   RowBox[{"fE26", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], "-", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"2", "+", 
      FractionBox[
       RowBox[{"xs", " ", "xt"}], "xu"]}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]}]], "-", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"2", "+", 
      FractionBox[
       RowBox[{"xs", " ", "xu"}], "xt"]}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]}]], "-", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"2", "+", 
      FractionBox[
       RowBox[{"xs", " ", "xt"}], "xu"]}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", 
    SqrtBox[
     RowBox[{"xs", " ", "xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xs"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]}]],
   "-", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"2", "+", 
      FractionBox[
       RowBox[{"xt", " ", "xu"}], "xs"]}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", 
    SqrtBox[
     RowBox[{"xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xt", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]}]], "-", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"2", "+", 
      FractionBox[
       RowBox[{"xs", " ", "xu"}], "xt"]}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]], " ", 
    SqrtBox[
     RowBox[{"xs", " ", "xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xs"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]}]],
   "-", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"2", "+", 
      FractionBox[
       RowBox[{"xt", " ", "xu"}], "xs"]}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]], " ", 
    SqrtBox[
     RowBox[{"xt", " ", "xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xt"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], ")"}]}]]}]],
   "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xs"}], ")"}]}], "xu"], "-", 
      FractionBox[
       RowBox[{"2", " ", "xu"}], "xt"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xs"}], ")"}]}], "xt"], "-", 
      FractionBox[
       RowBox[{"2", " ", "xt"}], "xu"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xt"}], ")"}]}], "xu"], "-", 
      FractionBox[
       RowBox[{"2", " ", "xu"}], "xs"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xt"}], ")"}]}], "xs"], "-", 
      FractionBox[
       RowBox[{"2", " ", "xs"}], "xu"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "xt"}], "xs"]}], "+", 
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xu"}], ")"}]}], "xt"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "xs"}], "xt"]}], "+", 
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xu"}], ")"}]}], "xs"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["2", "xt"], "-", 
     FractionBox["2", "xu"]}], ")"}], " ", 
   RowBox[{"fE29", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["2", "xt"]}], "+", 
     FractionBox["2", "xu"]}], ")"}], " ", 
   RowBox[{"fE29", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["2", "xs"], "-", 
     FractionBox["2", "xu"]}], ")"}], " ", 
   RowBox[{"fE29", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["2", "xs"]}], "+", 
     FractionBox["2", "xu"]}], ")"}], " ", 
   RowBox[{"fE29", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["2", "xs"], "-", 
     FractionBox["2", "xt"]}], ")"}], " ", 
   RowBox[{"fE29", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["2", "xs"]}], "+", 
     FractionBox["2", "xt"]}], ")"}], " ", 
   RowBox[{"fE29", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      " ", 
      RowBox[{"r1L", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f1E3", "[", 
         RowBox[{
          RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
        "-", 
        RowBox[{
         FractionBox["1", "6"], " ", 
         RowBox[{"fE15", "[", 
          RowBox[{
           RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
          "]"}]}]}], ")"}], " ", 
      RowBox[{"r2L", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}]}],
     ")"}]}], "+", 
  RowBox[{
   FractionBox["1", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
      " ", 
      RowBox[{"r1L", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f1E3", "[", 
         RowBox[{
          RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
        "-", 
        RowBox[{
         FractionBox["1", "6"], " ", 
         RowBox[{"fE15", "[", 
          RowBox[{
           RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
          "]"}]}]}], ")"}], " ", 
      RowBox[{"r2L", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}]}],
     ")"}]}], "+", 
  RowBox[{
   FractionBox["1", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
      " ", 
      RowBox[{"r1L", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f1E3", "[", 
         RowBox[{
          RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
        "-", 
        RowBox[{
         FractionBox["1", "6"], " ", 
         RowBox[{"fE15", "[", 
          RowBox[{
           RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
          "]"}]}]}], ")"}], " ", 
      RowBox[{"r2L", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}]}],
     ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
      " ", 
      RowBox[{"fE15", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
     "+", 
     RowBox[{"fE3", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      " ", 
      RowBox[{"fE15", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
     "+", 
     RowBox[{"fE3", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
      " ", 
      RowBox[{"fE15", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
     "+", 
     RowBox[{"fE3", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE5", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE5", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE5", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "6", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "6", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "6", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "7", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "7", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "7", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "8", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "8", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "8", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "9", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xt"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xt", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "9", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xu"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xu", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "9", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xs", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xs"}], ")"}], "2"], " ", "xt"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "9", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xu"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xu", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "9", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xs", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xs"}], ")"}], "2"], " ", "xu"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "9", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xt", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xt"}], ")"}], "2"], " ", "xu"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "10", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "10", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "10", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "11", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "11", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "11", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "11", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "11", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "11", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xt"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], 
      ")"}]}]]]}]], "Output",
 CellChangeTimes->{3.919749475424796*^9}]
}, Closed]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"--", "++"}], "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Mmmpp2LM", "[", 
   RowBox[{"xs", ",", "xt", ",", "xu"}], "]"}], "/.", 
  "sqrtreplace"}]], "Input",
 CellChangeTimes->{3.91974949316963*^9}],

Cell[BoxData[
 RowBox[{"4", "+", 
  RowBox[{"4", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["xs", "2"], "+", 
     RowBox[{"2", " ", "xt", " ", "xu"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
      
      RowBox[{"xs", " ", 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", "xu"}]],
      "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
      
      RowBox[{"xs", " ", "xt", " ", 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
      
      RowBox[{
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", "xt", 
       " ", "xu"}]]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "xs"}], "+", 
      RowBox[{"xt", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"f1E6", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "-", 
  RowBox[{"16", " ", "xs", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"f1E6", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
     FractionBox[
      RowBox[{"f1E6", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"8", " ", "xs", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "xs"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", 
       SuperscriptBox["xt", "2"]}]}], ")"}], " ", 
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   RowBox[{"xt", " ", 
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "xt"}], ")"}], "2"]}], "-", 
        RowBox[{"4", " ", 
         SuperscriptBox["xt", "2"]}]}], ")"}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xs", " ", "xt"}], "+", 
      RowBox[{"4", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"8", " ", "xs", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "xs"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", 
       SuperscriptBox["xu", "2"]}]}], ")"}], " ", 
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   RowBox[{"xu", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xt"}], "+", 
      RowBox[{"xs", " ", "xu"}]}], ")"}], " ", 
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "xu"}], ")"}], "2"]}], "-", 
        RowBox[{"4", " ", 
         SuperscriptBox["xu", "2"]}]}], ")"}]}]]}]], "-", 
  RowBox[{"16", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"8", "+", "xs", "-", 
      SuperscriptBox["xt", "2"], "-", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"fE21", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SuperscriptBox["xs", "2"]], "+", 
  RowBox[{"16", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"fE22", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
     FractionBox[
      RowBox[{"fE22", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xs", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    RowBox[{"fE24", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SuperscriptBox["xs", "2"]], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["xs", "2"], " ", 
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xs", " ", "xt"}], "+", 
      RowBox[{"4", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["xs", "2"], " ", 
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xt"}], "+", 
      RowBox[{"xs", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "xs"}], ")"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"fE27", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
       SqrtBox[
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xs", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
           RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
      FractionBox[
       RowBox[{"fE27", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], 
       SqrtBox[
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xs", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
           RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]]}], ")"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]], " ", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xs", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xs", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]], " ", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xs"}], "+", 
      RowBox[{"12", " ", "xt"}], "-", 
      SuperscriptBox["xt", "3"], "-", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   RowBox[{
    SuperscriptBox["xs", "2"], " ", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xs"}], "-", 
      SuperscriptBox["xt", "2"], "+", 
      RowBox[{"12", " ", "xu"}], "-", 
      SuperscriptBox["xu", "3"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   RowBox[{
    SuperscriptBox["xs", "2"], " ", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]], "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xs", "2"]], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", "xs"}], "+", 
      SuperscriptBox["xt", "2"], "+", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
        RowBox[{"fE28", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
        RowBox[{"fE28", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]]}], ")"}]}]}],
   "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xs", "2"]], 
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"4", "+", "xs", "-", 
      SuperscriptBox["xt", "2"], "+", 
      RowBox[{"3", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fE26", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], 
      "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"fE29", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], 
        "]"}]}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xs", "2"]], 
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"4", "+", "xs", "+", 
      RowBox[{"3", " ", "xt"}], "-", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fE26", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
      "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"fE29", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
        "]"}]}]}], ")"}]}]}], "-", 
  FractionBox[
   RowBox[{"8", " ", 
    SuperscriptBox["xs", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "16"}], "+", 
      SuperscriptBox["xs", "2"]}], ")"}], " ", 
    RowBox[{"fE5", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xs", " ", "xt"}], "+", 
      RowBox[{"4", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xt"}], "+", 
      RowBox[{"xs", " ", "xu"}]}], ")"}]}]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE17", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], "+", 
     RowBox[{"fE26", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "12", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE17", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], "+", 
     RowBox[{"fE26", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "12", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "13", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "13", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE20", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], "+", 
     RowBox[{"fE20", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "14", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE24", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], "-", 
     RowBox[{"fE29", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "15", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE24", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], "-", 
     RowBox[{"fE29", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "15", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "16", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "16", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "17", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "18", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "18", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "19", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "19", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE15", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "20", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE15", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "20", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "21", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xs", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xs"}], ")"}], "2"], " ", "xt"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "21", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xs", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xs"}], ")"}], "2"], " ", "xu"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "22", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xu"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xu", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "22", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xt", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xt"}], ")"}], "2"], " ", "xu"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "23", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xt"}]}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "23", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "24", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"fE19", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
       "+", 
       RowBox[{"fE19", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], 
       "-", 
       RowBox[{"fE22", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
       "-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
         RowBox[{"fE27", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
          "]"}]}], 
        RowBox[{"4", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]}]], "-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
         RowBox[{"fE27", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], 
          "]"}]}], 
        RowBox[{"4", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]]}], ")"}],
      " ", 
     RowBox[{"r2L", "[", 
      RowBox[{
       RowBox[{"{", "25", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
    ")"}], "/", 
   RowBox[{"(", 
    SqrtBox[
     RowBox[{"xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xt", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "6"}], " ", 
      RowBox[{"f1E5", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
     "+", 
     RowBox[{"fE14", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "26", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "27", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "27", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "28", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "28", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
      " ", 
      RowBox[{"fE15", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
     "+", 
     RowBox[{"fE3", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "29", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE3", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "30", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE3", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "30", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E3", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"fE15", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "31", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E3", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"fE15", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "31", "}"}], ",", "xs", ",", "xu", ",", "xt"}], 
    "]"}]}]}]], "Output",
 CellChangeTimes->{3.919749494070363*^9}]
}, Closed]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"+", 
   RowBox[{"-", 
    RowBox[{"+", "-"}]}]}], "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mpmpm2LM", "/.", "sqrtreplace"}]], "Input",
 CellChangeTimes->{3.91974951278253*^9}],

Cell[BoxData[
 RowBox[{"4", "+", 
  RowBox[{"4", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "xs", " ", "xt"}], "+", 
     SuperscriptBox["xu", "2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
      
      RowBox[{"xs", " ", "xt", " ", 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
      
      RowBox[{
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", "xt", 
       " ", "xu"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
      
      RowBox[{"xs", " ", 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", 
       "xu"}]]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xs", " ", "xt"}], "+", 
      RowBox[{"2", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"f1E6", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]], 
  "-", 
  RowBox[{"16", " ", "xu", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"f1E6", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"f1E6", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], 
      SqrtBox[
       RowBox[{"xt", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xt"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], 
         ")"}]}]]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"8", " ", "xu", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["xs", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "+", 
      RowBox[{"2", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   RowBox[{"xs", " ", 
    SqrtBox[
     RowBox[{"xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         SuperscriptBox["xs", "2"]}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "xs"}], ")"}], "2"], " ", "xu"}]}], 
       ")"}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xt"}], "+", 
      RowBox[{"xs", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"8", " ", "xu", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["xt", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "+", 
      RowBox[{"2", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   RowBox[{"xt", " ", 
    SqrtBox[
     RowBox[{"xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         SuperscriptBox["xt", "2"]}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "xt"}], ")"}], "2"], " ", "xu"}]}], 
       ")"}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xs"}], "+", 
      RowBox[{"xt", " ", "xu"}]}], ")"}]}]], "-", 
  RowBox[{"16", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
      SqrtBox[
       RowBox[{"xt", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xt"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], 
      SqrtBox[
       RowBox[{"xt", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xt"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], 
         ")"}]}]]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"8", "-", 
      SuperscriptBox["xs", "2"], "-", 
      SuperscriptBox["xt", "2"], "+", "xu"}], ")"}], " ", 
    RowBox[{"fE21", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SuperscriptBox["xu", "2"]], "+", 
  RowBox[{"16", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"fE22", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"fE22", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], 
      SqrtBox[
       RowBox[{"xt", " ", "xu", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xt"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], 
         ")"}]}]]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    RowBox[{"fE24", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SuperscriptBox["xu", "2"]], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["xu", "2"], " ", 
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xs", " ", "xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xs"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]], 
    " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xt"}], "+", 
      RowBox[{"xs", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["xu", "2"], " ", 
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xt", " ", "xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xt"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], ")"}]}]], 
    " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xs"}], "+", 
      RowBox[{"xt", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
    SqrtBox[
     RowBox[{"xs", " ", "xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xs"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]}]],
   "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", 
    SqrtBox[
     RowBox[{"xt", " ", "xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xt"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], ")"}]}]]}]],
   "+", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "xu"}], ")"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"fE27", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
       SqrtBox[
        RowBox[{"xs", " ", "xu", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "xs"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], 
          ")"}]}]]], "+", 
      FractionBox[
       RowBox[{"fE27", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], 
       SqrtBox[
        RowBox[{"xt", " ", "xu", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "xt"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], 
          ")"}]}]]]}], ")"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"12", " ", "xs"}], "-", 
      SuperscriptBox["xs", "3"], "-", 
      SuperscriptBox["xt", "2"], "+", 
      RowBox[{"4", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
    SuperscriptBox["xu", "2"]}]], "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xu", "2"]], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["xs", "2"], "+", 
      SuperscriptBox["xt", "2"], "-", 
      RowBox[{"4", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
        RowBox[{"fE28", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
        RowBox[{"fE28", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]]}], ")"}]}]}],
   "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["xs", "2"]}], "+", 
      RowBox[{"12", " ", "xt"}], "-", 
      SuperscriptBox["xt", "3"], "+", 
      RowBox[{"4", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", 
    SuperscriptBox["xu", "2"]}]], "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xu", "2"]], 
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"4", "-", 
      SuperscriptBox["xs", "2"], "+", 
      RowBox[{"3", " ", "xt"}], "+", "xu"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fE26", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], 
      "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"fE29", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], 
        "]"}]}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xu", "2"]], 
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"4", "+", 
      RowBox[{"3", " ", "xs"}], "-", 
      SuperscriptBox["xt", "2"], "+", "xu"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fE26", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
      "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"fE29", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
        "]"}]}]}], ")"}]}]}], "-", 
  FractionBox[
   RowBox[{"8", " ", 
    SuperscriptBox["xu", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "16"}], "+", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"fE5", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xt"}], "+", 
      RowBox[{"xs", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xs"}], "+", 
      RowBox[{"xt", " ", "xu"}]}], ")"}]}]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE17", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], "+", 
     RowBox[{"fE26", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "12", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE17", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], "+", 
     RowBox[{"fE26", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "12", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "13", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "13", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE20", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], "+", 
     RowBox[{"fE20", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "14", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE24", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], "-", 
     RowBox[{"fE29", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "15", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE24", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], "-", 
     RowBox[{"fE29", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "15", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "16", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "16", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "17", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "18", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "18", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "19", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "19", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE15", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "20", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE15", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "20", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "21", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xu"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xu", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "21", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xu"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xu", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "22", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xt"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xt", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "22", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xs", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xs"}], ")"}], "2"], " ", "xt"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "23", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "23", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xt"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "24", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"fE19", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
       "+", 
       RowBox[{"fE19", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], 
       "-", 
       RowBox[{"fE22", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], 
       "-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
         RowBox[{"fE27", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
          "]"}]}], 
        RowBox[{"4", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]}]], "-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
         RowBox[{"fE27", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], 
          "]"}]}], 
        RowBox[{"4", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]}]]}], ")"}],
      " ", 
     RowBox[{"r2L", "[", 
      RowBox[{
       RowBox[{"{", "25", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
    ")"}], "/", 
   RowBox[{"(", 
    SqrtBox[
     RowBox[{"xs", " ", "xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xs"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]], 
    ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "6"}], " ", 
      RowBox[{"f1E5", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
     "+", 
     RowBox[{"fE14", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "26", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "27", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "27", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "28", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "28", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], 
      " ", 
      RowBox[{"fE15", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
     "+", 
     RowBox[{"fE3", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "29", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE3", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "30", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE3", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "30", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E3", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
   RowBox[{"fE15", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "31", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E3", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
   RowBox[{"fE15", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "31", "}"}], ",", "xu", ",", "xt", ",", "xs"}], 
    "]"}]}]}]], "Output",
 CellChangeTimes->{3.9197495134370337`*^9}]
}, Closed]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"+", 
   RowBox[{"--", "+"}]}], "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mpmmp2LM", "/.", "sqrtreplace"}]], "Input",
 CellChangeTimes->{3.9197495298249073`*^9}],

Cell[BoxData[
 RowBox[{"4", "+", 
  RowBox[{"4", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["xt", "2"], "+", 
     RowBox[{"2", " ", "xs", " ", "xu"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
      
      RowBox[{"xs", " ", 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", "xu"}]],
      "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
      
      RowBox[{"xs", " ", "xt", " ", 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", 
       RowBox[{"f1E3", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
      
      RowBox[{
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", "xt", 
       " ", "xu"}]]}], ")"}]}], "-", 
  RowBox[{"16", " ", "xt", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"f1E6", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", "xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"f1E6", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
      SqrtBox[
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xt", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "xt"}], "+", 
      RowBox[{"xs", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"f1E6", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{"8", " ", "xt", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["xs", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xt"}], ")"}]}], "+", 
      RowBox[{"2", " ", "xt"}]}], ")"}], " ", 
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   RowBox[{"xs", " ", 
    SqrtBox[
     RowBox[{"xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         SuperscriptBox["xs", "2"]}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "xs"}], ")"}], "2"], " ", "xt"}]}], 
       ")"}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xs", " ", "xt"}], "+", 
      RowBox[{"4", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"8", " ", "xt", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "xt"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", 
       SuperscriptBox["xu", "2"]}]}], ")"}], " ", 
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   RowBox[{"xu", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xs"}], "+", 
      RowBox[{"xt", " ", "xu"}]}], ")"}], " ", 
    SqrtBox[
     RowBox[{"xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xt", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "xu"}], ")"}], "2"]}], "-", 
        RowBox[{"4", " ", 
         SuperscriptBox["xu", "2"]}]}], ")"}]}]]}]], "-", 
  RowBox[{"16", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", "xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", "xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
      SqrtBox[
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xt", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
     FractionBox[
      RowBox[{"fE19", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], 
      SqrtBox[
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xt", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"8", "-", 
      SuperscriptBox["xs", "2"], "+", "xt", "-", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"fE21", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SuperscriptBox["xt", "2"]], "+", 
  RowBox[{"16", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"fE22", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      SqrtBox[
       RowBox[{"xs", " ", "xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "xs"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]],
      "+", 
     FractionBox[
      RowBox[{"fE22", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
      SqrtBox[
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xt", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
          RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    RowBox[{"fE24", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SuperscriptBox["xt", "2"]], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["xt", "2"], " ", 
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xs", " ", "xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xs"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]], 
    " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xs", " ", "xt"}], "+", 
      RowBox[{"4", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["xt", "2"], " ", 
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xt", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xs"}], "+", 
      RowBox[{"xt", " ", "xu"}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
    SqrtBox[
     RowBox[{"xs", " ", "xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xs"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]}]],
   "+", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "xt"}], ")"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"fE27", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], 
       SqrtBox[
        RowBox[{"xs", " ", "xt", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "xs"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], 
          ")"}]}]]], "+", 
      FractionBox[
       RowBox[{"fE27", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], 
       SqrtBox[
        RowBox[{"xt", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xt", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
           RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]]}], ")"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xt"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
    RowBox[{"fE27", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"xt", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xt", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
        RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]], " ", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"12", " ", "xs"}], "-", 
      SuperscriptBox["xs", "3"], "+", 
      RowBox[{"4", " ", "xt"}], "-", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]], " ", 
    SuperscriptBox["xt", "2"]}]], "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xt", "2"]], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["xs", "2"], "-", 
      RowBox[{"4", " ", "xt"}], "+", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
        RowBox[{"fE28", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
        RowBox[{"fE28", "[", 
         RowBox[{
          RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]]}], ")"}]}]}],
   "+", 
  FractionBox[
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["xs", "2"]}], "+", 
      RowBox[{"4", " ", "xt"}], "+", 
      RowBox[{"12", " ", "xu"}], "-", 
      SuperscriptBox["xu", "3"]}], ")"}], " ", 
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
   RowBox[{
    SuperscriptBox["xt", "2"], " ", 
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]], "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xt", "2"]], 
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"4", "-", 
      SuperscriptBox["xs", "2"], "+", "xt", "+", 
      RowBox[{"3", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fE26", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"fE29", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], 
        "]"}]}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["xt", "2"]], 
   RowBox[{"8", " ", 
    RowBox[{"(", 
     RowBox[{"4", "+", 
      RowBox[{"3", " ", "xs"}], "+", "xt", "-", 
      SuperscriptBox["xu", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fE26", "[", 
       RowBox[{
        RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], 
      "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"fE29", "[", 
        RowBox[{
         RowBox[{"{", "4", "}"}], ",", "xu", ",", "xt", ",", "xs"}], 
        "]"}]}]}], ")"}]}]}], "-", 
  FractionBox[
   RowBox[{"8", " ", 
    SuperscriptBox["xt", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "16"}], "+", 
      SuperscriptBox["xt", "2"]}], ")"}], " ", 
    RowBox[{"fE5", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "xt"}], ")"}], " ", "xt"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xs", " ", "xt"}], "+", 
      RowBox[{"4", " ", "xu"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "xs"}], "+", 
      RowBox[{"xt", " ", "xu"}]}], ")"}]}]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE17", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], "+", 
     RowBox[{"fE26", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "12", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE17", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], "+", 
     RowBox[{"fE26", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "12", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "13", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE20", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "13", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE20", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], "+", 
     RowBox[{"fE20", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "14", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE24", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], "-", 
     RowBox[{"fE29", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "15", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fE24", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], "-", 
     RowBox[{"fE29", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "15", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "16", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "16", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "17", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "18", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "18", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "19", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE13", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "19", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE15", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "20", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE15", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "20", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "21", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xt"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xt", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "21", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xt", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xt"}], ")"}], "2"], " ", "xu"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "22", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xs", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xu"}], ")"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["xu", "2"]}]}], ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "22", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        SuperscriptBox["xs", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "xs"}], ")"}], "2"], " ", "xu"}]}], 
      ")"}]}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "23", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xt"}]}], ")"}]}]]], 
  "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "23", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xt", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"xt", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xu"}], ")"}]}], "-", 
       RowBox[{"4", " ", "xu"}]}], ")"}], " ", "xu"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
    
    RowBox[{"r2L", "[", 
     RowBox[{
      RowBox[{"{", "24", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
   SqrtBox[
    RowBox[{"xs", " ", "xu", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "xs"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]]], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"fE19", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xs", ",", "xu", ",", "xt"}], "]"}], 
       "+", 
       RowBox[{"fE19", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
       "-", 
       RowBox[{"fE22", "[", 
        RowBox[{
         RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], 
       "-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "xs"}], ")"}], " ", 
         RowBox[{"fE27", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", "xs", ",", "xu", ",", "xt"}], 
          "]"}]}], 
        RowBox[{"4", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xs"}]]}]], "-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "xu"}], ")"}], " ", 
         RowBox[{"fE27", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", "xu", ",", "xs", ",", "xt"}], 
          "]"}]}], 
        RowBox[{"4", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", "xu"}], ")"}], " ", "xu"}]]}]]}], ")"}],
      " ", 
     RowBox[{"r2L", "[", 
      RowBox[{
       RowBox[{"{", "25", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}]}], 
    ")"}], "/", 
   RowBox[{"(", 
    SqrtBox[
     RowBox[{"xs", " ", "xu", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "xs"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", "xs"}], ")"}], " ", "xu"}]}], ")"}]}]], 
    ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "6"}], " ", 
      RowBox[{"f1E5", "[", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
     "+", 
     RowBox[{"fE14", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "26", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "27", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE14", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "27", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "28", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E5", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "28", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"f1E3", "[", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], 
      " ", 
      RowBox[{"fE15", "[", 
       RowBox[{
        RowBox[{"{", "2", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
     "+", 
     RowBox[{"fE3", "[", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
    ")"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "29", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE3", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "30", "}"}], ",", "xs", ",", "xt", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"fE3", "[", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "30", "}"}], ",", "xu", ",", "xt", ",", "xs"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E3", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"fE15", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xu", ",", "xs", ",", "xt"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "31", "}"}], ",", "xt", ",", "xs", ",", "xu"}], "]"}]}], 
  "+", 
  RowBox[{
   RowBox[{"f1E3", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"fE15", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "xt", ",", "xu", ",", "xs"}], "]"}], " ", 
   RowBox[{"r2L", "[", 
    RowBox[{
     RowBox[{"{", "31", "}"}], ",", "xt", ",", "xu", ",", "xs"}], 
    "]"}]}]}]], "Output",
 CellChangeTimes->{3.9197495303202744`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Two-loop master integrals", "Section",
 CellChangeTimes->{{3.9197687672811747`*^9, 3.9197687719508266`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<twoloop_masterintegrals.wl\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.9197488801878967`*^9, 3.919748884822955*^9}, {
   3.919748968623146*^9, 3.9197489705257673`*^9}, 3.919768790713501*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"fEk", "[", 
      RowBox[{
       RowBox[{"{", "w", "}"}], ",", "x", ",", "y", ",", "z"}], "]"}], " ", 
     "is", " ", "k"}], "-", 
    RowBox[{"th", " ", "two"}], "-", 
    RowBox[{
    "loop", " ", "master", " ", "integral", " ", "with", " ", "the", " ", 
     "transcendental", " ", "weight", " ", "w"}]}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{"two", "-", 
    RowBox[{
    "loop", " ", "master", " ", "integrals", " ", "that", " ", "can", " ", 
     "be", " ", "expressed", " ", "into", " ", "GPLs"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "w", " ", "and", " ", "z", " ", "in", " ", "terms", " ", "of", " ", 
     "sij"}], ",", "sjk", ",", 
    RowBox[{"sik", " ", "can", " ", "be", " ", "found", " ", "in", " ", 
     RowBox[{"eq", ".", 
      RowBox[{"(", "3.4", ")"}]}], " ", "in", " ", 
     RowBox[{"arXiv", ":", "2312.16966"}]}]}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Note", " ", "that", " ", "they", " ", "are", " ", "for", " ", "sij"}], 
     "<", "0"}], ",", 
    RowBox[{"sjk", "<", "0"}], ",", 
    RowBox[{"sik", ">", "0"}]}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "The", " ", "analytic", " ", "continuation", " ", "is", " ", "needed", 
     " ", "for", " ", "other", " ", "regions"}], ",", 
    RowBox[{"see", " ", 
     RowBox[{"arXiv", ":", "2312.16966"}]}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.919768803081308*^9, 3.919768810076611*^9}}],

Cell[CellGroupData[{

Cell[BoxData["twoloopmasterintegralInG"], "Input",
 CellChangeTimes->{{3.919768818756174*^9, 3.919768818764711*^9}}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   PanelBox[GridBox[{
      {
       StyleBox[
        StyleBox[
         DynamicBox[ToBoxes[
           FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
           StandardForm],
          ImageSizeCache->{420., {3., 12.}}],
         StripOnInput->False,
         DynamicUpdating->True], "Panel",
        StripOnInput->False,
        Background->None]},
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"fE1", "[", 
             RowBox[{
              RowBox[{"{", "0", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], 
             "]"}], "\[Rule]", "1"}], ",", 
           RowBox[{
            RowBox[{"fE1", "[", 
             RowBox[{
              RowBox[{"{", "1", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], 
             "]"}], "\[Rule]", "0"}], ",", 
           RowBox[{"\[LeftSkeleton]", "133", "\[RightSkeleton]"}], ",", 
           RowBox[{
            RowBox[{"fE29", "[", 
             RowBox[{
              RowBox[{"{", "2", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], 
             "]"}], "\[Rule]", "0"}], ",", 
           RowBox[{
            RowBox[{"fE29", "[", 
             RowBox[{
              RowBox[{"{", "3", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], 
             "]"}], "\[Rule]", "0"}]}], "}"}],
         Short[#, 5]& ],
        Background->GrayLevel[1],
        BaseStyle->{Deployed -> False},
        Frame->True,
        FrameStyle->GrayLevel[0, 0.2],
        StripOnInput->False]},
      {
       RowBox[{
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
             StandardForm],
            ImageSizeCache->{75., {1., 12.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 2825, 25688603480912771137, 5/2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
             StandardForm],
            ImageSizeCache->{80., {1., 12.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 2825, 25688603480912771137, 5 2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
             StandardForm],
            ImageSizeCache->{125., {3., 12.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 2825, 25688603480912771137, Infinity],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
             StandardForm],
            ImageSizeCache->{111., {1., 11.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>FrontEndExecute[{
            FrontEnd`SetOptions[
            FrontEnd`$FrontEnd, 
             FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
            FrontEnd`FrontEndToken["PreferencesDialog"]}],
         Evaluator->None,
         Method->"Preemptive"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[1.2]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    DefaultBaseStyle->{},
    FrameMargins->5],
   Deploy,
   DefaultBaseStyle->{Deployed -> True}],
  Out[2825]]], "Output",
 CellChangeTimes->{3.919768819648128*^9}]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"two", "-", 
    RowBox[{
    "loop", " ", "master", " ", "integrals", " ", "that", " ", "contain", " ",
      "square", " ", "roots"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "They", " ", "are", " ", "expressed", " ", "into", " ", "iterated", " ", 
    "integrals", " ", "over", " ", "dlog", " ", "forms"}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{
   "iint", " ", "represents", " ", "an", " ", "iterated", " ", "integral"}], 
   "*)"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dg", "[", "i", "]"}], " ", "has", " ", "been", " ", "defined", 
    " ", "in", " ", 
    RowBox[{"eq", ".", 
     RowBox[{"(", "3.7", ")"}]}], " ", "in", " ", 
    RowBox[{"arXiv", ":", "2312.16966"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.919768839097166*^9, 3.919768841588829*^9}, 
   3.919778604224945*^9}],

Cell[CellGroupData[{

Cell[BoxData["twoloopmasterintegralIndlog"], "Input",
 CellChangeTimes->{{3.919768848373577*^9, 3.919768848382278*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}]}], ")"}]}]}], ",", 
   
   RowBox[{
    RowBox[{"fE18", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"3", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"3", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "2", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "2", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "2", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "10", "]"}], ",", 
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "10", "]"}], ",", 
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}]}], ")"}]}]}], ",", 
   
   RowBox[{
    RowBox[{"fE19", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["2", "3"], " ", 
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{
        FractionBox["4", "3"], " ", 
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "11", "]"}], ",", 
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "11", "]"}], ",", 
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"5", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"7", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"48", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}]}], ")"}]}]}], ",", 
   
   RowBox[{
    RowBox[{"fE20", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "2", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "2", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "2", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "7", "]"}], ",", 
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "7", "]"}], ",", 
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "10", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"3", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "6", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "15", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}]}], ")"}]}]}], ",", 
   
   RowBox[{
    RowBox[{"fE25", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "11", "]"}], ",", 
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "11", "]"}], ",", 
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"3", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"15", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"18", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"18", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"44", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"36", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"36", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"18", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"36", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}]}], ")"}]}]}], ",", 
   
   RowBox[{
    RowBox[{"fE26", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "7", "]"}], ",", 
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "7", "]"}], ",", 
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"3", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"7", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"10", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"10", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"20", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"10", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"20", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}]}], ")"}]}]}], ",", 
   
   RowBox[{
    RowBox[{"fE28", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"5", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "2", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"15", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "9", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "9", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "9", "]"}], ",", 
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "9", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "9", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}]}], ")"}]}]}], ",", 
   
   RowBox[{
    RowBox[{"fE29", "[", 
     RowBox[{
      RowBox[{"{", "4", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"3", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"3", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"24", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"16", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "7", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"iint", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dg", "[", "8", "]"}], ",", 
          RowBox[{"dg", "[", "9", "]"}], ",", 
          RowBox[{"dg", "[", "3", "]"}], ",", 
          RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "8", "]"}], ",", 
           RowBox[{"dg", "[", "11", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "3", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "4", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "12", "]"}], ",", 
           RowBox[{"dg", "[", "1", "]"}]}], "}"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"iint", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dg", "[", "10", "]"}], ",", 
           RowBox[{"dg", "[", "13", "]"}], ",", 
           RowBox[{"dg", "[", "14", "]"}], ",", 
           RowBox[{"dg", "[", "5", "]"}]}], "}"}], "]"}]}]}], ")"}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.919768849282228*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["One-loop master integrals", "Section",
 CellChangeTimes->{{3.919768861051827*^9, 3.9197688648314743`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<oneloop_masterintegrals.wl\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.9197488801878967`*^9, 3.919748884822955*^9}, {
   3.919748968623146*^9, 3.9197489705257673`*^9}, 3.919768790713501*^9, {
   3.91976887582657*^9, 3.9197688767928534`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"f1Ek", "[", 
      RowBox[{
       RowBox[{"{", "w", "}"}], ",", "x", ",", "y", ",", "z"}], "]"}], " ", 
     "is", " ", "k"}], "-", 
    RowBox[{"th", " ", "one"}], "-", 
    RowBox[{
    "loop", " ", "master", " ", "integral", " ", "with", " ", "the", " ", 
     "transcendental", " ", "weight", " ", "w"}]}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{"one", "-", 
    RowBox[{
    "loop", " ", "master", " ", "integrals", " ", "that", " ", "can", " ", 
     "be", " ", "expressed", " ", "into", " ", "GPLs", " ", "up", " ", "to", 
     " ", "weight", " ", "3"}]}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "w", " ", "and", " ", "z", " ", "in", " ", "terms", " ", "of", " ", 
     "sij"}], ",", "sjk", ",", 
    RowBox[{"sik", " ", "can", " ", "be", " ", "found", " ", "in", " ", 
     RowBox[{"eq", ".", 
      RowBox[{"(", "3.4", ")"}]}], " ", "in", " ", 
     RowBox[{"arXiv", ":", "2312.16966"}]}]}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Note", " ", "that", " ", "they", " ", "are", " ", "for", " ", "sij"}], 
     "<", "0"}], ",", 
    RowBox[{"sjk", "<", "0"}], ",", 
    RowBox[{"sik", ">", "0"}]}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "The", " ", "analytic", " ", "continuation", " ", "is", " ", "needed", 
     " ", "for", " ", "other", " ", "regions"}], ",", 
    RowBox[{"see", " ", 
     RowBox[{"arXiv", ":", "2312.16966"}]}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.919768889933667*^9, 3.919768889943325*^9}}],

Cell[CellGroupData[{

Cell[BoxData["oneloopmasterintegralInG"], "Input",
 CellChangeTimes->{{3.919768884986603*^9, 3.9197688849959087`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"f1E1", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"f1E1", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"f1E1", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"f1E1", "[", 
     RowBox[{
      RowBox[{"{", "3", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"f1E2", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "z"}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E2", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"G", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "w"}], "]"}]}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        FractionBox["1", "w"], ",", "z"}], "]"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        FractionBox["1", "w"], ",", "z"}], "]"}]}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "z"}], "]"}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{
        FractionBox["1", "w"], ",", 
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{
        FractionBox["1", "w"], ",", "1", ",", "z"}], "]"}]}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E2", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"G", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
          RowBox[{"G", "[", 
           RowBox[{"1", ",", "z"}], "]"}], "-", 
          RowBox[{"2", " ", 
           RowBox[{"G", "[", 
            RowBox[{
             FractionBox["1", "w"], ",", "z"}], "]"}]}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"G", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "w"}], "]"}], "-", 
          RowBox[{"G", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}], "+", 
          RowBox[{"G", "[", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "w"}], "]"}], "-", 
          RowBox[{"G", "[", 
           RowBox[{"1", ",", "1", ",", "w"}], "]"}]}], ")"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"G", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "w"}], "]"}], "-", 
          RowBox[{"G", "[", 
           RowBox[{"1", ",", "w"}], "]"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"G", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
          RowBox[{"G", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}], "-", 
          RowBox[{"2", " ", 
           RowBox[{"G", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", 
             FractionBox["1", "w"], ",", "z"}], "]"}]}], "+", 
          RowBox[{"G", "[", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
          RowBox[{"G", "[", 
           RowBox[{"1", ",", "1", ",", "z"}], "]"}], "-", 
          RowBox[{"2", " ", 
           RowBox[{"G", "[", 
            RowBox[{"1", ",", 
             FractionBox["1", "w"], ",", "z"}], "]"}]}], "-", 
          RowBox[{"2", " ", 
           RowBox[{"G", "[", 
            RowBox[{
             FractionBox["1", "w"], ",", 
             RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
          RowBox[{"2", " ", 
           RowBox[{"G", "[", 
            RowBox[{
             FractionBox["1", "w"], ",", "1", ",", "z"}], "]"}]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"G", "[", 
            RowBox[{
             FractionBox["1", "w"], ",", 
             FractionBox["1", "w"], ",", "z"}], "]"}]}]}], ")"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          FractionBox["1", "w"], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          FractionBox["1", "w"], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          FractionBox["1", "w"], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          FractionBox["1", "w"], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox["1", "w"], ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox["1", "w"], ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox["1", "w"], ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox["1", "w"], ",", "1", ",", "1", ",", "z"}], "]"}]}], "+", 
       RowBox[{"8", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox["1", "w"], ",", 
          FractionBox["1", "w"], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"8", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox["1", "w"], ",", 
          FractionBox["1", "w"], ",", "1", ",", "z"}], "]"}]}]}], ")"}]}]}], 
   ",", 
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"G", "[", 
       RowBox[{"0", ",", "w"}], "]"}]}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"0", ",", "z"}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["\[Pi]", "2"]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "w"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "w"}], ",", "0", ",", "z"}], "]"}]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E3", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}]}], "-", 
       RowBox[{
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "w"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "w"}], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "w"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "w"}], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"24", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "w"}], ",", 
          RowBox[{"-", "w"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "w"}], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "w"}], ",", "0", ",", "0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"24", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "w"}], ",", 
          RowBox[{"-", "w"}], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E4", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"G", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "w"}], "]"}]}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}]}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "z"}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E4", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"G", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "z"}], "]"}]}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        FractionBox["1", "w"], ",", "z"}], "]"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        FractionBox["1", "w"], ",", "z"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "1", ",", "w"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "1", ",", "w"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "1", ",", "z"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "1", ",", "z"}], "]"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", 
        FractionBox["1", "w"], ",", "z"}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", 
        FractionBox["1", "w"], ",", "z"}], "]"}]}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "z"}], "]"}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        FractionBox["1", "w"], ",", 
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        FractionBox["1", "w"], ",", "1", ",", "z"}], "]"}]}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "z"}], "]"}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", 
        FractionBox["1", "w"], ",", 
        RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", 
        FractionBox["1", "w"], ",", "1", ",", "z"}], "]"}]}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E5", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"G", "[", 
        RowBox[{"0", ",", "w"}], "]"}]}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"0", ",", "z"}], "]"}]}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"0", ",", "0", ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"0", ",", "0", ",", "z"}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E5", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}]}], "-", 
       RowBox[{
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "w"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "w"}], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"18", " ", 
        RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E6", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"G", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "z"}], "]"}]}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"0", ",", "w"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"0", ",", "z"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"0", ",", "z"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "w"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"0", ",", "w"}], "]"}], " ", 
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "z"}], "]"}]}], "-", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0", ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0", ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}], ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}], ",", "z"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"0", ",", "1", ",", "w"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"0", ",", "1", ",", "z"}], "]"}], "+", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "0", ",", "w"}], "]"}], "-", 
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "0", ",", "z"}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"f1E6", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", "sij", ",", "sjk", ",", "sik"}], "]"}], 
    "\[Rule]", 
    RowBox[{
     FractionBox["1", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[Pi]", "2"]}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "w"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          FractionBox["1", "w"], ",", "z"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          FractionBox["1", "w"], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "z"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "w"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "0", ",", "z"}], "]"}]}], 
       "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "0", ",", "z"}], "]"}]}], 
       "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "0", ",", "z"}], "]"}]}], 
       "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "1", ",", "z"}], "]"}]}], 
       "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "1", ",", "z"}], "]"}]}], 
       "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "1", ",", "z"}], "]"}]}], 
       "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "1", ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "w"}], "]"}], " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "w"}], ",", "0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", "1", ",", "1", ",", "z"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          FractionBox["1", "w"], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"0", ",", 
          FractionBox["1", "w"], ",", "1", ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", "0", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "0", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "0", ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "0", ",", "1", ",", "w"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", "0", ",", "w"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", "1", ",", "1", ",", "w"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "w"}], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "0", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "0", ",", "0", ",", "z"}], 
         "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "0", ",", "1", ",", "z"}], 
         "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "1", ",", "0", ",", "z"}], 
         "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "-", "w"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}]], ",", "1", ",", "1", ",", "z"}], 
         "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", 
          RowBox[{"-", "1"}], ",", "0", ",", "z"}], "]"}]}], "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "0", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "0", ",", "1", ",", "z"}], "]"}]}], 
       "+", 
       RowBox[{"12", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "w"]}], ",", "1", ",", "0", ",", "z"}], "]"}]}], 
       "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "0", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", 
          RowBox[{"-", "1"}], ",", "1", ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "0", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "0", ",", "0", ",", "z"}], "]"}]}], 
       "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "0", ",", "1", ",", "z"}], "]"}]}], 
       "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "1", ",", 
          RowBox[{"-", "1"}], ",", "z"}], "]"}]}], "-", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "1", ",", "0", ",", "z"}], "]"}]}], 
       "+", 
       RowBox[{"6", " ", 
        RowBox[{"G", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"-", "1"}], "+", "w"}], 
           RowBox[{"1", "+", "w"}]], ",", "1", ",", "1", ",", "z"}], 
         "]"}]}]}], ")"}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.919768894147585*^9}]
}, Closed]]
}, Closed]]
},
WindowSize->{740, 859},
WindowMargins->{{Automatic, 411}, {Automatic, 28}},
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 189, 4, 40, "Input"],
Cell[CellGroupData[{
Cell[771, 28, 103, 1, 100, "Section"],
Cell[877, 31, 214, 4, 63, "Input"],
Cell[1094, 37, 71, 2, 60, "Input"],
Cell[CellGroupData[{
Cell[1190, 43, 203, 5, 60, "Input"],
Cell[1396, 50, 15253, 473, 2422, "Output"]
}, Closed]],
Cell[16664, 526, 89, 3, 43, "Input"],
Cell[CellGroupData[{
Cell[16778, 533, 203, 5, 60, "Input"],
Cell[16984, 540, 38190, 1313, 7255, "Output"]
}, Closed]],
Cell[55189, 1856, 71, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[55285, 1862, 176, 5, 60, "Input"],
Cell[55464, 1869, 30857, 1041, 5284, "Output"]
}, Closed]],
Cell[86336, 2913, 108, 4, 43, "Input"],
Cell[CellGroupData[{
Cell[86469, 2921, 108, 2, 60, "Input"],
Cell[86580, 2925, 31473, 1079, 5284, "Output"]
}, Closed]],
Cell[118068, 4007, 89, 3, 43, "Input"],
Cell[CellGroupData[{
Cell[118182, 4014, 111, 2, 60, "Input"],
Cell[118296, 4018, 31201, 1063, 5283, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[149546, 5087, 114, 1, 53, "Section"],
Cell[149663, 5090, 252, 5, 42, "Input"],
Cell[149918, 5097, 1543, 43, 248, "Input"],
Cell[CellGroupData[{
Cell[151486, 5144, 116, 1, 40, "Input"],
Cell[151605, 5147, 4984, 141, 363, "Output"]
}, Closed]],
Cell[156604, 5291, 873, 23, 168, "Input"],
Cell[CellGroupData[{
Cell[157502, 5318, 119, 1, 40, "Input"],
Cell[157624, 5321, 65625, 1729, 7993, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[223298, 7056, 112, 1, 53, "Section"],
Cell[223413, 7059, 303, 6, 63, "Input"],
Cell[223719, 7067, 1571, 43, 372, "Input"],
Cell[CellGroupData[{
Cell[225315, 7114, 118, 1, 60, "Input"],
Cell[225436, 7117, 56150, 1683, 7152, "Output"]
}, Closed]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
