

(*fEk[{w},x,y,z] is k-th two-loop master integral with the transcendental weight w*)

(*two-loop master integrals that can be expressed into GPLs*)
(*w and z in terms of sij,sjk,sik can be found in eq.(3.4) in arXiv:2312.16966*)
(*Note that they are for sij<0,sjk<0, sik>0*)
(*The analytic continuation is needed for other regions, see arXiv:2312.16966*)

twoloopmasterintegralInG={fE1[{0}, sij, sjk, sik] -> 1, fE1[{1}, sij, sjk, sik] -> 0, 
 fE1[{2}, sij, sjk, sik] -> Pi^2/6, fE1[{3}, sij, sjk, sik] -> 
  (-2*Zeta[3])/3, fE1[{4}, sij, sjk, sik] -> (7*Pi^4)/360, 
 fE2[{0}, sij, sjk, sik] -> 0, fE2[{1}, sij, sjk, sik] -> 
  G[-1, w] - G[-1, z] - G[1, w] + G[1, z], fE2[{2}, sij, sjk, sik] -> 
  (G[-1, w] - G[1, w])*(G[-1, z] + G[1, z] - 2*G[w^(-1), z]) + G[-1, -1, w] - 
   G[-1, -1, z] - G[-1, 1, w] + G[-1, 1, z] + G[1, -1, w] - G[1, -1, z] - 
   G[1, 1, w] + G[1, 1, z] + 2*G[w^(-1), -1, z] - 2*G[w^(-1), 1, z], 
 fE2[{3}, sij, sjk, sik] -> (Pi^2*(G[-1, w] - G[-1, z] - G[1, w] + G[1, z]))/
    6 + (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, w] - G[-1, 1, w] + 
     G[1, -1, w] - G[1, 1, w]) + (G[-1, w] - G[1, w])*
    (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w^(-1), z] + G[1, -1, z] + 
     G[1, 1, z] - 2*G[1, w^(-1), z] - 2*G[w^(-1), -1, z] - 
     2*G[w^(-1), 1, z] + 4*G[w^(-1), w^(-1), z]) + G[-1, -1, -1, w] - 
   G[-1, -1, -1, z] - G[-1, -1, 1, w] + G[-1, -1, 1, z] + G[-1, 1, -1, w] - 
   G[-1, 1, -1, z] - G[-1, 1, 1, w] + G[-1, 1, 1, z] + 
   2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + G[1, -1, -1, w] - 
   G[1, -1, -1, z] - G[1, -1, 1, w] + G[1, -1, 1, z] + G[1, 1, -1, w] - 
   G[1, 1, -1, z] - G[1, 1, 1, w] + G[1, 1, 1, z] + 2*G[1, w^(-1), -1, z] - 
   2*G[1, w^(-1), 1, z] + 2*G[w^(-1), -1, -1, z] - 2*G[w^(-1), -1, 1, z] + 
   2*G[w^(-1), 1, -1, z] - 2*G[w^(-1), 1, 1, z] - 
   4*G[w^(-1), w^(-1), -1, z] + 4*G[w^(-1), w^(-1), 1, z], 
 fE2[{4}, sij, sjk, sik] -> 
  (Pi^2*((G[-1, w] - G[1, w])*(G[-1, z] + G[1, z] - 2*G[w^(-1), z]) + 
      G[-1, -1, w] - G[-1, -1, z] - G[-1, 1, w] + G[-1, 1, z] + G[1, -1, w] - 
      G[1, -1, z] - G[1, 1, w] + G[1, 1, z] + 2*G[w^(-1), -1, z] - 
      2*G[w^(-1), 1, z]))/6 + (G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - 
     G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w^(-1), z] + 
     G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z] - 2*G[w^(-1), -1, z] - 
     2*G[w^(-1), 1, z] + 4*G[w^(-1), w^(-1), z]) + 
   (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
     G[-1, -1, 1, w] + G[-1, 1, -1, w] - G[-1, 1, 1, w] + G[1, -1, -1, w] - 
     G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
   (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
     2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), z] - 2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + 
     4*G[-1, w^(-1), w^(-1), z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
     2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 
     2*G[1, 1, w^(-1), z] - 2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z] + 
     4*G[1, w^(-1), w^(-1), z] - 2*G[w^(-1), -1, -1, z] - 
     2*G[w^(-1), -1, 1, z] + 4*G[w^(-1), -1, w^(-1), z] - 
     2*G[w^(-1), 1, -1, z] - 2*G[w^(-1), 1, 1, z] + 
     4*G[w^(-1), 1, w^(-1), z] + 4*G[w^(-1), w^(-1), -1, z] + 
     4*G[w^(-1), w^(-1), 1, z] - 8*G[w^(-1), w^(-1), w^(-1), z]) + 
   G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
   G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
   G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
   2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
   G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - 
   G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
   2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
   2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
   2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
   4*G[-1, w^(-1), w^(-1), -1, z] + 4*G[-1, w^(-1), w^(-1), 1, z] + 
   G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
   G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
   G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
   2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
   G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
   G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
   2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
   2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
   2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
   4*G[1, w^(-1), w^(-1), -1, z] + 4*G[1, w^(-1), w^(-1), 1, z] + 
   2*G[w^(-1), -1, -1, -1, z] - 2*G[w^(-1), -1, -1, 1, z] + 
   2*G[w^(-1), -1, 1, -1, z] - 2*G[w^(-1), -1, 1, 1, z] - 
   4*G[w^(-1), -1, w^(-1), -1, z] + 4*G[w^(-1), -1, w^(-1), 1, z] + 
   2*G[w^(-1), 1, -1, -1, z] - 2*G[w^(-1), 1, -1, 1, z] + 
   2*G[w^(-1), 1, 1, -1, z] - 2*G[w^(-1), 1, 1, 1, z] - 
   4*G[w^(-1), 1, w^(-1), -1, z] + 4*G[w^(-1), 1, w^(-1), 1, z] - 
   4*G[w^(-1), w^(-1), -1, -1, z] + 4*G[w^(-1), w^(-1), -1, 1, z] - 
   4*G[w^(-1), w^(-1), 1, -1, z] + 4*G[w^(-1), w^(-1), 1, 1, z] + 
   8*G[w^(-1), w^(-1), w^(-1), -1, z] - 8*G[w^(-1), w^(-1), w^(-1), 1, z] - 
   (2*(G[-1, w] - G[-1, z] - G[1, w] + G[1, z])*Zeta[3])/3, 
 fE3[{0}, sij, sjk, sik] -> 0, fE3[{1}, sij, sjk, sik] -> 0, 
 fE3[{2}, sij, sjk, sik] -> -2*((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z]) + 
    G[-1, -1, w] + G[-1, -1, z] - G[-1, 1, w] - G[-1, 1, z] - G[1, -1, w] - 
    G[1, -1, z] + G[1, 1, w] + G[1, 1, z]), fE3[{3}, sij, sjk, sik] -> 
  -2*((-G[-1, z] + G[1, z])*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - 
       G[1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
       2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z]) + 
     G[-1, -1, -1, w] + G[-1, -1, -1, z] - G[-1, -1, 1, w] - 
     G[-1, -1, 1, z] + G[-1, 1, -1, w] + G[-1, 1, -1, z] - G[-1, 1, 1, w] - 
     G[-1, 1, 1, z] - 2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - 
     G[1, -1, -1, w] - G[1, -1, -1, z] + G[1, -1, 1, w] + G[1, -1, 1, z] - 
     G[1, 1, -1, w] - G[1, 1, -1, z] + G[1, 1, 1, w] + G[1, 1, 1, z] + 
     2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z]) - 
   4*((G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, w] - G[-1, 1, w] - 
       G[1, -1, w] + G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[-1, -1, z] + G[-1, 1, z] - G[1, -1, z] + G[1, 1, z] + 
       2*G[w^(-1), -1, z] - 2*G[w^(-1), 1, z]) + G[-1, -1, -1, w] + 
     G[-1, -1, -1, z] - G[-1, -1, 1, w] - G[-1, -1, 1, z] - G[-1, 1, -1, w] - 
     G[-1, 1, -1, z] + G[-1, 1, 1, w] + G[-1, 1, 1, z] + G[1, -1, -1, w] + 
     G[1, -1, -1, z] - G[1, -1, 1, w] - G[1, -1, 1, z] - G[1, 1, -1, w] - 
     G[1, 1, -1, z] + G[1, 1, 1, w] + G[1, 1, 1, z] - 
     2*G[w^(-1), -1, -1, z] + 2*G[w^(-1), -1, 1, z] + 2*G[w^(-1), 1, -1, z] - 
     2*G[w^(-1), 1, 1, z]), fE3[{4}, sij, sjk, sik] -> 
  -(Pi^2*((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z]) + G[-1, -1, w] + 
       G[-1, -1, z] - G[-1, 1, w] - G[-1, 1, z] - G[1, -1, w] - G[1, -1, z] + 
       G[1, 1, w] + G[1, 1, z]))/3 - 
   2*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w^(-1), z]) + (-G[-1, z] + G[1, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
       G[-1, -1, 1, z] + 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + 2*G[-1, w^(-1), -1, z] + 
       2*G[-1, w^(-1), 1, z] - 4*G[-1, w^(-1), w^(-1), z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + 
       G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z] - 2*G[1, w^(-1), -1, z] - 
       2*G[1, w^(-1), 1, z] + 4*G[1, w^(-1), w^(-1), z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 2*G[-1, -1, w^(-1), -1, z] + 
     2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
     2*G[-1, w^(-1), -1, -1, z] + 2*G[-1, w^(-1), -1, 1, z] - 
     2*G[-1, w^(-1), 1, -1, z] + 2*G[-1, w^(-1), 1, 1, z] + 
     4*G[-1, w^(-1), w^(-1), -1, z] - 4*G[-1, w^(-1), w^(-1), 1, z] - 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] - G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
     2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
     2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
     4*G[1, w^(-1), w^(-1), -1, z] + 4*G[1, w^(-1), w^(-1), 1, z]) - 
   4*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (-G[-1, -1, z] + G[-1, 1, z] - G[1, -1, z] + G[1, 1, z] + 
       2*G[w^(-1), -1, z] - 2*G[w^(-1), 1, z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] + G[-1, 1, -1, w] - G[-1, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w^(-1), z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 
       2*G[1, 1, w^(-1), z] + 2*G[w^(-1), -1, -1, z] + 
       2*G[w^(-1), -1, 1, z] - 4*G[w^(-1), -1, w^(-1), z] - 
       2*G[w^(-1), 1, -1, z] - 2*G[w^(-1), 1, 1, z] + 
       4*G[w^(-1), 1, w^(-1), z]) + G[-1, -1, -1, -1, w] + 
     G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] + 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w^(-1), -1, z] + 
     2*G[-1, -1, w^(-1), 1, z] - G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
     2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
     2*G[1, -1, w^(-1), 1, z] - G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] - 
     2*G[w^(-1), -1, -1, -1, z] + 2*G[w^(-1), -1, -1, 1, z] - 
     2*G[w^(-1), -1, 1, -1, z] + 2*G[w^(-1), -1, 1, 1, z] + 
     4*G[w^(-1), -1, w^(-1), -1, z] - 4*G[w^(-1), -1, w^(-1), 1, z] + 
     2*G[w^(-1), 1, -1, -1, z] - 2*G[w^(-1), 1, -1, 1, z] + 
     2*G[w^(-1), 1, 1, -1, z] - 2*G[w^(-1), 1, 1, 1, z] - 
     4*G[w^(-1), 1, w^(-1), -1, z] + 4*G[w^(-1), 1, w^(-1), 1, z]) - 
   8*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w^(-1), z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w^(-1), z] - 2*G[w^(-1), -1, z] - 
       2*G[w^(-1), 1, z] + 4*G[w^(-1), w^(-1), z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] - G[-1, 1, -1, w] + G[-1, 1, 1, w] + G[1, -1, -1, w] - 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w^(-1), -1, z] - 
       2*G[-1, w^(-1), 1, z] - G[1, -1, -1, z] + G[1, -1, 1, z] - 
       G[1, 1, -1, z] + G[1, 1, 1, z] + 2*G[1, w^(-1), -1, z] - 
       2*G[1, w^(-1), 1, z] + 2*G[w^(-1), -1, -1, z] - 
       2*G[w^(-1), -1, 1, z] + 2*G[w^(-1), 1, -1, z] - 2*G[w^(-1), 1, 1, z] - 
       4*G[w^(-1), w^(-1), -1, z] + 4*G[w^(-1), w^(-1), 1, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + G[-1, 1, -1, -1, w] + 
     G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] - 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] - 2*G[-1, w^(-1), -1, -1, z] + 
     2*G[-1, w^(-1), -1, 1, z] + 2*G[-1, w^(-1), 1, -1, z] - 
     2*G[-1, w^(-1), 1, 1, z] + G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - 
     G[1, -1, -1, 1, w] - G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - 
     G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + 
     G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] - 2*G[1, w^(-1), -1, -1, z] + 
     2*G[1, w^(-1), -1, 1, z] + 2*G[1, w^(-1), 1, -1, z] - 
     2*G[1, w^(-1), 1, 1, z] - 2*G[w^(-1), -1, -1, -1, z] + 
     2*G[w^(-1), -1, -1, 1, z] + 2*G[w^(-1), -1, 1, -1, z] - 
     2*G[w^(-1), -1, 1, 1, z] - 2*G[w^(-1), 1, -1, -1, z] + 
     2*G[w^(-1), 1, -1, 1, z] + 2*G[w^(-1), 1, 1, -1, z] - 
     2*G[w^(-1), 1, 1, 1, z] + 4*G[w^(-1), w^(-1), -1, -1, z] - 
     4*G[w^(-1), w^(-1), -1, 1, z] - 4*G[w^(-1), w^(-1), 1, -1, z] + 
     4*G[w^(-1), w^(-1), 1, 1, z]), fE4[{0}, sij, sjk, sik] -> 0, 
 fE4[{1}, sij, sjk, sik] -> 0, fE4[{2}, sij, sjk, sik] -> 
  -((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z])) - G[-1, -1, w] - 
   G[-1, -1, z] + G[-1, 1, w] + G[-1, 1, z] + G[1, -1, w] + G[1, -1, z] - 
   G[1, 1, w] - G[1, 1, z], fE4[{3}, sij, sjk, sik] -> 
  -((-G[-1, z] + G[1, z])*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - 
      G[1, 1, w])) - (G[-1, w] - G[1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
     2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z]) - 
   G[-1, -1, -1, w] - G[-1, -1, -1, z] + G[-1, -1, 1, w] + G[-1, -1, 1, z] - 
   G[-1, 1, -1, w] - G[-1, 1, -1, z] + G[-1, 1, 1, w] + G[-1, 1, 1, z] + 
   2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + G[1, -1, -1, w] + 
   G[1, -1, -1, z] - G[1, -1, 1, w] - G[1, -1, 1, z] + G[1, 1, -1, w] + 
   G[1, 1, -1, z] - G[1, 1, 1, w] - G[1, 1, 1, z] - 2*G[1, w^(-1), -1, z] + 
   2*G[1, w^(-1), 1, z], fE4[{4}, sij, sjk, sik] -> 
  -(Pi^2*((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z]) + G[-1, -1, w] + 
       G[-1, -1, z] - G[-1, 1, w] - G[-1, 1, z] - G[1, -1, w] - G[1, -1, z] + 
       G[1, 1, w] + G[1, 1, z]))/6 - 
   (G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
    (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] + G[1, -1, z] + 
     G[1, 1, z] - 2*G[1, w^(-1), z]) - (-G[-1, z] + G[1, z])*
    (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - G[-1, 1, 1, w] + 
     G[1, -1, -1, w] - G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
   (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
     2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
     2*G[-1, 1, w^(-1), z] + 2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - 
     4*G[-1, w^(-1), w^(-1), z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
     2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 
     2*G[1, 1, w^(-1), z] - 2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z] + 
     4*G[1, w^(-1), w^(-1), z]) - G[-1, -1, -1, -1, w] - 
   G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 
   G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + 
   G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
   2*G[-1, -1, w^(-1), 1, z] - G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + 
   G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - 
   G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
   2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
   2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
   2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
   4*G[-1, w^(-1), w^(-1), -1, z] + 4*G[-1, w^(-1), w^(-1), 1, z] + 
   G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
   G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - 
   G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
   2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
   G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + 
   G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
   2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] - 
   2*G[1, w^(-1), -1, -1, z] + 2*G[1, w^(-1), -1, 1, z] - 
   2*G[1, w^(-1), 1, -1, z] + 2*G[1, w^(-1), 1, 1, z] + 
   4*G[1, w^(-1), w^(-1), -1, z] - 4*G[1, w^(-1), w^(-1), 1, z], 
 fE5[{0}, sij, sjk, sik] -> 0, fE5[{1}, sij, sjk, sik] -> 0, 
 fE5[{2}, sij, sjk, sik] -> 0, fE5[{3}, sij, sjk, sik] -> 
  3*((-G[-1, z] + G[1, z])*(G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + 
      G[1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, z] - G[-1, 1, z] - 
      G[1, -1, z] + G[1, 1, z]) + G[-1, -1, -1, w] - G[-1, -1, -1, z] - 
    G[-1, -1, 1, w] + G[-1, -1, 1, z] - G[-1, 1, -1, w] + G[-1, 1, -1, z] + 
    G[-1, 1, 1, w] - G[-1, 1, 1, z] - G[1, -1, -1, w] + G[1, -1, -1, z] + 
    G[1, -1, 1, w] - G[1, -1, 1, z] + G[1, 1, -1, w] - G[1, 1, -1, z] - 
    G[1, 1, 1, w] + G[1, 1, 1, z]), fE5[{4}, sij, sjk, sik] -> 
  3*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[-1, -1, -1, z] + G[-1, -1, 1, z] - 2*G[-1, -1, w^(-1), z] - 
       G[-1, 1, -1, z] - G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] - 
       G[1, -1, -1, z] - G[1, -1, 1, z] + 2*G[1, -1, w^(-1), z] + 
       G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] - G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z]) + 
   4*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w^(-1), z]) + (-G[-1, z] + G[1, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] - 
       G[-1, -1, 1, z] + G[-1, 1, -1, z] - G[-1, 1, 1, z] - 
       2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - G[1, -1, -1, z] + 
       G[1, -1, 1, z] - G[1, 1, -1, z] + G[1, 1, 1, z] + 
       2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z]) + G[-1, -1, -1, -1, w] - 
     G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] - 
     2*G[-1, w^(-1), 1, -1, z] + 2*G[-1, w^(-1), 1, 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] - G[1, 1, -1, -1, w] + 
     G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] - 2*G[1, w^(-1), -1, -1, z] + 
     2*G[1, w^(-1), -1, 1, z] + 2*G[1, w^(-1), 1, -1, z] - 
     2*G[1, w^(-1), 1, 1, z]) + 
   3*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (-G[-1, -1, z] + G[-1, 1, z] - G[1, -1, z] + G[1, 1, z] + 
       2*G[w^(-1), -1, z] - 2*G[w^(-1), 1, z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] - G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] - G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - 
       G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[w^(-1), -1, -1, z] + 
       2*G[w^(-1), -1, 1, z] + 2*G[w^(-1), 1, -1, z] - 
       2*G[w^(-1), 1, 1, z]) + G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] + 
     G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[w^(-1), -1, -1, -1, z] - 2*G[w^(-1), -1, -1, 1, z] - 
     2*G[w^(-1), -1, 1, -1, z] + 2*G[w^(-1), -1, 1, 1, z] - 
     2*G[w^(-1), 1, -1, -1, z] + 2*G[w^(-1), 1, -1, 1, z] + 
     2*G[w^(-1), 1, 1, -1, z] - 2*G[w^(-1), 1, 1, 1, z]), 
 fE6[{0}, sij, sjk, sik] -> 0, fE6[{1}, sij, sjk, sik] -> 0, 
 fE6[{2}, sij, sjk, sik] -> 2*((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z]) + 
    G[-1, -1, w] + G[-1, -1, z] - G[-1, 1, w] - G[-1, 1, z] - G[1, -1, w] - 
    G[1, -1, z] + G[1, 1, w] + G[1, 1, z]), fE6[{3}, sij, sjk, sik] -> 
  6*((-G[-1, z] + G[1, z])*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - 
       G[1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
       2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z]) + 
     G[-1, -1, -1, w] + G[-1, -1, -1, z] - G[-1, -1, 1, w] - 
     G[-1, -1, 1, z] + G[-1, 1, -1, w] + G[-1, 1, -1, z] - G[-1, 1, 1, w] - 
     G[-1, 1, 1, z] - 2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - 
     G[1, -1, -1, w] - G[1, -1, -1, z] + G[1, -1, 1, w] + G[1, -1, 1, z] - 
     G[1, 1, -1, w] - G[1, 1, -1, z] + G[1, 1, 1, w] + G[1, 1, 1, z] + 
     2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z]) - 
   2*((-G[-1, z] + G[1, z])*(-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 
       2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w, z]) - G[-1, -1, -1, w] - G[-1, -1, -1, z] + 
     G[-1, -1, 1, w] + G[-1, -1, 1, z] + 2*G[-1, 0, -1, w] - 
     2*G[-1, 0, 1, w] - G[-1, 1, -1, w] - G[-1, 1, -1, z] + G[-1, 1, 1, w] + 
     G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] + 
     G[1, -1, -1, w] + G[1, -1, -1, z] - G[1, -1, 1, w] - G[1, -1, 1, z] - 
     2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] + G[1, 1, -1, z] - 
     G[1, 1, 1, w] - G[1, 1, 1, z] - 2*G[1, w, -1, z] + 2*G[1, w, 1, z]) + 
   2*((-G[-1, z] - G[1, z] + 2*G[w, z])*(G[-1, -1, w] - G[-1, 1, w] - 
       G[1, -1, w] + G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
       2*G[w, -1, z] + 2*G[w, 1, z]) - G[-1, -1, -1, w] - G[-1, -1, -1, z] + 
     G[-1, -1, 1, w] + G[-1, -1, 1, z] + G[-1, 1, -1, w] + G[-1, 1, -1, z] - 
     G[-1, 1, 1, w] - G[-1, 1, 1, z] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
     2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] - G[1, -1, -1, z] + 
     G[1, -1, 1, w] + G[1, -1, 1, z] + G[1, 1, -1, w] + G[1, 1, -1, z] - 
     G[1, 1, 1, w] - G[1, 1, 1, z] + 2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] - 
     2*G[w, 1, -1, z] + 2*G[w, 1, 1, z]), fE6[{4}, sij, sjk, sik] -> 
  (Pi^2*((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z]) + G[-1, -1, w] + 
      G[-1, -1, z] - G[-1, 1, w] - G[-1, 1, z] - G[1, -1, w] - G[1, -1, z] + 
      G[1, 1, w] + G[1, 1, z]))/3 - 
   12*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
       G[1, 1, -1, w] - G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[-1, -1, -1, z] + G[-1, -1, 1, z] + G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - G[1, 1, -1, z] + 
       G[1, 1, 1, z]) + G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - 
     G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z]) + 
   18*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w^(-1), z]) + (-G[-1, z] + G[1, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
       G[-1, -1, 1, z] + 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + 2*G[-1, w^(-1), -1, z] + 
       2*G[-1, w^(-1), 1, z] - 4*G[-1, w^(-1), w^(-1), z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + 
       G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z] - 2*G[1, w^(-1), -1, z] - 
       2*G[1, w^(-1), 1, z] + 4*G[1, w^(-1), w^(-1), z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 2*G[-1, -1, w^(-1), -1, z] + 
     2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
     2*G[-1, w^(-1), -1, -1, z] + 2*G[-1, w^(-1), -1, 1, z] - 
     2*G[-1, w^(-1), 1, -1, z] + 2*G[-1, w^(-1), 1, 1, z] + 
     4*G[-1, w^(-1), w^(-1), -1, z] - 4*G[-1, w^(-1), w^(-1), 1, z] - 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] - G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
     2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
     2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
     4*G[1, w^(-1), w^(-1), -1, z] + 4*G[1, w^(-1), w^(-1), 1, z]) - 
   6*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
       2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z]) + 
     (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
       2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 2*G[1, 0, -1, w] - 
       2*G[1, 0, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] - 2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + 
       4*G[-1, w^(-1), w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z] + 
       2*G[1, w^(-1), -1, z] + 2*G[1, w^(-1), 1, z] - 4*G[1, w^(-1), w, z]) - 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + 2*G[-1, -1, 0, -1, w] - 2*G[-1, -1, 0, 1, w] - 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 2*G[-1, -1, w, 1, z] - 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + 2*G[-1, 1, 0, -1, w] - 2*G[-1, 1, 0, 1, w] - 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
     2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
     4*G[-1, w^(-1), w, -1, z] + 4*G[-1, w^(-1), w, 1, z] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 2*G[1, -1, w, 1, z] + 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 2*G[1, 1, 0, 1, w] + 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[1, 1, w, -1, z] + 2*G[1, 1, w, 1, z] - 
     2*G[1, w^(-1), -1, -1, z] + 2*G[1, w^(-1), -1, 1, z] - 
     2*G[1, w^(-1), 1, -1, z] + 2*G[1, w^(-1), 1, 1, z] + 
     4*G[1, w^(-1), w, -1, z] - 4*G[1, w^(-1), w, 1, z]) - 
   6*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w, z]) + (-G[-1, z] + G[1, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
       2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w^(-1), z] - 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] + 
       4*G[-1, w, w^(-1), z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 
       2*G[1, 1, w^(-1), z] + 2*G[1, w, -1, z] + 2*G[1, w, 1, z] - 
       4*G[1, w, w^(-1), z]) - G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] + 
     G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - 
     G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 
     2*G[-1, -1, w^(-1), -1, z] - 2*G[-1, -1, w^(-1), 1, z] + 
     2*G[-1, 0, -1, -1, w] - 2*G[-1, 0, -1, 1, w] + 2*G[-1, 0, 1, -1, w] - 
     2*G[-1, 0, 1, 1, w] - G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
     2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[-1, w, -1, -1, z] - 2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 
     2*G[-1, w, 1, 1, z] - 4*G[-1, w, w^(-1), -1, z] + 
     4*G[-1, w, w^(-1), 1, z] + G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - 
     G[1, -1, -1, 1, w] - G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] + 
     G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 
     2*G[1, -1, w^(-1), -1, z] + 2*G[1, -1, w^(-1), 1, z] - 
     2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] - 2*G[1, 0, 1, -1, w] + 
     2*G[1, 0, 1, 1, w] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
     2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] - 
     2*G[1, w, -1, -1, z] + 2*G[1, w, -1, 1, z] - 2*G[1, w, 1, -1, z] + 
     2*G[1, w, 1, 1, z] + 4*G[1, w, w^(-1), -1, z] - 
     4*G[1, w, w^(-1), 1, z]) + 
   2*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 
       2*G[-1, w, z] - G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 
       4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 2*G[0, 1, -1, w] + 
       2*G[0, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w, z] + 2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - 
       4*G[-1, w, w, z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] - 
       2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 4*G[1, w, w, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] - 
     2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] + 4*G[-1, 0, 0, -1, w] - 
     4*G[-1, 0, 0, 1, w] - 2*G[-1, 0, 1, -1, w] + 2*G[-1, 0, 1, 1, w] + 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - 
     G[-1, 1, 1, 1, z] - 2*G[-1, 1, w, -1, z] + 2*G[-1, 1, w, 1, z] - 
     2*G[-1, w, -1, -1, z] + 2*G[-1, w, -1, 1, z] - 2*G[-1, w, 1, -1, z] + 
     2*G[-1, w, 1, 1, z] + 4*G[-1, w, w, -1, z] - 4*G[-1, w, w, 1, z] - 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] + 2*G[1, -1, 0, -1, w] - 2*G[1, -1, 0, 1, w] - 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] + 
     2*G[1, 0, -1, -1, w] - 2*G[1, 0, -1, 1, w] - 4*G[1, 0, 0, -1, w] + 
     4*G[1, 0, 0, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] - 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] + 
     2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 
     2*G[1, w, 1, 1, z] - 4*G[1, w, w, -1, z] + 4*G[1, w, w, 1, z]) + 
   6*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
       2*G[w, -1, z] + 2*G[w, 1, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + 
       G[-1, -1, 1, z] - 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - 
       G[1, 1, 1, z] + 2*G[1, 1, w^(-1), z] - 2*G[w, -1, -1, z] - 
       2*G[w, -1, 1, z] + 4*G[w, -1, w^(-1), z] + 2*G[w, 1, -1, z] + 
       2*G[w, 1, 1, z] - 4*G[w, 1, w^(-1), z]) - G[-1, -1, -1, -1, w] - 
     G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
     2*G[0, -1, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] - 
     2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] - G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
     2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 4*G[w, -1, w^(-1), -1, z] + 
     4*G[w, -1, w^(-1), 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 
     2*G[w, 1, 1, -1, z] + 2*G[w, 1, 1, 1, z] + 4*G[w, 1, w^(-1), -1, z] - 
     4*G[w, 1, w^(-1), 1, z]) - 
   2*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - 
       G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]) + 
     (-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
       2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 
       2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] + 
       2*G[w, -1, -1, z] + 2*G[w, -1, 1, z] - 4*G[w, -1, w, z] - 
       2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] + 4*G[w, 1, w, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] - 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + 2*G[-1, 1, 0, -1, w] - 2*G[-1, 1, 0, 1, w] - 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 4*G[0, -1, 0, -1, w] - 
     4*G[0, -1, 0, 1, w] - 2*G[0, -1, 1, -1, w] + 2*G[0, -1, 1, 1, w] + 
     2*G[0, 1, -1, -1, w] - 2*G[0, 1, -1, 1, w] - 4*G[0, 1, 0, -1, w] + 
     4*G[0, 1, 0, 1, w] + 2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 2*G[1, -1, w, 1, z] - 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] - 2*G[w, -1, 1, -1, z] + 
     2*G[w, -1, 1, 1, z] + 4*G[w, -1, w, -1, z] - 4*G[w, -1, w, 1, z] + 
     2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 2*G[w, 1, 1, -1, z] - 
     2*G[w, 1, 1, 1, z] - 4*G[w, 1, w, -1, z] + 4*G[w, 1, w, 1, z]) + 
   2*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 2*G[w, 1, z] + 
       4*G[w, w, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] - G[1, -1, -1, z] + G[1, -1, 1, z] - G[1, 1, -1, z] + 
       G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 
       2*G[w, 1, 1, z] - 4*G[w, w, -1, z] + 4*G[w, w, 1, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 2*G[-1, 0, -1, -1, w] + 
     2*G[-1, 0, -1, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] + 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] - 2*G[-1, w, -1, -1, z] + 
     2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
     2*G[0, -1, 1, 1, w] + 4*G[0, 0, -1, -1, w] - 4*G[0, 0, -1, 1, w] - 
     4*G[0, 0, 1, -1, w] + 4*G[0, 0, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 
     2*G[0, 1, -1, 1, w] + 2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] - 2*G[1, 0, -1, -1, w] + 
     2*G[1, 0, -1, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] + 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + 
     G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] - 2*G[1, w, -1, -1, z] + 
     2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 2*G[1, w, 1, 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] + 
     2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] + 4*G[w, w, -1, -1, z] - 
     4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z]), 
 fE7[{0}, sij, sjk, sik] -> 0, fE7[{1}, sij, sjk, sik] -> 
  -2*(G[-1, w] - G[-1, z] - G[1, w] + G[1, z]), 
 fE7[{2}, sij, sjk, sik] -> 
  -6*((G[-1, w] - G[1, w])*(G[-1, z] + G[1, z] - 2*G[w^(-1), z]) + 
     G[-1, -1, w] - G[-1, -1, z] - G[-1, 1, w] + G[-1, 1, z] + G[1, -1, w] - 
     G[1, -1, z] - G[1, 1, w] + G[1, 1, z] + 2*G[w^(-1), -1, z] - 
     2*G[w^(-1), 1, z]) + 
   2*((G[-1, w] - G[1, w])*(-G[-1, z] - G[1, z] + 2*G[w, z]) - G[-1, -1, w] + 
     G[-1, -1, z] + G[-1, 1, w] - G[-1, 1, z] + 2*G[0, -1, w] - 
     2*G[0, 1, w] - G[1, -1, w] + G[1, -1, z] + G[1, 1, w] - G[1, 1, z] - 
     2*G[w, -1, z] + 2*G[w, 1, z]), fE7[{3}, sij, sjk, sik] -> 
  -(Pi^2*(G[-1, w] - G[-1, z] - G[1, w] + G[1, z]))/3 + 
   12*((-G[-1, z] + G[1, z])*(G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + 
       G[1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, z] - G[-1, 1, z] - 
       G[1, -1, z] + G[1, 1, z]) + G[-1, -1, -1, w] - G[-1, -1, -1, z] - 
     G[-1, -1, 1, w] + G[-1, -1, 1, z] - G[-1, 1, -1, w] + G[-1, 1, -1, z] + 
     G[-1, 1, 1, w] - G[-1, 1, 1, z] - G[1, -1, -1, w] + G[1, -1, -1, z] + 
     G[1, -1, 1, w] - G[1, -1, 1, z] + G[1, 1, -1, w] - G[1, 1, -1, z] - 
     G[1, 1, 1, w] + G[1, 1, 1, z]) - 
   18*((G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, w] - G[-1, 1, w] + 
       G[1, -1, w] - G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w^(-1), z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w^(-1), z] - 2*G[w^(-1), -1, z] - 
       2*G[w^(-1), 1, z] + 4*G[w^(-1), w^(-1), z]) + G[-1, -1, -1, w] - 
     G[-1, -1, -1, z] - G[-1, -1, 1, w] + G[-1, -1, 1, z] + G[-1, 1, -1, w] - 
     G[-1, 1, -1, z] - G[-1, 1, 1, w] + G[-1, 1, 1, z] + 
     2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + G[1, -1, -1, w] - 
     G[1, -1, -1, z] - G[1, -1, 1, w] + G[1, -1, 1, z] + G[1, 1, -1, w] - 
     G[1, 1, -1, z] - G[1, 1, 1, w] + G[1, 1, 1, z] + 2*G[1, w^(-1), -1, z] - 
     2*G[1, w^(-1), 1, z] + 2*G[w^(-1), -1, -1, z] - 2*G[w^(-1), -1, 1, z] + 
     2*G[w^(-1), 1, -1, z] - 2*G[w^(-1), 1, 1, z] - 
     4*G[w^(-1), w^(-1), -1, z] + 4*G[w^(-1), w^(-1), 1, z]) + 
   6*((G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(-G[-1, -1, w] + G[-1, 1, w] + 
       2*G[0, -1, w] - 2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w, z] - 
       G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z] + 2*G[w^(-1), -1, z] + 
       2*G[w^(-1), 1, z] - 4*G[w^(-1), w, z]) - G[-1, -1, -1, w] + 
     G[-1, -1, -1, z] + G[-1, -1, 1, w] - G[-1, -1, 1, z] + 
     2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
     G[-1, 1, -1, z] + G[-1, 1, 1, w] - G[-1, 1, 1, z] - 2*G[-1, w, -1, z] + 
     2*G[-1, w, 1, z] - G[1, -1, -1, w] + G[1, -1, -1, z] + G[1, -1, 1, w] - 
     G[1, -1, 1, z] + 2*G[1, 0, -1, w] - 2*G[1, 0, 1, w] - G[1, 1, -1, w] + 
     G[1, 1, -1, z] + G[1, 1, 1, w] - G[1, 1, 1, z] - 2*G[1, w, -1, z] + 
     2*G[1, w, 1, z] - 2*G[w^(-1), -1, -1, z] + 2*G[w^(-1), -1, 1, z] - 
     2*G[w^(-1), 1, -1, z] + 2*G[w^(-1), 1, 1, z] + 4*G[w^(-1), w, -1, z] - 
     4*G[w^(-1), w, 1, z]) + 
   6*((-G[-1, z] - G[1, z] + 2*G[w, z])*(G[-1, -1, w] - G[-1, 1, w] + 
       G[1, -1, w] - G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w^(-1), z] + 2*G[w, -1, z] + 2*G[w, 1, z] - 
       4*G[w, w^(-1), z]) - G[-1, -1, -1, w] + G[-1, -1, -1, z] + 
     G[-1, -1, 1, w] - G[-1, -1, 1, z] - G[-1, 1, -1, w] + G[-1, 1, -1, z] + 
     G[-1, 1, 1, w] - G[-1, 1, 1, z] - 2*G[-1, w^(-1), -1, z] + 
     2*G[-1, w^(-1), 1, z] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
     2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, -1, z] + 
     G[1, -1, 1, w] - G[1, -1, 1, z] - G[1, 1, -1, w] + G[1, 1, -1, z] + 
     G[1, 1, 1, w] - G[1, 1, 1, z] - 2*G[1, w^(-1), -1, z] + 
     2*G[1, w^(-1), 1, z] - 2*G[w, -1, -1, z] + 2*G[w, -1, 1, z] - 
     2*G[w, 1, -1, z] + 2*G[w, 1, 1, z] + 4*G[w, w^(-1), -1, z] - 
     4*G[w, w^(-1), 1, z]) - 
   2*((-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, w] + G[-1, 1, w] + 
       2*G[0, -1, w] - 2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + 
       G[1, -1, z] + G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 
       2*G[w, 1, z] + 4*G[w, w, z]) + G[-1, -1, -1, w] - G[-1, -1, -1, z] - 
     G[-1, -1, 1, w] + G[-1, -1, 1, z] - 2*G[-1, 0, -1, w] + 
     2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - G[-1, 1, -1, z] - G[-1, 1, 1, w] + 
     G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] - 
     2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 4*G[0, 0, -1, w] - 
     4*G[0, 0, 1, w] - 2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] + G[1, -1, -1, w] - 
     G[1, -1, -1, z] - G[1, -1, 1, w] + G[1, -1, 1, z] - 2*G[1, 0, -1, w] + 
     2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, -1, z] - G[1, 1, 1, w] + 
     G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 2*G[w, -1, -1, z] - 
     2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] - 
     4*G[w, w, -1, z] + 4*G[w, w, 1, z]), fE7[{4}, sij, sjk, sik] -> 
  -(Pi^2*((G[-1, w] - G[1, w])*(G[-1, z] + G[1, z] - 2*G[w^(-1), z]) + 
      G[-1, -1, w] - G[-1, -1, z] - G[-1, 1, w] + G[-1, 1, z] + G[1, -1, w] - 
      G[1, -1, z] - G[1, 1, w] + G[1, 1, z] + 2*G[w^(-1), -1, z] - 
      2*G[w^(-1), 1, z])) + 
   (Pi^2*((G[-1, w] - G[1, w])*(-G[-1, z] - G[1, z] + 2*G[w, z]) - 
      G[-1, -1, w] + G[-1, -1, z] + G[-1, 1, w] - G[-1, 1, z] + 
      2*G[0, -1, w] - 2*G[0, 1, w] - G[1, -1, w] + G[1, -1, z] + G[1, 1, w] - 
      G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]))/3 + 
   36*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[-1, -1, -1, z] + G[-1, -1, 1, z] - 2*G[-1, -1, w^(-1), z] - 
       G[-1, 1, -1, z] - G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] - 
       G[1, -1, -1, z] - G[1, -1, 1, z] + 2*G[1, -1, w^(-1), z] + 
       G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] - G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z]) - 
   12*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + 
       G[1, 1, z]) + (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + 
       G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + 2*G[-1, -1, 0, -1, w] - 2*G[-1, -1, 0, 1, w] - 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] - 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[1, 1, w, -1, z] + 2*G[1, 1, w, 1, z]) + 
   12*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w, z]) + (-G[-1, z] + G[1, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] + G[1, 1, -1, z] - 
       G[1, 1, 1, z] - 2*G[1, w, -1, z] + 2*G[1, w, 1, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, 0, -1, -1, w] - 
     2*G[-1, 0, -1, 1, w] - 2*G[-1, 0, 1, -1, w] + 2*G[-1, 0, 1, 1, w] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] - 2*G[-1, w, -1, -1, z] + 
     2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, 0, -1, -1, w] + 
     2*G[1, 0, -1, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] + 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + 
     G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] + 2*G[1, w, -1, -1, z] - 
     2*G[1, w, -1, 1, z] - 2*G[1, w, 1, -1, z] + 2*G[1, w, 1, 1, z]) + 
   36*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (-G[-1, -1, z] + G[-1, 1, z] - G[1, -1, z] + G[1, 1, z] + 
       2*G[w^(-1), -1, z] - 2*G[w^(-1), 1, z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] - G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] - G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - 
       G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[w^(-1), -1, -1, z] + 
       2*G[w^(-1), -1, 1, z] + 2*G[w^(-1), 1, -1, z] - 
       2*G[w^(-1), 1, 1, z]) + G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] + 
     G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[w^(-1), -1, -1, -1, z] - 2*G[w^(-1), -1, -1, 1, z] - 
     2*G[w^(-1), -1, 1, -1, z] + 2*G[w^(-1), -1, 1, 1, z] - 
     2*G[w^(-1), 1, -1, -1, z] + 2*G[w^(-1), 1, -1, 1, z] + 
     2*G[w^(-1), 1, 1, -1, z] - 2*G[w^(-1), 1, 1, 1, z]) - 
   54*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w^(-1), z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w^(-1), z] - 2*G[w^(-1), -1, z] - 
       2*G[w^(-1), 1, z] + 4*G[w^(-1), w^(-1), z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] + G[-1, 1, -1, w] - G[-1, 1, 1, w] + G[1, -1, -1, w] - 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w^(-1), z] - 2*G[-1, w^(-1), -1, z] - 
       2*G[-1, w^(-1), 1, z] + 4*G[-1, w^(-1), w^(-1), z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + 
       G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z] - 2*G[1, w^(-1), -1, z] - 
       2*G[1, w^(-1), 1, z] + 4*G[1, w^(-1), w^(-1), z] - 
       2*G[w^(-1), -1, -1, z] - 2*G[w^(-1), -1, 1, z] + 
       4*G[w^(-1), -1, w^(-1), z] - 2*G[w^(-1), 1, -1, z] - 
       2*G[w^(-1), 1, 1, z] + 4*G[w^(-1), 1, w^(-1), z] + 
       4*G[w^(-1), w^(-1), -1, z] + 4*G[w^(-1), w^(-1), 1, z] - 
       8*G[w^(-1), w^(-1), w^(-1), z]) + G[-1, -1, -1, -1, w] - 
     G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] + 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
     2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
     2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
     4*G[-1, w^(-1), w^(-1), -1, z] + 4*G[-1, w^(-1), w^(-1), 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
     2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
     2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
     4*G[1, w^(-1), w^(-1), -1, z] + 4*G[1, w^(-1), w^(-1), 1, z] + 
     2*G[w^(-1), -1, -1, -1, z] - 2*G[w^(-1), -1, -1, 1, z] + 
     2*G[w^(-1), -1, 1, -1, z] - 2*G[w^(-1), -1, 1, 1, z] - 
     4*G[w^(-1), -1, w^(-1), -1, z] + 4*G[w^(-1), -1, w^(-1), 1, z] + 
     2*G[w^(-1), 1, -1, -1, z] - 2*G[w^(-1), 1, -1, 1, z] + 
     2*G[w^(-1), 1, 1, -1, z] - 2*G[w^(-1), 1, 1, 1, z] - 
     4*G[w^(-1), 1, w^(-1), -1, z] + 4*G[w^(-1), 1, w^(-1), 1, z] - 
     4*G[w^(-1), w^(-1), -1, -1, z] + 4*G[w^(-1), w^(-1), -1, 1, z] - 
     4*G[w^(-1), w^(-1), 1, -1, z] + 4*G[w^(-1), w^(-1), 1, 1, z] + 
     8*G[w^(-1), w^(-1), w^(-1), -1, z] - 
     8*G[w^(-1), w^(-1), w^(-1), 1, z]) + 
   18*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 
       2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z] - 
       2*G[w^(-1), -1, z] - 2*G[w^(-1), 1, z] + 4*G[w^(-1), w^(-1), z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(-G[-1, -1, -1, w] + 
       G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
       2*G[1, 0, -1, w] - 2*G[1, 0, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w, z] + 2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - 
       4*G[-1, w^(-1), w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z] + 
       2*G[1, w^(-1), -1, z] + 2*G[1, w^(-1), 1, z] - 4*G[1, w^(-1), w, z] + 
       2*G[w^(-1), -1, -1, z] + 2*G[w^(-1), -1, 1, z] - 
       4*G[w^(-1), -1, w, z] + 2*G[w^(-1), 1, -1, z] + 2*G[w^(-1), 1, 1, z] - 
       4*G[w^(-1), 1, w, z] - 4*G[w^(-1), w^(-1), -1, z] - 
       4*G[w^(-1), w^(-1), 1, z] + 8*G[w^(-1), w^(-1), w, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + 2*G[-1, -1, 0, -1, w] - 2*G[-1, -1, 0, 1, w] - 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] + 2*G[-1, 1, 0, -1, w] - 2*G[-1, 1, 0, 1, w] - 
     G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - 
     G[-1, 1, 1, 1, z] - 2*G[-1, 1, w, -1, z] + 2*G[-1, 1, w, 1, z] - 
     2*G[-1, w^(-1), -1, -1, z] + 2*G[-1, w^(-1), -1, 1, z] - 
     2*G[-1, w^(-1), 1, -1, z] + 2*G[-1, w^(-1), 1, 1, z] + 
     4*G[-1, w^(-1), w, -1, z] - 4*G[-1, w^(-1), w, 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] + 2*G[1, -1, 0, -1, w] - 2*G[1, -1, 0, 1, w] - 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 2*G[1, -1, w, 1, z] - 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[1, 1, w, -1, z] + 2*G[1, 1, w, 1, z] - 
     2*G[1, w^(-1), -1, -1, z] + 2*G[1, w^(-1), -1, 1, z] - 
     2*G[1, w^(-1), 1, -1, z] + 2*G[1, w^(-1), 1, 1, z] + 
     4*G[1, w^(-1), w, -1, z] - 4*G[1, w^(-1), w, 1, z] - 
     2*G[w^(-1), -1, -1, -1, z] + 2*G[w^(-1), -1, -1, 1, z] - 
     2*G[w^(-1), -1, 1, -1, z] + 2*G[w^(-1), -1, 1, 1, z] + 
     4*G[w^(-1), -1, w, -1, z] - 4*G[w^(-1), -1, w, 1, z] - 
     2*G[w^(-1), 1, -1, -1, z] + 2*G[w^(-1), 1, -1, 1, z] - 
     2*G[w^(-1), 1, 1, -1, z] + 2*G[w^(-1), 1, 1, 1, z] + 
     4*G[w^(-1), 1, w, -1, z] - 4*G[w^(-1), 1, w, 1, z] + 
     4*G[w^(-1), w^(-1), -1, -1, z] - 4*G[w^(-1), w^(-1), -1, 1, z] + 
     4*G[w^(-1), w^(-1), 1, -1, z] - 4*G[w^(-1), w^(-1), 1, 1, z] - 
     8*G[w^(-1), w^(-1), w, -1, z] + 8*G[w^(-1), w^(-1), w, 1, z]) + 
   18*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w, z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w, z] + 2*G[w^(-1), -1, z] + 2*G[w^(-1), 1, z] - 
       4*G[w^(-1), w, z]) + (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
       2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w^(-1), z] + 2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - 
       4*G[-1, w, w^(-1), z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 
       2*G[1, 1, w^(-1), z] + 2*G[1, w, -1, z] + 2*G[1, w, 1, z] - 
       4*G[1, w, w^(-1), z] + 2*G[w^(-1), -1, -1, z] + 
       2*G[w^(-1), -1, 1, z] - 4*G[w^(-1), -1, w^(-1), z] + 
       2*G[w^(-1), 1, -1, z] + 2*G[w^(-1), 1, 1, z] - 
       4*G[w^(-1), 1, w^(-1), z] - 4*G[w^(-1), w, -1, z] - 
       4*G[w^(-1), w, 1, z] + 8*G[w^(-1), w, w^(-1), z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 2*G[-1, -1, w^(-1), -1, z] + 
     2*G[-1, -1, w^(-1), 1, z] + 2*G[-1, 0, -1, -1, w] - 
     2*G[-1, 0, -1, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] + 
     G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 2*G[-1, 1, w^(-1), -1, z] + 
     2*G[-1, 1, w^(-1), 1, z] - 2*G[-1, w, -1, -1, z] + 
     2*G[-1, w, -1, 1, z] - 2*G[-1, w, 1, -1, z] + 2*G[-1, w, 1, 1, z] + 
     4*G[-1, w, w^(-1), -1, z] - 4*G[-1, w, w^(-1), 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
     2*G[1, -1, w^(-1), 1, z] + 2*G[1, 0, -1, -1, w] - 2*G[1, 0, -1, 1, w] + 
     2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] - G[1, 1, -1, -1, w] + 
     G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] - 
     2*G[1, w, -1, -1, z] + 2*G[1, w, -1, 1, z] - 2*G[1, w, 1, -1, z] + 
     2*G[1, w, 1, 1, z] + 4*G[1, w, w^(-1), -1, z] - 
     4*G[1, w, w^(-1), 1, z] - 2*G[w^(-1), -1, -1, -1, z] + 
     2*G[w^(-1), -1, -1, 1, z] - 2*G[w^(-1), -1, 1, -1, z] + 
     2*G[w^(-1), -1, 1, 1, z] + 4*G[w^(-1), -1, w^(-1), -1, z] - 
     4*G[w^(-1), -1, w^(-1), 1, z] - 2*G[w^(-1), 1, -1, -1, z] + 
     2*G[w^(-1), 1, -1, 1, z] - 2*G[w^(-1), 1, 1, -1, z] + 
     2*G[w^(-1), 1, 1, 1, z] + 4*G[w^(-1), 1, w^(-1), -1, z] - 
     4*G[w^(-1), 1, w^(-1), 1, z] + 4*G[w^(-1), w, -1, -1, z] - 
     4*G[w^(-1), w, -1, 1, z] + 4*G[w^(-1), w, 1, -1, z] - 
     4*G[w^(-1), w, 1, 1, z] - 8*G[w^(-1), w, w^(-1), -1, z] + 
     8*G[w^(-1), w, w^(-1), 1, z]) - 
   6*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
       2*G[-1, w, z] - G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z] + 
       2*G[w^(-1), -1, z] + 2*G[w^(-1), 1, z] - 4*G[w^(-1), w, z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] - 2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 
       2*G[0, -1, 1, w] + 4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] + G[1, -1, -1, w] - 
       G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + 
       G[-1, -1, 1, z] - 2*G[-1, -1, w, z] + G[-1, 1, -1, z] + 
       G[-1, 1, 1, z] - 2*G[-1, 1, w, z] - 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] + 4*G[-1, w, w, z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 
       2*G[1, 1, w, z] - 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
       4*G[1, w, w, z] - 2*G[w^(-1), -1, -1, z] - 2*G[w^(-1), -1, 1, z] + 
       4*G[w^(-1), -1, w, z] - 2*G[w^(-1), 1, -1, z] - 2*G[w^(-1), 1, 1, z] + 
       4*G[w^(-1), 1, w, z] + 4*G[w^(-1), w, -1, z] + 4*G[w^(-1), w, 1, z] - 
       8*G[w^(-1), w, w, z]) + G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 
     2*G[-1, -1, 0, 1, w] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 
     2*G[-1, -1, w, 1, z] - 2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] + 
     4*G[-1, 0, 0, -1, w] - 4*G[-1, 0, 0, 1, w] - 2*G[-1, 0, 1, -1, w] + 
     2*G[-1, 0, 1, 1, w] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 
     2*G[-1, 1, 0, 1, w] + G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 
     2*G[-1, 1, w, 1, z] + 2*G[-1, w, -1, -1, z] - 2*G[-1, w, -1, 1, z] + 
     2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] - 4*G[-1, w, w, -1, z] + 
     4*G[-1, w, w, 1, z] + G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - 
     G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 
     2*G[1, -1, 0, 1, w] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 
     2*G[1, -1, w, 1, z] - 2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] + 
     4*G[1, 0, 0, -1, w] - 4*G[1, 0, 0, 1, w] - 2*G[1, 0, 1, -1, w] + 
     2*G[1, 0, 1, 1, w] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 
     2*G[1, 1, 0, 1, w] + G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - 
     G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 
     2*G[1, 1, w, 1, z] + 2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 
     2*G[1, w, 1, -1, z] - 2*G[1, w, 1, 1, z] - 4*G[1, w, w, -1, z] + 
     4*G[1, w, w, 1, z] + 2*G[w^(-1), -1, -1, -1, z] - 
     2*G[w^(-1), -1, -1, 1, z] + 2*G[w^(-1), -1, 1, -1, z] - 
     2*G[w^(-1), -1, 1, 1, z] - 4*G[w^(-1), -1, w, -1, z] + 
     4*G[w^(-1), -1, w, 1, z] + 2*G[w^(-1), 1, -1, -1, z] - 
     2*G[w^(-1), 1, -1, 1, z] + 2*G[w^(-1), 1, 1, -1, z] - 
     2*G[w^(-1), 1, 1, 1, z] - 4*G[w^(-1), 1, w, -1, z] + 
     4*G[w^(-1), 1, w, 1, z] - 4*G[w^(-1), w, -1, -1, z] + 
     4*G[w^(-1), w, -1, 1, z] - 4*G[w^(-1), w, 1, -1, z] + 
     4*G[w^(-1), w, 1, 1, z] + 8*G[w^(-1), w, w, -1, z] - 
     8*G[w^(-1), w, w, 1, z]) - 
   12*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
       2*G[w, -1, z] + 2*G[w, 1, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + 
       G[-1, -1, 1, z] + G[-1, 1, -1, z] - G[-1, 1, 1, z] - G[1, -1, -1, z] + 
       G[1, -1, 1, z] + G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[w, -1, -1, z] - 
       2*G[w, -1, 1, z] - 2*G[w, 1, -1, z] + 2*G[w, 1, 1, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + G[-1, 1, -1, -1, w] - 
     G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - 
     G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - 
     G[-1, 1, 1, 1, z] + 2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] - 
     2*G[0, -1, 1, -1, w] + 2*G[0, -1, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 
     2*G[0, 1, -1, 1, w] + 2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + G[1, 1, -1, -1, w] - 
     G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] - 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] + 
     2*G[w, -1, 1, -1, z] - 2*G[w, -1, 1, 1, z] + 2*G[w, 1, -1, -1, z] - 
     2*G[w, 1, -1, 1, z] - 2*G[w, 1, 1, -1, z] + 2*G[w, 1, 1, 1, z]) + 
   18*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w^(-1), z] + 2*G[w, -1, z] + 2*G[w, 1, z] - 
       4*G[w, w^(-1), z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
       G[-1, -1, 1, z] + 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + 2*G[-1, w^(-1), -1, z] + 
       2*G[-1, w^(-1), 1, z] - 4*G[-1, w^(-1), w^(-1), z] - G[1, -1, -1, z] - 
       G[1, -1, 1, z] + 2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - 
       G[1, 1, 1, z] + 2*G[1, 1, w^(-1), z] + 2*G[1, w^(-1), -1, z] + 
       2*G[1, w^(-1), 1, z] - 4*G[1, w^(-1), w^(-1), z] + 2*G[w, -1, -1, z] + 
       2*G[w, -1, 1, z] - 4*G[w, -1, w^(-1), z] + 2*G[w, 1, -1, z] + 
       2*G[w, 1, 1, z] - 4*G[w, 1, w^(-1), z] - 4*G[w, w^(-1), -1, z] - 
       4*G[w, w^(-1), 1, z] + 8*G[w, w^(-1), w^(-1), z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 2*G[-1, -1, w^(-1), -1, z] + 
     2*G[-1, -1, w^(-1), 1, z] - G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
     2*G[-1, w^(-1), -1, -1, z] + 2*G[-1, w^(-1), -1, 1, z] - 
     2*G[-1, w^(-1), 1, -1, z] + 2*G[-1, w^(-1), 1, 1, z] + 
     4*G[-1, w^(-1), w^(-1), -1, z] - 4*G[-1, w^(-1), w^(-1), 1, z] + 
     2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
     2*G[0, -1, 1, 1, w] + 2*G[0, 1, -1, -1, w] - 2*G[0, 1, -1, 1, w] + 
     2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] - G[1, -1, -1, -1, w] + 
     G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - G[1, -1, -1, 1, z] - 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
     2*G[1, -1, w^(-1), 1, z] - G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] + 
     G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
     2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] - 
     2*G[1, w^(-1), -1, -1, z] + 2*G[1, w^(-1), -1, 1, z] - 
     2*G[1, w^(-1), 1, -1, z] + 2*G[1, w^(-1), 1, 1, z] + 
     4*G[1, w^(-1), w^(-1), -1, z] - 4*G[1, w^(-1), w^(-1), 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] - 2*G[w, -1, 1, -1, z] + 
     2*G[w, -1, 1, 1, z] + 4*G[w, -1, w^(-1), -1, z] - 
     4*G[w, -1, w^(-1), 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 
     2*G[w, 1, 1, -1, z] + 2*G[w, 1, 1, 1, z] + 4*G[w, 1, w^(-1), -1, z] - 
     4*G[w, 1, w^(-1), 1, z] + 4*G[w, w^(-1), -1, -1, z] - 
     4*G[w, w^(-1), -1, 1, z] + 4*G[w, w^(-1), 1, -1, z] - 
     4*G[w, w^(-1), 1, 1, z] - 8*G[w, w^(-1), w^(-1), -1, z] + 
     8*G[w, w^(-1), w^(-1), 1, z]) - 
   6*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
       2*G[-1, w^(-1), z] - G[1, -1, z] - G[1, 1, z] + 2*G[1, w^(-1), z] + 
       2*G[w, -1, z] + 2*G[w, 1, z] - 4*G[w, w^(-1), z]) + 
     (-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
       2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 2*G[1, 0, -1, w] - 
       2*G[1, 0, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] - 2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + 
       4*G[-1, w^(-1), w, z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] - 
       2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z] + 4*G[1, w^(-1), w, z] - 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 4*G[w, -1, w, z] - 
       2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] + 4*G[w, 1, w, z] + 
       4*G[w, w^(-1), -1, z] + 4*G[w, w^(-1), 1, z] - 8*G[w, w^(-1), w, z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 2*G[-1, -1, w, 1, z] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
     2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
     4*G[-1, w^(-1), w, -1, z] + 4*G[-1, w^(-1), w, 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 4*G[0, -1, 0, -1, w] - 
     4*G[0, -1, 0, 1, w] - 2*G[0, -1, 1, -1, w] + 2*G[0, -1, 1, 1, w] - 
     2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] + 4*G[0, 1, 0, -1, w] - 
     4*G[0, 1, 0, 1, w] - 2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] + 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 2*G[1, 1, 0, 1, w] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] + 
     2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
     2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
     4*G[1, w^(-1), w, -1, z] + 4*G[1, w^(-1), w, 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 4*G[w, -1, w, -1, z] + 4*G[w, -1, w, 1, z] + 
     2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 2*G[w, 1, 1, -1, z] - 
     2*G[w, 1, 1, 1, z] - 4*G[w, 1, w, -1, z] + 4*G[w, 1, w, 1, z] - 
     4*G[w, w^(-1), -1, -1, z] + 4*G[w, w^(-1), -1, 1, z] - 
     4*G[w, w^(-1), 1, -1, z] + 4*G[w, w^(-1), 1, 1, z] + 
     8*G[w, w^(-1), w, -1, z] - 8*G[w, w^(-1), w, 1, z]) - 
   6*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 2*G[w, 1, z] + 
       4*G[w, w, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
       2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w^(-1), z] - 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] + 
       4*G[-1, w, w^(-1), z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 
       2*G[1, 1, w^(-1), z] - 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
       4*G[1, w, w^(-1), z] - 2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 
       4*G[w, -1, w^(-1), z] - 2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] + 
       4*G[w, 1, w^(-1), z] + 4*G[w, w, -1, z] + 4*G[w, w, 1, z] - 
       8*G[w, w, w^(-1), z]) + G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - 
     G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 
     2*G[-1, -1, w^(-1), -1, z] - 2*G[-1, -1, w^(-1), 1, z] - 
     2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] - 2*G[-1, 0, 1, -1, w] + 
     2*G[-1, 0, 1, 1, w] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
     2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[-1, w, -1, -1, z] - 2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 
     2*G[-1, w, 1, 1, z] - 4*G[-1, w, w^(-1), -1, z] + 
     4*G[-1, w, w^(-1), 1, z] - 2*G[0, -1, -1, -1, w] + 
     2*G[0, -1, -1, 1, w] - 2*G[0, -1, 1, -1, w] + 2*G[0, -1, 1, 1, w] + 
     4*G[0, 0, -1, -1, w] - 4*G[0, 0, -1, 1, w] + 4*G[0, 0, 1, -1, w] - 
     4*G[0, 0, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] - 
     2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] + G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] - 2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] - 
     2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] + G[1, 1, -1, -1, w] - 
     G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
     2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 
     2*G[1, w, 1, 1, z] - 4*G[1, w, w^(-1), -1, z] + 
     4*G[1, w, w^(-1), 1, z] + 2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 
     2*G[w, -1, 1, -1, z] - 2*G[w, -1, 1, 1, z] - 4*G[w, -1, w^(-1), -1, z] + 
     4*G[w, -1, w^(-1), 1, z] + 2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 
     2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] - 4*G[w, 1, w^(-1), -1, z] + 
     4*G[w, 1, w^(-1), 1, z] - 4*G[w, w, -1, -1, z] + 4*G[w, w, -1, 1, z] - 
     4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z] + 8*G[w, w, w^(-1), -1, z] - 
     8*G[w, w, w^(-1), 1, z]) + 
   2*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 
       2*G[-1, w, z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w, z] - 
       2*G[w, -1, z] - 2*G[w, 1, z] + 4*G[w, w, z]) + 
     (-G[-1, z] - G[1, z] + 2*G[w, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 
       4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 2*G[0, 1, -1, w] + 
       2*G[0, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w, z] + 2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - 
       4*G[-1, w, w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z] + 
       2*G[1, w, -1, z] + 2*G[1, w, 1, z] - 4*G[1, w, w, z] + 
       2*G[w, -1, -1, z] + 2*G[w, -1, 1, z] - 4*G[w, -1, w, z] + 
       2*G[w, 1, -1, z] + 2*G[w, 1, 1, z] - 4*G[w, 1, w, z] - 
       4*G[w, w, -1, z] - 4*G[w, w, 1, z] + 8*G[w, w, w, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + 2*G[-1, -1, 0, -1, w] - 2*G[-1, -1, 0, 1, w] - 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] + 
     2*G[-1, 0, -1, -1, w] - 2*G[-1, 0, -1, 1, w] - 4*G[-1, 0, 0, -1, w] + 
     4*G[-1, 0, 0, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] + 2*G[-1, 1, 0, -1, w] - 2*G[-1, 1, 0, 1, w] - 
     G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - 
     G[-1, 1, 1, 1, z] - 2*G[-1, 1, w, -1, z] + 2*G[-1, 1, w, 1, z] - 
     2*G[-1, w, -1, -1, z] + 2*G[-1, w, -1, 1, z] - 2*G[-1, w, 1, -1, z] + 
     2*G[-1, w, 1, 1, z] + 4*G[-1, w, w, -1, z] - 4*G[-1, w, w, 1, z] + 
     2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] - 4*G[0, -1, 0, -1, w] + 
     4*G[0, -1, 0, 1, w] + 2*G[0, -1, 1, -1, w] - 2*G[0, -1, 1, 1, w] - 
     4*G[0, 0, -1, -1, w] + 4*G[0, 0, -1, 1, w] + 8*G[0, 0, 0, -1, w] - 
     8*G[0, 0, 0, 1, w] - 4*G[0, 0, 1, -1, w] + 4*G[0, 0, 1, 1, w] + 
     2*G[0, 1, -1, -1, w] - 2*G[0, 1, -1, 1, w] - 4*G[0, 1, 0, -1, w] + 
     4*G[0, 1, 0, 1, w] + 2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] + 2*G[1, -1, 0, -1, w] - 2*G[1, -1, 0, 1, w] - 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 2*G[1, -1, w, 1, z] + 
     2*G[1, 0, -1, -1, w] - 2*G[1, 0, -1, 1, w] - 4*G[1, 0, 0, -1, w] + 
     4*G[1, 0, 0, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] - 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[1, 1, w, -1, z] + 2*G[1, 1, w, 1, z] - 
     2*G[1, w, -1, -1, z] + 2*G[1, w, -1, 1, z] - 2*G[1, w, 1, -1, z] + 
     2*G[1, w, 1, 1, z] + 4*G[1, w, w, -1, z] - 4*G[1, w, w, 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] - 2*G[w, -1, 1, -1, z] + 
     2*G[w, -1, 1, 1, z] + 4*G[w, -1, w, -1, z] - 4*G[w, -1, w, 1, z] - 
     2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 2*G[w, 1, 1, -1, z] + 
     2*G[w, 1, 1, 1, z] + 4*G[w, 1, w, -1, z] - 4*G[w, 1, w, 1, z] + 
     4*G[w, w, -1, -1, z] - 4*G[w, w, -1, 1, z] + 4*G[w, w, 1, -1, z] - 
     4*G[w, w, 1, 1, z] - 8*G[w, w, w, -1, z] + 8*G[w, w, w, 1, z]) + 
   (4*(G[-1, w] - G[-1, z] - G[1, w] + G[1, z])*Zeta[3])/3, 
 fE8[{0}, sij, sjk, sik] -> 0, fE8[{1}, sij, sjk, sik] -> 0, 
 fE8[{2}, sij, sjk, sik] -> (-((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z])) - 
    G[-1, -1, w] - G[-1, -1, z] + G[-1, 1, w] + G[-1, 1, z] + G[1, -1, w] + 
    G[1, -1, z] - G[1, 1, w] - G[1, 1, z])/2, 
 fE8[{3}, sij, sjk, sik] -> 
  (-3*((-G[-1, z] + G[1, z])*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - 
        G[1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
        2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z]) + 
      G[-1, -1, -1, w] + G[-1, -1, -1, z] - G[-1, -1, 1, w] - 
      G[-1, -1, 1, z] + G[-1, 1, -1, w] + G[-1, 1, -1, z] - G[-1, 1, 1, w] - 
      G[-1, 1, 1, z] - 2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - 
      G[1, -1, -1, w] - G[1, -1, -1, z] + G[1, -1, 1, w] + G[1, -1, 1, z] - 
      G[1, 1, -1, w] - G[1, 1, -1, z] + G[1, 1, 1, w] + G[1, 1, 1, z] + 
      2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z]))/2 + 
   ((-G[-1, z] + G[1, z])*(-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 
       2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w, z]) - G[-1, -1, -1, w] - G[-1, -1, -1, z] + 
     G[-1, -1, 1, w] + G[-1, -1, 1, z] + 2*G[-1, 0, -1, w] - 
     2*G[-1, 0, 1, w] - G[-1, 1, -1, w] - G[-1, 1, -1, z] + G[-1, 1, 1, w] + 
     G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] + 
     G[1, -1, -1, w] + G[1, -1, -1, z] - G[1, -1, 1, w] - G[1, -1, 1, z] - 
     2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] + G[1, 1, -1, z] - 
     G[1, 1, 1, w] - G[1, 1, 1, z] - 2*G[1, w, -1, z] + 2*G[1, w, 1, z])/2 - 
   (3*((-G[-1, z] - G[1, z] + 2*G[w, z])*(G[-1, -1, w] - G[-1, 1, w] - 
        G[1, -1, w] + G[1, 1, w]) + (G[-1, w] - G[1, w])*
       (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
        2*G[w, -1, z] + 2*G[w, 1, z]) - G[-1, -1, -1, w] - G[-1, -1, -1, z] + 
      G[-1, -1, 1, w] + G[-1, -1, 1, z] + G[-1, 1, -1, w] + G[-1, 1, -1, z] - 
      G[-1, 1, 1, w] - G[-1, 1, 1, z] + 2*G[0, -1, -1, w] - 
      2*G[0, -1, 1, w] - 2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - 
      G[1, -1, -1, w] - G[1, -1, -1, z] + G[1, -1, 1, w] + G[1, -1, 1, z] + 
      G[1, 1, -1, w] + G[1, 1, -1, z] - G[1, 1, 1, w] - G[1, 1, 1, z] + 
      2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] - 2*G[w, 1, -1, z] + 
      2*G[w, 1, 1, z]))/2, fE8[{4}, sij, sjk, sik] -> 
  -(Pi^2*((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z]) + G[-1, -1, w] + 
       G[-1, -1, z] - G[-1, 1, w] - G[-1, 1, z] - G[1, -1, w] - G[1, -1, z] + 
       G[1, 1, w] + G[1, 1, z]))/12 + 
   3*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
       G[1, 1, -1, w] - G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[-1, -1, -1, z] + G[-1, -1, 1, z] + G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - G[1, 1, -1, z] + 
       G[1, 1, 1, z]) + G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - 
     G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z]) - 
   (9*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
       (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] + G[1, -1, z] + 
        G[1, 1, z] - 2*G[1, w^(-1), z]) + (-G[-1, z] + G[1, z])*
       (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
        G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] + G[1, 1, -1, w] - 
        G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
        G[-1, -1, 1, z] + 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
        G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + 2*G[-1, w^(-1), -1, z] + 
        2*G[-1, w^(-1), 1, z] - 4*G[-1, w^(-1), w^(-1), z] + 
        G[1, -1, -1, z] + G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] + 
        G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z] - 
        2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z] + 
        4*G[1, w^(-1), w^(-1), z]) + G[-1, -1, -1, -1, w] + 
      G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] + 
      G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - 
      G[-1, -1, 1, 1, z] - 2*G[-1, -1, w^(-1), -1, z] + 
      2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - 
      G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + 
      G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
      2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
      2*G[-1, w^(-1), -1, -1, z] + 2*G[-1, w^(-1), -1, 1, z] - 
      2*G[-1, w^(-1), 1, -1, z] + 2*G[-1, w^(-1), 1, 1, z] + 
      4*G[-1, w^(-1), w^(-1), -1, z] - 4*G[-1, w^(-1), w^(-1), 1, z] - 
      G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + 
      G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + 
      G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
      2*G[1, -1, w^(-1), 1, z] - G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + 
      G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
      G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
      2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
      2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
      2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
      4*G[1, w^(-1), w^(-1), -1, z] + 4*G[1, w^(-1), w^(-1), 1, z]))/2 + 
   (3*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
        G[1, -1, w] + G[1, 1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
        2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z]) + 
      (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
        2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
        G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
        2*G[1, 0, -1, w] - 2*G[1, 0, 1, w] - G[1, 1, -1, w] + 
        G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + 
        G[-1, -1, 1, z] - 2*G[-1, -1, w, z] + G[-1, 1, -1, z] + 
        G[-1, 1, 1, z] - 2*G[-1, 1, w, z] - 2*G[-1, w^(-1), -1, z] - 
        2*G[-1, w^(-1), 1, z] + 4*G[-1, w^(-1), w, z] - G[1, -1, -1, z] - 
        G[1, -1, 1, z] + 2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 
        2*G[1, 1, w, z] + 2*G[1, w^(-1), -1, z] + 2*G[1, w^(-1), 1, z] - 
        4*G[1, w^(-1), w, z]) - G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] + 
      G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] + 2*G[-1, -1, 0, -1, w] - 
      2*G[-1, -1, 0, 1, w] - G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + 
      G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 
      2*G[-1, -1, w, 1, z] - G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + 
      G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] + 2*G[-1, 1, 0, -1, w] - 
      2*G[-1, 1, 0, 1, w] - G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + 
      G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 
      2*G[-1, 1, w, 1, z] + 2*G[-1, w^(-1), -1, -1, z] - 
      2*G[-1, w^(-1), -1, 1, z] + 2*G[-1, w^(-1), 1, -1, z] - 
      2*G[-1, w^(-1), 1, 1, z] - 4*G[-1, w^(-1), w, -1, z] + 
      4*G[-1, w^(-1), w, 1, z] + G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - 
      G[1, -1, -1, 1, w] - G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 
      2*G[1, -1, 0, 1, w] + G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - 
      G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 
      2*G[1, -1, w, 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
      G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 
      2*G[1, 1, 0, 1, w] + G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] - 
      G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 2*G[1, 1, w, -1, z] + 
      2*G[1, 1, w, 1, z] - 2*G[1, w^(-1), -1, -1, z] + 
      2*G[1, w^(-1), -1, 1, z] - 2*G[1, w^(-1), 1, -1, z] + 
      2*G[1, w^(-1), 1, 1, z] + 4*G[1, w^(-1), w, -1, z] - 
      4*G[1, w^(-1), w, 1, z]))/2 + 
   (3*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
       (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - 
        G[1, 1, z] + 2*G[1, w, z]) + (-G[-1, z] + G[1, z])*
       (-G[-1, -1, -1, w] + G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
        G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
        2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
        G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
      (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
        2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
        2*G[-1, 1, w^(-1), z] - 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] + 
        4*G[-1, w, w^(-1), z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
        2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 
        2*G[1, 1, w^(-1), z] + 2*G[1, w, -1, z] + 2*G[1, w, 1, z] - 
        4*G[1, w, w^(-1), z]) - G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] + 
      G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - 
      G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 
      2*G[-1, -1, w^(-1), -1, z] - 2*G[-1, -1, w^(-1), 1, z] + 
      2*G[-1, 0, -1, -1, w] - 2*G[-1, 0, -1, 1, w] + 2*G[-1, 0, 1, -1, w] - 
      2*G[-1, 0, 1, 1, w] - G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + 
      G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - 
      G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
      2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
      2*G[-1, w, -1, -1, z] - 2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 
      2*G[-1, w, 1, 1, z] - 4*G[-1, w, w^(-1), -1, z] + 
      4*G[-1, w, w^(-1), 1, z] + G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - 
      G[1, -1, -1, 1, w] - G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] + 
      G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 
      2*G[1, -1, w^(-1), -1, z] + 2*G[1, -1, w^(-1), 1, z] - 
      2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] - 2*G[1, 0, 1, -1, w] + 
      2*G[1, 0, 1, 1, w] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
      G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + 
      G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
      2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] - 
      2*G[1, w, -1, -1, z] + 2*G[1, w, -1, 1, z] - 2*G[1, w, 1, -1, z] + 
      2*G[1, w, 1, 1, z] + 4*G[1, w, w^(-1), -1, z] - 
      4*G[1, w, w^(-1), 1, z]))/2 + 
   (-((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
        G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 
        2*G[-1, w, z] - G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z])) - 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 
       4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 2*G[0, 1, -1, w] + 
       2*G[0, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w, z] + 2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - 
       4*G[-1, w, w, z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] - 
       2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 4*G[1, w, w, z]) - 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + 2*G[-1, -1, 0, -1, w] - 2*G[-1, -1, 0, 1, w] - 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 2*G[-1, -1, w, 1, z] + 
     2*G[-1, 0, -1, -1, w] - 2*G[-1, 0, -1, 1, w] - 4*G[-1, 0, 0, -1, w] + 
     4*G[-1, 0, 0, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] - 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + 2*G[-1, 1, 0, -1, w] - 2*G[-1, 1, 0, 1, w] - 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     2*G[-1, w, -1, -1, z] - 2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 
     2*G[-1, w, 1, 1, z] - 4*G[-1, w, w, -1, z] + 4*G[-1, w, w, 1, z] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 2*G[1, -1, w, 1, z] - 
     2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] + 4*G[1, 0, 0, -1, w] - 
     4*G[1, 0, 0, 1, w] - 2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] + 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 2*G[1, 1, 0, 1, w] + 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[1, 1, w, -1, z] + 2*G[1, 1, w, 1, z] - 
     2*G[1, w, -1, -1, z] + 2*G[1, w, -1, 1, z] - 2*G[1, w, 1, -1, z] + 
     2*G[1, w, 1, 1, z] + 4*G[1, w, w, -1, z] - 4*G[1, w, w, 1, z])/2 - 
   (9*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
       (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
        2*G[w, -1, z] + 2*G[w, 1, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
       (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
        G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - G[1, 1, -1, w] + 
        G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + 
        G[-1, -1, 1, z] - 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
        G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + G[1, -1, -1, z] + 
        G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - 
        G[1, 1, 1, z] + 2*G[1, 1, w^(-1), z] - 2*G[w, -1, -1, z] - 
        2*G[w, -1, 1, z] + 4*G[w, -1, w^(-1), z] + 2*G[w, 1, -1, z] + 
        2*G[w, 1, 1, z] - 4*G[w, 1, w^(-1), z]) - G[-1, -1, -1, -1, w] - 
      G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 
      G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + 
      G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
      2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - 
      G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + 
      G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
      2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] + 
      2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
      2*G[0, -1, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] - 
      2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] - G[1, -1, -1, -1, w] - 
      G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 
      G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + 
      G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
      2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
      G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + 
      G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
      2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] + 
      2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
      2*G[w, -1, 1, 1, z] - 4*G[w, -1, w^(-1), -1, z] + 
      4*G[w, -1, w^(-1), 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 
      2*G[w, 1, 1, -1, z] + 2*G[w, 1, 1, 1, z] + 4*G[w, 1, w^(-1), -1, z] - 
      4*G[w, 1, w^(-1), 1, z]))/2 + 
   (3*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
        G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - 
        G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]) + 
      (-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + 
        G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - 
        G[-1, 1, -1, w] + G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
        2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - 
        G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
        G[-1, -1, 1, z] + 2*G[-1, -1, w, z] + G[-1, 1, -1, z] + 
        G[-1, 1, 1, z] - 2*G[-1, 1, w, z] - G[1, -1, -1, z] - 
        G[1, -1, 1, z] + 2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 
        2*G[1, 1, w, z] + 2*G[w, -1, -1, z] + 2*G[w, -1, 1, z] - 
        4*G[w, -1, w, z] - 2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] + 
        4*G[w, 1, w, z]) + G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - 
      G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 
      2*G[-1, -1, 0, 1, w] + G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - 
      G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 
      2*G[-1, -1, w, 1, z] - G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + 
      G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] + 2*G[-1, 1, 0, -1, w] - 
      2*G[-1, 1, 0, 1, w] - G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + 
      G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 
      2*G[-1, 1, w, 1, z] - 2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 
      4*G[0, -1, 0, -1, w] - 4*G[0, -1, 0, 1, w] - 2*G[0, -1, 1, -1, w] + 
      2*G[0, -1, 1, 1, w] + 2*G[0, 1, -1, -1, w] - 2*G[0, 1, -1, 1, w] - 
      4*G[0, 1, 0, -1, w] + 4*G[0, 1, 0, 1, w] + 2*G[0, 1, 1, -1, w] - 
      2*G[0, 1, 1, 1, w] + G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - 
      G[1, -1, -1, 1, w] - G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 
      2*G[1, -1, 0, 1, w] + G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - 
      G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 
      2*G[1, -1, w, 1, z] - G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + 
      G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 
      2*G[1, 1, 0, 1, w] - G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + 
      G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 
      2*G[1, 1, w, 1, z] - 2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] - 
      2*G[w, -1, 1, -1, z] + 2*G[w, -1, 1, 1, z] + 4*G[w, -1, w, -1, z] - 
      4*G[w, -1, w, 1, z] + 2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 
      2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] - 4*G[w, 1, w, -1, z] + 
      4*G[w, 1, w, 1, z]))/2 - 
   (3*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
       (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + G[1, -1, z] + 
        G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 2*G[w, 1, z] + 
        4*G[w, w, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
       (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
        G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
        2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
        G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
      (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
        G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
        2*G[-1, w, 1, z] - G[1, -1, -1, z] + G[1, -1, 1, z] - 
        G[1, 1, -1, z] + G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
        2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 
        2*G[w, 1, 1, z] - 4*G[w, w, -1, z] + 4*G[w, w, 1, z]) + 
      G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
      G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + 
      G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 2*G[-1, 0, -1, -1, w] + 
      2*G[-1, 0, -1, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] + 
      G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - 
      G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + 
      G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] - 2*G[-1, w, -1, -1, z] + 
      2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] - 
      2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
      2*G[0, -1, 1, 1, w] + 4*G[0, 0, -1, -1, w] - 4*G[0, 0, -1, 1, w] - 
      4*G[0, 0, 1, -1, w] + 4*G[0, 0, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 
      2*G[0, 1, -1, 1, w] + 2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] + 
      G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
      G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + 
      G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] - 2*G[1, 0, -1, -1, w] + 
      2*G[1, 0, -1, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] + 
      G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - 
      G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + 
      G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] - 2*G[1, w, -1, -1, z] + 
      2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 2*G[1, w, 1, 1, z] - 
      2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
      2*G[w, -1, 1, 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] + 
      2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] + 4*G[w, w, -1, -1, z] - 
      4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z]))/2, 
 fE9[{0}, sij, sjk, sik] -> 0, fE9[{1}, sij, sjk, sik] -> 0, 
 fE9[{2}, sij, sjk, sik] -> (-((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z])) - 
    G[-1, -1, w] - G[-1, -1, z] + G[-1, 1, w] + G[-1, 1, z] + G[1, -1, w] + 
    G[1, -1, z] - G[1, 1, w] - G[1, 1, z])/2, 
 fE9[{3}, sij, sjk, sik] -> 
  (-((-G[-1, z] + G[1, z])*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - 
        G[1, 1, w])) - (G[-1, w] - G[1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
       2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z]) - 
     G[-1, -1, -1, w] - G[-1, -1, -1, z] + G[-1, -1, 1, w] + 
     G[-1, -1, 1, z] - G[-1, 1, -1, w] - G[-1, 1, -1, z] + G[-1, 1, 1, w] + 
     G[-1, 1, 1, z] + 2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + 
     G[1, -1, -1, w] + G[1, -1, -1, z] - G[1, -1, 1, w] - G[1, -1, 1, z] + 
     G[1, 1, -1, w] + G[1, 1, -1, z] - G[1, 1, 1, w] - G[1, 1, 1, z] - 
     2*G[1, w^(-1), -1, z] + 2*G[1, w^(-1), 1, z])/2 + 
   (-((-G[-1, z] + G[1, z])*(-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 
        2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w])) - 
     (G[-1, w] - G[1, w])*(G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - 
       G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z]) + G[-1, -1, -1, w] + 
     G[-1, -1, -1, z] - G[-1, -1, 1, w] - G[-1, -1, 1, z] - 
     2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] + 
     G[-1, 1, -1, z] - G[-1, 1, 1, w] - G[-1, 1, 1, z] - 2*G[-1, w, -1, z] + 
     2*G[-1, w, 1, z] - G[1, -1, -1, w] - G[1, -1, -1, z] + G[1, -1, 1, w] + 
     G[1, -1, 1, z] + 2*G[1, 0, -1, w] - 2*G[1, 0, 1, w] - G[1, 1, -1, w] - 
     G[1, 1, -1, z] + G[1, 1, 1, w] + G[1, 1, 1, z] + 2*G[1, w, -1, z] - 
     2*G[1, w, 1, z])/2 + ((-G[-1, z] - G[1, z] + 2*G[w, z])*
      (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - 
       G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]) - G[-1, -1, -1, w] - 
     G[-1, -1, -1, z] + G[-1, -1, 1, w] + G[-1, -1, 1, z] + G[-1, 1, -1, w] + 
     G[-1, 1, -1, z] - G[-1, 1, 1, w] - G[-1, 1, 1, z] + 2*G[0, -1, -1, w] - 
     2*G[0, -1, 1, w] - 2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - 
     G[1, -1, -1, w] - G[1, -1, -1, z] + G[1, -1, 1, w] + G[1, -1, 1, z] + 
     G[1, 1, -1, w] + G[1, 1, -1, z] - G[1, 1, 1, w] - G[1, 1, 1, z] + 
     2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] - 2*G[w, 1, -1, z] + 
     2*G[w, 1, 1, z])/2, fE9[{4}, sij, sjk, sik] -> 
  -(Pi^2*((G[-1, w] - G[1, w])*(-G[-1, z] + G[1, z]) + G[-1, -1, w] + 
       G[-1, -1, z] - G[-1, 1, w] - G[-1, 1, z] - G[1, -1, w] - G[1, -1, z] + 
       G[1, 1, w] + G[1, 1, z]))/12 - 
   (-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
     G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - 
     G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]) - 
   (-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
     2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
     G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 
     2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
   (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
     2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
     2*G[-1, 1, w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 2*G[1, -1, w, z] + 
     G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] + 2*G[w, -1, -1, z] + 
     2*G[w, -1, 1, z] - 4*G[w, -1, w, z] - 2*G[w, 1, -1, z] - 
     2*G[w, 1, 1, z] + 4*G[w, 1, w, z]) - G[-1, -1, -1, -1, w] - 
   G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] + 
   2*G[-1, -1, 0, -1, w] - 2*G[-1, -1, 0, 1, w] - G[-1, -1, 1, -1, w] - 
   G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 
   2*G[-1, -1, w, -1, z] - 2*G[-1, -1, w, 1, z] + G[-1, 1, -1, -1, w] + 
   G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] - 
   2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + G[-1, 1, 1, -1, w] + 
   G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
   2*G[-1, 1, w, -1, z] + 2*G[-1, 1, w, 1, z] + 2*G[0, -1, -1, -1, w] - 
   2*G[0, -1, -1, 1, w] - 4*G[0, -1, 0, -1, w] + 4*G[0, -1, 0, 1, w] + 
   2*G[0, -1, 1, -1, w] - 2*G[0, -1, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 
   2*G[0, 1, -1, 1, w] + 4*G[0, 1, 0, -1, w] - 4*G[0, 1, 0, 1, w] - 
   2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] - G[1, -1, -1, -1, w] - 
   G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
   2*G[1, -1, 0, -1, w] - 2*G[1, -1, 0, 1, w] - G[1, -1, 1, -1, w] - 
   G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 
   2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] + G[1, 1, -1, -1, w] + 
   G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - 
   2*G[1, 1, 0, -1, w] + 2*G[1, 1, 0, 1, w] + G[1, 1, 1, -1, w] + 
   G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] + 
   ((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
       G[1, 1, -1, w] - G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[-1, -1, -1, z] + G[-1, -1, 1, z] + G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - G[1, 1, -1, z] + 
       G[1, 1, 1, z]) + G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - 
     G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z])/2 - 
   2*G[1, 1, w, -1, z] + 2*G[1, 1, w, 1, z] + 
   (-((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
       (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] + G[1, -1, z] + 
        G[1, 1, z] - 2*G[1, w^(-1), z])) - (-G[-1, z] + G[1, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) - (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
       G[-1, -1, 1, z] + 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + 2*G[-1, w^(-1), -1, z] + 
       2*G[-1, w^(-1), 1, z] - 4*G[-1, w^(-1), w^(-1), z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + 
       G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z] - 2*G[1, w^(-1), -1, z] - 
       2*G[1, w^(-1), 1, z] + 4*G[1, w^(-1), w^(-1), z]) - 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] - G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
     2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
     2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
     4*G[-1, w^(-1), w^(-1), -1, z] + 4*G[-1, w^(-1), w^(-1), 1, z] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
     2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] - 
     2*G[1, w^(-1), -1, -1, z] + 2*G[1, w^(-1), -1, 1, z] - 
     2*G[1, w^(-1), 1, -1, z] + 2*G[1, w^(-1), 1, 1, z] + 
     4*G[1, w^(-1), w^(-1), -1, z] - 4*G[1, w^(-1), w^(-1), 1, z])/2 + 
   (-((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
        G[1, -1, w] + G[1, 1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
        2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z])) - 
     (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
       2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 2*G[1, 0, -1, w] - 
       2*G[1, 0, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) - 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] - 2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + 
       4*G[-1, w^(-1), w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z] + 
       2*G[1, w^(-1), -1, z] + 2*G[1, w^(-1), 1, z] - 4*G[1, w^(-1), w, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] + 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - 
     G[-1, 1, 1, 1, z] - 2*G[-1, 1, w, -1, z] + 2*G[-1, 1, w, 1, z] - 
     2*G[-1, w^(-1), -1, -1, z] + 2*G[-1, w^(-1), -1, 1, z] - 
     2*G[-1, w^(-1), 1, -1, z] + 2*G[-1, w^(-1), 1, 1, z] + 
     4*G[-1, w^(-1), w, -1, z] - 4*G[-1, w^(-1), w, 1, z] - 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] + 2*G[1, -1, 0, -1, w] - 2*G[1, -1, 0, 1, w] - 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] - 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] + 
     2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
     2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
     4*G[1, w^(-1), w, -1, z] + 4*G[1, w^(-1), w, 1, z])/2 + 
   (-((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
       (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - 
        G[1, 1, z] + 2*G[1, w, z])) - (-G[-1, z] + G[1, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
       2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) - 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w^(-1), z] - 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] + 
       4*G[-1, w, w^(-1), z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 
       2*G[1, 1, w^(-1), z] + 2*G[1, w, -1, z] + 2*G[1, w, 1, z] - 
       4*G[1, w, w^(-1), z]) + G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] + 
     G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 
     2*G[-1, -1, w^(-1), -1, z] + 2*G[-1, -1, w^(-1), 1, z] - 
     2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] - 2*G[-1, 0, 1, -1, w] + 
     2*G[-1, 0, 1, 1, w] + G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
     2*G[-1, w, -1, -1, z] + 2*G[-1, w, -1, 1, z] - 2*G[-1, w, 1, -1, z] + 
     2*G[-1, w, 1, 1, z] + 4*G[-1, w, w^(-1), -1, z] - 
     4*G[-1, w, w^(-1), 1, z] - G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] + 
     G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - 
     G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 
     2*G[1, -1, w^(-1), -1, z] - 2*G[1, -1, w^(-1), 1, z] + 
     2*G[1, 0, -1, -1, w] - 2*G[1, 0, -1, 1, w] + 2*G[1, 0, 1, -1, w] - 
     2*G[1, 0, 1, 1, w] - G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
     2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 
     2*G[1, w, 1, 1, z] - 4*G[1, w, w^(-1), -1, z] + 4*G[1, w, w^(-1), 1, z])/
    2 + ((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 
       2*G[-1, w, z] - G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 
       4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 2*G[0, 1, -1, w] + 
       2*G[0, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w, z] + 2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - 
       4*G[-1, w, w, z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] - 
       2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 4*G[1, w, w, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] - 
     2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] + 4*G[-1, 0, 0, -1, w] - 
     4*G[-1, 0, 0, 1, w] - 2*G[-1, 0, 1, -1, w] + 2*G[-1, 0, 1, 1, w] + 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - 
     G[-1, 1, 1, 1, z] - 2*G[-1, 1, w, -1, z] + 2*G[-1, 1, w, 1, z] - 
     2*G[-1, w, -1, -1, z] + 2*G[-1, w, -1, 1, z] - 2*G[-1, w, 1, -1, z] + 
     2*G[-1, w, 1, 1, z] + 4*G[-1, w, w, -1, z] - 4*G[-1, w, w, 1, z] - 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] + 2*G[1, -1, 0, -1, w] - 2*G[1, -1, 0, 1, w] - 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] + 
     2*G[1, 0, -1, -1, w] - 2*G[1, 0, -1, 1, w] - 4*G[1, 0, 0, -1, w] + 
     4*G[1, 0, 0, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] - 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] + 
     2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 
     2*G[1, w, 1, 1, z] - 4*G[1, w, w, -1, z] + 4*G[1, w, w, 1, z])/2 + 
   2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
   2*G[w, -1, 1, 1, z] - 4*G[w, -1, w, -1, z] + 4*G[w, -1, w, 1, z] - 
   2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 2*G[w, 1, 1, -1, z] + 
   2*G[w, 1, 1, 1, z] + 
   ((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
       2*G[w, -1, z] + 2*G[w, 1, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + 
       G[-1, -1, 1, z] - 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - 
       G[1, 1, 1, z] + 2*G[1, 1, w^(-1), z] - 2*G[w, -1, -1, z] - 
       2*G[w, -1, 1, z] + 4*G[w, -1, w^(-1), z] + 2*G[w, 1, -1, z] + 
       2*G[w, 1, 1, z] - 4*G[w, 1, w^(-1), z]) - G[-1, -1, -1, -1, w] - 
     G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
     2*G[0, -1, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] - 
     2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] - G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
     2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 4*G[w, -1, w^(-1), -1, z] + 
     4*G[w, -1, w^(-1), 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 
     2*G[w, 1, 1, -1, z] + 2*G[w, 1, 1, 1, z] + 4*G[w, 1, w^(-1), -1, z] - 
     4*G[w, 1, w^(-1), 1, z])/2 + 4*G[w, 1, w, -1, z] - 4*G[w, 1, w, 1, z] + 
   (-((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
       (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + G[1, -1, z] + 
        G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 2*G[w, 1, z] + 
        4*G[w, w, z])) - (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] - G[1, -1, -1, z] + G[1, -1, 1, z] - G[1, 1, -1, z] + 
       G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 
       2*G[w, 1, 1, z] - 4*G[w, w, -1, z] + 4*G[w, w, 1, z]) - 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] + 2*G[-1, 0, -1, -1, w] - 
     2*G[-1, 0, -1, 1, w] - 2*G[-1, 0, 1, -1, w] + 2*G[-1, 0, 1, 1, w] - 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] + 2*G[-1, w, -1, -1, z] - 
     2*G[-1, w, -1, 1, z] - 2*G[-1, w, 1, -1, z] + 2*G[-1, w, 1, 1, z] + 
     2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] - 2*G[0, -1, 1, -1, w] + 
     2*G[0, -1, 1, 1, w] - 4*G[0, 0, -1, -1, w] + 4*G[0, 0, -1, 1, w] + 
     4*G[0, 0, 1, -1, w] - 4*G[0, 0, 1, 1, w] + 2*G[0, 1, -1, -1, w] - 
     2*G[0, 1, -1, 1, w] - 2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] - 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] + 2*G[1, 0, -1, -1, w] - 
     2*G[1, 0, -1, 1, w] - 2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] - 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] - 
     G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] + 2*G[1, w, -1, -1, z] - 
     2*G[1, w, -1, 1, z] - 2*G[1, w, 1, -1, z] + 2*G[1, w, 1, 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] - 2*G[w, -1, 1, -1, z] + 
     2*G[w, -1, 1, 1, z] + 2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] - 
     2*G[w, 1, 1, -1, z] + 2*G[w, 1, 1, 1, z] - 4*G[w, w, -1, -1, z] + 
     4*G[w, w, -1, 1, z] + 4*G[w, w, 1, -1, z] - 4*G[w, w, 1, 1, z])/2, 
 fE10[{0}, sij, sjk, sik] -> 0, fE10[{1}, sij, sjk, sik] -> 0, 
 fE10[{2}, sij, sjk, sik] -> 0, fE10[{3}, sij, sjk, sik] -> 
  -((-G[-1, z] + G[1, z])*(-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 
      2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w])) - 
   (G[-1, w] - G[1, w])*(G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - 
     G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z]) + G[-1, -1, -1, w] + 
   G[-1, -1, -1, z] - G[-1, -1, 1, w] - G[-1, -1, 1, z] - 2*G[-1, 0, -1, w] + 
   2*G[-1, 0, 1, w] + G[-1, 1, -1, w] + G[-1, 1, -1, z] - G[-1, 1, 1, w] - 
   G[-1, 1, 1, z] - 2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - G[1, -1, -1, w] - 
   G[1, -1, -1, z] + G[1, -1, 1, w] + G[1, -1, 1, z] + 2*G[1, 0, -1, w] - 
   2*G[1, 0, 1, w] - G[1, 1, -1, w] - G[1, 1, -1, z] + G[1, 1, 1, w] + 
   G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z], 
 fE10[{4}, sij, sjk, sik] -> 
  (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
    (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) - 
   (-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
     G[1, -1, w] + G[1, 1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
     2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z]) - 
   (G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
    (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - G[1, 1, z] + 
     2*G[1, w, z]) + (-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 
     2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 
     2*G[-1, w, z] - G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z]) - 
   (-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
     G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - 
     G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]) + 
   (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
     G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
     G[1, 1, -1, w] - G[1, 1, 1, w]) - (-G[-1, z] - G[1, z] + 2*G[w, z])*
    (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 
     2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + G[-1, 1, 1, w] + G[1, -1, -1, w] - 
     G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - 
     G[1, 1, 1, w]) + (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - 
     G[-1, -1, 1, w] - 2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + 
     G[-1, 1, -1, w] - G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 
     2*G[0, -1, 1, w] + 4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 
     2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
     2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
   (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] - 
     G[-1, 1, -1, w] + G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 
     2*G[0, -1, 1, w] + 2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - 
     G[1, -1, -1, w] + G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) - 
   (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
     2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
     G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 2*G[1, 0, -1, w] - 
     2*G[1, 0, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
   (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] + 
     G[-1, 1, -1, z] - G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - 
     G[1, 1, -1, z] + G[1, 1, 1, z]) - (G[-1, w] - G[1, w])*
    (G[-1, -1, -1, z] + G[-1, -1, 1, z] - 2*G[-1, -1, w, z] + 
     G[-1, 1, -1, z] + G[-1, 1, 1, z] - 2*G[-1, 1, w, z] - 
     2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + 4*G[-1, w^(-1), w, z] - 
     G[1, -1, -1, z] - G[1, -1, 1, z] + 2*G[1, -1, w, z] - G[1, 1, -1, z] - 
     G[1, 1, 1, z] + 2*G[1, 1, w, z] + 2*G[1, w^(-1), -1, z] + 
     2*G[1, w^(-1), 1, z] - 4*G[1, w^(-1), w, z]) - 
   (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
     2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), z] - 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] + 
     4*G[-1, w, w^(-1), z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
     2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 
     2*G[1, 1, w^(-1), z] + 2*G[1, w, -1, z] + 2*G[1, w, 1, z] - 
     4*G[1, w, w^(-1), z]) + (G[-1, w] - G[1, w])*
    (-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 2*G[-1, -1, w, z] - 
     G[-1, 1, -1, z] - G[-1, 1, 1, z] + 2*G[-1, 1, w, z] + 
     2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - 4*G[-1, w, w, z] + 
     G[1, -1, -1, z] + G[1, -1, 1, z] - 2*G[1, -1, w, z] + G[1, 1, -1, z] + 
     G[1, 1, 1, z] - 2*G[1, 1, w, z] - 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
     4*G[1, w, w, z]) - (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
     G[-1, -1, 1, z] + 2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
     2*G[-1, 1, w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 2*G[1, -1, w, z] + 
     G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] + 2*G[w, -1, -1, z] + 
     2*G[w, -1, 1, z] - 4*G[w, -1, w, z] - 2*G[w, 1, -1, z] - 
     2*G[w, 1, 1, z] + 4*G[w, 1, w, z]) + 3*G[-1, -1, -1, -1, w] + 
   3*G[-1, -1, -1, -1, z] - 3*G[-1, -1, -1, 1, w] - 3*G[-1, -1, -1, 1, z] - 
   2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + G[-1, -1, 1, -1, w] + 
   G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 
   2*G[-1, -1, w^(-1), -1, z] + 2*G[-1, -1, w^(-1), 1, z] - 
   2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] - 4*G[-1, 0, -1, -1, w] + 
   4*G[-1, 0, -1, 1, w] + 4*G[-1, 0, 0, -1, w] - 4*G[-1, 0, 0, 1, w] - 
   4*G[-1, 0, 1, -1, w] + 4*G[-1, 0, 1, 1, w] + 3*G[-1, 1, -1, -1, w] + 
   3*G[-1, 1, -1, -1, z] - 3*G[-1, 1, -1, 1, w] - 3*G[-1, 1, -1, 1, z] - 
   6*G[-1, 1, 0, -1, w] + 6*G[-1, 1, 0, 1, w] + 5*G[-1, 1, 1, -1, w] + 
   5*G[-1, 1, 1, -1, z] - 5*G[-1, 1, 1, 1, w] - 5*G[-1, 1, 1, 1, z] - 
   2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
   6*G[-1, 1, w, -1, z] + 6*G[-1, 1, w, 1, z] - 2*G[-1, w^(-1), -1, -1, z] + 
   2*G[-1, w^(-1), -1, 1, z] - 2*G[-1, w^(-1), 1, -1, z] + 
   2*G[-1, w^(-1), 1, 1, z] + 4*G[-1, w^(-1), w, -1, z] - 
   4*G[-1, w^(-1), w, 1, z] - 4*G[-1, w, -1, -1, z] + 4*G[-1, w, -1, 1, z] - 
   4*G[-1, w, 1, -1, z] + 4*G[-1, w, 1, 1, z] + 4*G[-1, w, w^(-1), -1, z] - 
   4*G[-1, w, w^(-1), 1, z] + 4*G[-1, w, w, -1, z] - 4*G[-1, w, w, 1, z] + 
   2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] - 4*G[0, -1, 0, -1, w] + 
   4*G[0, -1, 0, 1, w] + 2*G[0, -1, 1, -1, w] - 2*G[0, -1, 1, 1, w] - 
   2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] + 4*G[0, 1, 0, -1, w] - 
   4*G[0, 1, 0, 1, w] - 2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] - 
   5*G[1, -1, -1, -1, w] - 5*G[1, -1, -1, -1, z] + 5*G[1, -1, -1, 1, w] + 
   5*G[1, -1, -1, 1, z] + 6*G[1, -1, 0, -1, w] - 6*G[1, -1, 0, 1, w] - 
   3*G[1, -1, 1, -1, w] - 3*G[1, -1, 1, -1, z] + 3*G[1, -1, 1, 1, w] + 
   3*G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
   2*G[1, -1, w^(-1), 1, z] + 6*G[1, -1, w, -1, z] - 6*G[1, -1, w, 1, z] + 
   4*G[1, 0, -1, -1, w] - 4*G[1, 0, -1, 1, w] - 4*G[1, 0, 0, -1, w] + 
   4*G[1, 0, 0, 1, w] + 4*G[1, 0, 1, -1, w] - 4*G[1, 0, 1, 1, w] - 
   G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] + 
   G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
   3*G[1, 1, 1, -1, w] - 3*G[1, 1, 1, -1, z] + 3*G[1, 1, 1, 1, w] + 
   3*G[1, 1, 1, 1, z] + 2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
   2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] + 2*G[1, w^(-1), -1, -1, z] - 
   2*G[1, w^(-1), -1, 1, z] + 2*G[1, w^(-1), 1, -1, z] - 
   2*G[1, w^(-1), 1, 1, z] - 4*G[1, w^(-1), w, -1, z] + 
   4*G[1, w^(-1), w, 1, z] + 4*G[1, w, -1, -1, z] - 4*G[1, w, -1, 1, z] + 
   4*G[1, w, 1, -1, z] - 4*G[1, w, 1, 1, z] - 4*G[1, w, w^(-1), -1, z] + 
   4*G[1, w, w^(-1), 1, z] - 4*G[1, w, w, -1, z] + 4*G[1, w, w, 1, z] + 
   2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
   2*G[w, -1, 1, 1, z] - 4*G[w, -1, w, -1, z] + 4*G[w, -1, w, 1, z] - 
   2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 2*G[w, 1, 1, -1, z] + 
   2*G[w, 1, 1, 1, z] + 4*G[w, 1, w, -1, z] - 4*G[w, 1, w, 1, z], 
 fE11[{0}, sij, sjk, sik] -> 0, fE11[{1}, sij, sjk, sik] -> 0, 
 fE11[{2}, sij, sjk, sik] -> 
  (-((G[-1, w] - G[1, w])*(-G[-1, z] - G[1, z] + 2*G[w, z])) + G[-1, -1, w] - 
    G[-1, -1, z] - G[-1, 1, w] + G[-1, 1, z] - 2*G[0, -1, w] + 2*G[0, 1, w] + 
    G[1, -1, w] - G[1, -1, z] - G[1, 1, w] + G[1, 1, z] + 2*G[w, -1, z] - 
    2*G[w, 1, z])/2, fE11[{3}, sij, sjk, sik] -> 
  ((-G[-1, z] + G[1, z])*(G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + 
       G[1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, z] - G[-1, 1, z] - 
       G[1, -1, z] + G[1, 1, z]) + G[-1, -1, -1, w] - G[-1, -1, -1, z] - 
     G[-1, -1, 1, w] + G[-1, -1, 1, z] - G[-1, 1, -1, w] + G[-1, 1, -1, z] + 
     G[-1, 1, 1, w] - G[-1, 1, 1, z] - G[1, -1, -1, w] + G[1, -1, -1, z] + 
     G[1, -1, 1, w] - G[1, -1, 1, z] + G[1, 1, -1, w] - G[1, 1, -1, z] - 
     G[1, 1, 1, w] + G[1, 1, 1, z])/2 + 
   (-((G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(-G[-1, -1, w] + G[-1, 1, w] + 
        2*G[0, -1, w] - 2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w])) - 
     (G[-1, w] - G[1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w, z] - 
       G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z] + 2*G[w^(-1), -1, z] + 
       2*G[w^(-1), 1, z] - 4*G[w^(-1), w, z]) + G[-1, -1, -1, w] - 
     G[-1, -1, -1, z] - G[-1, -1, 1, w] + G[-1, -1, 1, z] - 
     2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - 
     G[-1, 1, -1, z] - G[-1, 1, 1, w] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
     2*G[-1, w, 1, z] + G[1, -1, -1, w] - G[1, -1, -1, z] - G[1, -1, 1, w] + 
     G[1, -1, 1, z] - 2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - 
     G[1, 1, -1, z] - G[1, 1, 1, w] + G[1, 1, 1, z] + 2*G[1, w, -1, z] - 
     2*G[1, w, 1, z] + 2*G[w^(-1), -1, -1, z] - 2*G[w^(-1), -1, 1, z] + 
     2*G[w^(-1), 1, -1, z] - 2*G[w^(-1), 1, 1, z] - 4*G[w^(-1), w, -1, z] + 
     4*G[w^(-1), w, 1, z])/2 + 
   (-((-G[-1, z] - G[1, z] + 2*G[w, z])*(G[-1, -1, w] - G[-1, 1, w] + 
        G[1, -1, w] - G[1, 1, w])) - (G[-1, w] - G[1, w])*
      (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w^(-1), z] + 2*G[w, -1, z] + 2*G[w, 1, z] - 
       4*G[w, w^(-1), z]) + G[-1, -1, -1, w] - G[-1, -1, -1, z] - 
     G[-1, -1, 1, w] + G[-1, -1, 1, z] + G[-1, 1, -1, w] - G[-1, 1, -1, z] - 
     G[-1, 1, 1, w] + G[-1, 1, 1, z] + 2*G[-1, w^(-1), -1, z] - 
     2*G[-1, w^(-1), 1, z] - 2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] - 
     2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, -1, z] - 
     G[1, -1, 1, w] + G[1, -1, 1, z] + G[1, 1, -1, w] - G[1, 1, -1, z] - 
     G[1, 1, 1, w] + G[1, 1, 1, z] + 2*G[1, w^(-1), -1, z] - 
     2*G[1, w^(-1), 1, z] + 2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 
     2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] - 4*G[w, w^(-1), -1, z] + 
     4*G[w, w^(-1), 1, z])/2 + 
   ((-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, w] + G[-1, 1, w] + 
       2*G[0, -1, w] - 2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + 
       G[1, -1, z] + G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 
       2*G[w, 1, z] + 4*G[w, w, z]) + G[-1, -1, -1, w] - G[-1, -1, -1, z] - 
     G[-1, -1, 1, w] + G[-1, -1, 1, z] - 2*G[-1, 0, -1, w] + 
     2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - G[-1, 1, -1, z] - G[-1, 1, 1, w] + 
     G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] - 
     2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 4*G[0, 0, -1, w] - 
     4*G[0, 0, 1, w] - 2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] + G[1, -1, -1, w] - 
     G[1, -1, -1, z] - G[1, -1, 1, w] + G[1, -1, 1, z] - 2*G[1, 0, -1, w] + 
     2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, -1, z] - G[1, 1, 1, w] + 
     G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 2*G[w, -1, -1, z] - 
     2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] - 
     4*G[w, w, -1, z] + 4*G[w, w, 1, z])/2, fE11[{4}, sij, sjk, sik] -> 
  -(Pi^2*((G[-1, w] - G[1, w])*(-G[-1, z] - G[1, z] + 2*G[w, z]) - 
       G[-1, -1, w] + G[-1, -1, z] + G[-1, 1, w] - G[-1, 1, z] + 
       2*G[0, -1, w] - 2*G[0, 1, w] - G[1, -1, w] + G[1, -1, z] + 
       G[1, 1, w] - G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]))/12 + 
   ((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[-1, -1, -1, z] + G[-1, -1, 1, z] - 2*G[-1, -1, w^(-1), z] - 
       G[-1, 1, -1, z] - G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] - 
       G[1, -1, -1, z] - G[1, -1, 1, z] + 2*G[1, -1, w^(-1), z] + 
       G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] - G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z])/2 + 
   ((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + 
       G[1, 1, z]) + (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + 
       G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + 2*G[-1, -1, 0, -1, w] - 2*G[-1, -1, 0, 1, w] - 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] - 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[1, 1, w, -1, z] + 2*G[1, 1, w, 1, z])/2 + 
   (-((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
       (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - 
        G[1, 1, z] + 2*G[1, w, z])) - (-G[-1, z] + G[1, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] + G[1, 1, -1, z] - 
       G[1, 1, 1, z] - 2*G[1, w, -1, z] + 2*G[1, w, 1, z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 2*G[-1, 0, -1, -1, w] + 
     2*G[-1, 0, -1, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] + 
     G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] + 2*G[-1, w, -1, -1, z] - 
     2*G[-1, w, -1, 1, z] - 2*G[-1, w, 1, -1, z] + 2*G[-1, w, 1, 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, 0, -1, -1, w] - 
     2*G[1, 0, -1, 1, w] - 2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] - 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - 
     G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] - 2*G[1, w, -1, -1, z] + 
     2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 2*G[1, w, 1, 1, z])/2 + 
   ((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (-G[-1, -1, z] + G[-1, 1, z] - G[1, -1, z] + G[1, 1, z] + 
       2*G[w^(-1), -1, z] - 2*G[w^(-1), 1, z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] - G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] - G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - 
       G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[w^(-1), -1, -1, z] + 
       2*G[w^(-1), -1, 1, z] + 2*G[w^(-1), 1, -1, z] - 
       2*G[w^(-1), 1, 1, z]) + G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] + 
     G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[w^(-1), -1, -1, -1, z] - 2*G[w^(-1), -1, -1, 1, z] - 
     2*G[w^(-1), -1, 1, -1, z] + 2*G[w^(-1), -1, 1, 1, z] - 
     2*G[w^(-1), 1, -1, -1, z] + 2*G[w^(-1), 1, -1, 1, z] + 
     2*G[w^(-1), 1, 1, -1, z] - 2*G[w^(-1), 1, 1, 1, z])/2 + 
   (-((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
        G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 
        2*G[-1, w^(-1), z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w^(-1), z] - 
        2*G[w^(-1), -1, z] - 2*G[w^(-1), 1, z] + 4*G[w^(-1), w^(-1), z])) - 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(-G[-1, -1, -1, w] + 
       G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
       2*G[1, 0, -1, w] - 2*G[1, 0, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) - 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w, z] + 2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - 
       4*G[-1, w^(-1), w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z] + 
       2*G[1, w^(-1), -1, z] + 2*G[1, w^(-1), 1, z] - 4*G[1, w^(-1), w, z] + 
       2*G[w^(-1), -1, -1, z] + 2*G[w^(-1), -1, 1, z] - 
       4*G[w^(-1), -1, w, z] + 2*G[w^(-1), 1, -1, z] + 2*G[w^(-1), 1, 1, z] - 
       4*G[w^(-1), 1, w, z] - 4*G[w^(-1), w^(-1), -1, z] - 
       4*G[w^(-1), w^(-1), 1, z] + 8*G[w^(-1), w^(-1), w, z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 2*G[-1, -1, w, 1, z] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
     2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
     4*G[-1, w^(-1), w, -1, z] + 4*G[-1, w^(-1), w, 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] + 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 2*G[1, 1, 0, 1, w] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] + 
     2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
     2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
     4*G[1, w^(-1), w, -1, z] + 4*G[1, w^(-1), w, 1, z] + 
     2*G[w^(-1), -1, -1, -1, z] - 2*G[w^(-1), -1, -1, 1, z] + 
     2*G[w^(-1), -1, 1, -1, z] - 2*G[w^(-1), -1, 1, 1, z] - 
     4*G[w^(-1), -1, w, -1, z] + 4*G[w^(-1), -1, w, 1, z] + 
     2*G[w^(-1), 1, -1, -1, z] - 2*G[w^(-1), 1, -1, 1, z] + 
     2*G[w^(-1), 1, 1, -1, z] - 2*G[w^(-1), 1, 1, 1, z] - 
     4*G[w^(-1), 1, w, -1, z] + 4*G[w^(-1), 1, w, 1, z] - 
     4*G[w^(-1), w^(-1), -1, -1, z] + 4*G[w^(-1), w^(-1), -1, 1, z] - 
     4*G[w^(-1), w^(-1), 1, -1, z] + 4*G[w^(-1), w^(-1), 1, 1, z] + 
     8*G[w^(-1), w^(-1), w, -1, z] - 8*G[w^(-1), w^(-1), w, 1, z])/2 + 
   (-((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
       (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w, z] - G[1, -1, z] - 
        G[1, 1, z] + 2*G[1, w, z] + 2*G[w^(-1), -1, z] + 2*G[w^(-1), 1, z] - 
        4*G[w^(-1), w, z])) - (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
       2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) - 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w^(-1), z] + 2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - 
       4*G[-1, w, w^(-1), z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 
       2*G[1, 1, w^(-1), z] + 2*G[1, w, -1, z] + 2*G[1, w, 1, z] - 
       4*G[1, w, w^(-1), z] + 2*G[w^(-1), -1, -1, z] + 
       2*G[w^(-1), -1, 1, z] - 4*G[w^(-1), -1, w^(-1), z] + 
       2*G[w^(-1), 1, -1, z] + 2*G[w^(-1), 1, 1, z] - 
       4*G[w^(-1), 1, w^(-1), z] - 4*G[w^(-1), w, -1, z] - 
       4*G[w^(-1), w, 1, z] + 8*G[w^(-1), w, w^(-1), z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] - 2*G[-1, 0, -1, -1, w] + 
     2*G[-1, 0, -1, 1, w] - 2*G[-1, 0, 1, -1, w] + 2*G[-1, 0, 1, 1, w] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 2*G[-1, 1, w^(-1), -1, z] - 
     2*G[-1, 1, w^(-1), 1, z] + 2*G[-1, w, -1, -1, z] - 
     2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] - 
     4*G[-1, w, w^(-1), -1, z] + 4*G[-1, w, w^(-1), 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] - 2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] - 
     2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] + G[1, 1, -1, -1, w] - 
     G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
     2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 
     2*G[1, w, 1, 1, z] - 4*G[1, w, w^(-1), -1, z] + 
     4*G[1, w, w^(-1), 1, z] + 2*G[w^(-1), -1, -1, -1, z] - 
     2*G[w^(-1), -1, -1, 1, z] + 2*G[w^(-1), -1, 1, -1, z] - 
     2*G[w^(-1), -1, 1, 1, z] - 4*G[w^(-1), -1, w^(-1), -1, z] + 
     4*G[w^(-1), -1, w^(-1), 1, z] + 2*G[w^(-1), 1, -1, -1, z] - 
     2*G[w^(-1), 1, -1, 1, z] + 2*G[w^(-1), 1, 1, -1, z] - 
     2*G[w^(-1), 1, 1, 1, z] - 4*G[w^(-1), 1, w^(-1), -1, z] + 
     4*G[w^(-1), 1, w^(-1), 1, z] - 4*G[w^(-1), w, -1, -1, z] + 
     4*G[w^(-1), w, -1, 1, z] - 4*G[w^(-1), w, 1, -1, z] + 
     4*G[w^(-1), w, 1, 1, z] + 8*G[w^(-1), w, w^(-1), -1, z] - 
     8*G[w^(-1), w, w^(-1), 1, z])/2 + 
   ((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
       2*G[-1, w, z] - G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z] + 
       2*G[w^(-1), -1, z] + 2*G[w^(-1), 1, z] - 4*G[w^(-1), w, z]) + 
     (G[-1, z] + G[1, z] - 2*G[w^(-1), z])*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] - 2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 
       2*G[0, -1, 1, w] + 4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] + G[1, -1, -1, w] - 
       G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + 
       G[-1, -1, 1, z] - 2*G[-1, -1, w, z] + G[-1, 1, -1, z] + 
       G[-1, 1, 1, z] - 2*G[-1, 1, w, z] - 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] + 4*G[-1, w, w, z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 
       2*G[1, 1, w, z] - 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
       4*G[1, w, w, z] - 2*G[w^(-1), -1, -1, z] - 2*G[w^(-1), -1, 1, z] + 
       4*G[w^(-1), -1, w, z] - 2*G[w^(-1), 1, -1, z] - 2*G[w^(-1), 1, 1, z] + 
       4*G[w^(-1), 1, w, z] + 4*G[w^(-1), w, -1, z] + 4*G[w^(-1), w, 1, z] - 
       8*G[w^(-1), w, w, z]) + G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 
     2*G[-1, -1, 0, 1, w] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 
     2*G[-1, -1, w, 1, z] - 2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] + 
     4*G[-1, 0, 0, -1, w] - 4*G[-1, 0, 0, 1, w] - 2*G[-1, 0, 1, -1, w] + 
     2*G[-1, 0, 1, 1, w] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 
     2*G[-1, 1, 0, 1, w] + G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 
     2*G[-1, 1, w, 1, z] + 2*G[-1, w, -1, -1, z] - 2*G[-1, w, -1, 1, z] + 
     2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] - 4*G[-1, w, w, -1, z] + 
     4*G[-1, w, w, 1, z] + G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - 
     G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 
     2*G[1, -1, 0, 1, w] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 
     2*G[1, -1, w, 1, z] - 2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] + 
     4*G[1, 0, 0, -1, w] - 4*G[1, 0, 0, 1, w] - 2*G[1, 0, 1, -1, w] + 
     2*G[1, 0, 1, 1, w] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 
     2*G[1, 1, 0, 1, w] + G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - 
     G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 
     2*G[1, 1, w, 1, z] + 2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 
     2*G[1, w, 1, -1, z] - 2*G[1, w, 1, 1, z] - 4*G[1, w, w, -1, z] + 
     4*G[1, w, w, 1, z] + 2*G[w^(-1), -1, -1, -1, z] - 
     2*G[w^(-1), -1, -1, 1, z] + 2*G[w^(-1), -1, 1, -1, z] - 
     2*G[w^(-1), -1, 1, 1, z] - 4*G[w^(-1), -1, w, -1, z] + 
     4*G[w^(-1), -1, w, 1, z] + 2*G[w^(-1), 1, -1, -1, z] - 
     2*G[w^(-1), 1, -1, 1, z] + 2*G[w^(-1), 1, 1, -1, z] - 
     2*G[w^(-1), 1, 1, 1, z] - 4*G[w^(-1), 1, w, -1, z] + 
     4*G[w^(-1), 1, w, 1, z] - 4*G[w^(-1), w, -1, -1, z] + 
     4*G[w^(-1), w, -1, 1, z] - 4*G[w^(-1), w, 1, -1, z] + 
     4*G[w^(-1), w, 1, 1, z] + 8*G[w^(-1), w, w, -1, z] - 
     8*G[w^(-1), w, w, 1, z])/2 + 
   (-((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
       (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
        2*G[w, -1, z] + 2*G[w, 1, z])) - (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) - (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + 
       G[-1, -1, 1, z] + G[-1, 1, -1, z] - G[-1, 1, 1, z] - G[1, -1, -1, z] + 
       G[1, -1, 1, z] + G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[w, -1, -1, z] - 
       2*G[w, -1, 1, z] - 2*G[w, 1, -1, z] + 2*G[w, 1, 1, z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] - G[-1, -1, 1, 1, z] - G[-1, 1, -1, -1, w] + 
     G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] - 2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 
     2*G[0, -1, 1, -1, w] - 2*G[0, -1, 1, 1, w] + 2*G[0, 1, -1, -1, w] - 
     2*G[0, 1, -1, 1, w] - 2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - G[1, 1, -1, -1, w] + 
     G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] - 
     2*G[w, -1, 1, -1, z] + 2*G[w, -1, 1, 1, z] - 2*G[w, 1, -1, -1, z] + 
     2*G[w, 1, -1, 1, z] + 2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z])/2 + 
   (-((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
       (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] - G[1, -1, z] - 
        G[1, 1, z] + 2*G[1, w^(-1), z] + 2*G[w, -1, z] + 2*G[w, 1, z] - 
        4*G[w, w^(-1), z])) - (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) - (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
       G[-1, -1, 1, z] + 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + 2*G[-1, w^(-1), -1, z] + 
       2*G[-1, w^(-1), 1, z] - 4*G[-1, w^(-1), w^(-1), z] - G[1, -1, -1, z] - 
       G[1, -1, 1, z] + 2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - 
       G[1, 1, 1, z] + 2*G[1, 1, w^(-1), z] + 2*G[1, w^(-1), -1, z] + 
       2*G[1, w^(-1), 1, z] - 4*G[1, w^(-1), w^(-1), z] + 2*G[w, -1, -1, z] + 
       2*G[w, -1, 1, z] - 4*G[w, -1, w^(-1), z] + 2*G[w, 1, -1, z] + 
       2*G[w, 1, 1, z] - 4*G[w, 1, w^(-1), z] - 4*G[w, w^(-1), -1, z] - 
       4*G[w, w^(-1), 1, z] + 8*G[w, w^(-1), w^(-1), z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
     2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
     2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
     4*G[-1, w^(-1), w^(-1), -1, z] + 4*G[-1, w^(-1), w^(-1), 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] - 2*G[0, -1, 1, -1, w] + 
     2*G[0, -1, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] - 
     2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] + G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
     2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
     2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
     4*G[1, w^(-1), w^(-1), -1, z] + 4*G[1, w^(-1), w^(-1), 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 4*G[w, -1, w^(-1), -1, z] + 
     4*G[w, -1, w^(-1), 1, z] + 2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 
     2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] - 4*G[w, 1, w^(-1), -1, z] + 
     4*G[w, 1, w^(-1), 1, z] - 4*G[w, w^(-1), -1, -1, z] + 
     4*G[w, w^(-1), -1, 1, z] - 4*G[w, w^(-1), 1, -1, z] + 
     4*G[w, w^(-1), 1, 1, z] + 8*G[w, w^(-1), w^(-1), -1, z] - 
     8*G[w, w^(-1), w^(-1), 1, z])/2 + 
   ((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(-G[-1, -1, z] - G[-1, 1, z] + 
       2*G[-1, w^(-1), z] - G[1, -1, z] - G[1, 1, z] + 2*G[1, w^(-1), z] + 
       2*G[w, -1, z] + 2*G[w, 1, z] - 4*G[w, w^(-1), z]) + 
     (-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
       2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 2*G[1, 0, -1, w] - 
       2*G[1, 0, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] - 2*G[-1, w^(-1), -1, z] - 2*G[-1, w^(-1), 1, z] + 
       4*G[-1, w^(-1), w, z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] - 
       2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z] + 4*G[1, w^(-1), w, z] - 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 4*G[w, -1, w, z] - 
       2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] + 4*G[w, 1, w, z] + 
       4*G[w, w^(-1), -1, z] + 4*G[w, w^(-1), 1, z] - 8*G[w, w^(-1), w, z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 2*G[-1, -1, w, 1, z] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] + 
     2*G[-1, w^(-1), 1, -1, z] - 2*G[-1, w^(-1), 1, 1, z] - 
     4*G[-1, w^(-1), w, -1, z] + 4*G[-1, w^(-1), w, 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 4*G[0, -1, 0, -1, w] - 
     4*G[0, -1, 0, 1, w] - 2*G[0, -1, 1, -1, w] + 2*G[0, -1, 1, 1, w] - 
     2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] + 4*G[0, 1, 0, -1, w] - 
     4*G[0, 1, 0, 1, w] - 2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] + 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 2*G[1, 1, 0, 1, w] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] + 
     2*G[1, w^(-1), -1, -1, z] - 2*G[1, w^(-1), -1, 1, z] + 
     2*G[1, w^(-1), 1, -1, z] - 2*G[1, w^(-1), 1, 1, z] - 
     4*G[1, w^(-1), w, -1, z] + 4*G[1, w^(-1), w, 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 4*G[w, -1, w, -1, z] + 4*G[w, -1, w, 1, z] + 
     2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 2*G[w, 1, 1, -1, z] - 
     2*G[w, 1, 1, 1, z] - 4*G[w, 1, w, -1, z] + 4*G[w, 1, w, 1, z] - 
     4*G[w, w^(-1), -1, -1, z] + 4*G[w, w^(-1), -1, 1, z] - 
     4*G[w, w^(-1), 1, -1, z] + 4*G[w, w^(-1), 1, 1, z] + 
     8*G[w, w^(-1), w, -1, z] - 8*G[w, w^(-1), w, 1, z])/2 + 
   ((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 2*G[w, 1, z] + 
       4*G[w, w, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
       2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       2*G[-1, -1, w^(-1), z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w^(-1), z] - 2*G[-1, w, -1, z] - 2*G[-1, w, 1, z] + 
       4*G[-1, w, w^(-1), z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w^(-1), z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 
       2*G[1, 1, w^(-1), z] - 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
       4*G[1, w, w^(-1), z] - 2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 
       4*G[w, -1, w^(-1), z] - 2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] + 
       4*G[w, 1, w^(-1), z] + 4*G[w, w, -1, z] + 4*G[w, w, 1, z] - 
       8*G[w, w, w^(-1), z]) + G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - 
     G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - 
     G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 
     2*G[-1, -1, w^(-1), -1, z] - 2*G[-1, -1, w^(-1), 1, z] - 
     2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] - 2*G[-1, 0, 1, -1, w] + 
     2*G[-1, 0, 1, 1, w] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
     2*G[-1, 1, w^(-1), -1, z] - 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[-1, w, -1, -1, z] - 2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 
     2*G[-1, w, 1, 1, z] - 4*G[-1, w, w^(-1), -1, z] + 
     4*G[-1, w, w^(-1), 1, z] - 2*G[0, -1, -1, -1, w] + 
     2*G[0, -1, -1, 1, w] - 2*G[0, -1, 1, -1, w] + 2*G[0, -1, 1, 1, w] + 
     4*G[0, 0, -1, -1, w] - 4*G[0, 0, -1, 1, w] + 4*G[0, 0, 1, -1, w] - 
     4*G[0, 0, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] - 
     2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] + G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] - 2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] - 
     2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] + G[1, 1, -1, -1, w] - 
     G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z] + 
     2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 
     2*G[1, w, 1, 1, z] - 4*G[1, w, w^(-1), -1, z] + 
     4*G[1, w, w^(-1), 1, z] + 2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 
     2*G[w, -1, 1, -1, z] - 2*G[w, -1, 1, 1, z] - 4*G[w, -1, w^(-1), -1, z] + 
     4*G[w, -1, w^(-1), 1, z] + 2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 
     2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] - 4*G[w, 1, w^(-1), -1, z] + 
     4*G[w, 1, w^(-1), 1, z] - 4*G[w, w, -1, -1, z] + 4*G[w, w, -1, 1, z] - 
     4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z] + 8*G[w, w, w^(-1), -1, z] - 
     8*G[w, w, w^(-1), 1, z])/2 + 
   (-((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
        G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] + G[-1, 1, z] - 
        2*G[-1, w, z] + G[1, -1, z] + G[1, 1, z] - 2*G[1, w, z] - 
        2*G[w, -1, z] - 2*G[w, 1, z] + 4*G[w, w, z])) - 
     (-G[-1, z] - G[1, z] + 2*G[w, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 
       4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 2*G[0, 1, -1, w] + 
       2*G[0, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] - G[-1, 1, -1, z] - G[-1, 1, 1, z] + 
       2*G[-1, 1, w, z] + 2*G[-1, w, -1, z] + 2*G[-1, w, 1, z] - 
       4*G[-1, w, w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z] + 
       2*G[1, w, -1, z] + 2*G[1, w, 1, z] - 4*G[1, w, w, z] + 
       2*G[w, -1, -1, z] + 2*G[w, -1, 1, z] - 4*G[w, -1, w, z] + 
       2*G[w, 1, -1, z] + 2*G[w, 1, 1, z] - 4*G[w, 1, w, z] - 
       4*G[w, w, -1, z] - 4*G[w, w, 1, z] + 8*G[w, w, w, z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w, -1, z] - 2*G[-1, -1, w, 1, z] - 
     2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] + 4*G[-1, 0, 0, -1, w] - 
     4*G[-1, 0, 0, 1, w] - 2*G[-1, 0, 1, -1, w] + 2*G[-1, 0, 1, 1, w] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     2*G[-1, w, -1, -1, z] - 2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 
     2*G[-1, w, 1, 1, z] - 4*G[-1, w, w, -1, z] + 4*G[-1, w, w, 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 4*G[0, -1, 0, -1, w] - 
     4*G[0, -1, 0, 1, w] - 2*G[0, -1, 1, -1, w] + 2*G[0, -1, 1, 1, w] + 
     4*G[0, 0, -1, -1, w] - 4*G[0, 0, -1, 1, w] - 8*G[0, 0, 0, -1, w] + 
     8*G[0, 0, 0, 1, w] + 4*G[0, 0, 1, -1, w] - 4*G[0, 0, 1, 1, w] - 
     2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] + 4*G[0, 1, 0, -1, w] - 
     4*G[0, 1, 0, 1, w] - 2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] - 
     2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] + 4*G[1, 0, 0, -1, w] - 
     4*G[1, 0, 0, 1, w] - 2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] + 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] - 2*G[1, 1, 0, -1, w] + 2*G[1, 1, 0, 1, w] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] + 
     2*G[1, w, -1, -1, z] - 2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 
     2*G[1, w, 1, 1, z] - 4*G[1, w, w, -1, z] + 4*G[1, w, w, 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 4*G[w, -1, w, -1, z] + 4*G[w, -1, w, 1, z] + 
     2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 2*G[w, 1, 1, -1, z] - 
     2*G[w, 1, 1, 1, z] - 4*G[w, 1, w, -1, z] + 4*G[w, 1, w, 1, z] - 
     4*G[w, w, -1, -1, z] + 4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 
     4*G[w, w, 1, 1, z] + 8*G[w, w, w, -1, z] - 8*G[w, w, w, 1, z])/2, 
 fE12[{0}, sij, sjk, sik] -> 0, fE12[{1}, sij, sjk, sik] -> 0, 
 fE12[{2}, sij, sjk, sik] -> 0, fE12[{3}, sij, sjk, sik] -> 0, 
 fE12[{4}, sij, sjk, sik] -> 
  (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
    (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + G[1, -1, z] + G[1, 1, z] - 
     2*G[1, w, z] - 2*G[w, -1, z] - 2*G[w, 1, z] + 4*G[w, w, z]) + 
   (-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
     G[-1, 1, -1, w] - G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 
     2*G[0, -1, 1, w] - 2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - 
     G[1, -1, -1, w] + G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
   (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
     G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
     2*G[-1, w, 1, z] - G[1, -1, -1, z] + G[1, -1, 1, z] - G[1, 1, -1, z] + 
     G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 2*G[w, -1, -1, z] - 
     2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] - 
     4*G[w, w, -1, z] + 4*G[w, w, 1, z]) + G[-1, -1, -1, -1, w] + 
   G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] - 
   G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + 
   G[-1, -1, 1, 1, z] - 2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] + 
   2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] + G[-1, 1, -1, -1, w] + 
   G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] - 
   G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + 
   G[-1, 1, 1, 1, z] - 2*G[-1, w, -1, -1, z] + 2*G[-1, w, -1, 1, z] + 
   2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] - 2*G[0, -1, -1, -1, w] + 
   2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 2*G[0, -1, 1, 1, w] + 
   4*G[0, 0, -1, -1, w] - 4*G[0, 0, -1, 1, w] - 4*G[0, 0, 1, -1, w] + 
   4*G[0, 0, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] + 
   2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] + G[1, -1, -1, -1, w] + 
   G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - G[1, -1, -1, 1, z] - 
   G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + 
   G[1, -1, 1, 1, z] - 2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] + 
   2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] + G[1, 1, -1, -1, w] + 
   G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - 
   G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + 
   G[1, 1, 1, 1, z] - 
   (3*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
       (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
      (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
        G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
        G[1, 1, -1, w] - G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
       (-G[-1, -1, -1, z] + G[-1, -1, 1, z] + G[-1, 1, -1, z] - 
        G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - G[1, 1, -1, z] + 
        G[1, 1, 1, z]) + G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - 
      G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - 
      G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 
      G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
      G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - 
      G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - G[1, -1, -1, -1, w] - 
      G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
      G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
      G[1, -1, 1, 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
      G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
      G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z]))/2 - 
   2*G[1, w, -1, -1, z] + 2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 
   2*G[1, w, 1, 1, z] - 2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] + 
   2*G[w, -1, 1, -1, z] - 2*G[w, -1, 1, 1, z] - 2*G[w, 1, -1, -1, z] + 
   2*G[w, 1, -1, 1, z] + 2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] + 
   ((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - 
       G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]) + 
     (-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
       2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 
       2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 
       2*G[1, -1, w, z] + G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] + 
       2*G[w, -1, -1, z] + 2*G[w, -1, 1, z] - 4*G[w, -1, w, z] - 
       2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] + 4*G[w, 1, w, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - 2*G[-1, -1, 0, -1, w] + 2*G[-1, -1, 0, 1, w] + 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] - 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] + 2*G[-1, 1, 0, -1, w] - 2*G[-1, 1, 0, 1, w] - 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 4*G[0, -1, 0, -1, w] - 
     4*G[0, -1, 0, 1, w] - 2*G[0, -1, 1, -1, w] + 2*G[0, -1, 1, 1, w] + 
     2*G[0, 1, -1, -1, w] - 2*G[0, 1, -1, 1, w] - 4*G[0, 1, 0, -1, w] + 
     4*G[0, 1, 0, 1, w] + 2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
     G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 2*G[1, -1, w, 1, z] - 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] + 2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] - 2*G[w, -1, 1, -1, z] + 
     2*G[w, -1, 1, 1, z] + 4*G[w, -1, w, -1, z] - 4*G[w, -1, w, 1, z] + 
     2*G[w, 1, -1, -1, z] - 2*G[w, 1, -1, 1, z] + 2*G[w, 1, 1, -1, z] - 
     2*G[w, 1, 1, 1, z] - 4*G[w, 1, w, -1, z] + 4*G[w, 1, w, 1, z])/2 + 
   4*G[w, w, -1, -1, z] - 4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 
   4*G[w, w, 1, 1, z], fE13[{0}, sij, sjk, sik] -> 0, 
 fE13[{1}, sij, sjk, sik] -> 0, fE13[{2}, sij, sjk, sik] -> 0, 
 fE13[{3}, sij, sjk, sik] -> 0, fE13[{4}, sij, sjk, sik] -> 
  -8*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
     (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[-1, -1, -1, z] + G[-1, -1, 1, z] - 2*G[-1, -1, w^(-1), z] - 
       G[-1, 1, -1, z] - G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] - 
       G[1, -1, -1, z] - G[1, -1, 1, z] + 2*G[1, -1, w^(-1), z] + 
       G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w^(-1), z]) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] - G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w^(-1), -1, z] + 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] - 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
     2*G[1, 1, w^(-1), -1, z] - 2*G[1, 1, w^(-1), 1, z]) + 
   2*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + 
       G[1, 1, z]) + (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + 
       G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - G[-1, -1, 1, z] + 
       2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
       2*G[-1, 1, w, z] + G[1, -1, -1, z] + G[1, -1, 1, z] - 
       2*G[1, -1, w, z] - G[1, 1, -1, z] - G[1, 1, 1, z] + 2*G[1, 1, w, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + 2*G[-1, -1, 0, -1, w] - 2*G[-1, -1, 0, 1, w] - 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] + 
     G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, -1, 1, z] - 2*G[-1, 1, 0, -1, w] + 2*G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] + 
     G[-1, 1, 1, 1, z] + 2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - 2*G[1, -1, 0, -1, w] + 2*G[1, -1, 0, 1, w] + 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w, -1, z] - 2*G[1, -1, w, 1, z] - 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] + 2*G[1, 1, 0, -1, w] - 2*G[1, 1, 0, 1, w] - 
     G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] - 
     G[1, 1, 1, 1, z] - 2*G[1, 1, w, -1, z] + 2*G[1, 1, w, 1, z]) + 
   4*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (-G[-1, -1, z] - G[-1, 1, z] + 2*G[-1, w^(-1), z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w^(-1), z]) + (-G[-1, z] + G[1, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] - 
       G[-1, -1, 1, z] + G[-1, 1, -1, z] - G[-1, 1, 1, z] - 
       2*G[-1, w^(-1), -1, z] + 2*G[-1, w^(-1), 1, z] - G[1, -1, -1, z] + 
       G[1, -1, 1, z] - G[1, 1, -1, z] + G[1, 1, 1, z] + 
       2*G[1, w^(-1), -1, z] - 2*G[1, w^(-1), 1, z]) + G[-1, -1, -1, -1, w] - 
     G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 
     G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] - 
     G[-1, -1, 1, 1, z] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] + 
     2*G[-1, w^(-1), -1, -1, z] - 2*G[-1, w^(-1), -1, 1, z] - 
     2*G[-1, w^(-1), 1, -1, z] + 2*G[-1, w^(-1), 1, 1, z] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] - 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] - G[1, 1, -1, -1, w] + 
     G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] + 
     G[1, 1, 1, 1, z] - 2*G[1, w^(-1), -1, -1, z] + 
     2*G[1, w^(-1), -1, 1, z] + 2*G[1, w^(-1), 1, -1, z] - 
     2*G[1, w^(-1), 1, 1, z]) - 
   7*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - G[1, -1, z] - 
       G[1, 1, z] + 2*G[1, w, z]) + (-G[-1, z] + G[1, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] + G[1, 1, -1, z] - 
       G[1, 1, 1, z] - 2*G[1, w, -1, z] + 2*G[1, w, 1, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] - 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] + 2*G[-1, 0, -1, -1, w] - 
     2*G[-1, 0, -1, 1, w] - 2*G[-1, 0, 1, -1, w] + 2*G[-1, 0, 1, 1, w] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] - 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] - 2*G[-1, w, -1, -1, z] + 
     2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] + 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, 0, -1, -1, w] + 
     2*G[1, 0, -1, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] + 
     G[1, 1, -1, -1, w] - G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] + 
     G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] + G[1, 1, 1, -1, z] + 
     G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] + 2*G[1, w, -1, -1, z] - 
     2*G[1, w, -1, 1, z] - 2*G[1, w, 1, -1, z] + 2*G[1, w, 1, 1, z]), 
 fE14[{0}, sij, sjk, sik] -> 0, fE14[{1}, sij, sjk, sik] -> 0, 
 fE14[{2}, sij, sjk, sik] -> 2*(-(G[0, w]*G[0, z]) + G[0, 0, w] + 
    G[0, 0, z]), fE14[{3}, sij, sjk, sik] -> -(Pi^2*(-G[0, w] + G[0, z]))/3 + 
   2*(4*G[0, z]*G[0, 0, w] - G[0, w]*(4*G[0, 0, z] - 6*G[0, -w, z] - 
       2*G[0, w, z]) - 4*G[0, 0, 0, w] + 4*G[0, 0, 0, z] - 6*G[0, -w, 0, z] - 
     2*G[0, w, 0, z]) + 2*((-G[0, z] + 2*G[w, z])*G[0, 0, w] - 
     G[0, w]*(-G[0, 0, z] + 2*G[w, 0, z]) + G[0, 0, 0, w] - G[0, 0, 0, z] + 
     2*G[w, 0, 0, z]) - 6*Zeta[3], fE14[{4}, sij, sjk, sik] -> 
  (-13*Pi^4)/180 + (Pi^2*(-(G[0, w]*G[0, z]) + G[0, 0, w] + G[0, 0, z]))/3 - 
   (Pi^2*(-4*G[0, w]*G[0, z] + 4*G[0, 0, w] + 4*G[0, 0, z] - 6*G[0, -w, z] - 
      2*G[0, w, z]))/3 - (Pi^2*(-(G[0, w]*(-G[0, z] + 2*G[w, z])) - 
      G[0, 0, w] - G[0, 0, z] + 2*G[w, 0, z]))/3 - 
   12*(G[0, 0, w]*G[0, 0, z] - G[0, z]*G[0, 0, 0, w] - 
     G[0, w]*G[0, 0, 0, z] + G[0, 0, 0, 0, w] + G[0, 0, 0, 0, z]) + 
   2*(4*G[0, 0, w]*(4*G[0, 0, z] - 6*G[0, -w, z] - 2*G[0, w, z]) - 
     16*G[0, z]*G[0, 0, 0, w] - G[0, w]*(16*G[0, 0, 0, z] - 
       24*G[0, 0, -w, z] - 8*G[0, 0, w, z] - 24*G[0, -w, 0, z] + 
       36*G[0, -w, -w, z] + 12*G[0, -w, w, z] - 8*G[0, w, 0, z] + 
       12*G[0, w, -w, z] + 4*G[0, w, w, z]) + 16*G[0, 0, 0, 0, w] + 
     16*G[0, 0, 0, 0, z] - 24*G[0, 0, -w, 0, z] - 8*G[0, 0, w, 0, z] - 
     24*G[0, -w, 0, 0, z] + 36*G[0, -w, -w, 0, z] + 12*G[0, -w, w, 0, z] - 
     8*G[0, w, 0, 0, z] + 12*G[0, w, -w, 0, z] + 4*G[0, w, w, 0, z]) + 
   2*(4*G[0, 0, w]*(-G[0, 0, z] + 2*G[w, 0, z]) - 4*(-G[0, z] + 2*G[w, z])*
      G[0, 0, 0, w] - G[0, w]*(-4*G[0, 0, 0, z] + 6*G[0, 0, -w, z] + 
       2*G[0, 0, w, z] + 8*G[w, 0, 0, z] - 12*G[w, 0, -w, z] - 
       4*G[w, 0, w, z]) - 4*G[0, 0, 0, 0, w] - 4*G[0, 0, 0, 0, z] + 
     6*G[0, 0, -w, 0, z] + 2*G[0, 0, w, 0, z] + 8*G[w, 0, 0, 0, z] - 
     12*G[w, 0, -w, 0, z] - 4*G[w, 0, w, 0, z]) + 
   2*(G[0, 0, w]*(G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 4*G[w, w, z]) + 
     (-G[0, z] + 2*G[w, z])*G[0, 0, 0, w] - 
     G[0, w]*(G[0, 0, 0, z] - 2*G[0, w, 0, z] - 2*G[w, 0, 0, z] + 
       4*G[w, w, 0, z]) + G[0, 0, 0, 0, w] + G[0, 0, 0, 0, z] - 
     2*G[0, w, 0, 0, z] - 2*G[w, 0, 0, 0, z] + 4*G[w, w, 0, 0, z]) - 
   22*(-G[0, w] + G[0, z])*Zeta[3] - 6*(G[0, w] - G[0, z] + 2*G[w, z])*
    Zeta[3], fE15[{0}, sij, sjk, sik] -> 0, fE15[{1}, sij, sjk, sik] -> 
  2*(-G[0, w] + G[0, z]), fE15[{2}, sij, sjk, sik] -> 
  -Pi^2/3 + 2*(-(G[0, w]*(4*G[0, z] - 6*G[-w, z] - 2*G[w, z])) + 
     4*G[0, 0, w] + 4*G[0, 0, z] - 6*G[-w, 0, z] - 2*G[w, 0, z]), 
 fE15[{3}, sij, sjk, sik] -> (Pi^2*(-G[0, w] + G[0, z]))/3 - 
   (Pi^2*(-4*G[0, w] + 4*G[0, z] - 6*G[-w, z] - 2*G[w, z]))/3 - 
   12*(G[0, z]*G[0, 0, w] - G[0, w]*G[0, 0, z] - G[0, 0, 0, w] + 
     G[0, 0, 0, z]) + 2*(4*(4*G[0, z] - 6*G[-w, z] - 2*G[w, z])*G[0, 0, w] - 
     G[0, w]*(16*G[0, 0, z] - 24*G[0, -w, z] - 8*G[0, w, z] - 
       24*G[-w, 0, z] + 36*G[-w, -w, z] + 12*G[-w, w, z] - 8*G[w, 0, z] + 
       12*G[w, -w, z] + 4*G[w, w, z]) - 16*G[0, 0, 0, w] + 16*G[0, 0, 0, z] - 
     24*G[0, -w, 0, z] - 8*G[0, w, 0, z] - 24*G[-w, 0, 0, z] + 
     36*G[-w, -w, 0, z] + 12*G[-w, w, 0, z] - 8*G[w, 0, 0, z] + 
     12*G[w, -w, 0, z] + 4*G[w, w, 0, z]) - 22*Zeta[3], 
 fE15[{4}, sij, sjk, sik] -> (-29*Pi^4)/90 + 
   2*Pi^2*(-(G[0, w]*G[0, z]) + G[0, 0, w] + G[0, 0, z]) + 
   (Pi^2*(-(G[0, w]*(4*G[0, z] - 6*G[-w, z] - 2*G[w, z])) + 4*G[0, 0, w] + 
      4*G[0, 0, z] - 6*G[-w, 0, z] - 2*G[w, 0, z]))/3 - 
   (Pi^2*(-4*G[0, w]*(4*G[0, z] - 6*G[-w, z] - 2*G[w, z]) + 16*G[0, 0, w] + 
      16*G[0, 0, z] - 24*G[0, -w, z] - 8*G[0, w, z] - 24*G[-w, 0, z] + 
      36*G[-w, -w, z] + 12*G[-w, w, z] - 8*G[w, 0, z] + 12*G[w, -w, z] + 
      4*G[w, w, z]))/3 - 12*(4*G[0, 0, w]*G[0, 0, z] - 
     4*G[0, z]*G[0, 0, 0, w] - G[0, w]*(4*G[0, 0, 0, z] - 6*G[0, 0, -w, z] - 
       2*G[0, 0, w, z]) + 4*G[0, 0, 0, 0, w] + 4*G[0, 0, 0, 0, z] - 
     6*G[0, 0, -w, 0, z] - 2*G[0, 0, w, 0, z]) - 
   12*(G[0, 0, w]*(-G[0, 0, z] + 2*G[0, w, z]) + G[0, z]*G[0, 0, 0, w] - 
     G[0, w]*(-G[0, 0, 0, z] + 2*G[0, w, 0, z]) - G[0, 0, 0, 0, w] - 
     G[0, 0, 0, 0, z] + 2*G[0, w, 0, 0, z]) - 
   12*(G[0, 0, w]*(4*G[0, 0, z] - 6*G[-w, 0, z] - 2*G[w, 0, z]) - 
     (4*G[0, z] - 6*G[-w, z] - 2*G[w, z])*G[0, 0, 0, w] - 
     G[0, w]*(4*G[0, 0, 0, z] - 6*G[-w, 0, 0, z] - 2*G[w, 0, 0, z]) + 
     4*G[0, 0, 0, 0, w] + 4*G[0, 0, 0, 0, z] - 6*G[-w, 0, 0, 0, z] - 
     2*G[w, 0, 0, 0, z]) + 
   2*(4*G[0, 0, w]*(16*G[0, 0, z] - 24*G[0, -w, z] - 8*G[0, w, z] - 
       24*G[-w, 0, z] + 36*G[-w, -w, z] + 12*G[-w, w, z] - 8*G[w, 0, z] + 
       12*G[w, -w, z] + 4*G[w, w, z]) - 16*(4*G[0, z] - 6*G[-w, z] - 
       2*G[w, z])*G[0, 0, 0, w] - G[0, w]*(64*G[0, 0, 0, z] - 
       96*G[0, 0, -w, z] - 32*G[0, 0, w, z] - 96*G[0, -w, 0, z] + 
       144*G[0, -w, -w, z] + 48*G[0, -w, w, z] - 32*G[0, w, 0, z] + 
       48*G[0, w, -w, z] + 16*G[0, w, w, z] - 96*G[-w, 0, 0, z] + 
       144*G[-w, 0, -w, z] + 48*G[-w, 0, w, z] + 144*G[-w, -w, 0, z] - 
       216*G[-w, -w, -w, z] - 72*G[-w, -w, w, z] + 48*G[-w, w, 0, z] - 
       72*G[-w, w, -w, z] - 24*G[-w, w, w, z] - 32*G[w, 0, 0, z] + 
       48*G[w, 0, -w, z] + 16*G[w, 0, w, z] + 48*G[w, -w, 0, z] - 
       72*G[w, -w, -w, z] - 24*G[w, -w, w, z] + 16*G[w, w, 0, z] - 
       24*G[w, w, -w, z] - 8*G[w, w, w, z]) + 64*G[0, 0, 0, 0, w] + 
     64*G[0, 0, 0, 0, z] - 96*G[0, 0, -w, 0, z] - 32*G[0, 0, w, 0, z] - 
     96*G[0, -w, 0, 0, z] + 144*G[0, -w, -w, 0, z] + 48*G[0, -w, w, 0, z] - 
     32*G[0, w, 0, 0, z] + 48*G[0, w, -w, 0, z] + 16*G[0, w, w, 0, z] - 
     96*G[-w, 0, 0, 0, z] + 144*G[-w, 0, -w, 0, z] + 48*G[-w, 0, w, 0, z] + 
     144*G[-w, -w, 0, 0, z] - 216*G[-w, -w, -w, 0, z] - 
     72*G[-w, -w, w, 0, z] + 48*G[-w, w, 0, 0, z] - 72*G[-w, w, -w, 0, z] - 
     24*G[-w, w, w, 0, z] - 32*G[w, 0, 0, 0, z] + 48*G[w, 0, -w, 0, z] + 
     16*G[w, 0, w, 0, z] + 48*G[w, -w, 0, 0, z] - 72*G[w, -w, -w, 0, z] - 
     24*G[w, -w, w, 0, z] + 16*G[w, w, 0, 0, z] - 24*G[w, w, -w, 0, z] - 
     8*G[w, w, w, 0, z]) + (104*(-G[0, w] + G[0, z])*Zeta[3])/3 - 
   22*(-4*G[0, w] + 4*G[0, z] - 6*G[-w, z] - 2*G[w, z])*Zeta[3], 
 fE16[{0}, sij, sjk, sik] -> 0, fE16[{1}, sij, sjk, sik] -> 0, 
 fE16[{2}, sij, sjk, sik] -> (G[0, w]*G[0, z] - G[0, 0, w] - G[0, 0, z])/2, 
 fE16[{3}, sij, sjk, sik] -> (Pi^2*(-G[0, w] + G[0, z]))/12 + 
   (-4*G[0, z]*G[0, 0, w] + G[0, w]*(4*G[0, 0, z] - 6*G[0, -w, z] - 
       2*G[0, w, z]) + 4*G[0, 0, 0, w] - 4*G[0, 0, 0, z] + 6*G[0, -w, 0, z] + 
     2*G[0, w, 0, z])/2 - (3*((-G[0, z] + 2*G[w, z])*G[0, 0, w] - 
      G[0, w]*(-G[0, 0, z] + 2*G[w, 0, z]) + G[0, 0, 0, w] - G[0, 0, 0, z] + 
      2*G[w, 0, 0, z]))/2 - Zeta[3]/2, fE16[{4}, sij, sjk, sik] -> 
  (29*Pi^4)/720 - (Pi^2*(-(G[0, w]*G[0, z]) + G[0, 0, w] + G[0, 0, z]))/12 + 
   (Pi^2*(-4*G[0, w]*G[0, z] + 4*G[0, 0, w] + 4*G[0, 0, z] - 6*G[0, -w, z] - 
      2*G[0, w, z]))/12 + (Pi^2*(-(G[0, w]*(-G[0, z] + 2*G[w, z])) - 
      G[0, 0, w] - G[0, 0, z] + 2*G[w, 0, z]))/4 + 
   3*(G[0, 0, w]*G[0, 0, z] - G[0, z]*G[0, 0, 0, w] - G[0, w]*G[0, 0, 0, z] + 
     G[0, 0, 0, 0, w] + G[0, 0, 0, 0, z]) + 
   (-4*G[0, 0, w]*(4*G[0, 0, z] - 6*G[0, -w, z] - 2*G[0, w, z]) + 
     16*G[0, z]*G[0, 0, 0, w] + G[0, w]*(16*G[0, 0, 0, z] - 
       24*G[0, 0, -w, z] - 8*G[0, 0, w, z] - 24*G[0, -w, 0, z] + 
       36*G[0, -w, -w, z] + 12*G[0, -w, w, z] - 8*G[0, w, 0, z] + 
       12*G[0, w, -w, z] + 4*G[0, w, w, z]) - 16*G[0, 0, 0, 0, w] - 
     16*G[0, 0, 0, 0, z] + 24*G[0, 0, -w, 0, z] + 8*G[0, 0, w, 0, z] + 
     24*G[0, -w, 0, 0, z] - 36*G[0, -w, -w, 0, z] - 12*G[0, -w, w, 0, z] + 
     8*G[0, w, 0, 0, z] - 12*G[0, w, -w, 0, z] - 4*G[0, w, w, 0, z])/2 - 
   (3*(4*G[0, 0, w]*(-G[0, 0, z] + 2*G[w, 0, z]) - 4*(-G[0, z] + 2*G[w, z])*
       G[0, 0, 0, w] - G[0, w]*(-4*G[0, 0, 0, z] + 6*G[0, 0, -w, z] + 
        2*G[0, 0, w, z] + 8*G[w, 0, 0, z] - 12*G[w, 0, -w, z] - 
        4*G[w, 0, w, z]) - 4*G[0, 0, 0, 0, w] - 4*G[0, 0, 0, 0, z] + 
      6*G[0, 0, -w, 0, z] + 2*G[0, 0, w, 0, z] + 8*G[w, 0, 0, 0, z] - 
      12*G[w, 0, -w, 0, z] - 4*G[w, 0, w, 0, z]))/2 - 
   (3*(G[0, 0, w]*(G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 4*G[w, w, z]) + 
      (-G[0, z] + 2*G[w, z])*G[0, 0, 0, w] - 
      G[0, w]*(G[0, 0, 0, z] - 2*G[0, w, 0, z] - 2*G[w, 0, 0, z] + 
        4*G[w, w, 0, z]) + G[0, 0, 0, 0, w] + G[0, 0, 0, 0, z] - 
      2*G[0, w, 0, 0, z] - 2*G[w, 0, 0, 0, z] + 4*G[w, w, 0, 0, z]))/2 + 
   (11*(-G[0, w] + G[0, z])*Zeta[3])/2 + 
   (9*(G[0, w] - G[0, z] + 2*G[w, z])*Zeta[3])/2, 
 fE17[{0}, sij, sjk, sik] -> 0, fE17[{1}, sij, sjk, sik] -> 0, 
 fE17[{2}, sij, sjk, sik] -> 0, fE17[{3}, sij, sjk, sik] -> 0, 
 fE17[{4}, sij, sjk, sik] -> -Pi^4/15 + 
   2*(G[0, 0, w]*(G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 4*G[w, w, z]) + 
     (-G[0, z] + 2*G[w, z])*G[0, 0, 0, w] - 
     G[0, w]*(G[0, 0, 0, z] - 2*G[0, w, 0, z] - 2*G[w, 0, 0, z] + 
       4*G[w, w, 0, z]) + G[0, 0, 0, 0, w] + G[0, 0, 0, 0, z] - 
     2*G[0, w, 0, 0, z] - 2*G[w, 0, 0, 0, z] + 4*G[w, w, 0, 0, z]) + 
   4*(G[0, w] - G[0, z] + 2*G[w, z])*Zeta[3], fE18[{0}, sij, sjk, sik] -> 0, 
 fE18[{1}, sij, sjk, sik] -> 0, fE18[{2}, sij, sjk, sik] -> 0, 
 fE19[{0}, sij, sjk, sik] -> 0, fE19[{1}, sij, sjk, sik] -> 0, 
 fE19[{2}, sij, sjk, sik] -> 
  (4*(-(G[0, z]*(G[-1, w] - G[1, w])) - G[0, -1, w] + G[0, -1, z] + 
      G[0, 1, w] - G[0, 1, z]) + 8*(-(G[0, w]*(-G[-1, z]/2 + G[1, z]/2)) + 
      G[-1, 0, w]/2 - G[-1, 0, z]/2 - G[1, 0, w]/2 + G[1, 0, z]/2))/4, 
 fE19[{3}, sij, sjk, sik] -> 
  -(Pi^2*(-G[-1, w]/2 - G[-1, z]/2 + G[1, w]/2 + G[1, z]/2))/3 + 
   (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
    (-G[0, -1, w] + G[0, 1, w]) + (G[-1, w] - G[1, w])*
    (-G[0, -1, z] - G[0, 1, z] + 2*G[0, w^(-1), z]) - 
   (G[-1, w] - G[1, w])*(G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z]) - 
   G[0, z]*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w]) + 
   G[0, z]*(-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
     G[1, -1, w] + G[1, 1, w]) + (G[-1, w] - G[1, w])*
    (-2*G[0, 0, z] + 6*G[-w^(-1), 0, z] + 2*G[w, 0, z] + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 2*G[-1, 0, -1, w] + 
   2*G[-1, 0, 1, w] - 2*G[0, -1, -1, w] + 2*G[0, -1, -1, z] + 
   2*G[0, -1, 1, w] - 2*G[0, -1, 1, z] + 2*G[0, 0, -1, w] + 
   2*G[0, 0, -1, z] - 2*G[0, 0, 1, w] - 2*G[0, 0, 1, z] - 2*G[0, 1, -1, w] + 
   2*G[0, 1, -1, z] + 2*G[0, 1, 1, w] - 2*G[0, 1, 1, z] - 
   2*G[0, w^(-1), -1, z] + 2*G[0, w^(-1), 1, z] - 2*G[0, w, -1, z] + 
   2*G[0, w, 1, z] - 2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + 
   2*(4*(-G[-1, z]/2 + G[1, z]/2)*G[0, 0, w] - 
     G[0, w]*(-2*G[-1, 0, z] + 3*G[-1, -w, z] + G[-1, w, z] + 2*G[1, 0, z] - 
       3*G[1, -w, z] - G[1, w, z]) - 2*G[-1, 0, 0, w] - 2*G[-1, 0, 0, z] + 
     3*G[-1, -w, 0, z] + G[-1, w, 0, z] + 2*G[1, 0, 0, w] + 2*G[1, 0, 0, z] - 
     3*G[1, -w, 0, z] - G[1, w, 0, z]) - 6*G[-w^(-1), 0, -1, z] + 
   6*G[-w^(-1), 0, 1, z] - 2*G[w, 0, -1, z] + 2*G[w, 0, 1, z] + 
   ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
   ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
   ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) - 
   2*((G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      G[0, 0, w] - G[0, w]*(G[(-1 + w)/(1 + w), 0, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - G[-1, 0, 0, w] + 
     G[1, 0, 0, w] + G[(-1 + w)/(1 + w), 0, 0, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) + 
   ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
   2*((2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, w]/2 - G[1, 0, w]/2) - G[0, w]*(-G[0, -1, z] + G[0, 1, z] + 
       3*G[-w^(-1), -1, z] - 3*G[-w^(-1), 1, z] + G[w, -1, z] - G[w, 1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, z] + ((1 - w)*G[-((1 + w)/(-1 + w)), -1, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), 1, z]) + G[-1, -1, 0, w] - 
     G[-1, 1, 0, w] - G[0, -1, 0, z] + G[0, 1, 0, z] + G[1, -1, 0, w] - 
     G[1, 1, 0, w] + 3*G[-w^(-1), -1, 0, z] - 3*G[-w^(-1), 1, 0, z] + 
     G[w, -1, 0, z] - G[w, 1, 0, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, 0, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, 0, z]) - 
   2*((G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, z] + G[-((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - G[-1, -1, -1, w] + 
     G[-1, -1, 1, w] + G[-1, 1, -1, w] - G[-1, 1, 1, w] + G[1, -1, -1, w] - 
     G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w] + 
     G[(-1 + w)/(1 + w), -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, 1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, 1, z] + G[-((1 + w)/(-1 + w)), 1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)), 
 fE20[{0}, sij, sjk, sik] -> 0, fE20[{1}, sij, sjk, sik] -> 0, 
 fE20[{2}, sij, sjk, sik] -> 0, fE20[{3}, sij, sjk, sik] -> 
  -((-G[-1, z] - G[1, z] + 2*G[w, z])*G[0, 0, w]) + 
   (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
    (-G[0, -1, w] + G[0, 1, w]) + (-G[0, z] + 2*G[w, z])*
    (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
   G[0, w]*(-G[-1, 0, z] - G[1, 0, z] + 2*G[w, 0, z]) + 
   (G[-1, w] - G[1, w])*(G[0, -1, z] - G[0, 1, z] - 2*G[w, -1, z] + 
     2*G[w, 1, z]) + (G[-1, w] - G[1, w])*
    (((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, z]) + G[-1, 0, -1, w] + G[-1, 0, 0, w] + 
   G[-1, 0, 0, z] - G[-1, 0, 1, w] + G[0, -1, -1, w] - G[0, -1, -1, z] - 
   G[0, -1, 1, w] + G[0, -1, 1, z] - 2*G[0, 0, 0, w] - G[0, 1, -1, w] + 
   G[0, 1, -1, z] + G[0, 1, 1, w] - G[0, 1, 1, z] - G[1, 0, -1, w] + 
   G[1, 0, 0, w] + G[1, 0, 0, z] + G[1, 0, 1, w] + 
   (-((-G[-1, z] + G[1, z])*(-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 
        2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w])) - 
     (G[-1, w] - G[1, w])*(G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] - 
       G[1, -1, z] - G[1, 1, z] + 2*G[1, w, z]) + G[-1, -1, -1, w] + 
     G[-1, -1, -1, z] - G[-1, -1, 1, w] - G[-1, -1, 1, z] - 
     2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] + 
     G[-1, 1, -1, z] - G[-1, 1, 1, w] - G[-1, 1, 1, z] - 2*G[-1, w, -1, z] + 
     2*G[-1, w, 1, z] - G[1, -1, -1, w] - G[1, -1, -1, z] + G[1, -1, 1, w] + 
     G[1, -1, 1, z] + 2*G[1, 0, -1, w] - 2*G[1, 0, 1, w] - G[1, 1, -1, w] - 
     G[1, 1, -1, z] + G[1, 1, 1, w] + G[1, 1, 1, z] + 2*G[1, w, -1, z] - 
     2*G[1, w, 1, z])/2 + 2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] - 
   2*G[w, 0, 0, z] + 2*((-G[0, z] + 2*G[w, z])*G[0, 0, w] - 
     G[0, w]*(-G[0, 0, z] + 2*G[w, 0, z]) + G[0, 0, 0, w] - G[0, 0, 0, z] + 
     2*G[w, 0, 0, z]) - 2*G[w, 1, -1, z] + 
   (-((-G[-1, z] - G[1, z] + 2*G[w, z])*(G[-1, -1, w] - G[-1, 1, w] - 
        G[1, -1, w] + G[1, 1, w])) - (G[-1, w] - G[1, w])*
      (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
       2*G[w, -1, z] + 2*G[w, 1, z]) + G[-1, -1, -1, w] + G[-1, -1, -1, z] - 
     G[-1, -1, 1, w] - G[-1, -1, 1, z] - G[-1, 1, -1, w] - G[-1, 1, -1, z] + 
     G[-1, 1, 1, w] + G[-1, 1, 1, z] - 2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 
     2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] + G[1, -1, -1, w] + G[1, -1, -1, z] - 
     G[1, -1, 1, w] - G[1, -1, 1, z] - G[1, 1, -1, w] - G[1, 1, -1, z] + 
     G[1, 1, 1, w] + G[1, 1, 1, z] - 2*G[w, -1, -1, z] + 2*G[w, -1, 1, z] + 
     2*G[w, 1, -1, z] - 2*G[w, 1, 1, z])/2 + 2*G[w, 1, 1, z] + 
   G[(-1 + w)/(1 + w), 0, -1, z] + ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, z])/
    (1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) - 
   2*((-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*G[0, 0, w] - 
     G[0, w]*(-G[0, 0, z] + G[w, 0, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     G[-1, 0, 0, w]/2 - G[0, 0, 0, z] + G[1, 0, 0, w]/2 + G[w, 0, 0, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) + 
   G[-((1 + w)/(-1 + w)), 0, 1, z] + 
   2*((G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, w]/2 - G[1, 0, w]/2) - 
     G[0, w]*(((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - 
     G[-1, -1, 0, w]/2 + G[-1, 1, 0, w]/2 + G[1, -1, 0, w]/2 - 
     G[1, 1, 0, w]/2 + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) - 
   2*((-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[0, -1, z] - G[0, 1, z] - G[w, -1, z] + 
       G[w, 1, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, -1, w]/2 - G[-1, -1, 1, w]/2 - G[-1, 1, -1, w]/2 + 
     G[-1, 1, 1, w]/2 - G[0, -1, -1, z] + G[0, -1, 1, z] + G[0, 1, -1, z] - 
     G[0, 1, 1, z] + G[1, -1, -1, w]/2 - G[1, -1, 1, w]/2 - 
     G[1, 1, -1, w]/2 + G[1, 1, 1, w]/2 + G[w, -1, -1, z] - G[w, -1, 1, z] - 
     G[w, 1, -1, z] + G[w, 1, 1, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)), 
 fE21[{0}, sij, sjk, sik] -> 0, fE21[{1}, sij, sjk, sik] -> 0, 
 fE21[{2}, sij, sjk, sik] -> 0, fE21[{3}, sij, sjk, sik] -> 0, 
 fE21[{4}, sij, sjk, sik] -> -Pi^4/15 + 
   14*(G[0, 0, w]*(G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 4*G[w, w, z]) + 
     (-G[0, z] + 2*G[w, z])*G[0, 0, 0, w] - 
     G[0, w]*(G[0, 0, 0, z] - 2*G[0, w, 0, z] - 2*G[w, 0, 0, z] + 
       4*G[w, w, 0, z]) + G[0, 0, 0, 0, w] + G[0, 0, 0, 0, z] - 
     2*G[0, w, 0, 0, z] - 2*G[w, 0, 0, 0, z] + 4*G[w, w, 0, 0, z]) - 
   2*(G[0, 0, w]*(G[-1, 0, z] - 2*G[-1, w, z] + G[1, 0, z] - 2*G[1, w, z] - 
       2*G[w, 0, z] + 4*G[w, w, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      G[0, 0, 0, w] - G[0, w]*(G[-1, 0, 0, z] - 2*G[-1, w, 0, z] + 
       G[1, 0, 0, z] - 2*G[1, w, 0, z] - 2*G[w, 0, 0, z] + 4*G[w, w, 0, z]) - 
     G[-1, 0, 0, 0, w] + G[-1, 0, 0, 0, z] - 2*G[-1, w, 0, 0, z] + 
     2*G[0, 0, 0, 0, w] - G[1, 0, 0, 0, w] + G[1, 0, 0, 0, z] - 
     2*G[1, w, 0, 0, z] - 2*G[w, 0, 0, 0, z] + 4*G[w, w, 0, 0, z]) - 
   4*(G[0, 0, w]*(G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z] - 2*G[w, -1, z] - 
       2*G[w, 1, z] + 4*G[w, w, z]) + (-G[0, z] + 2*G[w, z])*
      (-G[-1, 0, 0, w] + 2*G[0, 0, 0, w] - G[1, 0, 0, w]) - 
     G[0, w]*(G[0, -1, 0, z] + G[0, 1, 0, z] - 2*G[0, w, 0, z] - 
       2*G[w, -1, 0, z] - 2*G[w, 1, 0, z] + 4*G[w, w, 0, z]) - 
     G[0, -1, 0, 0, w] + G[0, -1, 0, 0, z] + 2*G[0, 0, 0, 0, w] - 
     G[0, 1, 0, 0, w] + G[0, 1, 0, 0, z] - 2*G[0, w, 0, 0, z] - 
     2*G[w, -1, 0, 0, z] - 2*G[w, 1, 0, 0, z] + 4*G[w, w, 0, 0, z]) + 
   4*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 4*G[w, w, z]) + 
     (-G[0, z] + 2*G[w, z])*(G[0, -1, -1, w] - G[0, -1, 1, w] - 
       G[0, 1, -1, w] + G[0, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[0, 0, -1, z] + G[0, 0, 1, z] + 2*G[0, w, -1, z] - 2*G[0, w, 1, z] + 
       2*G[w, 0, -1, z] - 2*G[w, 0, 1, z] - 4*G[w, w, -1, z] + 
       4*G[w, w, 1, z]) + G[0, 0, -1, -1, w] + G[0, 0, -1, -1, z] - 
     G[0, 0, -1, 1, w] - G[0, 0, -1, 1, z] - G[0, 0, 1, -1, w] - 
     G[0, 0, 1, -1, z] + G[0, 0, 1, 1, w] + G[0, 0, 1, 1, z] - 
     2*G[0, w, -1, -1, z] + 2*G[0, w, -1, 1, z] + 2*G[0, w, 1, -1, z] - 
     2*G[0, w, 1, 1, z] - 2*G[w, 0, -1, -1, z] + 2*G[w, 0, -1, 1, z] + 
     2*G[w, 0, 1, -1, z] - 2*G[w, 0, 1, 1, z] + 4*G[w, w, -1, -1, z] - 
     4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z]) + 
   2*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z] - 2*G[w, -1, z] - 
       2*G[w, 1, z] + 4*G[w, w, z]) + (-G[0, z] + 2*G[w, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, -1, -1, z] + G[0, -1, 1, z] - 
       G[0, 1, -1, z] + G[0, 1, 1, z] + 2*G[0, w, -1, z] - 2*G[0, w, 1, z] + 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 
       2*G[w, 1, 1, z] - 4*G[w, w, -1, z] + 4*G[w, w, 1, z]) - 
     G[0, -1, -1, -1, w] + G[0, -1, -1, -1, z] + G[0, -1, -1, 1, w] - 
     G[0, -1, -1, 1, z] + G[0, -1, 1, -1, w] - G[0, -1, 1, -1, z] - 
     G[0, -1, 1, 1, w] + G[0, -1, 1, 1, z] + 2*G[0, 0, -1, -1, w] - 
     2*G[0, 0, -1, 1, w] - 2*G[0, 0, 1, -1, w] + 2*G[0, 0, 1, 1, w] - 
     G[0, 1, -1, -1, w] + G[0, 1, -1, -1, z] + G[0, 1, -1, 1, w] - 
     G[0, 1, -1, 1, z] + G[0, 1, 1, -1, w] - G[0, 1, 1, -1, z] - 
     G[0, 1, 1, 1, w] + G[0, 1, 1, 1, z] - 2*G[0, w, -1, -1, z] + 
     2*G[0, w, -1, 1, z] + 2*G[0, w, 1, -1, z] - 2*G[0, w, 1, 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] + 
     2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] + 4*G[w, w, -1, -1, z] - 
     4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z]) + 
   2*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 2*G[w, 1, z] + 
       4*G[w, w, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] - G[1, -1, -1, z] + G[1, -1, 1, z] - G[1, 1, -1, z] + 
       G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 
       2*G[w, 1, 1, z] - 4*G[w, w, -1, z] + 4*G[w, w, 1, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 2*G[-1, 0, -1, -1, w] + 
     2*G[-1, 0, -1, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] + 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] - 2*G[-1, w, -1, -1, z] + 
     2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
     2*G[0, -1, 1, 1, w] + 4*G[0, 0, -1, -1, w] - 4*G[0, 0, -1, 1, w] - 
     4*G[0, 0, 1, -1, w] + 4*G[0, 0, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 
     2*G[0, 1, -1, 1, w] + 2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] - 2*G[1, 0, -1, -1, w] + 
     2*G[1, 0, -1, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] + 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + 
     G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] - 2*G[1, w, -1, -1, z] + 
     2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 2*G[1, w, 1, 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] + 
     2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] + 4*G[w, w, -1, -1, z] - 
     4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z]) - 
   8*(G[0, 0, w]*(G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - 2*G[w, 0, z] + 2*G[w, w, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z]) + 
     (-G[0, z] + 2*G[w, z])*(G[-1, 0, 0, w]/2 + G[1, 0, 0, w]/2) - 
     G[0, w]*(G[0, 0, 0, z] - G[0, w, 0, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 0, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, z] - 
       2*G[w, 0, 0, z] + 2*G[w, w, 0, z] + ((1 + w)^(-1) + w/(1 + w))*
        G[w, (-1 + w)/(1 + w), 0, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), 0, z]) + G[0, -1, 0, 0, w]/2 + 
     G[0, 0, 0, 0, z] + G[0, 1, 0, 0, w]/2 - G[0, w, 0, 0, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 0, 0, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, 0, z] - 
     2*G[w, 0, 0, 0, z] + 2*G[w, w, 0, 0, z] + ((1 + w)^(-1) + w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, 0, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, 0, z]) + 
   4*((-G[0, -1, w] + G[0, 1, w])*(-G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       2*G[w, (-1 + w)/(1 + w), z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z]) + (-G[0, z] + 2*G[w, z])*
      (G[-1, 0, -1, w] - G[-1, 0, 1, w] - G[1, 0, -1, w] + G[1, 0, 1, w]) + 
     (G[-1, w] - G[1, w])*(((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 
         0, z] - G[0, -((1 + w)/(-1 + w)), 0, z] + 
       (-2/(1 + w) - (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 0, z] + 
       2*G[w, -((1 + w)/(-1 + w)), 0, z]) + G[0, -1, 0, -1, w] - 
     G[0, -1, 0, 1, w] - G[0, 1, 0, -1, w] + G[0, 1, 0, 1, w] - 
     G[0, (-1 + w)/(1 + w), 0, -1, z] + ((1 + w)^(-1) + w/(1 + w))*
      G[0, (-1 + w)/(1 + w), 0, 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, -1, z] - G[0, -((1 + w)/(-1 + w)), 0, 1, 
      z] + 2*G[w, (-1 + w)/(1 + w), 0, -1, z] + (-2/(1 + w) - (2*w)/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, 1, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, -1, z] + 
     2*G[w, -((1 + w)/(-1 + w)), 0, 1, z]) + 
   8*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(-G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       2*G[w, (-1 + w)/(1 + w), z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z]) + (-G[0, z] + 2*G[w, z])*
      (-G[-1, -1, 0, w]/2 + G[-1, 1, 0, w]/2 + G[1, -1, 0, w]/2 - 
       G[1, 1, 0, w]/2) - G[0, w]*((1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), -1, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), 1, z] + ((-1 - w)^(-1) - w/(1 + w))*
        G[w, (-1 + w)/(1 + w), -1, z] + (-(-1 - w)^(-1) + w/(1 + w))*
        G[w, (-1 + w)/(1 + w), 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), -1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), 1, z]) - G[0, -1, -1, 0, w]/2 + 
     G[0, -1, 1, 0, w]/2 + G[0, 1, -1, 0, w]/2 - G[0, 1, 1, 0, w]/2 + 
     (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, 0, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, 0, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 0, z] + 
     ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), -1, 0, z] + 
     (-(-1 - w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), 1, 0, z] + 
     ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-(1 - w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 1, 0, z]) - 
   8*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - 2*G[w, 0, z] + 2*G[w, w, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z]) + 
     (-G[0, z] + 2*G[w, z])*(G[-1, -1, -1, w]/2 - G[-1, -1, 1, w]/2 - 
       G[-1, 1, -1, w]/2 + G[-1, 1, 1, w]/2 + G[1, -1, -1, w]/2 - 
       G[1, -1, 1, w]/2 - G[1, 1, -1, w]/2 + G[1, 1, 1, w]/2) + 
     (G[-1, w] - G[1, w])*(-G[0, 0, -1, z] + G[0, 0, 1, z] + G[0, w, -1, z] - 
       G[0, w, 1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 
         -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, 
         z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 
         -1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 
         1, z] + 2*G[w, 0, -1, z] - 2*G[w, 0, 1, z] - 2*G[w, w, -1, z] + 
       2*G[w, w, 1, z] + ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), 
         -1, z] + (-(-1 - w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), 1, z] + 
       (-(1 - w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 1, z]) + 
     G[0, -1, -1, -1, w]/2 - G[0, -1, -1, 1, w]/2 - G[0, -1, 1, -1, w]/2 + 
     G[0, -1, 1, 1, w]/2 + G[0, 0, -1, -1, z] - G[0, 0, -1, 1, z] - 
     G[0, 0, 1, -1, z] + G[0, 0, 1, 1, z] + G[0, 1, -1, -1, w]/2 - 
     G[0, 1, -1, 1, w]/2 - G[0, 1, 1, -1, w]/2 + G[0, 1, 1, 1, w]/2 - 
     G[0, w, -1, -1, z] + G[0, w, -1, 1, z] + G[0, w, 1, -1, z] - 
     G[0, w, 1, 1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, -1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, 1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), -1, -1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 1, z] - 
     2*G[w, 0, -1, -1, z] + 2*G[w, 0, -1, 1, z] + 2*G[w, 0, 1, -1, z] - 
     2*G[w, 0, 1, 1, z] + 2*G[w, w, -1, -1, z] - 2*G[w, w, -1, 1, z] - 
     2*G[w, w, 1, -1, z] + 2*G[w, w, 1, 1, z] + (-(-1 - w)^(-1) + w/(1 + w))*
      G[w, (-1 + w)/(1 + w), -1, -1, z] + ((-1 - w)^(-1) - w/(1 + w))*
      G[w, (-1 + w)/(1 + w), -1, 1, z] + ((-1 - w)^(-1) - w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 1, -1, z] + (-(-1 - w)^(-1) + w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 1, 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), -1, -1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), -1, 1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 1, -1, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 1, 1, z]) - 
   12*(G[0, 0, w]*(G[0, 0, z] - 2*G[0, w, z] - G[w, 0, z] + 2*G[w, w, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*G[0, 0, 0, w] - 
     G[0, w]*(G[0, 0, 0, z] - 2*G[0, w, 0, z] - G[w, 0, 0, z] + 
       2*G[w, w, 0, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, z])/
        (1 + w) + G[(-1 + w)/(1 + w), w, 0, z] + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 0, z]) + G[-1, 0, 0, 0, w]/2 + 
     G[0, 0, 0, 0, z] - 2*G[0, w, 0, 0, z] + G[1, 0, 0, 0, w]/2 - 
     G[w, 0, 0, 0, z] + 2*G[w, w, 0, 0, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 0, 0, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 0, 0, z]) + 
   4*(G[0, 0, w]*(G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z] - G[w, -1, z] - 
       G[w, 1, z] + 2*G[w, w, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/
        (1 + w) + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 
          z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, 0, w] + 2*G[0, 0, 0, w] - G[1, 0, 0, w]) - 
     G[0, w]*(G[0, -1, 0, z] + G[0, 1, 0, z] - 2*G[0, w, 0, z] - 
       G[w, -1, 0, z] - G[w, 1, 0, z] + 2*G[w, w, 0, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 0, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 
          0, z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 0, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, 0, z]) - G[-1, -1, 0, 0, w]/2 + 
     G[-1, 0, 0, 0, w] - G[-1, 1, 0, 0, w]/2 + G[0, -1, 0, 0, z] + 
     G[0, 1, 0, 0, z] - 2*G[0, w, 0, 0, z] - G[1, -1, 0, 0, w]/2 + 
     G[1, 0, 0, 0, w] - G[1, 1, 0, 0, w]/2 - G[w, -1, 0, 0, z] - 
     G[w, 1, 0, 0, z] + 2*G[w, w, 0, 0, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 0, 0, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 0, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 0, 0, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 0, 0, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 0, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 0, 0, z]) - 
   4*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, 0, z] - 2*G[0, w, z] - G[w, 0, z] + 2*G[w, w, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[0, -1, -1, w] - G[0, -1, 1, w] - G[0, 1, -1, w] + G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, 0, -1, z] + G[0, 0, 1, z] + 
       2*G[0, w, -1, z] - 2*G[0, w, 1, z] + G[w, 0, -1, z] - G[w, 0, 1, z] - 
       2*G[w, w, -1, z] + 2*G[w, w, 1, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 1, z] + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 
          -1, z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/
        (-1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 1, z]) + G[-1, 0, -1, -1, w]/2 - 
     G[-1, 0, -1, 1, w]/2 - G[-1, 0, 1, -1, w]/2 + G[-1, 0, 1, 1, w]/2 + 
     G[0, 0, -1, -1, z] - G[0, 0, -1, 1, z] - G[0, 0, 1, -1, z] + 
     G[0, 0, 1, 1, z] - 2*G[0, w, -1, -1, z] + 2*G[0, w, -1, 1, z] + 
     2*G[0, w, 1, -1, z] - 2*G[0, w, 1, 1, z] + G[1, 0, -1, -1, w]/2 - 
     G[1, 0, -1, 1, w]/2 - G[1, 0, 1, -1, w]/2 + G[1, 0, 1, 1, w]/2 - 
     G[w, 0, -1, -1, z] + G[w, 0, -1, 1, z] + G[w, 0, 1, -1, z] - 
     G[w, 0, 1, 1, z] + 2*G[w, w, -1, -1, z] - 2*G[w, w, -1, 1, z] - 
     2*G[w, w, 1, -1, z] + 2*G[w, w, 1, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 1, 1, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, -1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 1, 1, z]) - 
   4*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z] - G[w, -1, z] - G[w, 1, z] + 
       2*G[w, w, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 
          z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, -1, -1, z] + G[0, -1, 1, z] - 
       G[0, 1, -1, z] + G[0, 1, 1, z] + 2*G[0, w, -1, z] - 2*G[0, w, 1, z] + 
       G[w, -1, -1, z] - G[w, -1, 1, z] + G[w, 1, -1, z] - G[w, 1, 1, z] - 
       2*G[w, w, -1, z] + 2*G[w, w, 1, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 1, z] + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 
          -1, -1, z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, 
          z])/(-1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, -1, z])/
        (-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 1, z]) - G[-1, -1, -1, -1, w]/2 + 
     G[-1, -1, -1, 1, w]/2 + G[-1, -1, 1, -1, w]/2 - G[-1, -1, 1, 1, w]/2 + 
     G[-1, 0, -1, -1, w] - G[-1, 0, -1, 1, w] - G[-1, 0, 1, -1, w] + 
     G[-1, 0, 1, 1, w] - G[-1, 1, -1, -1, w]/2 + G[-1, 1, -1, 1, w]/2 + 
     G[-1, 1, 1, -1, w]/2 - G[-1, 1, 1, 1, w]/2 + G[0, -1, -1, -1, z] - 
     G[0, -1, -1, 1, z] - G[0, -1, 1, -1, z] + G[0, -1, 1, 1, z] + 
     G[0, 1, -1, -1, z] - G[0, 1, -1, 1, z] - G[0, 1, 1, -1, z] + 
     G[0, 1, 1, 1, z] - 2*G[0, w, -1, -1, z] + 2*G[0, w, -1, 1, z] + 
     2*G[0, w, 1, -1, z] - 2*G[0, w, 1, 1, z] - G[1, -1, -1, -1, w]/2 + 
     G[1, -1, -1, 1, w]/2 + G[1, -1, 1, -1, w]/2 - G[1, -1, 1, 1, w]/2 + 
     G[1, 0, -1, -1, w] - G[1, 0, -1, 1, w] - G[1, 0, 1, -1, w] + 
     G[1, 0, 1, 1, w] - G[1, 1, -1, -1, w]/2 + G[1, 1, -1, 1, w]/2 + 
     G[1, 1, 1, -1, w]/2 - G[1, 1, 1, 1, w]/2 - G[w, -1, -1, -1, z] + 
     G[w, -1, -1, 1, z] + G[w, -1, 1, -1, z] - G[w, -1, 1, 1, z] - 
     G[w, 1, -1, -1, z] + G[w, 1, -1, 1, z] + G[w, 1, 1, -1, z] - 
     G[w, 1, 1, 1, z] + 2*G[w, w, -1, -1, z] - 2*G[w, w, -1, 1, z] - 
     2*G[w, w, 1, -1, z] + 2*G[w, w, 1, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 1, 1, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, -1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 1, 1, z]) + 
   8*(G[0, 0, w]*(G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - G[w, 0, z] + G[w, w, z] + 
       (1/(2*(1 + w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, 0, w]/2 + G[1, 0, 0, w]/2) - 
     G[0, w]*(G[0, 0, 0, z] - G[0, w, 0, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 0, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, z] - 
       G[w, 0, 0, z] + G[w, w, 0, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), 0, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     G[-1, -1, 0, 0, w]/4 + G[-1, 1, 0, 0, w]/4 + G[0, 0, 0, 0, z] - 
     G[0, w, 0, 0, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 0, 0, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), 0, 0, z] + G[1, -1, 0, 0, w]/4 + 
     G[1, 1, 0, 0, w]/4 - G[w, 0, 0, 0, z] + G[w, w, 0, 0, z] + 
     (1/(2*(1 + w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), 0, 0, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 0, 0, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 0, 0, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, 0, z])/(1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 0, 0, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 0, 0, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) - 
   4*((-G[0, -1, w] + G[0, 1, w])*(-G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       G[w, (-1 + w)/(1 + w), z] + ((-1 + w)^(-1) - w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, -1, w] - G[-1, 0, 1, w] - G[1, 0, -1, w] + G[1, 0, 1, w]) + 
     (G[-1, w] - G[1, w])*(((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 
         0, z] - G[0, -((1 + w)/(-1 + w)), 0, z] + 
       ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), 0, z] + 
       G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/
        (-1 + w)) + G[-1, -1, 0, -1, w]/2 - G[-1, -1, 0, 1, w]/2 - 
     G[-1, 1, 0, -1, w]/2 + G[-1, 1, 0, 1, w]/2 - G[0, (-1 + w)/(1 + w), 0, 
      -1, z] + ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 0, 1, z] + 
     ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, -1, z] - 
     G[0, -((1 + w)/(-1 + w)), 0, 1, z] + G[1, -1, 0, -1, w]/2 - 
     G[1, -1, 0, 1, w]/2 - G[1, 1, 0, -1, w]/2 + G[1, 1, 0, 1, w]/2 + 
     G[w, (-1 + w)/(1 + w), 0, -1, z] + ((-1 - w)^(-1) - w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, 1, z] + ((-1 + w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, -1, z] + G[w, -((1 + w)/(-1 + w)), 0, 1, 
      z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, -1, z])/
      (1 + w) + ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, 1, z])/
      (1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, -1, 
        z])/(-1 + w) + ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*
       G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) + 
     ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/
      (-1 + w)) - 8*((G[-1, 0, w]/2 - G[1, 0, w]/2)*
      (-G[0, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z] + G[w, (-1 + w)/(1 + w), z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, 0, w]/2 + G[-1, 1, 0, w]/2 + G[1, -1, 0, w]/2 - 
       G[1, 1, 0, w]/2) - G[0, w]*((1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), -1, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), 1, z] + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), -1, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), 1, z] + (1/(2*(1 - w)) + w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), -1, z] + (-1/(2*(1 - w)) - w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), 1, z] + 
       ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - 
     G[-1, -1, -1, 0, w]/4 + G[-1, -1, 1, 0, w]/4 + G[-1, 1, -1, 0, w]/4 - 
     G[-1, 1, 1, 0, w]/4 + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, 0, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, 0, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 0, z] - 
     G[1, -1, -1, 0, w]/4 + G[1, -1, 1, 0, w]/4 + G[1, 1, -1, 0, w]/4 - 
     G[1, 1, 1, 0, w]/4 + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), -1, 0, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), 1, 0, z] + (1/(2*(1 - w)) + w/(2*(-1 + w)))*
      G[w, -((1 + w)/(-1 + w)), -1, 0, z] + (-1/(2*(1 - w)) - w/(2*(-1 + w)))*
      G[w, -((1 + w)/(-1 + w)), 1, 0, z] + 
     ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 0, z])/(1 + w) + 
     ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 0, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 0, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) + 
   8*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - G[w, 0, z] + G[w, w, z] + 
       (1/(2*(1 + w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, -1, w]/2 - G[-1, -1, 1, w]/2 - G[-1, 1, -1, w]/2 + 
       G[-1, 1, 1, w]/2 + G[1, -1, -1, w]/2 - G[1, -1, 1, w]/2 - 
       G[1, 1, -1, w]/2 + G[1, 1, 1, w]/2) + (G[-1, w] - G[1, w])*
      (-G[0, 0, -1, z] + G[0, 0, 1, z] + G[0, w, -1, z] - G[0, w, 1, z] + 
       (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, z] + 
       G[w, 0, -1, z] - G[w, 0, 1, z] - G[w, w, -1, z] + G[w, w, 1, z] + 
       (1/(2*(-1 - w)) - w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), -1, z] + 
       (-1/(2*(-1 - w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), 1, z] + 
       (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, z] + 
       (1/(2*(1 - w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w) + 
       ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, -1, -1, w]/4 - G[-1, -1, -1, 1, w]/4 - G[-1, -1, 1, -1, w]/4 + 
     G[-1, -1, 1, 1, w]/4 + G[-1, 1, -1, -1, w]/4 - G[-1, 1, -1, 1, w]/4 - 
     G[-1, 1, 1, -1, w]/4 + G[-1, 1, 1, 1, w]/4 + G[0, 0, -1, -1, z] - 
     G[0, 0, -1, 1, z] - G[0, 0, 1, -1, z] + G[0, 0, 1, 1, z] - 
     G[0, w, -1, -1, z] + G[0, w, -1, 1, z] + G[0, w, 1, -1, z] - 
     G[0, w, 1, 1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, -1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, 1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), -1, -1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 1, z] + 
     G[1, -1, -1, -1, w]/4 - G[1, -1, -1, 1, w]/4 - G[1, -1, 1, -1, w]/4 + 
     G[1, -1, 1, 1, w]/4 + G[1, 1, -1, -1, w]/4 - G[1, 1, -1, 1, w]/4 - 
     G[1, 1, 1, -1, w]/4 + G[1, 1, 1, 1, w]/4 - G[w, 0, -1, -1, z] + 
     G[w, 0, -1, 1, z] + G[w, 0, 1, -1, z] - G[w, 0, 1, 1, z] + 
     G[w, w, -1, -1, z] - G[w, w, -1, 1, z] - G[w, w, 1, -1, z] + 
     G[w, w, 1, 1, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), -1, -1, z] + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), -1, 1, z] + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), 1, -1, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), 1, 1, z] + (1/(2*(1 - w)) + w/(2*(-1 + w)))*
      G[w, -((1 + w)/(-1 + w)), -1, -1, z] + 
     (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, 1, z] + 
     (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (1/(2*(1 - w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, -1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 1, 1, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
     ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, -1, z])/(1 + w) + 
     ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 1, z])/(1 + w) + 
     ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, -1, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 1, z])/(1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, -1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, -1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, 1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 1, 1, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, -1, z])/(-1 + w) + 
     ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 1, z])/(-1 + w) + 
     ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, -1, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 1, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 1, z])/(-1 + w) + 
     ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)) + 
   12*(G[0, w] - G[0, z] + 2*G[w, z])*Zeta[3] - 
   4*(-G[-1, w] - G[-1, z] + 2*G[0, w] - G[1, w] - G[1, z] + 2*G[w, z])*
    Zeta[3] - 8*(G[-1, w]/2 - G[0, z] + G[1, w]/2 + G[w, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*Zeta[3], 
 fE22[{0}, sij, sjk, sik] -> 0, fE22[{1}, sij, sjk, sik] -> 0, 
 fE22[{2}, sij, sjk, sik] -> 
  2*(-(G[0, z]*(G[-1, w] - G[1, w])) - G[0, -1, w] + G[0, -1, z] + 
     G[0, 1, w] - G[0, 1, z]) + 4*(-(G[0, w]*(-G[-1, z]/2 + G[1, z]/2)) + 
     G[-1, 0, w]/2 - G[-1, 0, z]/2 - G[1, 0, w]/2 + G[1, 0, z]/2), 
 fE22[{3}, sij, sjk, sik] -> 
  (-2*Pi^2*(-G[-1, w]/2 - G[-1, z]/2 + G[1, w]/2 + G[1, z]/2))/3 + 
   6*((G[-1, w] - G[1, w])*(-G[0, -1, z] - G[0, 1, z] + 2*G[0, w^(-1), z]) - 
     G[0, z]*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w]) - 
     G[0, -1, -1, w] + G[0, -1, -1, z] + G[0, -1, 1, w] - G[0, -1, 1, z] - 
     G[0, 1, -1, w] + G[0, 1, -1, z] + G[0, 1, 1, w] - G[0, 1, 1, z] - 
     2*G[0, w^(-1), -1, z] + 2*G[0, w^(-1), 1, z]) - 
   2*((G[-1, w] - G[1, w])*(G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z]) - 
     G[0, z]*(-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w]) + G[0, -1, -1, w] - G[0, -1, -1, z] - 
     G[0, -1, 1, w] + G[0, -1, 1, z] - 2*G[0, 0, -1, w] + 2*G[0, 0, 1, w] + 
     G[0, 1, -1, w] - G[0, 1, -1, z] - G[0, 1, 1, w] + G[0, 1, 1, z] + 
     2*G[0, w, -1, z] - 2*G[0, w, 1, z]) + 
   4*(4*(-G[-1, z]/2 + G[1, z]/2)*G[0, 0, w] - 
     G[0, w]*(-2*G[-1, 0, z] + 3*G[-1, -w, z] + G[-1, w, z] + 2*G[1, 0, z] - 
       3*G[1, -w, z] - G[1, w, z]) - 2*G[-1, 0, 0, w] - 2*G[-1, 0, 0, z] + 
     3*G[-1, -w, 0, z] + G[-1, w, 0, z] + 2*G[1, 0, 0, w] + 2*G[1, 0, 0, z] - 
     3*G[1, -w, 0, z] - G[1, w, 0, z]) - 
   4*((-G[0, z] + 2*G[w, z])*(-G[0, -1, w] + G[0, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[0, 0, z] - 2*G[w, 0, z]) - G[0, 0, -1, w] - 
     G[0, 0, -1, z] + G[0, 0, 1, w] + G[0, 0, 1, z] + 2*G[w, 0, -1, z] - 
     2*G[w, 0, 1, z]) - 
   8*((-G[0, z] + 2*G[w, z])*(G[-1, 0, w]/2 - G[1, 0, w]/2) - 
     G[0, w]*(G[0, -1, z]/2 - G[0, 1, z]/2 - G[w, -1, z] + G[w, 1, z]) + 
     G[0, -1, 0, w]/2 + G[0, -1, 0, z]/2 - G[0, 1, 0, w]/2 - 
     G[0, 1, 0, z]/2 - G[w, -1, 0, z] + G[w, 1, 0, z]) - 
   8*((G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      G[0, 0, w] - G[0, w]*(G[(-1 + w)/(1 + w), 0, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - G[-1, 0, 0, w] + 
     G[1, 0, 0, w] + G[(-1 + w)/(1 + w), 0, 0, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) + 
   2*((2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[0, -1, w] + G[0, 1, w]) + (G[-1, w] - G[1, w])*
      (-2*G[0, 0, z] + 6*G[-w^(-1), 0, z] + 2*G[w, 0, z] + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + 2*G[0, 0, -1, z] - 
     2*G[0, 0, 1, z] - 2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] - 
     6*G[-w^(-1), 0, -1, z] + 6*G[-w^(-1), 0, 1, z] - 2*G[w, 0, -1, z] + 
     2*G[w, 0, 1, z] + ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w)) + 
   8*((-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[0, -1, w] + G[0, 1, w]) + (G[-1, w] - G[1, w])*
      (G[0, 0, z] - G[w, 0, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/
        (1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     G[-1, 0, -1, w]/2 + G[-1, 0, 1, w]/2 - G[0, 0, -1, z] + G[0, 0, 1, z] - 
     G[1, 0, -1, w]/2 + G[1, 0, 1, w]/2 + G[w, 0, -1, z] - G[w, 0, 1, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w)) + 
   4*((2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, w]/2 - G[1, 0, w]/2) - G[0, w]*(-G[0, -1, z] + G[0, 1, z] + 
       3*G[-w^(-1), -1, z] - 3*G[-w^(-1), 1, z] + G[w, -1, z] - G[w, 1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, z] + ((1 - w)*G[-((1 + w)/(-1 + w)), -1, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), 1, z]) + G[-1, -1, 0, w] - 
     G[-1, 1, 0, w] - G[0, -1, 0, z] + G[0, 1, 0, z] + G[1, -1, 0, w] - 
     G[1, 1, 0, w] + 3*G[-w^(-1), -1, 0, z] - 3*G[-w^(-1), 1, 0, z] + 
     G[w, -1, 0, z] - G[w, 1, 0, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, 0, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, 0, z]) + 
   16*((-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, w]/2 - G[1, 0, w]/2) - G[0, w]*(G[0, -1, z]/2 - 
       G[0, 1, z]/2 - G[w, -1, z]/2 + G[w, 1, z]/2 + 
       ((-1/4 - w/4)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/4 + w/4)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, 0, w]/4 - G[-1, 1, 0, w]/4 + G[0, -1, 0, z]/2 - 
     G[0, 1, 0, z]/2 + G[1, -1, 0, w]/4 - G[1, 1, 0, w]/4 - 
     G[w, -1, 0, z]/2 + G[w, 1, 0, z]/2 + 
     ((-1/4 - w/4)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/4 + w/4)*G[(-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) - 
   8*((G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, z] + G[-((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - G[-1, -1, -1, w] + 
     G[-1, -1, 1, w] + G[-1, 1, -1, w] - G[-1, 1, 1, w] + G[1, -1, -1, w] - 
     G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w] + 
     G[(-1 + w)/(1 + w), -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, 1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, 1, z] + G[-((1 + w)/(-1 + w)), 1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)), 
 fE22[{4}, sij, sjk, sik] -> 
  (Pi^2*(-(G[0, z]*(G[-1, w] - G[1, w])) - G[0, -1, w] + G[0, -1, z] + 
      G[0, 1, w] - G[0, 1, z]))/3 + 
   (2*Pi^2*(-(G[0, w]*(-G[-1, z]/2 + G[1, z]/2)) + G[-1, 0, w]/2 - 
      G[-1, 0, z]/2 - G[1, 0, w]/2 + G[1, 0, z]/2))/3 - 
   (2*Pi^2*(-4*G[0, w]*(-G[-1, z]/2 + G[1, z]/2) + 2*G[-1, 0, w] - 
      2*G[-1, 0, z] + 3*G[-1, -w, z] + G[-1, w, z] - 2*G[1, 0, w] + 
      2*G[1, 0, z] - 3*G[1, -w, z] - G[1, w, z]))/3 + 
   (4*Pi^2*((-G[-1, w]/2 + G[1, w]/2)*(-G[0, z] + 2*G[w, z]) - 
      G[0, -1, w]/2 + G[0, -1, z]/2 + G[0, 1, w]/2 - G[0, 1, z]/2 - 
      G[w, -1, z] + G[w, 1, z]))/3 + 
   (4*Pi^2*(-(G[0, w]*(G[(-1 + w)/(1 + w), z] + 
         ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))) + G[-1, 0, w] - 
      G[1, 0, w] + G[(-1 + w)/(1 + w), 0, z] + 
      ((1 - w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)))/3 - 
   (2*Pi^2*((-G[-1, w]/2 + G[1, w]/2)*(2*G[0, z] - 6*G[-w^(-1), z] - 
        2*G[w, z] + ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
        ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w)) - G[-1, -1, w] + 
      G[-1, 1, w] - G[0, -1, z] + G[0, 1, z] - G[1, -1, w] + G[1, 1, w] + 
      3*G[-w^(-1), -1, z] - 3*G[-w^(-1), 1, z] + G[w, -1, z] - G[w, 1, z] + 
      ((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
      G[(-1 + w)/(1 + w), 1, z] + ((1 - w)*G[-((1 + w)/(-1 + w)), -1, z])/
       (-1 + w) + G[-((1 + w)/(-1 + w)), 1, z]))/3 - 
   (8*Pi^2*((-G[-1, w]/2 + G[1, w]/2)*(-G[0, z] + G[w, z] + 
        ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
        ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w)) - G[-1, -1, w]/4 + 
      G[-1, 1, w]/4 + G[0, -1, z]/2 - G[0, 1, z]/2 - G[1, -1, w]/4 + 
      G[1, 1, w]/4 - G[w, -1, z]/2 + G[w, 1, z]/2 + 
      ((-1/4 - w/4)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
      ((1/4 + w/4)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
      ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
      ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)))/3 - 
   12*((G[0, -1, z] - G[0, 1, z])*(G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + 
       G[1, 1, w]) + (G[-1, w] - G[1, w])*(-G[0, -1, -1, z] + 
       G[0, -1, 1, z] + G[0, 1, -1, z] - G[0, 1, 1, z]) - 
     G[0, z]*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + G[1, 1, -1, w] - 
       G[1, 1, 1, w]) - G[0, -1, -1, -1, w] + G[0, -1, -1, -1, z] + 
     G[0, -1, -1, 1, w] - G[0, -1, -1, 1, z] + G[0, -1, 1, -1, w] - 
     G[0, -1, 1, -1, z] - G[0, -1, 1, 1, w] + G[0, -1, 1, 1, z] + 
     G[0, 1, -1, -1, w] - G[0, 1, -1, -1, z] - G[0, 1, -1, 1, w] + 
     G[0, 1, -1, 1, z] - G[0, 1, 1, -1, w] + G[0, 1, 1, -1, z] + 
     G[0, 1, 1, 1, w] - G[0, 1, 1, 1, z]) + 
   18*((-G[0, -1, z] - G[0, 1, z] + 2*G[0, w^(-1), z])*
      (G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, -1, -1, z] - G[0, -1, 1, z] + 
       2*G[0, -1, w^(-1), z] - G[0, 1, -1, z] - G[0, 1, 1, z] + 
       2*G[0, 1, w^(-1), z] + 2*G[0, w^(-1), -1, z] + 2*G[0, w^(-1), 1, z] - 
       4*G[0, w^(-1), w^(-1), z]) - G[0, z]*(G[-1, -1, -1, w] - 
       G[-1, -1, 1, w] + G[-1, 1, -1, w] - G[-1, 1, 1, w] + G[1, -1, -1, w] - 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
     G[0, -1, -1, -1, w] + G[0, -1, -1, -1, z] + G[0, -1, -1, 1, w] - 
     G[0, -1, -1, 1, z] - G[0, -1, 1, -1, w] + G[0, -1, 1, -1, z] + 
     G[0, -1, 1, 1, w] - G[0, -1, 1, 1, z] - 2*G[0, -1, w^(-1), -1, z] + 
     2*G[0, -1, w^(-1), 1, z] - G[0, 1, -1, -1, w] + G[0, 1, -1, -1, z] + 
     G[0, 1, -1, 1, w] - G[0, 1, -1, 1, z] - G[0, 1, 1, -1, w] + 
     G[0, 1, 1, -1, z] + G[0, 1, 1, 1, w] - G[0, 1, 1, 1, z] - 
     2*G[0, 1, w^(-1), -1, z] + 2*G[0, 1, w^(-1), 1, z] - 
     2*G[0, w^(-1), -1, -1, z] + 2*G[0, w^(-1), -1, 1, z] - 
     2*G[0, w^(-1), 1, -1, z] + 2*G[0, w^(-1), 1, 1, z] + 
     4*G[0, w^(-1), w^(-1), -1, z] - 4*G[0, w^(-1), w^(-1), 1, z]) - 
   6*((-G[0, -1, z] - G[0, 1, z] + 2*G[0, w^(-1), z])*
      (-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[0, -1, -1, z] + G[0, -1, 1, z] - 2*G[0, -1, w, z] + G[0, 1, -1, z] + 
       G[0, 1, 1, z] - 2*G[0, 1, w, z] - 2*G[0, w^(-1), -1, z] - 
       2*G[0, w^(-1), 1, z] + 4*G[0, w^(-1), w, z]) - 
     G[0, z]*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 
       2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + G[-1, 1, 1, w] - 
       G[1, -1, -1, w] + G[1, -1, 1, w] + 2*G[1, 0, -1, w] - 
       2*G[1, 0, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     G[0, -1, -1, -1, w] - G[0, -1, -1, -1, z] - G[0, -1, -1, 1, w] + 
     G[0, -1, -1, 1, z] - 2*G[0, -1, 0, -1, w] + 2*G[0, -1, 0, 1, w] + 
     G[0, -1, 1, -1, w] - G[0, -1, 1, -1, z] - G[0, -1, 1, 1, w] + 
     G[0, -1, 1, 1, z] + 2*G[0, -1, w, -1, z] - 2*G[0, -1, w, 1, z] + 
     G[0, 1, -1, -1, w] - G[0, 1, -1, -1, z] - G[0, 1, -1, 1, w] + 
     G[0, 1, -1, 1, z] - 2*G[0, 1, 0, -1, w] + 2*G[0, 1, 0, 1, w] + 
     G[0, 1, 1, -1, w] - G[0, 1, 1, -1, z] - G[0, 1, 1, 1, w] + 
     G[0, 1, 1, 1, z] + 2*G[0, 1, w, -1, z] - 2*G[0, 1, w, 1, z] + 
     2*G[0, w^(-1), -1, -1, z] - 2*G[0, w^(-1), -1, 1, z] + 
     2*G[0, w^(-1), 1, -1, z] - 2*G[0, w^(-1), 1, 1, z] - 
     4*G[0, w^(-1), w, -1, z] + 4*G[0, w^(-1), w, 1, z]) - 
   6*((G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z])*(G[-1, -1, w] - G[-1, 1, w] + 
       G[1, -1, w] - G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[0, -1, -1, z] + G[0, -1, 1, z] - 2*G[0, -1, w^(-1), z] + 
       G[0, 1, -1, z] + G[0, 1, 1, z] - 2*G[0, 1, w^(-1), z] - 
       2*G[0, w, -1, z] - 2*G[0, w, 1, z] + 4*G[0, w, w^(-1), z]) - 
     G[0, z]*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] - G[-1, 1, -1, w] + 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] + 
       2*G[0, 1, -1, w] - 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] - G[1, 1, -1, w] + G[1, 1, 1, w]) + 
     G[0, -1, -1, -1, w] - G[0, -1, -1, -1, z] - G[0, -1, -1, 1, w] + 
     G[0, -1, -1, 1, z] + G[0, -1, 1, -1, w] - G[0, -1, 1, -1, z] - 
     G[0, -1, 1, 1, w] + G[0, -1, 1, 1, z] + 2*G[0, -1, w^(-1), -1, z] - 
     2*G[0, -1, w^(-1), 1, z] - 2*G[0, 0, -1, -1, w] + 2*G[0, 0, -1, 1, w] - 
     2*G[0, 0, 1, -1, w] + 2*G[0, 0, 1, 1, w] + G[0, 1, -1, -1, w] - 
     G[0, 1, -1, -1, z] - G[0, 1, -1, 1, w] + G[0, 1, -1, 1, z] + 
     G[0, 1, 1, -1, w] - G[0, 1, 1, -1, z] - G[0, 1, 1, 1, w] + 
     G[0, 1, 1, 1, z] + 2*G[0, 1, w^(-1), -1, z] - 2*G[0, 1, w^(-1), 1, z] + 
     2*G[0, w, -1, -1, z] - 2*G[0, w, -1, 1, z] + 2*G[0, w, 1, -1, z] - 
     2*G[0, w, 1, 1, z] - 4*G[0, w, w^(-1), -1, z] + 
     4*G[0, w, w^(-1), 1, z]) + 
   2*((G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z])*(-G[-1, -1, w] + 
       G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - G[1, -1, w] + 
       G[1, 1, w]) + (G[-1, w] - G[1, w])*(-G[0, -1, -1, z] - 
       G[0, -1, 1, z] + 2*G[0, -1, w, z] - G[0, 1, -1, z] - G[0, 1, 1, z] + 
       2*G[0, 1, w, z] + 2*G[0, w, -1, z] + 2*G[0, w, 1, z] - 
       4*G[0, w, w, z]) - G[0, z]*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - 2*G[0, -1, -1, w] + 2*G[0, -1, 1, w] + 
       4*G[0, 0, -1, w] - 4*G[0, 0, 1, w] - 2*G[0, 1, -1, w] + 
       2*G[0, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
     G[0, -1, -1, -1, w] + G[0, -1, -1, -1, z] + G[0, -1, -1, 1, w] - 
     G[0, -1, -1, 1, z] + 2*G[0, -1, 0, -1, w] - 2*G[0, -1, 0, 1, w] - 
     G[0, -1, 1, -1, w] + G[0, -1, 1, -1, z] + G[0, -1, 1, 1, w] - 
     G[0, -1, 1, 1, z] - 2*G[0, -1, w, -1, z] + 2*G[0, -1, w, 1, z] + 
     2*G[0, 0, -1, -1, w] - 2*G[0, 0, -1, 1, w] - 4*G[0, 0, 0, -1, w] + 
     4*G[0, 0, 0, 1, w] + 2*G[0, 0, 1, -1, w] - 2*G[0, 0, 1, 1, w] - 
     G[0, 1, -1, -1, w] + G[0, 1, -1, -1, z] + G[0, 1, -1, 1, w] - 
     G[0, 1, -1, 1, z] + 2*G[0, 1, 0, -1, w] - 2*G[0, 1, 0, 1, w] - 
     G[0, 1, 1, -1, w] + G[0, 1, 1, -1, z] + G[0, 1, 1, 1, w] - 
     G[0, 1, 1, 1, z] - 2*G[0, 1, w, -1, z] + 2*G[0, 1, w, 1, z] - 
     2*G[0, w, -1, -1, z] + 2*G[0, w, -1, 1, z] - 2*G[0, w, 1, -1, z] + 
     2*G[0, w, 1, 1, z] + 4*G[0, w, w, -1, z] - 4*G[0, w, w, 1, z]) - 
   24*(G[0, 0, w]*(-G[-1, 0, z]/2 + G[1, 0, z]/2) - 
     (-G[-1, z]/2 + G[1, z]/2)*G[0, 0, 0, w] - 
     G[0, w]*(-G[-1, 0, 0, z]/2 + G[1, 0, 0, z]/2) + G[-1, 0, 0, 0, w]/2 - 
     G[-1, 0, 0, 0, z]/2 - G[1, 0, 0, 0, w]/2 + G[1, 0, 0, 0, z]/2) + 
   4*(4*G[0, 0, w]*(-2*G[-1, 0, z] + 3*G[-1, -w, z] + G[-1, w, z] + 
       2*G[1, 0, z] - 3*G[1, -w, z] - G[1, w, z]) - 
     16*(-G[-1, z]/2 + G[1, z]/2)*G[0, 0, 0, w] - 
     G[0, w]*(-8*G[-1, 0, 0, z] + 12*G[-1, 0, -w, z] + 4*G[-1, 0, w, z] + 
       12*G[-1, -w, 0, z] - 18*G[-1, -w, -w, z] - 6*G[-1, -w, w, z] + 
       4*G[-1, w, 0, z] - 6*G[-1, w, -w, z] - 2*G[-1, w, w, z] + 
       8*G[1, 0, 0, z] - 12*G[1, 0, -w, z] - 4*G[1, 0, w, z] - 
       12*G[1, -w, 0, z] + 18*G[1, -w, -w, z] + 6*G[1, -w, w, z] - 
       4*G[1, w, 0, z] + 6*G[1, w, -w, z] + 2*G[1, w, w, z]) + 
     8*G[-1, 0, 0, 0, w] - 8*G[-1, 0, 0, 0, z] + 12*G[-1, 0, -w, 0, z] + 
     4*G[-1, 0, w, 0, z] + 12*G[-1, -w, 0, 0, z] - 18*G[-1, -w, -w, 0, z] - 
     6*G[-1, -w, w, 0, z] + 4*G[-1, w, 0, 0, z] - 6*G[-1, w, -w, 0, z] - 
     2*G[-1, w, w, 0, z] - 8*G[1, 0, 0, 0, w] + 8*G[1, 0, 0, 0, z] - 
     12*G[1, 0, -w, 0, z] - 4*G[1, 0, w, 0, z] - 12*G[1, -w, 0, 0, z] + 
     18*G[1, -w, -w, 0, z] + 6*G[1, -w, w, 0, z] - 4*G[1, w, 0, 0, z] + 
     6*G[1, w, -w, 0, z] + 2*G[1, w, w, 0, z]) - 
   12*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[0, 0, z] - 2*G[w, 0, z]) + (-G[0, z] + 2*G[w, z])*
      (-G[0, -1, -1, w] + G[0, -1, 1, w] - G[0, 1, -1, w] + G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[0, 0, -1, z] + G[0, 0, 1, z] - 
       2*G[0, 0, w^(-1), z] - 2*G[w, 0, -1, z] - 2*G[w, 0, 1, z] + 
       4*G[w, 0, w^(-1), z]) - G[0, 0, -1, -1, w] - G[0, 0, -1, -1, z] + 
     G[0, 0, -1, 1, w] + G[0, 0, -1, 1, z] - G[0, 0, 1, -1, w] - 
     G[0, 0, 1, -1, z] + G[0, 0, 1, 1, w] + G[0, 0, 1, 1, z] + 
     2*G[0, 0, w^(-1), -1, z] - 2*G[0, 0, w^(-1), 1, z] + 
     2*G[w, 0, -1, -1, z] - 2*G[w, 0, -1, 1, z] + 2*G[w, 0, 1, -1, z] - 
     2*G[w, 0, 1, 1, z] - 4*G[w, 0, w^(-1), -1, z] + 
     4*G[w, 0, w^(-1), 1, z]) + 
   4*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[0, 0, z] - 2*G[w, 0, z]) + 
     (-G[0, z] + 2*G[w, z])*(G[0, -1, -1, w] - G[0, -1, 1, w] - 
       2*G[0, 0, -1, w] + 2*G[0, 0, 1, w] + G[0, 1, -1, w] - G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, 0, -1, z] - G[0, 0, 1, z] + 
       2*G[0, 0, w, z] + 2*G[w, 0, -1, z] + 2*G[w, 0, 1, z] - 
       4*G[w, 0, w, z]) + G[0, 0, -1, -1, w] + G[0, 0, -1, -1, z] - 
     G[0, 0, -1, 1, w] - G[0, 0, -1, 1, z] - 2*G[0, 0, 0, -1, w] + 
     2*G[0, 0, 0, 1, w] + G[0, 0, 1, -1, w] + G[0, 0, 1, -1, z] - 
     G[0, 0, 1, 1, w] - G[0, 0, 1, 1, z] - 2*G[0, 0, w, -1, z] + 
     2*G[0, 0, w, 1, z] - 2*G[w, 0, -1, -1, z] + 2*G[w, 0, -1, 1, z] - 
     2*G[w, 0, 1, -1, z] + 2*G[w, 0, 1, 1, z] + 4*G[w, 0, w, -1, z] - 
     4*G[w, 0, w, 1, z]) - 
   8*(4*G[0, 0, w]*(G[0, -1, z]/2 - G[0, 1, z]/2 - G[w, -1, z] + 
       G[w, 1, z]) + (-G[0, z] + 2*G[w, z])*(-2*G[-1, 0, 0, w] + 
       2*G[1, 0, 0, w]) - G[0, w]*(2*G[0, -1, 0, z] - 3*G[0, -1, -w, z] - 
       G[0, -1, w, z] - 2*G[0, 1, 0, z] + 3*G[0, 1, -w, z] + G[0, 1, w, z] - 
       4*G[w, -1, 0, z] + 6*G[w, -1, -w, z] + 2*G[w, -1, w, z] + 
       4*G[w, 1, 0, z] - 6*G[w, 1, -w, z] - 2*G[w, 1, w, z]) - 
     2*G[0, -1, 0, 0, w] + 2*G[0, -1, 0, 0, z] - 3*G[0, -1, -w, 0, z] - 
     G[0, -1, w, 0, z] + 2*G[0, 1, 0, 0, w] - 2*G[0, 1, 0, 0, z] + 
     3*G[0, 1, -w, 0, z] + G[0, 1, w, 0, z] - 4*G[w, -1, 0, 0, z] + 
     6*G[w, -1, -w, 0, z] + 2*G[w, -1, w, 0, z] + 4*G[w, 1, 0, 0, z] - 
     6*G[w, 1, -w, 0, z] - 2*G[w, 1, w, 0, z]) + 
   8*((-G[0, -1, w] + G[0, 1, w])*(G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 
       4*G[w, w, z]) + (-G[0, z] + 2*G[w, z])*(-G[0, 0, -1, w] + 
       G[0, 0, 1, w]) + (G[-1, w] - G[1, w])*(-G[0, 0, 0, z] + 
       2*G[0, w, 0, z] + 2*G[w, 0, 0, z] - 4*G[w, w, 0, z]) - 
     G[0, 0, 0, -1, w] + G[0, 0, 0, -1, z] + G[0, 0, 0, 1, w] - 
     G[0, 0, 0, 1, z] - 2*G[0, w, 0, -1, z] + 2*G[0, w, 0, 1, z] - 
     2*G[w, 0, 0, -1, z] + 2*G[w, 0, 0, 1, z] + 4*G[w, w, 0, -1, z] - 
     4*G[w, w, 0, 1, z]) + 16*((G[-1, 0, w]/2 - G[1, 0, w]/2)*
      (G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 4*G[w, w, z]) + 
     (-G[0, z] + 2*G[w, z])*(G[0, -1, 0, w]/2 - G[0, 1, 0, w]/2) - 
     G[0, w]*(-G[0, 0, -1, z]/2 + G[0, 0, 1, z]/2 + G[0, w, -1, z] - 
       G[0, w, 1, z] + G[w, 0, -1, z] - G[w, 0, 1, z] - 2*G[w, w, -1, z] + 
       2*G[w, w, 1, z]) + G[0, 0, -1, 0, w]/2 - G[0, 0, -1, 0, z]/2 - 
     G[0, 0, 1, 0, w]/2 + G[0, 0, 1, 0, z]/2 + G[0, w, -1, 0, z] - 
     G[0, w, 1, 0, z] + G[w, 0, -1, 0, z] - G[w, 0, 1, 0, z] - 
     2*G[w, w, -1, 0, z] + 2*G[w, w, 1, 0, z]) + 
   16*(G[0, 0, w]*(-G[0, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z] + 2*G[w, (-1 + w)/(1 + w), z] + 
       (2/(-1 + w) - (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z]) + 
     (-G[0, z] + 2*G[w, z])*(-G[-1, 0, 0, w] + G[1, 0, 0, w]) - 
     G[0, w]*(-G[0, (-1 + w)/(1 + w), 0, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), 0, z] + 2*G[w, (-1 + w)/(1 + w), 0, z] + 
       (2/(-1 + w) - (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, z]) - 
     G[0, -1, 0, 0, w] + G[0, 1, 0, 0, w] - G[0, (-1 + w)/(1 + w), 0, 0, z] + 
     ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, 0, z] + 
     2*G[w, (-1 + w)/(1 + w), 0, 0, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, 0, z]) - 
   4*((-G[0, -1, w] + G[0, 1, w])*(-2*G[0, 0, z] + 6*G[0, -w^(-1), z] + 
       2*G[0, w, z] + (-2/(1 + w) - (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), 
         z] + (2/(-1 + w) - (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       4*G[w, 0, z] - 12*G[w, -w^(-1), z] - 4*G[w, w, z] + 
       (4/(1 + w) + (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       (-4/(-1 + w) + (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z]) + 
     (-G[0, z] + 2*G[w, z])*(-2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] - 
       2*G[1, 0, -1, w] + 2*G[1, 0, 1, w]) + (G[-1, w] - G[1, w])*
      (2*G[0, 0, 0, z] - 6*G[0, -w^(-1), 0, z] - 2*G[0, w, 0, z] + 
       (2/(1 + w) + (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), 0, z] + 
       (-2/(-1 + w) + (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, z] - 
       4*G[w, 0, 0, z] + 12*G[w, -w^(-1), 0, z] + 4*G[w, w, 0, z] + 
       (-4/(1 + w) - (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 0, z] + 
       (4/(-1 + w) - (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, z]) - 
     2*G[0, -1, 0, -1, w] + 2*G[0, -1, 0, 1, w] - 2*G[0, 0, 0, -1, z] + 
     2*G[0, 0, 0, 1, z] - 2*G[0, 1, 0, -1, w] + 2*G[0, 1, 0, 1, w] + 
     6*G[0, -w^(-1), 0, -1, z] - 6*G[0, -w^(-1), 0, 1, z] + 
     2*G[0, w, 0, -1, z] - 2*G[0, w, 0, 1, z] + (-2/(1 + w) - (2*w)/(1 + w))*
      G[0, (-1 + w)/(1 + w), 0, -1, z] + (2/(1 + w) + (2*w)/(1 + w))*
      G[0, (-1 + w)/(1 + w), 0, 1, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, -1, z] + (-2/(-1 + w) + (2*w)/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, 1, z] + 4*G[w, 0, 0, -1, z] - 
     4*G[w, 0, 0, 1, z] - 12*G[w, -w^(-1), 0, -1, z] + 
     12*G[w, -w^(-1), 0, 1, z] - 4*G[w, w, 0, -1, z] + 4*G[w, w, 0, 1, z] + 
     (-4/(-1 - w) + (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 0, -1, z] + 
     (4/(-1 - w) - (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 0, 1, z] + 
     (4/(1 - w) + (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, -1, z] + 
     (-4/(1 - w) - (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, 1, z]) - 
   16*((-G[0, -1, w] + G[0, 1, w])*(G[0, 0, z] - G[0, w, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), z] - 
       2*G[w, 0, z] + 2*G[w, w, z] + ((1 + w)^(-1) + w/(1 + w))*
        G[w, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z]) + (-G[0, z] + 2*G[w, z])*
      (-G[-1, 0, -1, w]/2 + G[-1, 0, 1, w]/2 - G[1, 0, -1, w]/2 + 
       G[1, 0, 1, w]/2) + (G[-1, w] - G[1, w])*(-G[0, 0, 0, z] + 
       G[0, w, 0, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 
         0, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 
         0, z] + 2*G[w, 0, 0, z] - 2*G[w, w, 0, z] + 
       ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), 0, z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, z]) - 
     G[0, -1, 0, -1, w]/2 + G[0, -1, 0, 1, w]/2 + G[0, 0, 0, -1, z] - 
     G[0, 0, 0, 1, z] - G[0, 1, 0, -1, w]/2 + G[0, 1, 0, 1, w]/2 - 
     G[0, w, 0, -1, z] + G[0, w, 0, 1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 0, -1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 0, 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), 0, -1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, 1, z] - 
     2*G[w, 0, 0, -1, z] + 2*G[w, 0, 0, 1, z] + 2*G[w, w, 0, -1, z] - 
     2*G[w, w, 0, 1, z] + (-(-1 - w)^(-1) + w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, -1, z] + ((-1 - w)^(-1) - w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, -1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, 1, z]) - 
   8*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(-2*G[0, 0, z] + 6*G[0, -w^(-1), z] + 
       2*G[0, w, z] + (-2/(1 + w) - (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), 
         z] + (2/(-1 + w) - (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       4*G[w, 0, z] - 12*G[w, -w^(-1), z] - 4*G[w, w, z] + 
       (4/(1 + w) + (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       (-4/(-1 + w) + (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z]) + 
     (-G[0, z] + 2*G[w, z])*(G[-1, -1, 0, w] - G[-1, 1, 0, w] + 
       G[1, -1, 0, w] - G[1, 1, 0, w]) - 
     G[0, w]*(G[0, 0, -1, z] - G[0, 0, 1, z] - 3*G[0, -w^(-1), -1, z] + 
       3*G[0, -w^(-1), 1, z] - G[0, w, -1, z] + G[0, w, 1, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), -1, z] - 
       G[0, (-1 + w)/(1 + w), 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), -1, z] - G[0, -((1 + w)/(-1 + w)), 1, z] - 
       2*G[w, 0, -1, z] + 2*G[w, 0, 1, z] + 6*G[w, -w^(-1), -1, z] - 
       6*G[w, -w^(-1), 1, z] + 2*G[w, w, -1, z] - 2*G[w, w, 1, z] + 
       (-2/(1 + w) - (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), -1, z] + 
       2*G[w, (-1 + w)/(1 + w), 1, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), -1, z] + 2*G[w, -((1 + w)/(-1 + w)), 1, 
         z]) + G[0, -1, -1, 0, w] - G[0, -1, 1, 0, w] + G[0, 0, -1, 0, z] - 
     G[0, 0, 1, 0, z] + G[0, 1, -1, 0, w] - G[0, 1, 1, 0, w] - 
     3*G[0, -w^(-1), -1, 0, z] + 3*G[0, -w^(-1), 1, 0, z] - 
     G[0, w, -1, 0, z] + G[0, w, 1, 0, z] + ((1 + w)^(-1) + w/(1 + w))*
      G[0, (-1 + w)/(1 + w), -1, 0, z] - G[0, (-1 + w)/(1 + w), 1, 0, z] + 
     ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), -1, 0, z] - 
     G[0, -((1 + w)/(-1 + w)), 1, 0, z] - 2*G[w, 0, -1, 0, z] + 
     2*G[w, 0, 1, 0, z] + 6*G[w, -w^(-1), -1, 0, z] - 
     6*G[w, -w^(-1), 1, 0, z] + 2*G[w, w, -1, 0, z] - 2*G[w, w, 1, 0, z] + 
     (-2/(1 + w) - (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), -1, 0, z] + 
     2*G[w, (-1 + w)/(1 + w), 1, 0, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), -1, 0, z] + 
     2*G[w, -((1 + w)/(-1 + w)), 1, 0, z]) - 
   32*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(G[0, 0, z] - G[0, w, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), z] - 
       2*G[w, 0, z] + 2*G[w, w, z] + ((1 + w)^(-1) + w/(1 + w))*
        G[w, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z]) + (-G[0, z] + 2*G[w, z])*
      (G[-1, -1, 0, w]/4 - G[-1, 1, 0, w]/4 + G[1, -1, 0, w]/4 - 
       G[1, 1, 0, w]/4) - G[0, w]*(-G[0, 0, -1, z]/2 + G[0, 0, 1, z]/2 + 
       G[0, w, -1, z]/2 - G[0, w, 1, z]/2 + (1/(4*(1 + w)) + w/(4*(1 + w)))*
        G[0, (-1 + w)/(1 + w), -1, z] + (-1/(4*(1 + w)) - w/(4*(1 + w)))*
        G[0, (-1 + w)/(1 + w), 1, z] + (-1/(4*(-1 + w)) + w/(4*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), -1, z] + (1/(4*(-1 + w)) - w/(4*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), 1, z] + G[w, 0, -1, z] - G[w, 0, 1, z] - 
       G[w, w, -1, z] + G[w, w, 1, z] + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), -1, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), 1, z] + (-1/(2*(1 - w)) - w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), -1, z] + (1/(2*(1 - w)) + w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), 1, z]) + G[0, -1, -1, 0, w]/4 - 
     G[0, -1, 1, 0, w]/4 - G[0, 0, -1, 0, z]/2 + G[0, 0, 1, 0, z]/2 + 
     G[0, 1, -1, 0, w]/4 - G[0, 1, 1, 0, w]/4 + G[0, w, -1, 0, z]/2 - 
     G[0, w, 1, 0, z]/2 + (1/(4*(1 + w)) + w/(4*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, 0, z] + (-1/(4*(1 + w)) - w/(4*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, 0, z] + (-1/(4*(-1 + w)) + w/(4*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), -1, 0, z] + (1/(4*(-1 + w)) - w/(4*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), 1, 0, z] + G[w, 0, -1, 0, z] - 
     G[w, 0, 1, 0, z] - G[w, w, -1, 0, z] + G[w, w, 1, 0, z] + 
     (1/(2*(-1 - w)) - w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), -1, 0, z] + 
     (-1/(2*(-1 - w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), 1, 0, z] + 
     (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (1/(2*(1 - w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, 0, z]) + 
   16*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (-G[0, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z] + 2*G[w, (-1 + w)/(1 + w), z] + 
       (2/(-1 + w) - (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z]) + 
     (-G[0, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), -1, z] - 
       G[0, (-1 + w)/(1 + w), 1, z] - G[0, -((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 1, z] + 
       (-2/(1 + w) - (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), -1, z] + 
       2*G[w, (-1 + w)/(1 + w), 1, z] + 2*G[w, -((1 + w)/(-1 + w)), -1, z] + 
       (2/(-1 + w) - (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 1, z]) - 
     G[0, -1, -1, -1, w] + G[0, -1, -1, 1, w] + G[0, -1, 1, -1, w] - 
     G[0, -1, 1, 1, w] + G[0, 1, -1, -1, w] - G[0, 1, -1, 1, w] - 
     G[0, 1, 1, -1, w] + G[0, 1, 1, 1, w] - G[0, (-1 + w)/(1 + w), -1, -1, 
      z] + ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), -1, 1, z] + 
     ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 1, -1, z] - 
     G[0, (-1 + w)/(1 + w), 1, 1, z] + (-(-1 + w)^(-1) + w/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), -1, -1, z] - G[0, -((1 + w)/(-1 + w)), -1, 1, 
      z] - G[0, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (-(-1 + w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 1, 1, z] + 
     2*G[w, (-1 + w)/(1 + w), -1, -1, z] + (2/(-1 - w) - (2*w)/(1 + w))*
      G[w, (-1 + w)/(1 + w), -1, 1, z] + (2/(-1 - w) - (2*w)/(1 + w))*
      G[w, (-1 + w)/(1 + w), 1, -1, z] + 2*G[w, (-1 + w)/(1 + w), 1, 1, z] + 
     (-2/(1 - w) - (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), -1, -1, z] + 
     2*G[w, -((1 + w)/(-1 + w)), -1, 1, z] + 
     2*G[w, -((1 + w)/(-1 + w)), 1, -1, z] + (-2/(1 - w) - (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 1, 1, z]) + 
   24*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[0, 0, z] - G[w, 0, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/
        (1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[0, -1, -1, w] + G[0, -1, 1, w] - G[0, 1, -1, w] + G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[0, 0, -1, z] + G[0, 0, 1, z] - 
       2*G[0, 0, w^(-1), z] - G[w, 0, -1, z] - G[w, 0, 1, z] + 
       2*G[w, 0, w^(-1), z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/
        (1 + w) + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 0, w^(-1), z] + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, w^(-1), z]) - G[-1, 0, -1, -1, w]/2 + 
     G[-1, 0, -1, 1, w]/2 - G[-1, 0, 1, -1, w]/2 + G[-1, 0, 1, 1, w]/2 - 
     G[0, 0, -1, -1, z] + G[0, 0, -1, 1, z] - G[0, 0, 1, -1, z] + 
     G[0, 0, 1, 1, z] + 2*G[0, 0, w^(-1), -1, z] - 2*G[0, 0, w^(-1), 1, z] - 
     G[1, 0, -1, -1, w]/2 + G[1, 0, -1, 1, w]/2 - G[1, 0, 1, -1, w]/2 + 
     G[1, 0, 1, 1, w]/2 + G[w, 0, -1, -1, z] - G[w, 0, -1, 1, z] + 
     G[w, 0, 1, -1, z] - G[w, 0, 1, 1, z] - 2*G[w, 0, w^(-1), -1, z] + 
     2*G[w, 0, w^(-1), 1, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, -1, 
        z])/(1 + w) + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/
      (1 + w) + ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, w^(-1), -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 0, w^(-1), 1, z] + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, w^(-1), -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, w^(-1), 1, z]) + 
   6*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (-2*G[0, 0, z] + 6*G[-w^(-1), 0, z] + 2*G[w, 0, z] + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[0, -1, -1, w] + G[0, -1, 1, w] - G[0, 1, -1, w] + G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-2*G[0, 0, -1, z] - 2*G[0, 0, 1, z] + 
       4*G[0, 0, w^(-1), z] + 6*G[-w^(-1), 0, -1, z] + 
       6*G[-w^(-1), 0, 1, z] - 12*G[-w^(-1), 0, w^(-1), z] + 
       2*G[w, 0, -1, z] + 2*G[w, 0, 1, z] - 4*G[w, 0, w^(-1), z] + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((4 + 4*w)*G[(-1 + w)/(1 + w), 0, w^(-1), z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), 0, w^(-1), z])/(-1 + w)) - 
     2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] - 2*G[-1, 0, 1, -1, w] + 
     2*G[-1, 0, 1, 1, w] + 2*G[0, 0, -1, -1, z] - 2*G[0, 0, -1, 1, z] + 
     2*G[0, 0, 1, -1, z] - 2*G[0, 0, 1, 1, z] - 4*G[0, 0, w^(-1), -1, z] + 
     4*G[0, 0, w^(-1), 1, z] - 2*G[1, 0, -1, -1, w] + 2*G[1, 0, -1, 1, w] - 
     2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] - 6*G[-w^(-1), 0, -1, -1, z] + 
     6*G[-w^(-1), 0, -1, 1, z] - 6*G[-w^(-1), 0, 1, -1, z] + 
     6*G[-w^(-1), 0, 1, 1, z] + 12*G[-w^(-1), 0, w^(-1), -1, z] - 
     12*G[-w^(-1), 0, w^(-1), 1, z] - 2*G[w, 0, -1, -1, z] + 
     2*G[w, 0, -1, 1, z] - 2*G[w, 0, 1, -1, z] + 2*G[w, 0, 1, 1, z] + 
     4*G[w, 0, w^(-1), -1, z] - 4*G[w, 0, w^(-1), 1, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     ((-4 - 4*w)*G[(-1 + w)/(1 + w), 0, w^(-1), -1, z])/(1 + w) + 
     ((4 + 4*w)*G[(-1 + w)/(1 + w), 0, w^(-1), 1, z])/(1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) + 
     ((4 - 4*w)*G[-((1 + w)/(-1 + w)), 0, w^(-1), -1, z])/(-1 + w) + 
     ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), 0, w^(-1), 1, z])/(-1 + w)) - 
   8*(4*G[0, 0, w]*(G[(-1 + w)/(1 + w), 0, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     4*(G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/
        (-1 + w))*G[0, 0, 0, w] - 
     G[0, w]*(((4 + 4*w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((-6 - 6*w)*G[(-1 + w)/(1 + w), 0, -w, z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, w, z])/(1 + w) + 
       ((4 - 4*w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), 0, -w, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, w, z])/(-1 + w)) + 
     4*G[-1, 0, 0, 0, w] - 4*G[1, 0, 0, 0, w] + 
     ((4 + 4*w)*G[(-1 + w)/(1 + w), 0, 0, 0, z])/(1 + w) + 
     ((-6 - 6*w)*G[(-1 + w)/(1 + w), 0, -w, 0, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, w, 0, z])/(1 + w) + 
     ((4 - 4*w)*G[-((1 + w)/(-1 + w)), 0, 0, 0, z])/(-1 + w) + 
     ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), 0, -w, 0, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, w, 0, z])/(-1 + w)) - 
   2*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(-2*G[0, 0, z] + 6*G[-w^(-1), 0, z] + 
       2*G[w, 0, z] + ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[0, -1, -1, w] - G[0, -1, 1, w] - 2*G[0, 0, -1, w] + 
       2*G[0, 0, 1, w] + G[0, 1, -1, w] - G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(2*G[0, 0, -1, z] + 2*G[0, 0, 1, z] - 
       4*G[0, 0, w, z] - 6*G[-w^(-1), 0, -1, z] - 6*G[-w^(-1), 0, 1, z] + 
       12*G[-w^(-1), 0, w, z] - 2*G[w, 0, -1, z] - 2*G[w, 0, 1, z] + 
       4*G[w, 0, w, z] + ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-4 - 4*w)*G[(-1 + w)/(1 + w), 0, w, z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((4 - 4*w)*G[-((1 + w)/(-1 + w)), 0, w, z])/(-1 + w)) + 
     2*G[-1, 0, -1, -1, w] - 2*G[-1, 0, -1, 1, w] - 4*G[-1, 0, 0, -1, w] + 
     4*G[-1, 0, 0, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] - 
     2*G[0, 0, -1, -1, z] + 2*G[0, 0, -1, 1, z] - 2*G[0, 0, 1, -1, z] + 
     2*G[0, 0, 1, 1, z] + 4*G[0, 0, w, -1, z] - 4*G[0, 0, w, 1, z] + 
     2*G[1, 0, -1, -1, w] - 2*G[1, 0, -1, 1, w] - 4*G[1, 0, 0, -1, w] + 
     4*G[1, 0, 0, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] + 
     6*G[-w^(-1), 0, -1, -1, z] - 6*G[-w^(-1), 0, -1, 1, z] + 
     6*G[-w^(-1), 0, 1, -1, z] - 6*G[-w^(-1), 0, 1, 1, z] - 
     12*G[-w^(-1), 0, w, -1, z] + 12*G[-w^(-1), 0, w, 1, z] + 
     2*G[w, 0, -1, -1, z] - 2*G[w, 0, -1, 1, z] + 2*G[w, 0, 1, -1, z] - 
     2*G[w, 0, 1, 1, z] - 4*G[w, 0, w, -1, z] + 4*G[w, 0, w, 1, z] + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     ((4 + 4*w)*G[(-1 + w)/(1 + w), 0, w, -1, z])/(1 + w) + 
     ((-4 - 4*w)*G[(-1 + w)/(1 + w), 0, w, 1, z])/(1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) + 
     ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), 0, w, -1, z])/(-1 + w) + 
     ((4 - 4*w)*G[-((1 + w)/(-1 + w)), 0, w, 1, z])/(-1 + w)) - 
   8*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[0, 0, z] - G[w, 0, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[0, -1, -1, w] - G[0, -1, 1, w] - 2*G[0, 0, -1, w] + 
       2*G[0, 0, 1, w] + G[0, 1, -1, w] - G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, 0, -1, z] - G[0, 0, 1, z] + 
       2*G[0, 0, w, z] + G[w, 0, -1, z] + G[w, 0, 1, z] - 2*G[w, 0, w, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 0, w, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, w, z])/(-1 + w)) + 
     G[-1, 0, -1, -1, w]/2 - G[-1, 0, -1, 1, w]/2 - G[-1, 0, 0, -1, w] + 
     G[-1, 0, 0, 1, w] + G[-1, 0, 1, -1, w]/2 - G[-1, 0, 1, 1, w]/2 + 
     G[0, 0, -1, -1, z] - G[0, 0, -1, 1, z] + G[0, 0, 1, -1, z] - 
     G[0, 0, 1, 1, z] - 2*G[0, 0, w, -1, z] + 2*G[0, 0, w, 1, z] + 
     G[1, 0, -1, -1, w]/2 - G[1, 0, -1, 1, w]/2 - G[1, 0, 0, -1, w] + 
     G[1, 0, 0, 1, w] + G[1, 0, 1, -1, w]/2 - G[1, 0, 1, 1, w]/2 - 
     G[w, 0, -1, -1, z] + G[w, 0, -1, 1, z] - G[w, 0, 1, -1, z] + 
     G[w, 0, 1, 1, z] + 2*G[w, 0, w, -1, z] - 2*G[w, 0, w, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 0, w, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, w, 1, z])/(1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, w, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, w, 1, z])/(-1 + w)) - 
   24*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, z] + G[-((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (((-1 - w)*G[(-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), -1, w^(-1), z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, -1, z] + G[(-1 + w)/(1 + w), 1, 1, z] + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 1, w^(-1), z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), -1, -1, z] + G[-((1 + w)/(-1 + w)), -1, 1, z] + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), -1, w^(-1), z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 1, w^(-1), z])/(-1 + w)) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, 1, w] - G[-1, -1, 1, -1, w] + 
     G[-1, -1, 1, 1, w] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, 1, w] + G[1, -1, -1, -1, w] - 
     G[1, -1, -1, 1, w] + G[1, -1, 1, -1, w] - G[1, -1, 1, 1, w] - 
     G[1, 1, -1, -1, w] + G[1, 1, -1, 1, w] - G[1, 1, 1, -1, w] + 
     G[1, 1, 1, 1, w] + G[(-1 + w)/(1 + w), -1, -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, -1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -1, 1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, 1, 1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), -1, w^(-1), -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), -1, w^(-1), 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, -1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, -1, 1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, 1, 1, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 1, w^(-1), -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 1, w^(-1), 1, z])/(1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, -1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, -1, 1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, 1, 1, z] + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -1, w^(-1), -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), -1, w^(-1), 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, -1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, -1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, 1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, 1, 1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 1, w^(-1), -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 1, w^(-1), 1, z])/(-1 + w)) + 
   4*(4*G[0, 0, w]*(-G[0, -1, z] + G[0, 1, z] + 3*G[-w^(-1), -1, z] - 
       3*G[-w^(-1), 1, z] + G[w, -1, z] - G[w, 1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, z] + ((1 - w)*G[-((1 + w)/(-1 + w)), -1, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), 1, z]) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-2*G[-1, 0, 0, w] + 2*G[1, 0, 0, w]) - 
     G[0, w]*(-4*G[0, -1, 0, z] + 6*G[0, -1, -w, z] + 2*G[0, -1, w, z] + 
       4*G[0, 1, 0, z] - 6*G[0, 1, -w, z] - 2*G[0, 1, w, z] + 
       12*G[-w^(-1), -1, 0, z] - 18*G[-w^(-1), -1, -w, z] - 
       6*G[-w^(-1), -1, w, z] - 12*G[-w^(-1), 1, 0, z] + 
       18*G[-w^(-1), 1, -w, z] + 6*G[-w^(-1), 1, w, z] + 4*G[w, -1, 0, z] - 
       6*G[w, -1, -w, z] - 2*G[w, -1, w, z] - 4*G[w, 1, 0, z] + 
       6*G[w, 1, -w, z] + 2*G[w, 1, w, z] + 
       ((-4 - 4*w)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
       ((6 + 6*w)*G[(-1 + w)/(1 + w), -1, -w, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), -1, w, z])/(1 + w) + 
       ((4 + 4*w)*G[(-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
       ((-6 - 6*w)*G[(-1 + w)/(1 + w), 1, -w, z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 1, w, z])/(1 + w) + 
       ((4 - 4*w)*G[-((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
       ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), -1, -w, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -1, w, z])/(-1 + w) + 
       ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w) + 
       ((6 - 6*w)*G[-((1 + w)/(-1 + w)), 1, -w, z])/(-1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 1, w, z])/(-1 + w)) - 
     4*G[-1, -1, 0, 0, w] + 4*G[-1, 1, 0, 0, w] - 4*G[0, -1, 0, 0, z] + 
     6*G[0, -1, -w, 0, z] + 2*G[0, -1, w, 0, z] + 4*G[0, 1, 0, 0, z] - 
     6*G[0, 1, -w, 0, z] - 2*G[0, 1, w, 0, z] - 4*G[1, -1, 0, 0, w] + 
     4*G[1, 1, 0, 0, w] + 12*G[-w^(-1), -1, 0, 0, z] - 
     18*G[-w^(-1), -1, -w, 0, z] - 6*G[-w^(-1), -1, w, 0, z] - 
     12*G[-w^(-1), 1, 0, 0, z] + 18*G[-w^(-1), 1, -w, 0, z] + 
     6*G[-w^(-1), 1, w, 0, z] + 4*G[w, -1, 0, 0, z] - 6*G[w, -1, -w, 0, z] - 
     2*G[w, -1, w, 0, z] - 4*G[w, 1, 0, 0, z] + 6*G[w, 1, -w, 0, z] + 
     2*G[w, 1, w, 0, z] + ((-4 - 4*w)*G[(-1 + w)/(1 + w), -1, 0, 0, z])/
      (1 + w) + ((6 + 6*w)*G[(-1 + w)/(1 + w), -1, -w, 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), -1, w, 0, z])/(1 + w) + 
     ((4 + 4*w)*G[(-1 + w)/(1 + w), 1, 0, 0, z])/(1 + w) + 
     ((-6 - 6*w)*G[(-1 + w)/(1 + w), 1, -w, 0, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 1, w, 0, z])/(1 + w) + 
     ((4 - 4*w)*G[-((1 + w)/(-1 + w)), -1, 0, 0, z])/(-1 + w) + 
     ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), -1, -w, 0, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -1, w, 0, z])/(-1 + w) + 
     ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), 1, 0, 0, z])/(-1 + w) + 
     ((6 - 6*w)*G[-((1 + w)/(-1 + w)), 1, -w, 0, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 1, w, 0, z])/(-1 + w)) + 
   16*(4*G[0, 0, w]*(G[0, -1, z]/2 - G[0, 1, z]/2 - G[w, -1, z]/2 + 
       G[w, 1, z]/2 + ((-1/4 - w/4)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/4 + w/4)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-2*G[-1, 0, 0, w] + 2*G[1, 0, 0, w]) - 
     G[0, w]*(2*G[0, -1, 0, z] - 3*G[0, -1, -w, z] - G[0, -1, w, z] - 
       2*G[0, 1, 0, z] + 3*G[0, 1, -w, z] + G[0, 1, w, z] - 
       2*G[w, -1, 0, z] + 3*G[w, -1, -w, z] + G[w, -1, w, z] + 
       2*G[w, 1, 0, z] - 3*G[w, 1, -w, z] - G[w, 1, w, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
       ((3/2 + (3*w)/2)*G[(-1 + w)/(1 + w), -1, -w, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, w, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, 0, z] + ((-3/2 - (3*w)/2)*G[(-1 + w)/(1 + w), 
          1, -w, z])/(1 + w) + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, w, z])/
        (1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
       ((-3/2 + (3*w)/2)*G[-((1 + w)/(-1 + w)), -1, -w, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, w, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), 1, 0, z] + 
       ((3/2 - (3*w)/2)*G[-((1 + w)/(-1 + w)), 1, -w, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, w, z])/(-1 + w)) - 
     G[-1, -1, 0, 0, w] + G[-1, 1, 0, 0, w] + 2*G[0, -1, 0, 0, z] - 
     3*G[0, -1, -w, 0, z] - G[0, -1, w, 0, z] - 2*G[0, 1, 0, 0, z] + 
     3*G[0, 1, -w, 0, z] + G[0, 1, w, 0, z] - G[1, -1, 0, 0, w] + 
     G[1, 1, 0, 0, w] - 2*G[w, -1, 0, 0, z] + 3*G[w, -1, -w, 0, z] + 
     G[w, -1, w, 0, z] + 2*G[w, 1, 0, 0, z] - 3*G[w, 1, -w, 0, z] - 
     G[w, 1, w, 0, z] + ((-1 - w)*G[(-1 + w)/(1 + w), -1, 0, 0, z])/(1 + w) + 
     ((3/2 + (3*w)/2)*G[(-1 + w)/(1 + w), -1, -w, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, w, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, 0, 0, z] + 
     ((-3/2 - (3*w)/2)*G[(-1 + w)/(1 + w), 1, -w, 0, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, w, 0, z])/(1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, 0, 0, z])/(-1 + w) + 
     ((-3/2 + (3*w)/2)*G[-((1 + w)/(-1 + w)), -1, -w, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, w, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, 0, 0, z] + 
     ((3/2 - (3*w)/2)*G[-((1 + w)/(-1 + w)), 1, -w, 0, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, w, 0, z])/(-1 + w)) + 
   8*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/
        (1 + w) + G[(-1 + w)/(1 + w), 1, z] + G[-((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 
       2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + G[-1, 1, 1, w] + 
       G[1, -1, -1, w] - G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 
       2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[(-1 + w)/(1 + w), -1, -1, z] + 
       G[(-1 + w)/(1 + w), -1, 1, z] + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), -1, w, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), 1, w, z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), -1, 1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -1, w, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), 1, -1, z] + G[-((1 + w)/(-1 + w)), 1, 1, z] + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 1, w, z])/(-1 + w)) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, 1, w] - 2*G[-1, -1, 0, -1, w] + 
     2*G[-1, -1, 0, 1, w] + G[-1, -1, 1, -1, w] - G[-1, -1, 1, 1, w] - 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, 1, w] + 2*G[-1, 1, 0, -1, w] - 
     2*G[-1, 1, 0, 1, w] - G[-1, 1, 1, -1, w] + G[-1, 1, 1, 1, w] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, 1, w] + 2*G[1, -1, 0, -1, w] - 
     2*G[1, -1, 0, 1, w] - G[1, -1, 1, -1, w] + G[1, -1, 1, 1, w] + 
     G[1, 1, -1, -1, w] - G[1, 1, -1, 1, w] - 2*G[1, 1, 0, -1, w] + 
     2*G[1, 1, 0, 1, w] + G[1, 1, 1, -1, w] - G[1, 1, 1, 1, w] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, -1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -1, -1, 1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -1, 1, 1, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), -1, w, -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), -1, w, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, -1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, 1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, 1, 1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 1, w, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 1, w, 1, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, -1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, -1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, 1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, 1, 1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), -1, w, -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -1, w, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, -1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, -1, 1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, 1, 1, z] + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 1, w, -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 1, w, 1, z])/(-1 + w)) - 
   36*(G[0, 0, w]*(((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, z] + ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 
          z])/(-1 + w)) + (G[(-1 + w)/(1 + w), z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*G[0, 0, 0, w] - 
     G[0, w]*(((-1 - w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, 0, z] + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w)) - 
     G[-1, 0, 0, 0, w] + G[1, 0, 0, 0, w] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, 0, 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 0, 0, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, 0, 0, z] + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, 0, z])/(-1 + w)) + 
   12*(G[0, 0, w]*(((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), -1, z] + G[-((1 + w)/(-1 + w)), 1, z] + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, 0, w] + 2*G[0, 0, 0, w] - G[1, 0, 0, w]) - 
     G[0, w]*(((-1 - w)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), -1, 0, z] + G[-((1 + w)/(-1 + w)), 1, 0, z] + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w)) + 
     G[-1, -1, 0, 0, w] - 2*G[-1, 0, 0, 0, w] + G[-1, 1, 0, 0, w] - 
     G[1, -1, 0, 0, w] + 2*G[1, 0, 0, 0, w] - G[1, 1, 0, 0, w] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, 0, 0, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, 0, 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 0, 0, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, 0, 0, z] + G[-((1 + w)/(-1 + w)), 1, 0, 0, 
      z] + ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, 0, z])/(-1 + w)) - 
   4*((-G[0, -1, w] + G[0, 1, w])*(-2*G[0, 0, z] + 4*G[0, w, z] + 
       6*G[-w^(-1), 0, z] - 12*G[-w^(-1), w, z] + 2*G[w, 0, z] - 
       4*G[w, w, z] + ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((4 + 4*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[0, 0, -1, w] + G[0, 0, 1, w]) + (G[-1, w] - G[1, w])*
      (2*G[0, 0, 0, z] - 4*G[0, w, 0, z] - 6*G[-w^(-1), 0, 0, z] + 
       12*G[-w^(-1), w, 0, z] - 2*G[w, 0, 0, z] + 4*G[w, w, 0, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((-4 - 4*w)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((4 - 4*w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w)) - 
     2*G[-1, 0, 0, -1, w] + 2*G[-1, 0, 0, 1, w] - 2*G[0, 0, 0, -1, z] + 
     2*G[0, 0, 0, 1, z] + 4*G[0, w, 0, -1, z] - 4*G[0, w, 0, 1, z] - 
     2*G[1, 0, 0, -1, w] + 2*G[1, 0, 0, 1, w] + 6*G[-w^(-1), 0, 0, -1, z] - 
     6*G[-w^(-1), 0, 0, 1, z] - 12*G[-w^(-1), w, 0, -1, z] + 
     12*G[-w^(-1), w, 0, 1, z] + 2*G[w, 0, 0, -1, z] - 2*G[w, 0, 0, 1, z] - 
     4*G[w, w, 0, -1, z] + 4*G[w, w, 0, 1, z] + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 0, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 0, 1, z])/(1 + w) + 
     ((4 + 4*w)*G[(-1 + w)/(1 + w), w, 0, -1, z])/(1 + w) + 
     ((-4 - 4*w)*G[(-1 + w)/(1 + w), w, 0, 1, z])/(1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
     ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), w, 0, -1, z])/(-1 + w) + 
     ((4 - 4*w)*G[-((1 + w)/(-1 + w)), w, 0, 1, z])/(-1 + w)) - 
   16*((-G[0, -1, w] + G[0, 1, w])*(G[0, 0, z] - 2*G[0, w, z] - G[w, 0, z] + 
       2*G[w, w, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[0, 0, -1, w] + G[0, 0, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[0, 0, 0, z] + 2*G[0, w, 0, z] + G[w, 0, 0, z] - 2*G[w, w, 0, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w)) - 
     G[-1, 0, 0, -1, w]/2 + G[-1, 0, 0, 1, w]/2 + G[0, 0, 0, -1, z] - 
     G[0, 0, 0, 1, z] - 2*G[0, w, 0, -1, z] + 2*G[0, w, 0, 1, z] - 
     G[1, 0, 0, -1, w]/2 + G[1, 0, 0, 1, w]/2 - G[w, 0, 0, -1, z] + 
     G[w, 0, 0, 1, z] + 2*G[w, w, 0, -1, z] - 2*G[w, w, 0, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 0, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 0, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 0, 1, z])/(1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 0, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, 0, 1, z])/(-1 + w)) - 
   32*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(G[0, 0, z] - 2*G[0, w, z] - 
       G[w, 0, z] + 2*G[w, w, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/
        (1 + w) + G[(-1 + w)/(1 + w), w, z] + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[0, -1, 0, w]/2 - G[0, 1, 0, w]/2) - 
     G[0, w]*(-G[0, 0, -1, z]/2 + G[0, 0, 1, z]/2 + G[0, w, -1, z] - 
       G[0, w, 1, z] + G[w, 0, -1, z]/2 - G[w, 0, 1, z]/2 - G[w, w, -1, z] + 
       G[w, w, 1, z] + ((1/4 + w/4)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1/4 - w/4)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w)) + 
     G[-1, 0, -1, 0, w]/4 - G[-1, 0, 1, 0, w]/4 - G[0, 0, -1, 0, z]/2 + 
     G[0, 0, 1, 0, z]/2 + G[0, w, -1, 0, z] - G[0, w, 1, 0, z] + 
     G[1, 0, -1, 0, w]/4 - G[1, 0, 1, 0, w]/4 + G[w, 0, -1, 0, z]/2 - 
     G[w, 0, 1, 0, z]/2 - G[w, w, -1, 0, z] + G[w, w, 1, 0, z] + 
     ((1/4 + w/4)*G[(-1 + w)/(1 + w), 0, -1, 0, z])/(1 + w) + 
     ((-1/4 - w/4)*G[(-1 + w)/(1 + w), 0, 1, 0, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, -1, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 1, 0, z])/(1 + w) + 
     ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), 0, -1, 0, z])/(-1 + w) + 
     ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, -1, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 1, 0, z])/(-1 + w)) - 
   8*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(-2*G[0, 0, z] + 4*G[0, w, z] + 
       6*G[-w^(-1), 0, z] - 12*G[-w^(-1), w, z] + 2*G[w, 0, z] - 
       4*G[w, w, z] + ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((4 + 4*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[0, -1, 0, w]/2 - G[0, 1, 0, w]/2) - 
     G[0, w]*(G[0, 0, -1, z] - G[0, 0, 1, z] - 2*G[0, w, -1, z] + 
       2*G[0, w, 1, z] - 3*G[-w^(-1), 0, -1, z] + 3*G[-w^(-1), 0, 1, z] + 
       6*G[-w^(-1), w, -1, z] - 6*G[-w^(-1), w, 1, z] - G[w, 0, -1, z] + 
       G[w, 0, 1, z] + 2*G[w, w, -1, z] - 2*G[w, w, 1, z] + 
       G[(-1 + w)/(1 + w), 0, -1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, -1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w)) + 
     G[-1, 0, -1, 0, w] - G[-1, 0, 1, 0, w] + G[0, 0, -1, 0, z] - 
     G[0, 0, 1, 0, z] - 2*G[0, w, -1, 0, z] + 2*G[0, w, 1, 0, z] + 
     G[1, 0, -1, 0, w] - G[1, 0, 1, 0, w] - 3*G[-w^(-1), 0, -1, 0, z] + 
     3*G[-w^(-1), 0, 1, 0, z] + 6*G[-w^(-1), w, -1, 0, z] - 
     6*G[-w^(-1), w, 1, 0, z] - G[w, 0, -1, 0, z] + G[w, 0, 1, 0, z] + 
     2*G[w, w, -1, 0, z] - 2*G[w, w, 1, 0, z] + G[(-1 + w)/(1 + w), 0, -1, 0, 
      z] + ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, 0, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, -1, 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 1, 0, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, -1, 0, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, -1, 0, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, 1, 0, z])/(-1 + w)) - 
   12*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, z] + ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 
          z])/(-1 + w)) + (G[(-1 + w)/(1 + w), z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[0, -1, -1, w] - G[0, -1, 1, w] - G[0, 1, -1, w] + G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[(-1 + w)/(1 + w), 0, -1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, 1, z] + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w)) - 
     G[-1, 0, -1, -1, w] + G[-1, 0, -1, 1, w] + G[-1, 0, 1, -1, w] - 
     G[-1, 0, 1, 1, w] + G[1, 0, -1, -1, w] - G[1, 0, -1, 1, w] - 
     G[1, 0, 1, -1, w] + G[1, 0, 1, 1, w] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 0, -1, 1, z] + G[(-1 + w)/(1 + w), 0, 1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, -1, -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 1, 1, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, -1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, 1, 1, z] + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, -1, -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, -1, 1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, 1, -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 1, 1, z])/(-1 + w)) - 
   12*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (((-1 - w)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), -1, z] + G[-((1 + w)/(-1 + w)), 1, z] + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[(-1 + w)/(1 + w), -1, -1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, -1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), -1, 1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), 1, 1, z] + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w)) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, 1, w] - G[-1, -1, 1, -1, w] + 
     G[-1, -1, 1, 1, w] - 2*G[-1, 0, -1, -1, w] + 2*G[-1, 0, -1, 1, w] + 
     2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] + G[-1, 1, -1, -1, w] - 
     G[-1, 1, -1, 1, w] - G[-1, 1, 1, -1, w] + G[-1, 1, 1, 1, w] - 
     G[1, -1, -1, -1, w] + G[1, -1, -1, 1, w] + G[1, -1, 1, -1, w] - 
     G[1, -1, 1, 1, w] + 2*G[1, 0, -1, -1, w] - 2*G[1, 0, -1, 1, w] - 
     2*G[1, 0, 1, -1, w] + 2*G[1, 0, 1, 1, w] - G[1, 1, -1, -1, w] + 
     G[1, 1, -1, 1, w] + G[1, 1, 1, -1, w] - G[1, 1, 1, 1, w] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, -1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -1, -1, 1, z] + G[(-1 + w)/(1 + w), -1, 1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, 1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, -1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, -1, 1, z] + G[(-1 + w)/(1 + w), 1, 1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, 1, 1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, -1, -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 1, 1, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, -1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, -1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, 1, 1, z] + G[-((1 + w)/(-1 + w)), 1, -1, -1, 
      z] + ((1 - w)*G[-((1 + w)/(-1 + w)), 1, -1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, 1, 1, z] + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, -1, -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, -1, 1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, 1, -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 1, 1, z])/(-1 + w)) - 
   8*(G[0, 0, w]*(2*G[0, (-1 + w)/(1 + w), z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z] - 6*G[-w^(-1), (-1 + w)/(1 + w), z] + 
       (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 
          z])/w - 2*G[w, (-1 + w)/(1 + w), z] + 
       (-2/(-1 + w) + (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, 0, w] + G[1, 0, 0, w]) - 
     G[0, w]*(2*G[0, (-1 + w)/(1 + w), 0, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), 0, z] - 6*G[-w^(-1), (-1 + w)/(1 + w), 0, 
         z] + (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*
         G[-w^(-1), -((1 + w)/(-1 + w)), 0, z])/w - 
       2*G[w, (-1 + w)/(1 + w), 0, z] + (-2/(-1 + w) + (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     2*G[-1, -1, 0, 0, w] + 2*G[-1, 1, 0, 0, w] + 
     2*G[0, (-1 + w)/(1 + w), 0, 0, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, 0, z] - 2*G[1, -1, 0, 0, w] + 
     2*G[1, 1, 0, 0, w] - 6*G[-w^(-1), (-1 + w)/(1 + w), 0, 0, z] + 
     (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 0, 
        0, z])/w - 2*G[w, (-1 + w)/(1 + w), 0, 0, z] + 
     (-2/(-1 + w) + (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, 0, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
     ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, 0, z])/(1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 0, z])/
      (-1 + w) + ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) - 
   32*(G[0, 0, w]*(-G[0, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z] + G[w, (-1 + w)/(1 + w), z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, 0, w] + G[1, 0, 0, w]) - 
     G[0, w]*(-G[0, (-1 + w)/(1 + w), 0, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), 0, z] + G[w, (-1 + w)/(1 + w), 0, z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, z])/
        (-1 + w) + ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     G[-1, -1, 0, 0, w]/2 + G[-1, 1, 0, 0, w]/2 - G[0, (-1 + w)/(1 + w), 0, 
      0, z] + ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, 0, 
       z] - G[1, -1, 0, 0, w]/2 + G[1, 1, 0, 0, w]/2 + 
     G[w, (-1 + w)/(1 + w), 0, 0, z] + ((-1 + w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, 0, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, 0, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 0, z])/
      (-1 + w) + ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) + 
   24*(G[0, 0, w]*(((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/(2*(1 + w)) + w/(1 + w) + 
          w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/
        (1 + w) + ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, 0, w]/2 + G[1, 0, 0, w]/2) - 
     G[0, w]*(((-1 - w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 0, z] + 
       ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, 0, 
        z] + ((1 - w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     G[-1, -1, 0, 0, w]/2 - G[-1, 1, 0, 0, w]/2 + G[1, -1, 0, 0, w]/2 + 
     G[1, 1, 0, 0, w]/2 + ((-1 - w)*G[(-1 + w)/(1 + w), 0, 0, 0, z])/
      (1 + w) + G[(-1 + w)/(1 + w), w, 0, 0, z] + 
     ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
     ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, 0, z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, 0, 
      0, z] + ((1 - w)*G[-((1 + w)/(-1 + w)), w, 0, 0, z])/(-1 + w) + 
     ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 0, 0, z])/(-1 + w) + 
     ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) - 
   12*((-G[0, -1, w] + G[0, 1, w])*(G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 
        z] + (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, -1, w] - G[-1, 0, 1, w] - G[1, 0, -1, w] + G[1, 0, 1, w]) + 
     (G[-1, w] - G[1, w])*((((-1 - w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, z] + 
       (((-1 - w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/
        (-1 + w)) - G[-1, -1, 0, -1, w] + G[-1, -1, 0, 1, w] + 
     G[-1, 1, 0, -1, w] - G[-1, 1, 0, 1, w] + G[1, -1, 0, -1, w] - 
     G[1, -1, 0, 1, w] - G[1, 1, 0, -1, w] + G[1, 1, 0, 1, w] + 
     G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, -1, z] + 
     (((-1 - w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 
        0, -1, z])/(1 + w) + G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, 1, 
      z] + ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, -1, z])/
      (-1 + w) + (((-1 - w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) + 
     (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*G[-((1 + w)/(-1 + w)), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/
      (-1 + w)) + 2*((-G[0, -1, w] + G[0, 1, w])*(4*G[0, 0, z] - 
       12*G[0, -w^(-1), z] - 4*G[0, w, z] + (4/(1 + w) + (4*w)/(1 + w))*
        G[0, (-1 + w)/(1 + w), z] + (-4/(-1 + w) + (4*w)/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z] - 12*G[-w^(-1), 0, z] + 
       36*G[-w^(-1), -w^(-1), z] + 12*G[-w^(-1), w, z] + 
       (((-12*w)/(1 + w) - (12*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), z])/
        w + (((12*w)/(-1 + w) - (12*w^2)/(-1 + w))*G[-w^(-1), 
          -((1 + w)/(-1 + w)), z])/w - 4*G[w, 0, z] + 12*G[w, -w^(-1), z] + 
       4*G[w, w, z] + (-4/(1 + w) - (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 
         z] + (4/(-1 + w) - (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((4 + 4*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((-12 - 12*w)*G[(-1 + w)/(1 + w), -w^(-1), z])/(1 + w) + 
       ((-4 - 4*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((4/(1 + w) + (8*w)/(1 + w) + (4*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), z])/(1 + w) + ((-4/(-1 + w) + (4*w^2)/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((12 - 12*w)*G[-((1 + w)/(-1 + w)), -w^(-1), z])/(-1 + w) + 
       ((4 - 4*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((-4/(1 + w) + (4*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((4/(-1 + w) - (8*w)/(-1 + w) + (4*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] - 2*G[1, 0, -1, w] + 
       2*G[1, 0, 1, w]) + (G[-1, w] - G[1, w])*(-4*G[0, 0, 0, z] + 
       12*G[0, -w^(-1), 0, z] + 4*G[0, w, 0, z] + 
       (-4/(1 + w) - (4*w)/(1 + w))*G[0, (-1 + w)/(1 + w), 0, z] + 
       (4/(-1 + w) - (4*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, z] + 
       12*G[-w^(-1), 0, 0, z] - 36*G[-w^(-1), -w^(-1), 0, z] - 
       12*G[-w^(-1), w, 0, z] + (((12*w)/(1 + w) + (12*w^2)/(1 + w))*
         G[-w^(-1), (-1 + w)/(1 + w), 0, z])/w + 
       (((-12*w)/(-1 + w) + (12*w^2)/(-1 + w))*G[-w^(-1), 
          -((1 + w)/(-1 + w)), 0, z])/w + 4*G[w, 0, 0, z] - 
       12*G[w, -w^(-1), 0, z] - 4*G[w, w, 0, z] + (4/(1 + w) + (4*w)/(1 + w))*
        G[w, (-1 + w)/(1 + w), 0, z] + (-4/(-1 + w) + (4*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((-4 - 4*w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((12 + 12*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, z])/(1 + w) + 
       ((4 + 4*w)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       ((-4/(1 + w) - (8*w)/(1 + w) - (4*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), 0, z])/(1 + w) + ((4/(-1 + w) - (4*w^2)/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((4 - 4*w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((-12 + 12*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, z])/(-1 + w) + 
       ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w) + 
       ((4/(1 + w) - (4*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((-4/(-1 + w) + (8*w)/(-1 + w) - (4*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     4*G[-1, -1, 0, -1, w] + 4*G[-1, -1, 0, 1, w] - 4*G[-1, 1, 0, -1, w] + 
     4*G[-1, 1, 0, 1, w] + 4*G[0, 0, 0, -1, z] - 4*G[0, 0, 0, 1, z] - 
     12*G[0, -w^(-1), 0, -1, z] + 12*G[0, -w^(-1), 0, 1, z] - 
     4*G[0, w, 0, -1, z] + 4*G[0, w, 0, 1, z] + (4/(1 + w) + (4*w)/(1 + w))*
      G[0, (-1 + w)/(1 + w), 0, -1, z] + (-4/(1 + w) - (4*w)/(1 + w))*
      G[0, (-1 + w)/(1 + w), 0, 1, z] + (-4/(-1 + w) + (4*w)/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, -1, z] + (4/(-1 + w) - (4*w)/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, 1, z] - 4*G[1, -1, 0, -1, w] + 
     4*G[1, -1, 0, 1, w] - 4*G[1, 1, 0, -1, w] + 4*G[1, 1, 0, 1, w] - 
     12*G[-w^(-1), 0, 0, -1, z] + 12*G[-w^(-1), 0, 0, 1, z] + 
     36*G[-w^(-1), -w^(-1), 0, -1, z] - 36*G[-w^(-1), -w^(-1), 0, 1, z] + 
     12*G[-w^(-1), w, 0, -1, z] - 12*G[-w^(-1), w, 0, 1, z] + 
     (((-12*w)/(1 + w) - (12*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), 0, 
        -1, z])/w + (((12*w)/(1 + w) + (12*w^2)/(1 + w))*
       G[-w^(-1), (-1 + w)/(1 + w), 0, 1, z])/w + 
     (((12*w)/(-1 + w) - (12*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 
        0, -1, z])/w + (((-12*w)/(-1 + w) + (12*w^2)/(-1 + w))*
       G[-w^(-1), -((1 + w)/(-1 + w)), 0, 1, z])/w - 4*G[w, 0, 0, -1, z] + 
     4*G[w, 0, 0, 1, z] + 12*G[w, -w^(-1), 0, -1, z] - 
     12*G[w, -w^(-1), 0, 1, z] + 4*G[w, w, 0, -1, z] - 4*G[w, w, 0, 1, z] + 
     (4/(-1 - w) - (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 0, -1, z] + 
     (-4/(-1 - w) + (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 0, 1, z] + 
     (-4/(1 - w) - (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, -1, z] + 
     (4/(1 - w) + (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, 1, z] + 
     ((4 + 4*w)*G[(-1 + w)/(1 + w), 0, 0, -1, z])/(1 + w) + 
     ((-4 - 4*w)*G[(-1 + w)/(1 + w), 0, 0, 1, z])/(1 + w) + 
     ((-12 - 12*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, -1, z])/(1 + w) + 
     ((12 + 12*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, 1, z])/(1 + w) + 
     ((-4 - 4*w)*G[(-1 + w)/(1 + w), w, 0, -1, z])/(1 + w) + 
     ((4 + 4*w)*G[(-1 + w)/(1 + w), w, 0, 1, z])/(1 + w) + 
     ((4/(1 + w) + (8*w)/(1 + w) + (4*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
     ((-4/(1 + w) - (8*w)/(1 + w) - (4*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((-4/(-1 + w) + (4*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(1 + w) + 
     ((4/(-1 + w) - (4*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, 1, z])/(1 + w) + 
     ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), 0, 0, -1, z])/(-1 + w) + 
     ((4 - 4*w)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
     ((12 - 12*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, -1, z])/(-1 + w) + 
     ((-12 + 12*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, 1, z])/(-1 + w) + 
     ((4 - 4*w)*G[-((1 + w)/(-1 + w)), w, 0, -1, z])/(-1 + w) + 
     ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), w, 0, 1, z])/(-1 + w) + 
     ((-4/(1 + w) + (4*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        0, -1, z])/(-1 + w) + ((4/(1 + w) - (4*w^2)/(1 + w))*
       G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) + 
     ((4/(-1 + w) - (8*w)/(-1 + w) + (4*w^2)/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((-4/(-1 + w) + (8*w)/(-1 + w) - (4*w^2)/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w)) + 
   8*((-G[0, -1, w] + G[0, 1, w])*(-2*G[0, 0, z] + 6*G[0, -w^(-1), z] + 
       2*G[0, w, z] + (-2/(1 + w) - (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), 
         z] + (2/(-1 + w) - (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       2*G[w, 0, z] - 6*G[w, -w^(-1), z] - 2*G[w, w, z] + 
       (2/(1 + w) + (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       (-2/(-1 + w) + (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       G[(-1 + w)/(1 + w), 0, z] + ((-3 - 3*w)*G[(-1 + w)/(1 + w), -w^(-1), 
          z])/(1 + w) + ((-1 - w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       (((1 + w)^(-1) + (2*w)/(1 + w) + w^2/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), z])/(1 + w) + (((1 - w)^(-1) + w^2/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, z] + ((3 - 3*w)*G[-((1 + w)/(-1 + w)), 
          -w^(-1), z])/(-1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), w, z])/
        (-1 + w) + (((-1 - w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] - 2*G[1, 0, -1, w] + 
       2*G[1, 0, 1, w]) + (G[-1, w] - G[1, w])*(2*G[0, 0, 0, z] - 
       6*G[0, -w^(-1), 0, z] - 2*G[0, w, 0, z] + (2/(1 + w) + (2*w)/(1 + w))*
        G[0, (-1 + w)/(1 + w), 0, z] + (-2/(-1 + w) + (2*w)/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), 0, z] - 2*G[w, 0, 0, z] + 
       6*G[w, -w^(-1), 0, z] + 2*G[w, w, 0, z] + (-2/(1 + w) - (2*w)/(1 + w))*
        G[w, (-1 + w)/(1 + w), 0, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((3 + 3*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 0, z] + (((-1 - w)^(-1) - (2*w)/(1 + w) - 
          w^2/(1 + w))*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((-3 + 3*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 0, z] + (((1 + w)^(-1) - w^2/(1 + w))*
         G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       (((1 - w)^(-1) + (2*w)/(-1 + w) - w^2/(-1 + w))*G[-((1 + w)/(-1 + w)), 
          -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - G[-1, -1, 0, -1, w] + 
     G[-1, -1, 0, 1, w] - G[-1, 1, 0, -1, w] + G[-1, 1, 0, 1, w] - 
     2*G[0, 0, 0, -1, z] + 2*G[0, 0, 0, 1, z] + 6*G[0, -w^(-1), 0, -1, z] - 
     6*G[0, -w^(-1), 0, 1, z] + 2*G[0, w, 0, -1, z] - 2*G[0, w, 0, 1, z] + 
     (-2/(1 + w) - (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), 0, -1, z] + 
     (2/(1 + w) + (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), 0, 1, z] + 
     (2/(-1 + w) - (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, -1, z] + 
     (-2/(-1 + w) + (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, 1, z] - 
     G[1, -1, 0, -1, w] + G[1, -1, 0, 1, w] - G[1, 1, 0, -1, w] + 
     G[1, 1, 0, 1, w] + 2*G[w, 0, 0, -1, z] - 2*G[w, 0, 0, 1, z] - 
     6*G[w, -w^(-1), 0, -1, z] + 6*G[w, -w^(-1), 0, 1, z] - 
     2*G[w, w, 0, -1, z] + 2*G[w, w, 0, 1, z] + (-2/(-1 - w) + (2*w)/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, -1, z] + (2/(-1 - w) - (2*w)/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, 1, z] + (2/(1 - w) + (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, -1, z] + (-2/(1 - w) - (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, 1, z] + G[(-1 + w)/(1 + w), 0, 0, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, 0, 1, z])/(1 + w) + 
     ((-3 - 3*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, -1, z])/(1 + w) + 
     ((3 + 3*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 0, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 0, 1, z] + 
     (((1 + w)^(-1) + (2*w)/(1 + w) + w^2/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
     ((-(1 + w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((-(-1 + w)^(-1) + w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(1 + w) + 
     (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 
        0, 1, z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, 0, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
     ((3 - 3*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, -1, z])/(-1 + w) + 
     ((-3 + 3*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, 0, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 0, 1, z] + 
     ((-(1 + w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        0, -1, z])/(-1 + w) + (((1 + w)^(-1) - w^2/(1 + w))*
       G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) + 
     (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*G[-((1 + w)/(-1 + w)), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((-(-1 + w)^(-1) + (2*w)/(-1 + w) - w^2/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w)) + 
   8*((-G[0, -1, w] + G[0, 1, w])*(-2*G[0, 0, z] + 2*G[0, w, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       6*G[-w^(-1), 0, z] - 6*G[-w^(-1), w, z] + 
       (((-3*w)/(1 + w) - (3*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), z])/
        w + (((3*w)/(-1 + w) - (3*w^2)/(-1 + w))*G[-w^(-1), 
          -((1 + w)/(-1 + w)), z])/w + 2*G[w, 0, z] - 2*G[w, w, z] + 
       ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       (((1 + w)^(-1) + (2*w)/(1 + w) + w^2/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), z])/(1 + w) + (((1 - w)^(-1) + w^2/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       (((-1 - w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, -1, w]/2 + G[-1, 0, 1, w]/2 - G[1, 0, -1, w]/2 + 
       G[1, 0, 1, w]/2) + (G[-1, w] - G[1, w])*(2*G[0, 0, 0, z] - 
       2*G[0, w, 0, z] + ((-1 - w)^(-1) - w/(1 + w))*G[0, (-1 + w)/(1 + w), 
         0, z] + ((-1 + w)^(-1) - w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, 
         z] - 6*G[-w^(-1), 0, 0, z] + 6*G[-w^(-1), w, 0, z] + 
       (((3*w)/(1 + w) + (3*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), 0, z])/
        w + (((-3*w)/(-1 + w) + (3*w^2)/(-1 + w))*G[-w^(-1), 
          -((1 + w)/(-1 + w)), 0, z])/w - 2*G[w, 0, 0, z] + 2*G[w, w, 0, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), 0, z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       (((-1 - w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), 0, z])/(1 + w) + (((-1 + w)^(-1) - w^2/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w) + 
       (((1 + w)^(-1) - w^2/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
          0, z])/(-1 + w) + (((1 - w)^(-1) + (2*w)/(-1 + w) - w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     G[-1, -1, 0, -1, w] + G[-1, -1, 0, 1, w] - G[-1, 1, 0, -1, w] + 
     G[-1, 1, 0, 1, w] - 2*G[0, 0, 0, -1, z] + 2*G[0, 0, 0, 1, z] + 
     2*G[0, w, 0, -1, z] - 2*G[0, w, 0, 1, z] + ((1 + w)^(-1) + w/(1 + w))*
      G[0, (-1 + w)/(1 + w), 0, -1, z] + (-(1 + w)^(-1) - w/(1 + w))*
      G[0, (-1 + w)/(1 + w), 0, 1, z] + (-(-1 + w)^(-1) + w/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, -1, z] + ((-1 + w)^(-1) - w/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, 1, z] - G[1, -1, 0, -1, w] + 
     G[1, -1, 0, 1, w] - G[1, 1, 0, -1, w] + G[1, 1, 0, 1, w] + 
     6*G[-w^(-1), 0, 0, -1, z] - 6*G[-w^(-1), 0, 0, 1, z] - 
     6*G[-w^(-1), w, 0, -1, z] + 6*G[-w^(-1), w, 0, 1, z] + 
     (((-3*w)/(1 + w) - (3*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), 0, -1, 
        z])/w + (((3*w)/(1 + w) + (3*w^2)/(1 + w))*
       G[-w^(-1), (-1 + w)/(1 + w), 0, 1, z])/w + 
     (((3*w)/(-1 + w) - (3*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 0, 
        -1, z])/w + (((-3*w)/(-1 + w) + (3*w^2)/(-1 + w))*
       G[-w^(-1), -((1 + w)/(-1 + w)), 0, 1, z])/w + 2*G[w, 0, 0, -1, z] - 
     2*G[w, 0, 0, 1, z] - 2*G[w, w, 0, -1, z] + 2*G[w, w, 0, 1, z] + 
     ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), 0, -1, z] + 
     (-(-1 - w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), 0, 1, z] + 
     (-(1 - w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, -1, z] + 
     ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 0, 1, z] + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 0, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 0, 1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 0, -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 0, 1, z])/(1 + w) + 
     (((1 + w)^(-1) + (2*w)/(1 + w) + w^2/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
     ((-(1 + w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((-(-1 + w)^(-1) + w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(1 + w) + 
     (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 
        0, 1, z])/(1 + w) + ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, -1, z])/
      (-1 + w) + ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, 0, -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, 1, z])/(-1 + w) + 
     ((-(1 + w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        0, -1, z])/(-1 + w) + (((1 + w)^(-1) - w^2/(1 + w))*
       G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) + 
     (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*G[-((1 + w)/(-1 + w)), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((-(-1 + w)^(-1) + (2*w)/(-1 + w) - w^2/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w)) + 
   32*((-G[0, -1, w] + G[0, 1, w])*(G[0, 0, z] - G[0, w, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), z] - 
       G[w, 0, z] + G[w, w, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, -1, w]/2 + G[-1, 0, 1, w]/2 - G[1, 0, -1, w]/2 + 
       G[1, 0, 1, w]/2) + (G[-1, w] - G[1, w])*(-G[0, 0, 0, z] + 
       G[0, w, 0, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 
         0, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 
         0, z] + G[w, 0, 0, z] - G[w, w, 0, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), 0, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w) + 
       ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     G[-1, -1, 0, -1, w]/4 + G[-1, -1, 0, 1, w]/4 - G[-1, 1, 0, -1, w]/4 + 
     G[-1, 1, 0, 1, w]/4 + G[0, 0, 0, -1, z] - G[0, 0, 0, 1, z] - 
     G[0, w, 0, -1, z] + G[0, w, 0, 1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 0, -1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 0, 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), 0, -1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, 1, z] - 
     G[1, -1, 0, -1, w]/4 + G[1, -1, 0, 1, w]/4 - G[1, 1, 0, -1, w]/4 + 
     G[1, 1, 0, 1, w]/4 - G[w, 0, 0, -1, z] + G[w, 0, 0, 1, z] + 
     G[w, w, 0, -1, z] - G[w, w, 0, 1, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), 0, -1, z] + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), 0, 1, z] + (1/(2*(1 - w)) + w/(2*(-1 + w)))*
      G[w, -((1 + w)/(-1 + w)), 0, -1, z] + (-1/(2*(1 - w)) - w/(2*(-1 + w)))*
      G[w, -((1 + w)/(-1 + w)), 0, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 0, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 0, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, 0, 1, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
     ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(1 + w) + 
     ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, 1, z])/(1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 0, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, 0, 1, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 0, -1, z])/(-1 + w) + 
     ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w)) + 
   16*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(-2*G[0, 0, z] + 6*G[0, -w^(-1), z] + 
       2*G[0, w, z] + (-2/(1 + w) - (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), 
         z] + (2/(-1 + w) - (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       2*G[w, 0, z] - 6*G[w, -w^(-1), z] - 2*G[w, w, z] + 
       (2/(1 + w) + (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       (-2/(-1 + w) + (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       G[(-1 + w)/(1 + w), 0, z] + ((-3 - 3*w)*G[(-1 + w)/(1 + w), -w^(-1), 
          z])/(1 + w) + ((-1 - w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       (((1 + w)^(-1) + (2*w)/(1 + w) + w^2/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), z])/(1 + w) + (((1 - w)^(-1) + w^2/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, z] + ((3 - 3*w)*G[-((1 + w)/(-1 + w)), 
          -w^(-1), z])/(-1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), w, z])/
        (-1 + w) + (((-1 - w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, 0, w] - G[-1, 1, 0, w] + G[1, -1, 0, w] - G[1, 1, 0, w]) - 
     G[0, w]*(G[0, 0, -1, z] - G[0, 0, 1, z] - 3*G[0, -w^(-1), -1, z] + 
       3*G[0, -w^(-1), 1, z] - G[0, w, -1, z] + G[0, w, 1, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), -1, z] - 
       G[0, (-1 + w)/(1 + w), 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), -1, z] - G[0, -((1 + w)/(-1 + w)), 1, z] - 
       G[w, 0, -1, z] + G[w, 0, 1, z] + 3*G[w, -w^(-1), -1, z] - 
       3*G[w, -w^(-1), 1, z] + G[w, w, -1, z] - G[w, w, 1, z] + 
       ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), -1, z] + 
       G[w, (-1 + w)/(1 + w), 1, z] + ((-1 + w)^(-1) - w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), -1, z] + G[w, -((1 + w)/(-1 + w)), 1, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((3/2 + (3*w)/2)*G[(-1 + w)/(1 + w), -w^(-1), -1, z])/(1 + w) + 
       ((-3/2 - (3*w)/2)*G[(-1 + w)/(1 + w), -w^(-1), 1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((-3/2 + (3*w)/2)*G[-((1 + w)/(-1 + w)), -w^(-1), -1, z])/(-1 + w) + 
       ((3/2 - (3*w)/2)*G[-((1 + w)/(-1 + w)), -w^(-1), 1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 1, z])/
        (-1 + w) + ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/
        (-1 + w)) + G[-1, -1, -1, 0, w]/2 - G[-1, -1, 1, 0, w]/2 + 
     G[-1, 1, -1, 0, w]/2 - G[-1, 1, 1, 0, w]/2 + G[0, 0, -1, 0, z] - 
     G[0, 0, 1, 0, z] - 3*G[0, -w^(-1), -1, 0, z] + 
     3*G[0, -w^(-1), 1, 0, z] - G[0, w, -1, 0, z] + G[0, w, 1, 0, z] + 
     ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), -1, 0, z] - 
     G[0, (-1 + w)/(1 + w), 1, 0, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), -1, 0, z] - G[0, -((1 + w)/(-1 + w)), 1, 0, 
      z] + G[1, -1, -1, 0, w]/2 - G[1, -1, 1, 0, w]/2 + G[1, 1, -1, 0, w]/2 - 
     G[1, 1, 1, 0, w]/2 - G[w, 0, -1, 0, z] + G[w, 0, 1, 0, z] + 
     3*G[w, -w^(-1), -1, 0, z] - 3*G[w, -w^(-1), 1, 0, z] + 
     G[w, w, -1, 0, z] - G[w, w, 1, 0, z] + ((-1 - w)^(-1) - w/(1 + w))*
      G[w, (-1 + w)/(1 + w), -1, 0, z] + G[w, (-1 + w)/(1 + w), 1, 0, z] + 
     ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), -1, 0, z] + 
     G[w, -((1 + w)/(-1 + w)), 1, 0, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, 0, z])/(1 + w) + 
     ((3/2 + (3*w)/2)*G[(-1 + w)/(1 + w), -w^(-1), -1, 0, z])/(1 + w) + 
     ((-3/2 - (3*w)/2)*G[(-1 + w)/(1 + w), -w^(-1), 1, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, -1, 0, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, 1, 0, z])/(1 + w) + 
     ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, 0, z])/
      (1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     ((-3/2 + (3*w)/2)*G[-((1 + w)/(-1 + w)), -w^(-1), -1, 0, z])/(-1 + w) + 
     ((3/2 - (3*w)/2)*G[-((1 + w)/(-1 + w)), -w^(-1), 1, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, -1, 0, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, 1, 0, z])/(-1 + w) + 
     ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 1, 0, z])/
      (-1 + w) + ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/
      (-1 + w)) + 4*((G[-1, 0, w]/2 - G[1, 0, w]/2)*
      (4*G[0, 0, z] - 12*G[0, -w^(-1), z] - 4*G[0, w, z] + 
       (4/(1 + w) + (4*w)/(1 + w))*G[0, (-1 + w)/(1 + w), z] + 
       (-4/(-1 + w) + (4*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] - 
       12*G[-w^(-1), 0, z] + 36*G[-w^(-1), -w^(-1), z] + 
       12*G[-w^(-1), w, z] + (((-12*w)/(1 + w) - (12*w^2)/(1 + w))*
         G[-w^(-1), (-1 + w)/(1 + w), z])/w + 
       (((12*w)/(-1 + w) - (12*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 
          z])/w - 4*G[w, 0, z] + 12*G[w, -w^(-1), z] + 4*G[w, w, z] + 
       (-4/(1 + w) - (4*w)/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       (4/(-1 + w) - (4*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((4 + 4*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((-12 - 12*w)*G[(-1 + w)/(1 + w), -w^(-1), z])/(1 + w) + 
       ((-4 - 4*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((4/(1 + w) + (8*w)/(1 + w) + (4*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), z])/(1 + w) + ((-4/(-1 + w) + (4*w^2)/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-4 + 4*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((12 - 12*w)*G[-((1 + w)/(-1 + w)), -w^(-1), z])/(-1 + w) + 
       ((4 - 4*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((-4/(1 + w) + (4*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((4/(-1 + w) - (8*w)/(-1 + w) + (4*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, 0, w] - G[-1, 1, 0, w] + G[1, -1, 0, w] - G[1, 1, 0, w]) - 
     G[0, w]*(-2*G[0, 0, -1, z] + 2*G[0, 0, 1, z] + 6*G[0, -w^(-1), -1, z] - 
       6*G[0, -w^(-1), 1, z] + 2*G[0, w, -1, z] - 2*G[0, w, 1, z] + 
       (-2/(1 + w) - (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), -1, z] + 
       2*G[0, (-1 + w)/(1 + w), 1, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), -1, z] + 2*G[0, -((1 + w)/(-1 + w)), 1, 
         z] + 6*G[-w^(-1), 0, -1, z] - 6*G[-w^(-1), 0, 1, z] - 
       18*G[-w^(-1), -w^(-1), -1, z] + 18*G[-w^(-1), -w^(-1), 1, z] - 
       6*G[-w^(-1), w, -1, z] + 6*G[-w^(-1), w, 1, z] + 
       (((6*w)/(1 + w) + (6*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), -1, 
          z])/w - 6*G[-w^(-1), (-1 + w)/(1 + w), 1, z] + 
       (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 
          -1, z])/w - 6*G[-w^(-1), -((1 + w)/(-1 + w)), 1, z] + 
       2*G[w, 0, -1, z] - 2*G[w, 0, 1, z] - 6*G[w, -w^(-1), -1, z] + 
       6*G[w, -w^(-1), 1, z] - 2*G[w, w, -1, z] + 2*G[w, w, 1, z] + 
       (2/(1 + w) + (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), -1, z] - 
       2*G[w, (-1 + w)/(1 + w), 1, z] + (-2/(-1 + w) + (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), -1, z] - 2*G[w, -((1 + w)/(-1 + w)), 1, 
         z] + ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((6 + 6*w)*G[(-1 + w)/(1 + w), -w^(-1), -1, z])/(1 + w) + 
       ((-6 - 6*w)*G[(-1 + w)/(1 + w), -w^(-1), 1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((-2/(1 + w) - (4*w)/(1 + w) - (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), -1, z])/(-1 + w) + 
       ((6 - 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w) + 
       ((2/(1 + w) - (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/
        (-1 + w)) + 2*G[-1, -1, -1, 0, w] - 2*G[-1, -1, 1, 0, w] + 
     2*G[-1, 1, -1, 0, w] - 2*G[-1, 1, 1, 0, w] - 2*G[0, 0, -1, 0, z] + 
     2*G[0, 0, 1, 0, z] + 6*G[0, -w^(-1), -1, 0, z] - 
     6*G[0, -w^(-1), 1, 0, z] + 2*G[0, w, -1, 0, z] - 2*G[0, w, 1, 0, z] + 
     (-2/(1 + w) - (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), -1, 0, z] + 
     2*G[0, (-1 + w)/(1 + w), 1, 0, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), -1, 0, z] + 
     2*G[0, -((1 + w)/(-1 + w)), 1, 0, z] + 2*G[1, -1, -1, 0, w] - 
     2*G[1, -1, 1, 0, w] + 2*G[1, 1, -1, 0, w] - 2*G[1, 1, 1, 0, w] + 
     6*G[-w^(-1), 0, -1, 0, z] - 6*G[-w^(-1), 0, 1, 0, z] - 
     18*G[-w^(-1), -w^(-1), -1, 0, z] + 18*G[-w^(-1), -w^(-1), 1, 0, z] - 
     6*G[-w^(-1), w, -1, 0, z] + 6*G[-w^(-1), w, 1, 0, z] + 
     (((6*w)/(1 + w) + (6*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), -1, 0, 
        z])/w - 6*G[-w^(-1), (-1 + w)/(1 + w), 1, 0, z] + 
     (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 
        -1, 0, z])/w - 6*G[-w^(-1), -((1 + w)/(-1 + w)), 1, 0, z] + 
     2*G[w, 0, -1, 0, z] - 2*G[w, 0, 1, 0, z] - 6*G[w, -w^(-1), -1, 0, z] + 
     6*G[w, -w^(-1), 1, 0, z] - 2*G[w, w, -1, 0, z] + 2*G[w, w, 1, 0, z] + 
     (2/(1 + w) + (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), -1, 0, z] - 
     2*G[w, (-1 + w)/(1 + w), 1, 0, z] + (-2/(-1 + w) + (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), -1, 0, z] - 
     2*G[w, -((1 + w)/(-1 + w)), 1, 0, z] + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, -1, 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 1, 0, z])/(1 + w) + 
     ((6 + 6*w)*G[(-1 + w)/(1 + w), -w^(-1), -1, 0, z])/(1 + w) + 
     ((-6 - 6*w)*G[(-1 + w)/(1 + w), -w^(-1), 1, 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, -1, 0, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 1, 0, z])/(1 + w) + 
     ((-2/(1 + w) - (4*w)/(1 + w) - (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, 0, z])/(1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, -1, 0, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), -1, 0, z])/(-1 + w) + 
     ((6 - 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 1, 0, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, -1, 0, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 1, 0, z])/(-1 + w) + 
     ((2/(1 + w) - (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        -1, 0, z])/(-1 + w) + ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 0, z])/(-1 + w) + 
     ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/
      (-1 + w)) + 64*((G[-1, 0, w]/2 - G[1, 0, w]/2)*
      (G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - G[w, 0, z] + G[w, w, z] + 
       (1/(2*(1 + w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, 0, w]/4 - G[-1, 1, 0, w]/4 + G[1, -1, 0, w]/4 - 
       G[1, 1, 0, w]/4) - G[0, w]*(-G[0, 0, -1, z]/2 + G[0, 0, 1, z]/2 + 
       G[0, w, -1, z]/2 - G[0, w, 1, z]/2 + (1/(4*(1 + w)) + w/(4*(1 + w)))*
        G[0, (-1 + w)/(1 + w), -1, z] + (-1/(4*(1 + w)) - w/(4*(1 + w)))*
        G[0, (-1 + w)/(1 + w), 1, z] + (-1/(4*(-1 + w)) + w/(4*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), -1, z] + (1/(4*(-1 + w)) - w/(4*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), 1, z] + G[w, 0, -1, z]/2 - 
       G[w, 0, 1, z]/2 - G[w, w, -1, z]/2 + G[w, w, 1, z]/2 + 
       (1/(4*(-1 - w)) - w/(4*(1 + w)))*G[w, (-1 + w)/(1 + w), -1, z] + 
       (-1/(4*(-1 - w)) + w/(4*(1 + w)))*G[w, (-1 + w)/(1 + w), 1, z] + 
       (-1/(4*(1 - w)) - w/(4*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, z] + 
       (1/(4*(1 - w)) + w/(4*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, z] + 
       ((1/4 + w/4)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1/4 - w/4)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1/4 - w/4)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((1/4 + w/4)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((-1/(8*(1 + w)) - w/(4*(1 + w)) - w^2/(8*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(8*(1 + w)) + w/(4*(1 + w)) + w^2/(8*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/(8*(-1 + w)) - w^2/(8*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((-1/(8*(-1 + w)) + w^2/(8*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w) + 
       ((1/(8*(1 + w)) - w^2/(8*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-1/(8*(1 + w)) + w^2/(8*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((-1/(8*(-1 + w)) + w/(4*(-1 + w)) - w^2/(8*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1/(8*(-1 + w)) - w/(4*(-1 + w)) + w^2/(8*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, -1, 0, w]/8 - G[-1, -1, 1, 0, w]/8 + G[-1, 1, -1, 0, w]/8 - 
     G[-1, 1, 1, 0, w]/8 - G[0, 0, -1, 0, z]/2 + G[0, 0, 1, 0, z]/2 + 
     G[0, w, -1, 0, z]/2 - G[0, w, 1, 0, z]/2 + 
     (1/(4*(1 + w)) + w/(4*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, 0, z] + 
     (-1/(4*(1 + w)) - w/(4*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, 0, z] + 
     (-1/(4*(-1 + w)) + w/(4*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (1/(4*(-1 + w)) - w/(4*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 0, z] + 
     G[1, -1, -1, 0, w]/8 - G[1, -1, 1, 0, w]/8 + G[1, 1, -1, 0, w]/8 - 
     G[1, 1, 1, 0, w]/8 + G[w, 0, -1, 0, z]/2 - G[w, 0, 1, 0, z]/2 - 
     G[w, w, -1, 0, z]/2 + G[w, w, 1, 0, z]/2 + 
     (1/(4*(-1 - w)) - w/(4*(1 + w)))*G[w, (-1 + w)/(1 + w), -1, 0, z] + 
     (-1/(4*(-1 - w)) + w/(4*(1 + w)))*G[w, (-1 + w)/(1 + w), 1, 0, z] + 
     (-1/(4*(1 - w)) - w/(4*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (1/(4*(1 - w)) + w/(4*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, 0, z] + 
     ((1/4 + w/4)*G[(-1 + w)/(1 + w), 0, -1, 0, z])/(1 + w) + 
     ((-1/4 - w/4)*G[(-1 + w)/(1 + w), 0, 1, 0, z])/(1 + w) + 
     ((-1/4 - w/4)*G[(-1 + w)/(1 + w), w, -1, 0, z])/(1 + w) + 
     ((1/4 + w/4)*G[(-1 + w)/(1 + w), w, 1, 0, z])/(1 + w) + 
     ((-1/(8*(1 + w)) - w/(4*(1 + w)) - w^2/(8*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/(8*(1 + w)) + w/(4*(1 + w)) + w^2/(8*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((1/(8*(-1 + w)) - w^2/(8*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     ((-1/(8*(-1 + w)) + w^2/(8*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 0, z])/(1 + w) + 
     ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), 0, -1, 0, z])/(-1 + w) + 
     ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     ((1/4 - w/4)*G[-((1 + w)/(-1 + w)), w, -1, 0, z])/(-1 + w) + 
     ((-1/4 + w/4)*G[-((1 + w)/(-1 + w)), w, 1, 0, z])/(-1 + w) + 
     ((1/(8*(1 + w)) - w^2/(8*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 0, z])/(-1 + w) + 
     ((-1/(8*(1 + w)) + w^2/(8*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 0, z])/(-1 + w) + 
     ((-1/(8*(-1 + w)) + w/(4*(-1 + w)) - w^2/(8*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((1/(8*(-1 + w)) - w/(4*(-1 + w)) + w^2/(8*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) - 
   24*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 
        z] + (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, 0, w]/2 + G[-1, 1, 0, w]/2 + G[1, -1, 0, w]/2 - 
       G[1, 1, 0, w]/2) - G[0, w]*
      (((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, -1, 0, w]/2 - G[-1, -1, 1, 0, w]/2 - G[-1, 1, -1, 0, w]/2 + 
     G[-1, 1, 1, 0, w]/2 - G[1, -1, -1, 0, w]/2 + G[1, -1, 1, 0, w]/2 + 
     G[1, 1, -1, 0, w]/2 - G[1, 1, 1, 0, w]/2 + 
     ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 0, z])/(1 + w) + 
     ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 0, z])/(-1 + w) + 
     ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 0, z])/(-1 + w) + 
     ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) + 
   16*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(-2*G[0, 0, z] + 2*G[0, w, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       6*G[-w^(-1), 0, z] - 6*G[-w^(-1), w, z] + 
       (((-3*w)/(1 + w) - (3*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), z])/
        w + (((3*w)/(-1 + w) - (3*w^2)/(-1 + w))*G[-w^(-1), 
          -((1 + w)/(-1 + w)), z])/w + 2*G[w, 0, z] - 2*G[w, w, z] + 
       ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       (((1 + w)^(-1) + (2*w)/(1 + w) + w^2/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), z])/(1 + w) + (((1 - w)^(-1) + w^2/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       (((-1 - w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, 0, w]/4 - G[-1, 1, 0, w]/4 + G[1, -1, 0, w]/4 - 
       G[1, 1, 0, w]/4) - G[0, w]*(G[0, 0, -1, z] - G[0, 0, 1, z] - 
       G[0, w, -1, z] + G[0, w, 1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), -1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), -1, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), 1, z] - 3*G[-w^(-1), 0, -1, z] + 
       3*G[-w^(-1), 0, 1, z] + 3*G[-w^(-1), w, -1, z] - 
       3*G[-w^(-1), w, 1, z] + (((3*w)/(2*(1 + w)) + (3*w^2)/(2*(1 + w)))*
         G[-w^(-1), (-1 + w)/(1 + w), -1, z])/w + 
       (((-3*w)/(2*(1 + w)) - (3*w^2)/(2*(1 + w)))*G[-w^(-1), 
          (-1 + w)/(1 + w), 1, z])/w + 
       (((-3*w)/(2*(-1 + w)) + (3*w^2)/(2*(-1 + w)))*
         G[-w^(-1), -((1 + w)/(-1 + w)), -1, z])/w + 
       (((3*w)/(2*(-1 + w)) - (3*w^2)/(2*(-1 + w)))*
         G[-w^(-1), -((1 + w)/(-1 + w)), 1, z])/w - G[w, 0, -1, z] + 
       G[w, 0, 1, z] + G[w, w, -1, z] - G[w, w, 1, z] + 
       (-1/(2*(-1 - w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), -1, z] + 
       (1/(2*(-1 - w)) - w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), 1, z] + 
       (1/(2*(1 - w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, z] + 
       (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, z] + 
       G[(-1 + w)/(1 + w), 0, -1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 1, z] + 
       ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, -1, 
        z] + ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 1, z] + ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*
         G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, -1, 0, w]/2 - G[-1, -1, 1, 0, w]/2 + G[-1, 1, -1, 0, w]/2 - 
     G[-1, 1, 1, 0, w]/2 + G[0, 0, -1, 0, z] - G[0, 0, 1, 0, z] - 
     G[0, w, -1, 0, z] + G[0, w, 1, 0, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, 0, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, 0, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 0, z] + 
     G[1, -1, -1, 0, w]/2 - G[1, -1, 1, 0, w]/2 + G[1, 1, -1, 0, w]/2 - 
     G[1, 1, 1, 0, w]/2 - 3*G[-w^(-1), 0, -1, 0, z] + 
     3*G[-w^(-1), 0, 1, 0, z] + 3*G[-w^(-1), w, -1, 0, z] - 
     3*G[-w^(-1), w, 1, 0, z] + (((3*w)/(2*(1 + w)) + (3*w^2)/(2*(1 + w)))*
       G[-w^(-1), (-1 + w)/(1 + w), -1, 0, z])/w + 
     (((-3*w)/(2*(1 + w)) - (3*w^2)/(2*(1 + w)))*G[-w^(-1), (-1 + w)/(1 + w), 
        1, 0, z])/w + (((-3*w)/(2*(-1 + w)) + (3*w^2)/(2*(-1 + w)))*
       G[-w^(-1), -((1 + w)/(-1 + w)), -1, 0, z])/w + 
     (((3*w)/(2*(-1 + w)) - (3*w^2)/(2*(-1 + w)))*
       G[-w^(-1), -((1 + w)/(-1 + w)), 1, 0, z])/w - G[w, 0, -1, 0, z] + 
     G[w, 0, 1, 0, z] + G[w, w, -1, 0, z] - G[w, w, 1, 0, z] + 
     (-1/(2*(-1 - w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), -1, 0, z] + 
     (1/(2*(-1 - w)) - w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), 1, 0, z] + 
     (1/(2*(1 - w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, 0, z] + 
     G[(-1 + w)/(1 + w), 0, -1, 0, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, 0, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 1, 0, z] + 
     ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 0, z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, 
      -1, 0, z] + ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 1, 0, z] + 
     ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 0, z])/(-1 + w) + 
     ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 0, z])/(-1 + w) + 
     ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) - 
   8*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (2*G[0, (-1 + w)/(1 + w), z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z] - 6*G[-w^(-1), (-1 + w)/(1 + w), z] + 
       (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 
          z])/w - 2*G[w, (-1 + w)/(1 + w), z] + 
       (-2/(-1 + w) + (2*w)/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (2*G[0, z] - 6*G[-w^(-1), z] - 2*G[w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      ((-2/(1 + w) - (2*w)/(1 + w))*G[0, (-1 + w)/(1 + w), -1, z] + 
       2*G[0, (-1 + w)/(1 + w), 1, z] + 2*G[0, -((1 + w)/(-1 + w)), -1, z] + 
       (2/(-1 + w) - (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 1, z] + 
       (((6*w)/(1 + w) + (6*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), -1, 
          z])/w - 6*G[-w^(-1), (-1 + w)/(1 + w), 1, z] - 
       6*G[-w^(-1), -((1 + w)/(-1 + w)), -1, z] + 
       (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 
          1, z])/w + (2/(1 + w) + (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), -1, 
         z] - 2*G[w, (-1 + w)/(1 + w), 1, z] - 
       2*G[w, -((1 + w)/(-1 + w)), -1, z] + (-2/(-1 + w) + (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), 1, z] + 
       ((-2/(1 + w) - (4*w)/(1 + w) - (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((2/(1 + w) - (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/
        (-1 + w) + ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - 
     2*G[-1, -1, -1, -1, w] + 2*G[-1, -1, -1, 1, w] + 2*G[-1, -1, 1, -1, w] - 
     2*G[-1, -1, 1, 1, w] + 2*G[-1, 1, -1, -1, w] - 2*G[-1, 1, -1, 1, w] - 
     2*G[-1, 1, 1, -1, w] + 2*G[-1, 1, 1, 1, w] + 
     2*G[0, (-1 + w)/(1 + w), -1, -1, z] + (-2/(1 + w) - (2*w)/(1 + w))*
      G[0, (-1 + w)/(1 + w), -1, 1, z] + (-2/(1 + w) - (2*w)/(1 + w))*
      G[0, (-1 + w)/(1 + w), 1, -1, z] + 2*G[0, (-1 + w)/(1 + w), 1, 1, z] + 
     (2/(-1 + w) - (2*w)/(-1 + w))*G[0, -((1 + w)/(-1 + w)), -1, -1, z] + 
     2*G[0, -((1 + w)/(-1 + w)), -1, 1, z] + 
     2*G[0, -((1 + w)/(-1 + w)), 1, -1, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 1, 1, z] - 2*G[1, -1, -1, -1, w] + 
     2*G[1, -1, -1, 1, w] + 2*G[1, -1, 1, -1, w] - 2*G[1, -1, 1, 1, w] + 
     2*G[1, 1, -1, -1, w] - 2*G[1, 1, -1, 1, w] - 2*G[1, 1, 1, -1, w] + 
     2*G[1, 1, 1, 1, w] - 6*G[-w^(-1), (-1 + w)/(1 + w), -1, -1, z] + 
     (((6*w)/(1 + w) + (6*w^2)/(1 + w))*G[-w^(-1), (-1 + w)/(1 + w), -1, 1, 
        z])/w + (((6*w)/(1 + w) + (6*w^2)/(1 + w))*
       G[-w^(-1), (-1 + w)/(1 + w), 1, -1, z])/w - 
     6*G[-w^(-1), (-1 + w)/(1 + w), 1, 1, z] + 
     (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 
        -1, -1, z])/w - 6*G[-w^(-1), -((1 + w)/(-1 + w)), -1, 1, z] - 
     6*G[-w^(-1), -((1 + w)/(-1 + w)), 1, -1, z] + 
     (((-6*w)/(-1 + w) + (6*w^2)/(-1 + w))*G[-w^(-1), -((1 + w)/(-1 + w)), 1, 
        1, z])/w - 2*G[w, (-1 + w)/(1 + w), -1, -1, z] + 
     (-2/(-1 - w) + (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), -1, 1, z] + 
     (-2/(-1 - w) + (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 1, -1, z] - 
     2*G[w, (-1 + w)/(1 + w), 1, 1, z] + (2/(1 - w) + (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), -1, -1, z] - 
     2*G[w, -((1 + w)/(-1 + w)), -1, 1, z] - 
     2*G[w, -((1 + w)/(-1 + w)), 1, -1, z] + (2/(1 - w) + (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 1, 1, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
     ((-2/(1 + w) - (4*w)/(1 + w) - (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-2/(1 + w) - (4*w)/(1 + w) - (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
     ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), -1, 1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, -1, z])/(1 + w) + 
     ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 1, z])/(1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), -1, -1, z])/
      (-1 + w) + ((2/(1 + w) - (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 1, z])/(-1 + w) + 
     ((2/(1 + w) - (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        1, -1, z])/(-1 + w) + ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 1, z])/(-1 + w) + 
     ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 1, z])/
      (-1 + w) + ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 
        -1, z])/(-1 + w) + ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)) - 
   32*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (-G[0, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z] + G[w, (-1 + w)/(1 + w), z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), -1, z] - 
       G[0, (-1 + w)/(1 + w), 1, z] - G[0, -((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 1, z] + 
       ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), -1, z] + 
       G[w, (-1 + w)/(1 + w), 1, z] + G[w, -((1 + w)/(-1 + w)), -1, z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 1, z] + 
       ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), -1, z])/
        (1 + w) + ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 1, z])/
        (-1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 
          -1, z])/(-1 + w) + ((-1/(2*(-1 + w)) + w/(-1 + w) - 
          w^2/(2*(-1 + w)))*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 
          z])/(-1 + w)) - G[-1, -1, -1, -1, w]/2 + G[-1, -1, -1, 1, w]/2 + 
     G[-1, -1, 1, -1, w]/2 - G[-1, -1, 1, 1, w]/2 + G[-1, 1, -1, -1, w]/2 - 
     G[-1, 1, -1, 1, w]/2 - G[-1, 1, 1, -1, w]/2 + G[-1, 1, 1, 1, w]/2 - 
     G[0, (-1 + w)/(1 + w), -1, -1, z] + ((1 + w)^(-1) + w/(1 + w))*
      G[0, (-1 + w)/(1 + w), -1, 1, z] + ((1 + w)^(-1) + w/(1 + w))*
      G[0, (-1 + w)/(1 + w), 1, -1, z] - G[0, (-1 + w)/(1 + w), 1, 1, z] + 
     (-(-1 + w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), -1, -1, z] - 
     G[0, -((1 + w)/(-1 + w)), -1, 1, z] - G[0, -((1 + w)/(-1 + w)), 1, -1, 
      z] + (-(-1 + w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 1, 1, z] - 
     G[1, -1, -1, -1, w]/2 + G[1, -1, -1, 1, w]/2 + G[1, -1, 1, -1, w]/2 - 
     G[1, -1, 1, 1, w]/2 + G[1, 1, -1, -1, w]/2 - G[1, 1, -1, 1, w]/2 - 
     G[1, 1, 1, -1, w]/2 + G[1, 1, 1, 1, w]/2 + G[w, (-1 + w)/(1 + w), -1, 
      -1, z] + ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), -1, 1, z] + 
     ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), 1, -1, z] + 
     G[w, (-1 + w)/(1 + w), 1, 1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), -1, -1, z] + G[w, -((1 + w)/(-1 + w)), -1, 1, 
      z] + G[w, -((1 + w)/(-1 + w)), 1, -1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 1, 1, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
     ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), -1, 1, z])/
      (1 + w) + ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, -1, 
        z])/(1 + w) + ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*
       G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, 1, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), -1, -1, z])/
      (-1 + w) + ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 1, z])/(-1 + w) + 
     ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 1, 1, z])/
      (-1 + w) + ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 1, z])/
      (-1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 
        -1, z])/(-1 + w) + ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)) + 
   24*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + G[(-1 + w)/(1 + w), w, 
        z] + ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, -1, w]/2 - G[-1, -1, 1, w]/2 - G[-1, 1, -1, w]/2 + 
       G[-1, 1, 1, w]/2 + G[1, -1, -1, w]/2 - G[1, -1, 1, w]/2 - 
       G[1, 1, -1, w]/2 + G[1, 1, 1, w]/2) + (G[-1, w] - G[1, w])*
      (G[(-1 + w)/(1 + w), 0, -1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 1, z] + 
       ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, 1, z] + G[-((1 + w)/(-1 + w)), w, -1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w) + 
       ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - 
     G[-1, -1, -1, -1, w]/2 + G[-1, -1, -1, 1, w]/2 + G[-1, -1, 1, -1, w]/2 - 
     G[-1, -1, 1, 1, w]/2 - G[-1, 1, -1, -1, w]/2 + G[-1, 1, -1, 1, w]/2 + 
     G[-1, 1, 1, -1, w]/2 - G[-1, 1, 1, 1, w]/2 + G[1, -1, -1, -1, w]/2 - 
     G[1, -1, -1, 1, w]/2 - G[1, -1, 1, -1, w]/2 + G[1, -1, 1, 1, w]/2 + 
     G[1, 1, -1, -1, w]/2 - G[1, 1, -1, 1, w]/2 - G[1, 1, 1, -1, w]/2 + 
     G[1, 1, 1, 1, w]/2 + ((-1 - w)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/
      (1 + w) + G[(-1 + w)/(1 + w), 0, -1, 1, z] + G[(-1 + w)/(1 + w), 0, 1, 
      -1, z] + ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 1, 1, z] + 
     ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
     ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
     ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, -1, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 1, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, -1, z])/(1 + w) + 
     ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 1, z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, 
      -1, -1, z] + ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, 1, 1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, -1, 1, z] + G[-((1 + w)/(-1 + w)), w, 1, -1, 
      z] + ((1 - w)*G[-((1 + w)/(-1 + w)), w, 1, 1, z])/(-1 + w) + 
     ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, -1, z])/(-1 + w) + 
     ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 1, z])/(-1 + w) + 
     ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, -1, z])/(-1 + w) + 
     ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 1, z])/(-1 + w) + 
     ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 1, z])/(-1 + w) + 
     ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
     ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)) - 
   44*(-G[-1, w]/2 - G[-1, z]/2 + G[1, w]/2 + G[1, z]/2)*Zeta[3] + 
   16*(-G[-1, w] + G[1, w] + G[(-1 + w)/(1 + w), z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*Zeta[3], 
 fE23[{0}, sij, sjk, sik] -> 0, fE23[{1}, sij, sjk, sik] -> 0, 
 fE23[{2}, sij, sjk, sik] -> 0, fE23[{3}, sij, sjk, sik] -> 
  (-G[-1, z] - G[1, z] + 2*G[w, z])*G[0, 0, w] - 
   (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
    (-G[0, -1, w] + G[0, 1, w]) - (-G[0, z] + 2*G[w, z])*
    (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w]) - 
   (-G[-1, z] - G[1, z] + 2*G[w, z])*(G[-1, -1, w] - G[-1, 1, w] - 
     G[1, -1, w] + G[1, 1, w]) - G[0, w]*(-G[-1, 0, z] - G[1, 0, z] + 
     2*G[w, 0, z]) - (G[-1, w] - G[1, w])*(G[0, -1, z] - G[0, 1, z] - 
     2*G[w, -1, z] + 2*G[w, 1, z]) - (G[-1, w] - G[1, w])*
    (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 2*G[w, -1, z] + 
     2*G[w, 1, z]) - (G[-1, w] - G[1, w])*
    (((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, z]) + G[-1, -1, -1, w] + G[-1, -1, -1, z] - 
   G[-1, -1, 1, w] - G[-1, -1, 1, z] - G[-1, 0, -1, w] - G[-1, 0, 0, w] - 
   G[-1, 0, 0, z] + G[-1, 0, 1, w] - G[-1, 1, -1, w] - G[-1, 1, -1, z] + 
   G[-1, 1, 1, w] + G[-1, 1, 1, z] - 3*G[0, -1, -1, w] + G[0, -1, -1, z] + 
   3*G[0, -1, 1, w] - G[0, -1, 1, z] + 2*G[0, 0, 0, w] + 3*G[0, 1, -1, w] - 
   G[0, 1, -1, z] - 3*G[0, 1, 1, w] + G[0, 1, 1, z] + G[1, -1, -1, w] + 
   G[1, -1, -1, z] - G[1, -1, 1, w] - G[1, -1, 1, z] + G[1, 0, -1, w] - 
   G[1, 0, 0, w] - G[1, 0, 0, z] - G[1, 0, 1, w] - G[1, 1, -1, w] - 
   G[1, 1, -1, z] + G[1, 1, 1, w] + G[1, 1, 1, z] - 4*G[w, -1, -1, z] + 
   4*G[w, -1, 1, z] + 2*G[w, 0, 0, z] - 
   3*((-G[0, z] + 2*G[w, z])*G[0, 0, w] - 
     G[0, w]*(-G[0, 0, z] + 2*G[w, 0, z]) + G[0, 0, 0, w] - G[0, 0, 0, z] + 
     2*G[w, 0, 0, z]) + 4*G[w, 1, -1, z] - 4*G[w, 1, 1, z] - 
   G[(-1 + w)/(1 + w), 0, -1, z] - ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, z])/
    (1 + w) - ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
   2*((-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*G[0, 0, w] - 
     G[0, w]*(-G[0, 0, z] + G[w, 0, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     G[-1, 0, 0, w]/2 - G[0, 0, 0, z] + G[1, 0, 0, w]/2 + G[w, 0, 0, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) - 
   G[-((1 + w)/(-1 + w)), 0, 1, z] - 
   2*((G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, w]/2 - G[1, 0, w]/2) - 
     G[0, w]*(((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - 
     G[-1, -1, 0, w]/2 + G[-1, 1, 0, w]/2 + G[1, -1, 0, w]/2 - 
     G[1, 1, 0, w]/2 + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) + 
   2*((-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[0, -1, z] - G[0, 1, z] - G[w, -1, z] + 
       G[w, 1, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, -1, w]/2 - G[-1, -1, 1, w]/2 - G[-1, 1, -1, w]/2 + 
     G[-1, 1, 1, w]/2 - G[0, -1, -1, z] + G[0, -1, 1, z] + G[0, 1, -1, z] - 
     G[0, 1, 1, z] + G[1, -1, -1, w]/2 - G[1, -1, 1, w]/2 - 
     G[1, 1, -1, w]/2 + G[1, 1, 1, w]/2 + G[w, -1, -1, z] - G[w, -1, 1, z] - 
     G[w, 1, -1, z] + G[w, 1, 1, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)) - 2*Zeta[3], 
 fE23[{4}, sij, sjk, sik] -> (4*Pi^4)/45 + 
   (Pi^2*(-(G[0, w]*(-G[0, z] + 2*G[w, z])) - G[0, 0, w] - G[0, 0, z] + 
      2*G[w, 0, z]))/2 + 4*G[0, 0, w]*(-G[-1, 0, z] - G[1, 0, z] + 
     2*G[w, 0, z]) - (Pi^2*(-(G[0, w]*(-G[-1, z] - G[1, z] + 2*G[w, z])) + 
      G[-1, 0, w] - G[-1, 0, z] - 2*G[0, 0, w] + G[1, 0, w] - G[1, 0, z] + 
      2*G[w, 0, z]))/6 + (-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 
     2*G[0, 1, w] - G[1, -1, w] + G[1, 1, w])*(G[0, -1, z] - G[0, 1, z] - 
     2*G[w, -1, z] + 2*G[w, 1, z]) + 
   (-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
     G[1, -1, w] + G[1, 1, w])*(G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - 
     G[1, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]) + 
   (-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
     G[1, -1, w] + G[1, 1, w])*(((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/
      (1 + w) + G[-((1 + w)/(-1 + w)), 0, z]) - 
   (Pi^2*(-(G[0, w]*(-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), 
            z])/(1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/
          (-1 + w))) - G[-1, 0, w]/2 - G[0, 0, z] - G[1, 0, w]/2 + 
      G[w, 0, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
      ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)))/3 + 
   (Pi^2*((-G[-1, w]/2 + G[1, w]/2)*(G[(-1 + w)/(1 + w), z] + 
        ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w)) + G[-1, -1, w]/2 - 
      G[-1, 1, w]/2 - G[1, -1, w]/2 + G[1, 1, w]/2 + 
      ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
      ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
      ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
      ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)))/3 - 
   (-G[0, -1, w] + G[0, 1, w])*(((2 + 2*w)*G[(-1 + w)/(1 + w), 0, z])/
      (1 + w) + ((-6 - 6*w)*G[(-1 + w)/(1 + w), -w^(-1), z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
     ((2/(1 + w) + (4*w)/(1 + w) + (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), z])/(1 + w) + ((-2/(-1 + w) + (2*w^2)/(-1 + w))*
       G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), z])/(1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
     ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
     ((2/(1 + w) - (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        z])/(-1 + w) + ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) - 
   4*(-G[-1, z] - G[1, z] + 2*G[w, z])*G[0, 0, 0, w] + 
   (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
    (G[0, -1, -1, w] - G[0, -1, 1, w] - 2*G[0, 0, -1, w] + 2*G[0, 0, 1, w] + 
     G[0, 1, -1, w] - G[0, 1, 1, w]) - 
   (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
    (-2*G[-1, 0, -1, w] + 2*G[-1, 0, 1, w] - 2*G[1, 0, -1, w] + 
     2*G[1, 0, 1, w]) + (-G[0, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + 
     G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - 
     G[-1, 1, -1, w] + G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
     2*G[1, 0, -1, w] + 2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
   (-G[-1, z] - G[1, z] + 2*G[w, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
     2*G[-1, 0, -1, w] - 2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + 
     G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 
     2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) - 
   G[0, w]*(-4*G[-1, 0, 0, z] + 6*G[-1, 0, -w, z] + 2*G[-1, 0, w, z] - 
     4*G[1, 0, 0, z] + 6*G[1, 0, -w, z] + 2*G[1, 0, w, z] + 8*G[w, 0, 0, z] - 
     12*G[w, 0, -w, z] - 4*G[w, 0, w, z]) + (G[-1, w] - G[1, w])*
    (-G[0, -1, -1, z] - G[0, -1, 1, z] + 2*G[0, -1, w, z] + G[0, 1, -1, z] + 
     G[0, 1, 1, z] - 2*G[0, 1, w, z] + 2*G[w, -1, -1, z] + 2*G[w, -1, 1, z] - 
     4*G[w, -1, w, z] - 2*G[w, 1, -1, z] - 2*G[w, 1, 1, z] + 
     4*G[w, 1, w, z]) + (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] - 
     G[-1, -1, 1, z] + 2*G[-1, -1, w, z] + G[-1, 1, -1, z] + G[-1, 1, 1, z] - 
     2*G[-1, 1, w, z] - G[1, -1, -1, z] - G[1, -1, 1, z] + 2*G[1, -1, w, z] + 
     G[1, 1, -1, z] + G[1, 1, 1, z] - 2*G[1, 1, w, z] + 2*G[w, -1, -1, z] + 
     2*G[w, -1, 1, z] - 4*G[w, -1, w, z] - 2*G[w, 1, -1, z] - 
     2*G[w, 1, 1, z] + 4*G[w, 1, w, z]) + (G[-1, w] - G[1, w])*
    (G[(-1 + w)/(1 + w), 0, -1, z] + G[(-1 + w)/(1 + w), 0, 1, z] + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, w, z])/(1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, w, z])/(-1 + w)) - 
   (G[-1, w] - G[1, w])*(((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
     ((6 + 6*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
     ((-2/(1 + w) - (4*w)/(1 + w) - (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, z])/(1 + w) + 
     ((2/(-1 + w) - (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
     ((6 - 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w) + 
     ((-2/(1 + w) + (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        0, z])/(-1 + w) + ((2/(-1 + w) - (4*w)/(-1 + w) + (2*w^2)/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
   G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
   G[-1, -1, -1, 1, z] - 4*G[-1, -1, 0, -1, w] + 4*G[-1, -1, 0, 1, w] + 
   G[-1, -1, 1, -1, w] + G[-1, -1, 1, -1, z] - G[-1, -1, 1, 1, w] - 
   G[-1, -1, 1, 1, z] - 2*G[-1, -1, w, -1, z] + 2*G[-1, -1, w, 1, z] - 
   G[-1, 0, -1, -1, w] + G[-1, 0, -1, 1, w] + 2*G[-1, 0, 0, -1, w] + 
   4*G[-1, 0, 0, 0, w] - 4*G[-1, 0, 0, 0, z] - 2*G[-1, 0, 0, 1, w] - 
   G[-1, 0, 1, -1, w] + G[-1, 0, 1, 1, w] + 6*G[-1, 0, -w, 0, z] + 
   2*G[-1, 0, w, 0, z] - G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + 
   G[-1, 1, -1, 1, w] + G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - 
   G[-1, 1, 1, -1, z] + G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] + 
   2*G[-1, 1, w, -1, z] - 2*G[-1, 1, w, 1, z] - 3*G[0, -1, -1, -1, w] + 
   G[0, -1, -1, -1, z] + 3*G[0, -1, -1, 1, w] - G[0, -1, -1, 1, z] + 
   6*G[0, -1, 0, -1, w] - 6*G[0, -1, 0, 1, w] - 3*G[0, -1, 1, -1, w] + 
   G[0, -1, 1, -1, z] + 3*G[0, -1, 1, 1, w] - G[0, -1, 1, 1, z] - 
   2*G[0, -1, w, -1, z] + 2*G[0, -1, w, 1, z] - 8*G[0, 0, 0, 0, w] + 
   3*G[0, 1, -1, -1, w] - G[0, 1, -1, -1, z] - 3*G[0, 1, -1, 1, w] + 
   G[0, 1, -1, 1, z] - 6*G[0, 1, 0, -1, w] + 6*G[0, 1, 0, 1, w] + 
   3*G[0, 1, 1, -1, w] - G[0, 1, 1, -1, z] - 3*G[0, 1, 1, 1, w] + 
   G[0, 1, 1, 1, z] + 2*G[0, 1, w, -1, z] - 2*G[0, 1, w, 1, z] + 
   G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
   G[1, -1, -1, 1, z] + G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - 
   G[1, -1, 1, 1, w] - G[1, -1, 1, 1, z] - 2*G[1, -1, w, -1, z] + 
   2*G[1, -1, w, 1, z] + G[1, 0, -1, -1, w] - G[1, 0, -1, 1, w] - 
   2*G[1, 0, 0, -1, w] + 4*G[1, 0, 0, 0, w] - 4*G[1, 0, 0, 0, z] + 
   2*G[1, 0, 0, 1, w] + G[1, 0, 1, -1, w] - G[1, 0, 1, 1, w] + 
   6*G[1, 0, -w, 0, z] + 2*G[1, 0, w, 0, z] - G[1, 1, -1, -1, w] - 
   G[1, 1, -1, -1, z] + G[1, 1, -1, 1, w] + G[1, 1, -1, 1, z] + 
   4*G[1, 1, 0, -1, w] - 4*G[1, 1, 0, 1, w] - G[1, 1, 1, -1, w] - 
   G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] + 
   2*G[1, 1, w, -1, z] - 2*G[1, 1, w, 1, z] - 4*G[w, -1, -1, -1, z] + 
   4*G[w, -1, -1, 1, z] - 4*G[w, -1, 1, -1, z] + 4*G[w, -1, 1, 1, z] + 
   8*G[w, -1, w, -1, z] - 8*G[w, -1, w, 1, z] + 8*G[w, 0, 0, 0, z] - 
   12*G[w, 0, -w, 0, z] - 3*(4*G[0, 0, w]*(-G[0, 0, z] + 2*G[w, 0, z]) - 
     4*(-G[0, z] + 2*G[w, z])*G[0, 0, 0, w] - 
     G[0, w]*(-4*G[0, 0, 0, z] + 6*G[0, 0, -w, z] + 2*G[0, 0, w, z] + 
       8*G[w, 0, 0, z] - 12*G[w, 0, -w, z] - 4*G[w, 0, w, z]) - 
     4*G[0, 0, 0, 0, w] - 4*G[0, 0, 0, 0, z] + 6*G[0, 0, -w, 0, z] + 
     2*G[0, 0, w, 0, z] + 8*G[w, 0, 0, 0, z] - 12*G[w, 0, -w, 0, z] - 
     4*G[w, 0, w, 0, z]) - 4*G[w, 0, w, 0, z] + 4*G[w, 1, -1, -1, z] - 
   4*G[w, 1, -1, 1, z] + 4*G[w, 1, 1, -1, z] - 4*G[w, 1, 1, 1, z] - 
   3*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[0, -1, z] - G[0, 1, z] - 2*G[w, -1, z] + 2*G[w, 1, z]) + 
     (-G[0, z] + 2*G[w, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (G[0, -1, -1, z] + G[0, -1, 1, z] - 2*G[0, -1, w^(-1), z] - 
       G[0, 1, -1, z] - G[0, 1, 1, z] + 2*G[0, 1, w^(-1), z] - 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 4*G[w, -1, w^(-1), z] + 
       2*G[w, 1, -1, z] + 2*G[w, 1, 1, z] - 4*G[w, 1, w^(-1), z]) + 
     G[0, -1, -1, -1, w] - G[0, -1, -1, -1, z] - G[0, -1, -1, 1, w] + 
     G[0, -1, -1, 1, z] + G[0, -1, 1, -1, w] - G[0, -1, 1, -1, z] - 
     G[0, -1, 1, 1, w] + G[0, -1, 1, 1, z] + 2*G[0, -1, w^(-1), -1, z] - 
     2*G[0, -1, w^(-1), 1, z] - G[0, 1, -1, -1, w] + G[0, 1, -1, -1, z] + 
     G[0, 1, -1, 1, w] - G[0, 1, -1, 1, z] - G[0, 1, 1, -1, w] + 
     G[0, 1, 1, -1, z] + G[0, 1, 1, 1, w] - G[0, 1, 1, 1, z] - 
     2*G[0, 1, w^(-1), -1, z] + 2*G[0, 1, w^(-1), 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 4*G[w, -1, w^(-1), -1, z] + 
     4*G[w, -1, w^(-1), 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 
     2*G[w, 1, 1, -1, z] + 2*G[w, 1, 1, 1, z] + 4*G[w, 1, w^(-1), -1, z] - 
     4*G[w, 1, w^(-1), 1, z]) - 
   3*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[-1, -1, z] - G[-1, 1, z] + G[1, -1, z] - G[1, 1, z] - 
       2*G[w, -1, z] + 2*G[w, 1, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[-1, -1, -1, z] + 
       G[-1, -1, 1, z] - 2*G[-1, -1, w^(-1), z] - G[-1, 1, -1, z] - 
       G[-1, 1, 1, z] + 2*G[-1, 1, w^(-1), z] + G[1, -1, -1, z] + 
       G[1, -1, 1, z] - 2*G[1, -1, w^(-1), z] - G[1, 1, -1, z] - 
       G[1, 1, 1, z] + 2*G[1, 1, w^(-1), z] - 2*G[w, -1, -1, z] - 
       2*G[w, -1, 1, z] + 4*G[w, -1, w^(-1), z] + 2*G[w, 1, -1, z] + 
       2*G[w, 1, 1, z] - 4*G[w, 1, w^(-1), z]) - G[-1, -1, -1, -1, w] - 
     G[-1, -1, -1, -1, z] + G[-1, -1, -1, 1, w] + G[-1, -1, -1, 1, z] - 
     G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + 
     G[-1, -1, 1, 1, z] + 2*G[-1, -1, w^(-1), -1, z] - 
     2*G[-1, -1, w^(-1), 1, z] + G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - 
     G[-1, 1, -1, 1, w] - G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + 
     G[-1, 1, 1, -1, z] - G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - 
     2*G[-1, 1, w^(-1), -1, z] + 2*G[-1, 1, w^(-1), 1, z] + 
     2*G[0, -1, -1, -1, w] - 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
     2*G[0, -1, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 2*G[0, 1, -1, 1, w] - 
     2*G[0, 1, 1, -1, w] + 2*G[0, 1, 1, 1, w] - G[1, -1, -1, -1, w] - 
     G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] - 
     G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + G[1, -1, 1, 1, w] + 
     G[1, -1, 1, 1, z] + 2*G[1, -1, w^(-1), -1, z] - 
     2*G[1, -1, w^(-1), 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
     G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] + G[1, 1, 1, -1, w] + 
     G[1, 1, 1, -1, z] - G[1, 1, 1, 1, w] - G[1, 1, 1, 1, z] - 
     2*G[1, 1, w^(-1), -1, z] + 2*G[1, 1, w^(-1), 1, z] + 
     2*G[w, -1, -1, -1, z] - 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 4*G[w, -1, w^(-1), -1, z] + 
     4*G[w, -1, w^(-1), 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] - 
     2*G[w, 1, 1, -1, z] + 2*G[w, 1, 1, 1, z] + 4*G[w, 1, w^(-1), -1, z] - 
     4*G[w, 1, w^(-1), 1, z]) - 8*G[w, 1, w, -1, z] + 8*G[w, 1, w, 1, z] - 
   21*(G[0, 0, w]*(G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 4*G[w, w, z]) + 
     (-G[0, z] + 2*G[w, z])*G[0, 0, 0, w] - 
     G[0, w]*(G[0, 0, 0, z] - 2*G[0, w, 0, z] - 2*G[w, 0, 0, z] + 
       4*G[w, w, 0, z]) + G[0, 0, 0, 0, w] + G[0, 0, 0, 0, z] - 
     2*G[0, w, 0, 0, z] - 2*G[w, 0, 0, 0, z] + 4*G[w, w, 0, 0, z]) + 
   3*(G[0, 0, w]*(G[-1, 0, z] - 2*G[-1, w, z] + G[1, 0, z] - 2*G[1, w, z] - 
       2*G[w, 0, z] + 4*G[w, w, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      G[0, 0, 0, w] - G[0, w]*(G[-1, 0, 0, z] - 2*G[-1, w, 0, z] + 
       G[1, 0, 0, z] - 2*G[1, w, 0, z] - 2*G[w, 0, 0, z] + 4*G[w, w, 0, z]) - 
     G[-1, 0, 0, 0, w] + G[-1, 0, 0, 0, z] - 2*G[-1, w, 0, 0, z] + 
     2*G[0, 0, 0, 0, w] - G[1, 0, 0, 0, w] + G[1, 0, 0, 0, z] - 
     2*G[1, w, 0, 0, z] - 2*G[w, 0, 0, 0, z] + 4*G[w, w, 0, 0, z]) + 
   6*(G[0, 0, w]*(G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z] - 2*G[w, -1, z] - 
       2*G[w, 1, z] + 4*G[w, w, z]) + (-G[0, z] + 2*G[w, z])*
      (-G[-1, 0, 0, w] + 2*G[0, 0, 0, w] - G[1, 0, 0, w]) - 
     G[0, w]*(G[0, -1, 0, z] + G[0, 1, 0, z] - 2*G[0, w, 0, z] - 
       2*G[w, -1, 0, z] - 2*G[w, 1, 0, z] + 4*G[w, w, 0, z]) - 
     G[0, -1, 0, 0, w] + G[0, -1, 0, 0, z] + 2*G[0, 0, 0, 0, w] - 
     G[0, 1, 0, 0, w] + G[0, 1, 0, 0, z] - 2*G[0, w, 0, 0, z] - 
     2*G[w, -1, 0, 0, z] - 2*G[w, 1, 0, 0, z] + 4*G[w, w, 0, 0, z]) - 
   6*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, 0, z] - 2*G[0, w, z] - 2*G[w, 0, z] + 4*G[w, w, z]) + 
     (-G[0, z] + 2*G[w, z])*(G[0, -1, -1, w] - G[0, -1, 1, w] - 
       G[0, 1, -1, w] + G[0, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[0, 0, -1, z] + G[0, 0, 1, z] + 2*G[0, w, -1, z] - 2*G[0, w, 1, z] + 
       2*G[w, 0, -1, z] - 2*G[w, 0, 1, z] - 4*G[w, w, -1, z] + 
       4*G[w, w, 1, z]) + G[0, 0, -1, -1, w] + G[0, 0, -1, -1, z] - 
     G[0, 0, -1, 1, w] - G[0, 0, -1, 1, z] - G[0, 0, 1, -1, w] - 
     G[0, 0, 1, -1, z] + G[0, 0, 1, 1, w] + G[0, 0, 1, 1, z] - 
     2*G[0, w, -1, -1, z] + 2*G[0, w, -1, 1, z] + 2*G[0, w, 1, -1, z] - 
     2*G[0, w, 1, 1, z] - 2*G[w, 0, -1, -1, z] + 2*G[w, 0, -1, 1, z] + 
     2*G[w, 0, 1, -1, z] - 2*G[w, 0, 1, 1, z] + 4*G[w, w, -1, -1, z] - 
     4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z]) - 
   3*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z] - 2*G[w, -1, z] - 
       2*G[w, 1, z] + 4*G[w, w, z]) + (-G[0, z] + 2*G[w, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, -1, -1, z] + G[0, -1, 1, z] - 
       G[0, 1, -1, z] + G[0, 1, 1, z] + 2*G[0, w, -1, z] - 2*G[0, w, 1, z] + 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 
       2*G[w, 1, 1, z] - 4*G[w, w, -1, z] + 4*G[w, w, 1, z]) - 
     G[0, -1, -1, -1, w] + G[0, -1, -1, -1, z] + G[0, -1, -1, 1, w] - 
     G[0, -1, -1, 1, z] + G[0, -1, 1, -1, w] - G[0, -1, 1, -1, z] - 
     G[0, -1, 1, 1, w] + G[0, -1, 1, 1, z] + 2*G[0, 0, -1, -1, w] - 
     2*G[0, 0, -1, 1, w] - 2*G[0, 0, 1, -1, w] + 2*G[0, 0, 1, 1, w] - 
     G[0, 1, -1, -1, w] + G[0, 1, -1, -1, z] + G[0, 1, -1, 1, w] - 
     G[0, 1, -1, 1, z] + G[0, 1, 1, -1, w] - G[0, 1, 1, -1, z] - 
     G[0, 1, 1, 1, w] + G[0, 1, 1, 1, z] - 2*G[0, w, -1, -1, z] + 
     2*G[0, w, -1, 1, z] + 2*G[0, w, 1, -1, z] - 2*G[0, w, 1, 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] + 
     2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] + 4*G[w, w, -1, -1, z] - 
     4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z]) - 
   3*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[-1, -1, z] + G[-1, 1, z] - 2*G[-1, w, z] + G[1, -1, z] + 
       G[1, 1, z] - 2*G[1, w, z] - 2*G[w, -1, z] - 2*G[w, 1, z] + 
       4*G[w, w, z]) + (-G[-1, z] - G[1, z] + 2*G[w, z])*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[-1, -1, -1, z] + G[-1, -1, 1, z] - 
       G[-1, 1, -1, z] + G[-1, 1, 1, z] + 2*G[-1, w, -1, z] - 
       2*G[-1, w, 1, z] - G[1, -1, -1, z] + G[1, -1, 1, z] - G[1, 1, -1, z] + 
       G[1, 1, 1, z] + 2*G[1, w, -1, z] - 2*G[1, w, 1, z] + 
       2*G[w, -1, -1, z] - 2*G[w, -1, 1, z] + 2*G[w, 1, -1, z] - 
       2*G[w, 1, 1, z] - 4*G[w, w, -1, z] + 4*G[w, w, 1, z]) + 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - G[-1, -1, -1, 1, w] - 
     G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - G[-1, -1, 1, -1, z] + 
     G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 2*G[-1, 0, -1, -1, w] + 
     2*G[-1, 0, -1, 1, w] + 2*G[-1, 0, 1, -1, w] - 2*G[-1, 0, 1, 1, w] + 
     G[-1, 1, -1, -1, w] + G[-1, 1, -1, -1, z] - G[-1, 1, -1, 1, w] - 
     G[-1, 1, -1, 1, z] - G[-1, 1, 1, -1, w] - G[-1, 1, 1, -1, z] + 
     G[-1, 1, 1, 1, w] + G[-1, 1, 1, 1, z] - 2*G[-1, w, -1, -1, z] + 
     2*G[-1, w, -1, 1, z] + 2*G[-1, w, 1, -1, z] - 2*G[-1, w, 1, 1, z] - 
     2*G[0, -1, -1, -1, w] + 2*G[0, -1, -1, 1, w] + 2*G[0, -1, 1, -1, w] - 
     2*G[0, -1, 1, 1, w] + 4*G[0, 0, -1, -1, w] - 4*G[0, 0, -1, 1, w] - 
     4*G[0, 0, 1, -1, w] + 4*G[0, 0, 1, 1, w] - 2*G[0, 1, -1, -1, w] + 
     2*G[0, 1, -1, 1, w] + 2*G[0, 1, 1, -1, w] - 2*G[0, 1, 1, 1, w] + 
     G[1, -1, -1, -1, w] + G[1, -1, -1, -1, z] - G[1, -1, -1, 1, w] - 
     G[1, -1, -1, 1, z] - G[1, -1, 1, -1, w] - G[1, -1, 1, -1, z] + 
     G[1, -1, 1, 1, w] + G[1, -1, 1, 1, z] - 2*G[1, 0, -1, -1, w] + 
     2*G[1, 0, -1, 1, w] + 2*G[1, 0, 1, -1, w] - 2*G[1, 0, 1, 1, w] + 
     G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - G[1, 1, -1, 1, w] - 
     G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - G[1, 1, 1, -1, z] + 
     G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z] - 2*G[1, w, -1, -1, z] + 
     2*G[1, w, -1, 1, z] + 2*G[1, w, 1, -1, z] - 2*G[1, w, 1, 1, z] - 
     2*G[w, -1, -1, -1, z] + 2*G[w, -1, -1, 1, z] + 2*G[w, -1, 1, -1, z] - 
     2*G[w, -1, 1, 1, z] - 2*G[w, 1, -1, -1, z] + 2*G[w, 1, -1, 1, z] + 
     2*G[w, 1, 1, -1, z] - 2*G[w, 1, 1, 1, z] + 4*G[w, w, -1, -1, z] - 
     4*G[w, w, -1, 1, z] - 4*G[w, w, 1, -1, z] + 4*G[w, w, 1, 1, z]) + 
   12*(G[0, 0, w]*(G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - 2*G[w, 0, z] + 2*G[w, w, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z]) + 
     (-G[0, z] + 2*G[w, z])*(G[-1, 0, 0, w]/2 + G[1, 0, 0, w]/2) - 
     G[0, w]*(G[0, 0, 0, z] - G[0, w, 0, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 0, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, z] - 
       2*G[w, 0, 0, z] + 2*G[w, w, 0, z] + ((1 + w)^(-1) + w/(1 + w))*
        G[w, (-1 + w)/(1 + w), 0, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), 0, z]) + G[0, -1, 0, 0, w]/2 + 
     G[0, 0, 0, 0, z] + G[0, 1, 0, 0, w]/2 - G[0, w, 0, 0, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 0, 0, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, 0, z] - 
     2*G[w, 0, 0, 0, z] + 2*G[w, w, 0, 0, z] + ((1 + w)^(-1) + w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, 0, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, 0, z]) - 
   6*((-G[0, -1, w] + G[0, 1, w])*(-G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       2*G[w, (-1 + w)/(1 + w), z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z]) + (-G[0, z] + 2*G[w, z])*
      (G[-1, 0, -1, w] - G[-1, 0, 1, w] - G[1, 0, -1, w] + G[1, 0, 1, w]) + 
     (G[-1, w] - G[1, w])*(((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 
         0, z] - G[0, -((1 + w)/(-1 + w)), 0, z] + 
       (-2/(1 + w) - (2*w)/(1 + w))*G[w, (-1 + w)/(1 + w), 0, z] + 
       2*G[w, -((1 + w)/(-1 + w)), 0, z]) + G[0, -1, 0, -1, w] - 
     G[0, -1, 0, 1, w] - G[0, 1, 0, -1, w] + G[0, 1, 0, 1, w] - 
     G[0, (-1 + w)/(1 + w), 0, -1, z] + ((1 + w)^(-1) + w/(1 + w))*
      G[0, (-1 + w)/(1 + w), 0, 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[0, -((1 + w)/(-1 + w)), 0, -1, z] - G[0, -((1 + w)/(-1 + w)), 0, 1, 
      z] + 2*G[w, (-1 + w)/(1 + w), 0, -1, z] + (-2/(1 + w) - (2*w)/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, 1, z] + (2/(-1 + w) - (2*w)/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, -1, z] + 
     2*G[w, -((1 + w)/(-1 + w)), 0, 1, z]) - 
   12*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(-G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       2*G[w, (-1 + w)/(1 + w), z] + (2/(-1 + w) - (2*w)/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z]) + (-G[0, z] + 2*G[w, z])*
      (-G[-1, -1, 0, w]/2 + G[-1, 1, 0, w]/2 + G[1, -1, 0, w]/2 - 
       G[1, 1, 0, w]/2) - G[0, w]*((1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), -1, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), 1, z] + ((-1 - w)^(-1) - w/(1 + w))*
        G[w, (-1 + w)/(1 + w), -1, z] + (-(-1 - w)^(-1) + w/(1 + w))*
        G[w, (-1 + w)/(1 + w), 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), -1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), 1, z]) - G[0, -1, -1, 0, w]/2 + 
     G[0, -1, 1, 0, w]/2 + G[0, 1, -1, 0, w]/2 - G[0, 1, 1, 0, w]/2 + 
     (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, 0, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, 0, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 0, z] + 
     ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), -1, 0, z] + 
     (-(-1 - w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), 1, 0, z] + 
     ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-(1 - w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 1, 0, z]) + 
   12*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - 2*G[w, 0, z] + 2*G[w, w, z] + 
       ((1 + w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), z]) + 
     (-G[0, z] + 2*G[w, z])*(G[-1, -1, -1, w]/2 - G[-1, -1, 1, w]/2 - 
       G[-1, 1, -1, w]/2 + G[-1, 1, 1, w]/2 + G[1, -1, -1, w]/2 - 
       G[1, -1, 1, w]/2 - G[1, 1, -1, w]/2 + G[1, 1, 1, w]/2) + 
     (G[-1, w] - G[1, w])*(-G[0, 0, -1, z] + G[0, 0, 1, z] + G[0, w, -1, z] - 
       G[0, w, 1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 
         -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, 
         z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 
         -1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 
         1, z] + 2*G[w, 0, -1, z] - 2*G[w, 0, 1, z] - 2*G[w, w, -1, z] + 
       2*G[w, w, 1, z] + ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), 
         -1, z] + (-(-1 - w)^(-1) + w/(1 + w))*G[w, (-1 + w)/(1 + w), 1, z] + 
       (-(1 - w)^(-1) - w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[w, -((1 + w)/(-1 + w)), 1, z]) + 
     G[0, -1, -1, -1, w]/2 - G[0, -1, -1, 1, w]/2 - G[0, -1, 1, -1, w]/2 + 
     G[0, -1, 1, 1, w]/2 + G[0, 0, -1, -1, z] - G[0, 0, -1, 1, z] - 
     G[0, 0, 1, -1, z] + G[0, 0, 1, 1, z] + G[0, 1, -1, -1, w]/2 - 
     G[0, 1, -1, 1, w]/2 - G[0, 1, 1, -1, w]/2 + G[0, 1, 1, 1, w]/2 - 
     G[0, w, -1, -1, z] + G[0, w, -1, 1, z] + G[0, w, 1, -1, z] - 
     G[0, w, 1, 1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, -1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, 1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), -1, -1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 1, z] - 
     2*G[w, 0, -1, -1, z] + 2*G[w, 0, -1, 1, z] + 2*G[w, 0, 1, -1, z] - 
     2*G[w, 0, 1, 1, z] + 2*G[w, w, -1, -1, z] - 2*G[w, w, -1, 1, z] - 
     2*G[w, w, 1, -1, z] + 2*G[w, w, 1, 1, z] + (-(-1 - w)^(-1) + w/(1 + w))*
      G[w, (-1 + w)/(1 + w), -1, -1, z] + ((-1 - w)^(-1) - w/(1 + w))*
      G[w, (-1 + w)/(1 + w), -1, 1, z] + ((-1 - w)^(-1) - w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 1, -1, z] + (-(-1 - w)^(-1) + w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 1, 1, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), -1, -1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), -1, 1, z] + (-(1 - w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 1, -1, z] + ((1 - w)^(-1) + w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 1, 1, z]) + 
   ((-1 - w)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
   G[(-1 + w)/(1 + w), 0, -1, 1, z] - 
   ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 0, -1, z])/(1 + w) - 
   ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, 0, 1, z])/(1 + w) + 
   ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
   G[(-1 + w)/(1 + w), 0, 1, 1, z] + 
   ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, w, -1, z])/(1 + w) + 
   ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, w, 1, z])/(1 + w) - 
   ((-6 - 6*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, -1, z])/(1 + w) - 
   ((6 + 6*w)*G[(-1 + w)/(1 + w), -w^(-1), 0, 1, z])/(1 + w) - 
   ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 0, -1, z])/(1 + w) - 
   ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 0, 1, z])/(1 + w) - 
   ((2/(1 + w) + (4*w)/(1 + w) + (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
      (-1 + w)/(1 + w), 0, -1, z])/(1 + w) - 
   ((-2/(1 + w) - (4*w)/(1 + w) - (2*w^2)/(1 + w))*
     G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 1, z])/(1 + w) - 
   ((-2/(-1 + w) + (2*w^2)/(-1 + w))*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 
      0, -1, z])/(1 + w) - ((2/(-1 + w) - (2*w^2)/(-1 + w))*
     G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, 1, z])/(1 + w) + 
   G[-((1 + w)/(-1 + w)), 0, -1, -1, z] + 
   ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) - 
   ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, -1, z])/(-1 + w) - 
   ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
   G[-((1 + w)/(-1 + w)), 0, 1, -1, z] + 
   ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) - 
   3*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + G[-((1 + w)/(-1 + w)), 
        0, z]) + (G[(-1 + w)/(1 + w), z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[0, -1, -1, w] + G[0, -1, 1, w] - G[0, 1, -1, w] + G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(((-1 - w)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, w^(-1), z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, -1, z] + G[-((1 + w)/(-1 + w)), 0, 1, z] + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, w^(-1), z])/(-1 + w)) + 
     G[-1, 0, -1, -1, w] - G[-1, 0, -1, 1, w] + G[-1, 0, 1, -1, w] - 
     G[-1, 0, 1, 1, w] - G[1, 0, -1, -1, w] + G[1, 0, -1, 1, w] - 
     G[1, 0, 1, -1, w] + G[1, 0, 1, 1, w] + G[(-1 + w)/(1 + w), 0, -1, -1, 
      z] + ((-1 - w)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 0, 1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), 0, w^(-1), -1, z])/(1 + w) + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, w^(-1), 1, z])/(1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, -1, 1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, 1, 1, z] + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, w^(-1), -1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, w^(-1), 1, z])/(-1 + w)) + 
   ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, w, -1, z])/(-1 + w) + 
   2*(4*G[0, 0, w]*(-G[0, 0, z] + G[w, 0, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w)) - 
     4*(-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*G[0, 0, 0, w] - 
     G[0, w]*(-4*G[0, 0, 0, z] + 6*G[0, 0, -w, z] + 2*G[0, 0, w, z] + 
       4*G[w, 0, 0, z] - 6*G[w, 0, -w, z] - 2*G[w, 0, w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((-3 - 3*w)*G[(-1 + w)/(1 + w), 0, -w, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 0, w, z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((3 - 3*w)*G[-((1 + w)/(-1 + w)), 0, -w, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, w, z])/(-1 + w)) - 
     2*G[-1, 0, 0, 0, w] - 4*G[0, 0, 0, 0, z] + 6*G[0, 0, -w, 0, z] + 
     2*G[0, 0, w, 0, z] - 2*G[1, 0, 0, 0, w] + 4*G[w, 0, 0, 0, z] - 
     6*G[w, 0, -w, 0, z] - 2*G[w, 0, w, 0, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 0, 0, 0, z])/(1 + w) + 
     ((-3 - 3*w)*G[(-1 + w)/(1 + w), 0, -w, 0, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, w, 0, z])/(1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, 0, 0, z])/(-1 + w) + 
     ((3 - 3*w)*G[-((1 + w)/(-1 + w)), 0, -w, 0, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, w, 0, z])/(-1 + w)) + 
   ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), 0, w, 1, z])/(-1 + w) + 
   6*((G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - G[1, 1, w])*
      (G[0, -1, z] - G[0, 1, z] - G[w, -1, z] + G[w, 1, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, -1, w] - G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*(G[0, -1, -1, z] + 
       G[0, -1, 1, z] - 2*G[0, -1, w^(-1), z] - G[0, 1, -1, z] - 
       G[0, 1, 1, z] + 2*G[0, 1, w^(-1), z] - G[w, -1, -1, z] - 
       G[w, -1, 1, z] + 2*G[w, -1, w^(-1), z] + G[w, 1, -1, z] + 
       G[w, 1, 1, z] - 2*G[w, 1, w^(-1), z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), -1, w^(-1), z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 1, w^(-1), z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), -1, w^(-1), z] + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 1, w^(-1), z])/(-1 + w)) + 
     G[-1, -1, -1, -1, w]/2 - G[-1, -1, -1, 1, w]/2 + G[-1, -1, 1, -1, w]/2 - 
     G[-1, -1, 1, 1, w]/2 - G[-1, 1, -1, -1, w]/2 + G[-1, 1, -1, 1, w]/2 - 
     G[-1, 1, 1, -1, w]/2 + G[-1, 1, 1, 1, w]/2 - G[0, -1, -1, -1, z] + 
     G[0, -1, -1, 1, z] - G[0, -1, 1, -1, z] + G[0, -1, 1, 1, z] + 
     2*G[0, -1, w^(-1), -1, z] - 2*G[0, -1, w^(-1), 1, z] + 
     G[0, 1, -1, -1, z] - G[0, 1, -1, 1, z] + G[0, 1, 1, -1, z] - 
     G[0, 1, 1, 1, z] - 2*G[0, 1, w^(-1), -1, z] + 2*G[0, 1, w^(-1), 1, z] + 
     G[1, -1, -1, -1, w]/2 - G[1, -1, -1, 1, w]/2 + G[1, -1, 1, -1, w]/2 - 
     G[1, -1, 1, 1, w]/2 - G[1, 1, -1, -1, w]/2 + G[1, 1, -1, 1, w]/2 - 
     G[1, 1, 1, -1, w]/2 + G[1, 1, 1, 1, w]/2 + G[w, -1, -1, -1, z] - 
     G[w, -1, -1, 1, z] + G[w, -1, 1, -1, z] - G[w, -1, 1, 1, z] - 
     2*G[w, -1, w^(-1), -1, z] + 2*G[w, -1, w^(-1), 1, z] - 
     G[w, 1, -1, -1, z] + G[w, 1, -1, 1, z] - G[w, 1, 1, -1, z] + 
     G[w, 1, 1, 1, z] + 2*G[w, 1, w^(-1), -1, z] - 2*G[w, 1, w^(-1), 1, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, w^(-1), -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -1, w^(-1), 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, -1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, w^(-1), -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, w^(-1), 1, z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, -1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, w^(-1), -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, w^(-1), 1, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, -1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, 1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, w^(-1), -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, w^(-1), 1, z])/(-1 + w)) - 
   2*(4*G[0, 0, w]*(((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-2*G[-1, 0, 0, w] + 2*G[1, 0, 0, w]) - 
     G[0, w]*(((-2 - 2*w)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
       ((3 + 3*w)*G[(-1 + w)/(1 + w), -1, -w, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), -1, w, z] + 
       ((2 + 2*w)*G[(-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
       ((-3 - 3*w)*G[(-1 + w)/(1 + w), 1, -w, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), 1, w, z])/(1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
       ((3 - 3*w)*G[-((1 + w)/(-1 + w)), -1, -w, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), -1, w, z])/(-1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w) + 
       ((-3 + 3*w)*G[-((1 + w)/(-1 + w)), 1, -w, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), 1, w, z]) + 2*G[-1, -1, 0, 0, w] - 
     2*G[-1, 1, 0, 0, w] - 2*G[1, -1, 0, 0, w] + 2*G[1, 1, 0, 0, w] + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), -1, 0, 0, z])/(1 + w) + 
     ((3 + 3*w)*G[(-1 + w)/(1 + w), -1, -w, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -1, w, 0, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), 1, 0, 0, z])/(1 + w) + 
     ((-3 - 3*w)*G[(-1 + w)/(1 + w), 1, -w, 0, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, w, 0, z])/(1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), -1, 0, 0, z])/(-1 + w) + 
     ((3 - 3*w)*G[-((1 + w)/(-1 + w)), -1, -w, 0, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, w, 0, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 1, 0, 0, z])/(-1 + w) + 
     ((-3 + 3*w)*G[-((1 + w)/(-1 + w)), 1, -w, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, w, 0, z]) - 
   2*((-G[-1, -1, w] + G[-1, 1, w] + 2*G[0, -1, w] - 2*G[0, 1, w] - 
       G[1, -1, w] + G[1, 1, w])*(G[0, -1, z] - G[0, 1, z] - G[w, -1, z] + 
       G[w, 1, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 2*G[-1, 0, -1, w] - 
       2*G[-1, 0, 1, w] - G[-1, 1, -1, w] + G[-1, 1, 1, w] + 
       G[1, -1, -1, w] - G[1, -1, 1, w] - 2*G[1, 0, -1, w] + 
       2*G[1, 0, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, -1, -1, z] - G[0, -1, 1, z] + 
       2*G[0, -1, w, z] + G[0, 1, -1, z] + G[0, 1, 1, z] - 2*G[0, 1, w, z] + 
       G[w, -1, -1, z] + G[w, -1, 1, z] - 2*G[w, -1, w, z] - G[w, 1, -1, z] - 
       G[w, 1, 1, z] + 2*G[w, 1, w, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), -1, w, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 1, w, z] + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 
          -1, -1, z])/(-1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, 1, 
          z])/(-1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), -1, w, z])/
        (-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), 1, w, z]) - G[-1, -1, -1, -1, w]/2 + 
     G[-1, -1, -1, 1, w]/2 + G[-1, -1, 0, -1, w] - G[-1, -1, 0, 1, w] - 
     G[-1, -1, 1, -1, w]/2 + G[-1, -1, 1, 1, w]/2 + G[-1, 1, -1, -1, w]/2 - 
     G[-1, 1, -1, 1, w]/2 - G[-1, 1, 0, -1, w] + G[-1, 1, 0, 1, w] + 
     G[-1, 1, 1, -1, w]/2 - G[-1, 1, 1, 1, w]/2 + G[0, -1, -1, -1, z] - 
     G[0, -1, -1, 1, z] + G[0, -1, 1, -1, z] - G[0, -1, 1, 1, z] - 
     2*G[0, -1, w, -1, z] + 2*G[0, -1, w, 1, z] - G[0, 1, -1, -1, z] + 
     G[0, 1, -1, 1, z] - G[0, 1, 1, -1, z] + G[0, 1, 1, 1, z] + 
     2*G[0, 1, w, -1, z] - 2*G[0, 1, w, 1, z] - G[1, -1, -1, -1, w]/2 + 
     G[1, -1, -1, 1, w]/2 + G[1, -1, 0, -1, w] - G[1, -1, 0, 1, w] - 
     G[1, -1, 1, -1, w]/2 + G[1, -1, 1, 1, w]/2 + G[1, 1, -1, -1, w]/2 - 
     G[1, 1, -1, 1, w]/2 - G[1, 1, 0, -1, w] + G[1, 1, 0, 1, w] + 
     G[1, 1, 1, -1, w]/2 - G[1, 1, 1, 1, w]/2 - G[w, -1, -1, -1, z] + 
     G[w, -1, -1, 1, z] - G[w, -1, 1, -1, z] + G[w, -1, 1, 1, z] + 
     2*G[w, -1, w, -1, z] - 2*G[w, -1, w, 1, z] + G[w, 1, -1, -1, z] - 
     G[w, 1, -1, 1, z] + G[w, 1, 1, -1, z] - G[w, 1, 1, 1, z] - 
     2*G[w, 1, w, -1, z] + 2*G[w, 1, w, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, 1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -1, w, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), -1, w, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, -1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 1, w, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 1, w, 1, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, -1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, 1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), -1, w, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -1, w, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, -1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 1, w, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), 1, w, 1, z]) - 
   ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, -1, z])/(-1 + w) - 
   ((6 - 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 0, 1, z])/(-1 + w) - 
   ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, 0, -1, z])/(-1 + w) + 
   18*(G[0, 0, w]*(G[0, 0, z] - 2*G[0, w, z] - G[w, 0, z] + 2*G[w, w, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*G[0, 0, 0, w] - 
     G[0, w]*(G[0, 0, 0, z] - 2*G[0, w, 0, z] - G[w, 0, 0, z] + 
       2*G[w, w, 0, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, z])/
        (1 + w) + G[(-1 + w)/(1 + w), w, 0, z] + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 0, z]) + G[-1, 0, 0, 0, w]/2 + 
     G[0, 0, 0, 0, z] - 2*G[0, w, 0, 0, z] + G[1, 0, 0, 0, w]/2 - 
     G[w, 0, 0, 0, z] + 2*G[w, w, 0, 0, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 0, 0, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 0, 0, z]) - 
   6*(G[0, 0, w]*(G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z] - G[w, -1, z] - 
       G[w, 1, z] + 2*G[w, w, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/
        (1 + w) + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 
          z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, 0, w] + 2*G[0, 0, 0, w] - G[1, 0, 0, w]) - 
     G[0, w]*(G[0, -1, 0, z] + G[0, 1, 0, z] - 2*G[0, w, 0, z] - 
       G[w, -1, 0, z] - G[w, 1, 0, z] + 2*G[w, w, 0, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 0, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 
          0, z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 0, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, 0, z]) - G[-1, -1, 0, 0, w]/2 + 
     G[-1, 0, 0, 0, w] - G[-1, 1, 0, 0, w]/2 + G[0, -1, 0, 0, z] + 
     G[0, 1, 0, 0, z] - 2*G[0, w, 0, 0, z] - G[1, -1, 0, 0, w]/2 + 
     G[1, 0, 0, 0, w] - G[1, 1, 0, 0, w]/2 - G[w, -1, 0, 0, z] - 
     G[w, 1, 0, 0, z] + 2*G[w, w, 0, 0, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 0, 0, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 0, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 0, 0, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 0, 0, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 0, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 0, 0, z]) - 
   ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, 1, z])/(-1 + w) + 
   2*((-G[0, -1, w] + G[0, 1, w])*(((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/
        (1 + w) + ((2 + 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, z] + ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 
          z])/(-1 + w)) + (G[(-1 + w)/(1 + w), z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[0, 0, -1, w] + G[0, 0, 1, w]) + (G[-1, w] - G[1, w])*
      (G[(-1 + w)/(1 + w), 0, 0, z] + ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 0, 
          z])/(1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w)) + 
     G[-1, 0, 0, -1, w] - G[-1, 0, 0, 1, w] - G[1, 0, 0, -1, w] + 
     G[1, 0, 0, 1, w] + ((-1 - w)*G[(-1 + w)/(1 + w), 0, 0, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 0, 0, 1, z] + 
     ((2 + 2*w)*G[(-1 + w)/(1 + w), w, 0, -1, z])/(1 + w) + 
     ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, 0, 1, z])/(1 + w) + 
     G[-((1 + w)/(-1 + w)), 0, 0, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
     ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 0, -1, z])/(-1 + w) + 
     ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, 0, 1, z])/(-1 + w)) + 
   4*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/
        (1 + w) + ((2 + 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       G[-((1 + w)/(-1 + w)), 0, z] + ((2 - 2*w)*G[-((1 + w)/(-1 + w)), w, 
          z])/(-1 + w)) + (G[(-1 + w)/(1 + w), z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[0, -1, 0, w]/2 - G[0, 1, 0, w]/2) - 
     G[0, w]*(((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 1, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 
          -1, z])/(-1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, -1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w)) - 
     G[-1, 0, -1, 0, w]/2 + G[-1, 0, 1, 0, w]/2 + G[1, 0, -1, 0, w]/2 - 
     G[1, 0, 1, 0, w]/2 + ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, 0, z])/
      (1 + w) + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, 0, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 1, 0, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, -1, 0, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, 1, 0, z])/(-1 + w)) + 
   6*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, 0, z] - 2*G[0, w, z] - G[w, 0, z] + 2*G[w, w, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[0, -1, -1, w] - G[0, -1, 1, w] - G[0, 1, -1, w] + G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, 0, -1, z] + G[0, 0, 1, z] + 
       2*G[0, w, -1, z] - 2*G[0, w, 1, z] + G[w, 0, -1, z] - G[w, 0, 1, z] - 
       2*G[w, w, -1, z] + 2*G[w, w, 1, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 1, z] + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 
          -1, z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/
        (-1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 1, z]) + G[-1, 0, -1, -1, w]/2 - 
     G[-1, 0, -1, 1, w]/2 - G[-1, 0, 1, -1, w]/2 + G[-1, 0, 1, 1, w]/2 + 
     G[0, 0, -1, -1, z] - G[0, 0, -1, 1, z] - G[0, 0, 1, -1, z] + 
     G[0, 0, 1, 1, z] - 2*G[0, w, -1, -1, z] + 2*G[0, w, -1, 1, z] + 
     2*G[0, w, 1, -1, z] - 2*G[0, w, 1, 1, z] + G[1, 0, -1, -1, w]/2 - 
     G[1, 0, -1, 1, w]/2 - G[1, 0, 1, -1, w]/2 + G[1, 0, 1, 1, w]/2 - 
     G[w, 0, -1, -1, z] + G[w, 0, -1, 1, z] + G[w, 0, 1, -1, z] - 
     G[w, 0, 1, 1, z] + 2*G[w, w, -1, -1, z] - 2*G[w, w, -1, 1, z] - 
     2*G[w, w, 1, -1, z] + 2*G[w, w, 1, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 1, 1, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, -1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 1, 1, z]) + 
   6*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z] - G[w, -1, z] - G[w, 1, z] + 
       2*G[w, w, z] + ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, z] + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 
          z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, z])/
        (-1 + w) + G[-((1 + w)/(-1 + w)), w, z]) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + 2*G[0, -1, -1, w] - 2*G[0, -1, 1, w] - 
       2*G[0, 1, -1, w] + 2*G[0, 1, 1, w] - G[1, -1, -1, w] + 
       G[1, -1, 1, w] + G[1, 1, -1, w] - G[1, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(-G[0, -1, -1, z] + G[0, -1, 1, z] - 
       G[0, 1, -1, z] + G[0, 1, 1, z] + 2*G[0, w, -1, z] - 2*G[0, w, 1, z] + 
       G[w, -1, -1, z] - G[w, -1, 1, z] + G[w, 1, -1, z] - G[w, 1, 1, z] - 
       2*G[w, w, -1, z] + 2*G[w, w, 1, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), w, 1, z] + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 
          -1, -1, z])/(-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, 
          z])/(-1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, -1, z])/
        (-1 + w) + ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 1, z]) - G[-1, -1, -1, -1, w]/2 + 
     G[-1, -1, -1, 1, w]/2 + G[-1, -1, 1, -1, w]/2 - G[-1, -1, 1, 1, w]/2 + 
     G[-1, 0, -1, -1, w] - G[-1, 0, -1, 1, w] - G[-1, 0, 1, -1, w] + 
     G[-1, 0, 1, 1, w] - G[-1, 1, -1, -1, w]/2 + G[-1, 1, -1, 1, w]/2 + 
     G[-1, 1, 1, -1, w]/2 - G[-1, 1, 1, 1, w]/2 + G[0, -1, -1, -1, z] - 
     G[0, -1, -1, 1, z] - G[0, -1, 1, -1, z] + G[0, -1, 1, 1, z] + 
     G[0, 1, -1, -1, z] - G[0, 1, -1, 1, z] - G[0, 1, 1, -1, z] + 
     G[0, 1, 1, 1, z] - 2*G[0, w, -1, -1, z] + 2*G[0, w, -1, 1, z] + 
     2*G[0, w, 1, -1, z] - 2*G[0, w, 1, 1, z] - G[1, -1, -1, -1, w]/2 + 
     G[1, -1, -1, 1, w]/2 + G[1, -1, 1, -1, w]/2 - G[1, -1, 1, 1, w]/2 + 
     G[1, 0, -1, -1, w] - G[1, 0, -1, 1, w] - G[1, 0, 1, -1, w] + 
     G[1, 0, 1, 1, w] - G[1, 1, -1, -1, w]/2 + G[1, 1, -1, 1, w]/2 + 
     G[1, 1, 1, -1, w]/2 - G[1, 1, 1, 1, w]/2 - G[w, -1, -1, -1, z] + 
     G[w, -1, -1, 1, z] + G[w, -1, 1, -1, z] - G[w, -1, 1, 1, z] - 
     G[w, 1, -1, -1, z] + G[w, 1, -1, 1, z] + G[w, 1, 1, -1, z] - 
     G[w, 1, 1, 1, z] + 2*G[w, w, -1, -1, z] - 2*G[w, w, -1, 1, z] - 
     2*G[w, w, 1, -1, z] + 2*G[w, w, 1, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -1, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), -1, 1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 1, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 1, 1, 1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, -1, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, 1, 1, z] + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -1, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), -1, 1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 1, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 1, 1, 1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, -1, -1, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, 1, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 1, 1, z]) - 
   ((2/(1 + w) - (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 
      -1, z])/(-1 + w) - ((-2/(1 + w) + (2*w^2)/(1 + w))*
     G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) - 
   ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
     G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) - 
   12*(G[0, 0, w]*(G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - G[w, 0, z] + G[w, w, z] + 
       (1/(2*(1 + w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, 0, w]/2 + G[1, 0, 0, w]/2) - 
     G[0, w]*(G[0, 0, 0, z] - G[0, w, 0, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 0, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, z] - 
       G[w, 0, 0, z] + G[w, w, 0, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), 0, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 0, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 0, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     G[-1, -1, 0, 0, w]/4 + G[-1, 1, 0, 0, w]/4 + G[0, 0, 0, 0, z] - 
     G[0, w, 0, 0, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 0, 0, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), 0, 0, z] + G[1, -1, 0, 0, w]/4 + 
     G[1, 1, 0, 0, w]/4 - G[w, 0, 0, 0, z] + G[w, w, 0, 0, z] + 
     (1/(2*(1 + w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), 0, 0, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 0, 0, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 0, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 0, 0, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 0, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, 0, z])/(1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 0, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 0, 0, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 0, 0, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) + 
   4*(G[0, 0, w]*(G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z] + 
       (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, 0, w] + G[1, 0, 0, w]) - 
     G[0, w]*(G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z] + 
       (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     G[-1, -1, 0, 0, w] - G[-1, 1, 0, 0, w] - G[1, -1, 0, 0, w] + 
     G[1, 1, 0, 0, w] + G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 0, z] + 
     (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 
        0, 0, z])/(1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        0, 0, z])/(-1 + w) + (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w)) - 
   ((2/(-1 + w) - (4*w)/(-1 + w) + (2*w^2)/(-1 + w))*
     G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
   6*((-G[0, -1, w] + G[0, 1, w])*(-G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       G[w, (-1 + w)/(1 + w), z] + ((-1 + w)^(-1) - w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, 0, -1, w] - G[-1, 0, 1, w] - G[1, 0, -1, w] + G[1, 0, 1, w]) + 
     (G[-1, w] - G[1, w])*(((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 
         0, z] - G[0, -((1 + w)/(-1 + w)), 0, z] + 
       ((-1 - w)^(-1) - w/(1 + w))*G[w, (-1 + w)/(1 + w), 0, z] + 
       G[w, -((1 + w)/(-1 + w)), 0, z] + 
       ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/
        (-1 + w)) + G[-1, -1, 0, -1, w]/2 - G[-1, -1, 0, 1, w]/2 - 
     G[-1, 1, 0, -1, w]/2 + G[-1, 1, 0, 1, w]/2 - G[0, (-1 + w)/(1 + w), 0, 
      -1, z] + ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 0, 1, z] + 
     ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, -1, z] - 
     G[0, -((1 + w)/(-1 + w)), 0, 1, z] + G[1, -1, 0, -1, w]/2 - 
     G[1, -1, 0, 1, w]/2 - G[1, 1, 0, -1, w]/2 + G[1, 1, 0, 1, w]/2 + 
     G[w, (-1 + w)/(1 + w), 0, -1, z] + ((-1 - w)^(-1) - w/(1 + w))*
      G[w, (-1 + w)/(1 + w), 0, 1, z] + ((-1 + w)^(-1) - w/(-1 + w))*
      G[w, -((1 + w)/(-1 + w)), 0, -1, z] + G[w, -((1 + w)/(-1 + w)), 0, 1, 
      z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, -1, z])/
      (1 + w) + ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 0, 1, z])/
      (1 + w) + ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, -1, 
        z])/(-1 + w) + ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*
       G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) + 
     ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/
      (-1 + w)) - 4*((-G[0, -1, w] + G[0, 1, w])*
      (((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + G[(-1 + w)/(1 + w), w, 
        z] + ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, 0, -1, w]/2 + G[-1, 0, 1, w]/2 - G[1, 0, -1, w]/2 + 
       G[1, 0, 1, w]/2) + (G[-1, w] - G[1, w])*
      (G[(-1 + w)/(1 + w), 0, 0, z] + ((-1 - w)*G[(-1 + w)/(1 + w), w, 0, z])/
        (1 + w) + ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 0, z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 0, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 0, z] + ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*
         G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 0, z])/(-1 + w) + 
       ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, z])/(-1 + w)) + 
     G[-1, -1, 0, -1, w]/2 - G[-1, -1, 0, 1, w]/2 + G[-1, 1, 0, -1, w]/2 - 
     G[-1, 1, 0, 1, w]/2 - G[1, -1, 0, -1, w]/2 + G[1, -1, 0, 1, w]/2 - 
     G[1, 1, 0, -1, w]/2 + G[1, 1, 0, 1, w]/2 + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, 0, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 0, 0, 1, z] + G[(-1 + w)/(1 + w), w, 0, -1, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 0, 1, z])/(1 + w) + 
     ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
     ((-1/(2*(1 + w)) - w/(1 + w) - w^2/(2*(1 + w)))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
     ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, -1, z])/(1 + w) + 
     ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 0, 1, z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, 0, 
      -1, z] + ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 0, 1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, 0, -1, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 0, 1, z] + 
     ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 0, -1, z])/(-1 + w) + 
     ((-1/(2*(1 + w)) + w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 0, 1, z])/(-1 + w) + 
     ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
     ((1/(2*(-1 + w)) - w/(-1 + w) + w^2/(2*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w)) - 
   2*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(((2 + 2*w)*G[(-1 + w)/(1 + w), 0, z])/
        (1 + w) + ((-6 - 6*w)*G[(-1 + w)/(1 + w), -w^(-1), z])/(1 + w) + 
       ((-2 - 2*w)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((2/(1 + w) + (4*w)/(1 + w) + (2*w^2)/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), z])/(1 + w) + ((-2/(-1 + w) + (2*w^2)/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((2 - 2*w)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-6 + 6*w)*G[-((1 + w)/(-1 + w)), -w^(-1), z])/(-1 + w) + 
       ((-2 + 2*w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((2/(1 + w) - (2*w^2)/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-2/(-1 + w) + (4*w)/(-1 + w) - (2*w^2)/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, 0, w] - G[-1, 1, 0, w] + G[1, -1, 0, w] - G[1, 1, 0, w]) - 
     G[0, w]*(((-1 - w)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), 0, 1, z] + ((3 + 3*w)*G[(-1 + w)/(1 + w), -w^(-1), 
          -1, z])/(1 + w) + ((-3 - 3*w)*G[(-1 + w)/(1 + w), -w^(-1), 1, z])/
        (1 + w) + G[(-1 + w)/(1 + w), w, -1, z] + 
       ((-1 - w)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       (((-1 - w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, z] + (((-1 + w)^(-1) - w^2/(-1 + w))*
         G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, z] + 
       G[-((1 + w)/(-1 + w)), 0, -1, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((3 - 3*w)*G[-((1 + w)/(-1 + w)), -w^(-1), -1, z])/(-1 + w) + 
       ((-3 + 3*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       G[-((1 + w)/(-1 + w)), w, 1, z] + (((-1 - w)^(-1) + w^2/(1 + w))*
         G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/
        (-1 + w)) - G[-1, -1, -1, 0, w] + G[-1, -1, 1, 0, w] - 
     G[-1, 1, -1, 0, w] + G[-1, 1, 1, 0, w] + G[1, -1, -1, 0, w] - 
     G[1, -1, 1, 0, w] + G[1, 1, -1, 0, w] - G[1, 1, 1, 0, w] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), 0, -1, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), 0, 1, 0, z] + 
     ((3 + 3*w)*G[(-1 + w)/(1 + w), -w^(-1), -1, 0, z])/(1 + w) + 
     ((-3 - 3*w)*G[(-1 + w)/(1 + w), -w^(-1), 1, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), w, -1, 0, z] + 
     ((-1 - w)*G[(-1 + w)/(1 + w), w, 1, 0, z])/(1 + w) + 
     (((-1 - w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + G[(-1 + w)/(1 + w), 
      (-1 + w)/(1 + w), 1, 0, z] + (((-1 + w)^(-1) - w^2/(-1 + w))*
       G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, 0, z] + 
     G[-((1 + w)/(-1 + w)), 0, -1, 0, z] + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     ((3 - 3*w)*G[-((1 + w)/(-1 + w)), -w^(-1), -1, 0, z])/(-1 + w) + 
     ((-3 + 3*w)*G[-((1 + w)/(-1 + w)), -w^(-1), 1, 0, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), w, -1, 0, z])/(-1 + w) + 
     G[-((1 + w)/(-1 + w)), w, 1, 0, z] + 
     (((-1 - w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        -1, 0, z])/(-1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 0, z])/(-1 + w) + 
     (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*G[-((1 + w)/(-1 + w)), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/
      (-1 + w)) - 8*((G[-1, 0, w]/2 - G[1, 0, w]/2)*
      (((-1 - w)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + G[(-1 + w)/(1 + w), w, 
        z] + ((1/(2*(1 + w)) + w/(1 + w) + w^2/(2*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(2*(-1 + w)) + w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + G[-((1 + w)/(-1 + w)), 0, z] + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((1/(2*(1 + w)) - w^2/(2*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, 0, w]/4 - G[-1, 1, 0, w]/4 + G[1, -1, 0, w]/4 - 
       G[1, 1, 0, w]/4) - G[0, w]*
      (((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - 
     G[-1, -1, -1, 0, w]/4 + G[-1, -1, 1, 0, w]/4 - G[-1, 1, -1, 0, w]/4 + 
     G[-1, 1, 1, 0, w]/4 + G[1, -1, -1, 0, w]/4 - G[1, -1, 1, 0, w]/4 + 
     G[1, 1, -1, 0, w]/4 - G[1, 1, 1, 0, w]/4 + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, 0, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, 0, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, -1, 0, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 1, 0, z])/(1 + w) + 
     ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 0, z])/(1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 0, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, -1, 0, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, 1, 0, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 0, z])/(-1 + w) + 
     ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 0, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) + 
   12*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(-G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z] + 
       G[w, (-1 + w)/(1 + w), z] + ((-1 + w)^(-1) - w/(-1 + w))*
        G[w, -((1 + w)/(-1 + w)), z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((1/(2*(-1 + w)) - w^2/(2*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((-1/(2*(-1 + w)) + w/(-1 + w) - w^2/(2*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, 0, w]/2 + G[-1, 1, 0, w]/2 + G[1, -1, 0, w]/2 - 
       G[1, 1, 0, w]/2) - G[0, w]*((1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), -1, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), 1, z] + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), -1, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
        G[w, (-1 + w)/(1 + w), 1, z] + (1/(2*(1 - w)) + w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), -1, z] + (-1/(2*(1 - w)) - w/(2*(-1 + w)))*
        G[w, -((1 + w)/(-1 + w)), 1, z] + 
       ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) - 
     G[-1, -1, -1, 0, w]/4 + G[-1, -1, 1, 0, w]/4 + G[-1, 1, -1, 0, w]/4 - 
     G[-1, 1, 1, 0, w]/4 + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, 0, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, 0, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 0, z] - 
     G[1, -1, -1, 0, w]/4 + G[1, -1, 1, 0, w]/4 + G[1, 1, -1, 0, w]/4 - 
     G[1, 1, 1, 0, w]/4 + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), -1, 0, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), 1, 0, z] + (1/(2*(1 - w)) + w/(2*(-1 + w)))*
      G[w, -((1 + w)/(-1 + w)), -1, 0, z] + (-1/(2*(1 - w)) - w/(2*(-1 + w)))*
      G[w, -((1 + w)/(-1 + w)), 1, 0, z] + 
     ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, 0, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 0, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 0, z])/(1 + w) + 
     ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 0, z])/(1 + w) + 
     ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 0, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 0, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 0, z])/(-1 + w) + 
     ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 0, z])/(-1 + w)) - 
   12*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z] - G[w, 0, z] + G[w, w, z] + 
       (1/(2*(1 + w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), z] + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (-G[0, z] + G[w, z] + ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (G[-1, -1, -1, w]/2 - G[-1, -1, 1, w]/2 - G[-1, 1, -1, w]/2 + 
       G[-1, 1, 1, w]/2 + G[1, -1, -1, w]/2 - G[1, -1, 1, w]/2 - 
       G[1, 1, -1, w]/2 + G[1, 1, 1, w]/2) + (G[-1, w] - G[1, w])*
      (-G[0, 0, -1, z] + G[0, 0, 1, z] + G[0, w, -1, z] - G[0, w, 1, z] + 
       (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, z] + 
       G[w, 0, -1, z] - G[w, 0, 1, z] - G[w, w, -1, z] + G[w, w, 1, z] + 
       (1/(2*(-1 - w)) - w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), -1, z] + 
       (-1/(2*(-1 - w)) + w/(2*(1 + w)))*G[w, (-1 + w)/(1 + w), 1, z] + 
       (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, z] + 
       (1/(2*(1 - w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, z] + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, z])/(1 + w) + 
       ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, -1, z])/(1 + w) + 
       ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 1, z])/(1 + w) + 
       ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, z])/(1 + w) + 
       ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
         G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, z])/(1 + w) + 
       ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), -1, z])/(1 + w) + 
       ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, z])/(-1 + w) + 
       ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, -1, z])/(-1 + w) + 
       ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 1, z])/(-1 + w) + 
       ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/(-1 + w) + 
       ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, -1, -1, w]/4 - G[-1, -1, -1, 1, w]/4 - G[-1, -1, 1, -1, w]/4 + 
     G[-1, -1, 1, 1, w]/4 + G[-1, 1, -1, -1, w]/4 - G[-1, 1, -1, 1, w]/4 - 
     G[-1, 1, 1, -1, w]/4 + G[-1, 1, 1, 1, w]/4 + G[0, 0, -1, -1, z] - 
     G[0, 0, -1, 1, z] - G[0, 0, 1, -1, z] + G[0, 0, 1, 1, z] - 
     G[0, w, -1, -1, z] + G[0, w, -1, 1, z] + G[0, w, 1, -1, z] - 
     G[0, w, 1, 1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, -1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), -1, 1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[0, (-1 + w)/(1 + w), 1, 1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[0, -((1 + w)/(-1 + w)), -1, -1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 1, z] + 
     G[1, -1, -1, -1, w]/4 - G[1, -1, -1, 1, w]/4 - G[1, -1, 1, -1, w]/4 + 
     G[1, -1, 1, 1, w]/4 + G[1, 1, -1, -1, w]/4 - G[1, 1, -1, 1, w]/4 - 
     G[1, 1, 1, -1, w]/4 + G[1, 1, 1, 1, w]/4 - G[w, 0, -1, -1, z] + 
     G[w, 0, -1, 1, z] + G[w, 0, 1, -1, z] - G[w, 0, 1, 1, z] + 
     G[w, w, -1, -1, z] - G[w, w, -1, 1, z] - G[w, w, 1, -1, z] + 
     G[w, w, 1, 1, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), -1, -1, z] + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), -1, 1, z] + (1/(2*(-1 - w)) - w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), 1, -1, z] + (-1/(2*(-1 - w)) + w/(2*(1 + w)))*
      G[w, (-1 + w)/(1 + w), 1, 1, z] + (1/(2*(1 - w)) + w/(2*(-1 + w)))*
      G[w, -((1 + w)/(-1 + w)), -1, -1, z] + 
     (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), -1, 1, z] + 
     (-1/(2*(1 - w)) - w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (1/(2*(1 - w)) + w/(2*(-1 + w)))*G[w, -((1 + w)/(-1 + w)), 1, 1, z] + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, -1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, -1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), 0, 1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), 0, 1, 1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, -1, -1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, -1, 1, z])/(1 + w) + 
     ((-1/2 - w/2)*G[(-1 + w)/(1 + w), w, 1, -1, z])/(1 + w) + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), w, 1, 1, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, -1, z])/(1 + w) + 
     ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-1/(4*(1 + w)) - w/(2*(1 + w)) - w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, -1, z])/(1 + w) + 
     ((1/(4*(1 + w)) + w/(2*(1 + w)) + w^2/(4*(1 + w)))*
       G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), 1, 1, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, -1, z])/(1 + w) + 
     ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), -1, 1, z])/(1 + w) + 
     ((1/(4*(-1 + w)) - w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, -1, z])/(1 + w) + 
     ((-1/(4*(-1 + w)) + w^2/(4*(-1 + w)))*G[(-1 + w)/(1 + w), 
        -((1 + w)/(-1 + w)), 1, 1, z])/(1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, -1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, -1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), 0, 1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), 0, 1, 1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, -1, -1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, -1, 1, z])/(-1 + w) + 
     ((1/2 - w/2)*G[-((1 + w)/(-1 + w)), w, 1, -1, z])/(-1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), w, 1, 1, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, -1, z])/(-1 + w) + 
     ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), -1, 1, z])/(-1 + w) + 
     ((1/(4*(1 + w)) - w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, -1, z])/(-1 + w) + 
     ((-1/(4*(1 + w)) + w^2/(4*(1 + w)))*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 1, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 1, z])/(-1 + w) + 
     ((-1/(4*(-1 + w)) + w/(2*(-1 + w)) - w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, -1, z])/(-1 + w) + 
     ((1/(4*(-1 + w)) - w/(2*(-1 + w)) + w^2/(4*(-1 + w)))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)) + 
   4*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), z] + 
       (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), z])/(1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), z])/(-1 + w) + 
       (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), z])/(-1 + w)) + 
     (G[(-1 + w)/(1 + w), z] + ((1 - w)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*
      (-G[-1, -1, -1, w] + G[-1, -1, 1, w] + G[-1, 1, -1, w] - 
       G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - G[1, 1, -1, w] + 
       G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      ((((-1 - w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
          (-1 + w)/(1 + w), -1, z])/(1 + w) + G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, z] + G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 
        -1, z] + (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), 
          -((1 + w)/(-1 + w)), 1, z])/(1 + w) + 
       (((-1 - w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), 
          (-1 + w)/(1 + w), -1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 1, z])/(-1 + w) + 
       ((1 - w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, z])/
        (-1 + w) + (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
         G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, z])/(-1 + w)) + 
     G[-1, -1, -1, -1, w] - G[-1, -1, -1, 1, w] - G[-1, -1, 1, -1, w] + 
     G[-1, -1, 1, 1, w] - G[-1, 1, -1, -1, w] + G[-1, 1, -1, 1, w] + 
     G[-1, 1, 1, -1, w] - G[-1, 1, 1, 1, w] - G[1, -1, -1, -1, w] + 
     G[1, -1, -1, 1, w] + G[1, -1, 1, -1, w] - G[1, -1, 1, 1, w] + 
     G[1, 1, -1, -1, w] - G[1, 1, -1, 1, w] - G[1, 1, 1, -1, w] + 
     G[1, 1, 1, 1, w] + G[(-1 + w)/(1 + w), (-1 + w)/(1 + w), -1, -1, z] + 
     ((-(1 + w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), -1, 1, z])/(1 + w) + 
     ((-(1 + w)^(-1) - (2*w)/(1 + w) - w^2/(1 + w))*G[(-1 + w)/(1 + w), 
        (-1 + w)/(1 + w), 1, -1, z])/(1 + w) + G[(-1 + w)/(1 + w), 
      (-1 + w)/(1 + w), 1, 1, z] + (((-1 + w)^(-1) - w^2/(-1 + w))*
       G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), -1, -1, z])/(1 + w) + 
     G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), -1, 1, z] + 
     G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 1, -1, z] + 
     (((-1 + w)^(-1) - w^2/(-1 + w))*G[(-1 + w)/(1 + w), -((1 + w)/(-1 + w)), 
        1, 1, z])/(1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        -1, -1, z])/(-1 + w) + ((-(1 + w)^(-1) + w^2/(1 + w))*
       G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), -1, 1, z])/(-1 + w) + 
     ((-(1 + w)^(-1) + w^2/(1 + w))*G[-((1 + w)/(-1 + w)), (-1 + w)/(1 + w), 
        1, -1, z])/(-1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), 
        (-1 + w)/(1 + w), 1, 1, z])/(-1 + w) + 
     (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*G[-((1 + w)/(-1 + w)), 
        -((1 + w)/(-1 + w)), -1, -1, z])/(-1 + w) + 
     ((1 - w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), -1, 1, z])/
      (-1 + w) + ((1 - w)*G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, -1, 
        z])/(-1 + w) + (((-1 + w)^(-1) - (2*w)/(-1 + w) + w^2/(-1 + w))*
       G[-((1 + w)/(-1 + w)), -((1 + w)/(-1 + w)), 1, 1, z])/(-1 + w)) - 
   3*(G[0, w] - G[0, z] + 2*G[w, z])*Zeta[3] + 
   (-G[-1, w] - G[-1, z] + 2*G[0, w] - G[1, w] - G[1, z] + 2*G[w, z])*
    Zeta[3] + 2*(G[-1, w]/2 - G[0, z] + G[1, w]/2 + G[w, z] + 
     ((1/2 + w/2)*G[(-1 + w)/(1 + w), z])/(1 + w) + 
     ((-1/2 + w/2)*G[-((1 + w)/(-1 + w)), z])/(-1 + w))*Zeta[3], 
 fE24[{0}, sij, sjk, sik] -> 0, fE24[{1}, sij, sjk, sik] -> 0, 
 fE24[{2}, sij, sjk, sik] -> 0, fE24[{3}, sij, sjk, sik] -> 0, 
 fE24[{4}, sij, sjk, sik] -> 
  6*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
     (G[-1, -1, z] - G[-1, 1, z] - G[1, -1, z] + G[1, 1, z]) + 
    (-G[-1, z] + G[1, z])*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
      G[-1, 1, -1, w] + G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] + 
      G[1, 1, -1, w] - G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
     (-G[-1, -1, -1, z] + G[-1, -1, 1, z] + G[-1, 1, -1, z] - 
      G[-1, 1, 1, z] + G[1, -1, -1, z] - G[1, -1, 1, z] - G[1, 1, -1, z] + 
      G[1, 1, 1, z]) + G[-1, -1, -1, -1, w] + G[-1, -1, -1, -1, z] - 
    G[-1, -1, -1, 1, w] - G[-1, -1, -1, 1, z] - G[-1, -1, 1, -1, w] - 
    G[-1, -1, 1, -1, z] + G[-1, -1, 1, 1, w] + G[-1, -1, 1, 1, z] - 
    G[-1, 1, -1, -1, w] - G[-1, 1, -1, -1, z] + G[-1, 1, -1, 1, w] + 
    G[-1, 1, -1, 1, z] + G[-1, 1, 1, -1, w] + G[-1, 1, 1, -1, z] - 
    G[-1, 1, 1, 1, w] - G[-1, 1, 1, 1, z] - G[1, -1, -1, -1, w] - 
    G[1, -1, -1, -1, z] + G[1, -1, -1, 1, w] + G[1, -1, -1, 1, z] + 
    G[1, -1, 1, -1, w] + G[1, -1, 1, -1, z] - G[1, -1, 1, 1, w] - 
    G[1, -1, 1, 1, z] + G[1, 1, -1, -1, w] + G[1, 1, -1, -1, z] - 
    G[1, 1, -1, 1, w] - G[1, 1, -1, 1, z] - G[1, 1, 1, -1, w] - 
    G[1, 1, 1, -1, z] + G[1, 1, 1, 1, w] + G[1, 1, 1, 1, z]), 
 fE25[{0}, sij, sjk, sik] -> 0, fE25[{1}, sij, sjk, sik] -> 0, 
 fE25[{2}, sij, sjk, sik] -> 0, fE25[{3}, sij, sjk, sik] -> 0, 
 fE26[{0}, sij, sjk, sik] -> 0, fE26[{1}, sij, sjk, sik] -> 0, 
 fE26[{2}, sij, sjk, sik] -> 0, fE26[{3}, sij, sjk, sik] -> 0, 
 fE27[{0}, sij, sjk, sik] -> 0, fE27[{1}, sij, sjk, sik] -> 0, 
 fE27[{2}, sij, sjk, sik] -> 0, fE27[{3}, sij, sjk, sik] -> 0, 
 fE27[{4}, sij, sjk, sik] -> 
  -8*((G[0, -1, z] - G[0, 1, z])*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - 
       G[1, 1, w]) + (G[-1, w] - G[1, w])*(G[0, -1, -1, z] + G[0, -1, 1, z] - 
       2*G[0, -1, w^(-1), z] - G[0, 1, -1, z] - G[0, 1, 1, z] + 
       2*G[0, 1, w^(-1), z]) - G[0, z]*(G[-1, -1, -1, w] - G[-1, -1, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] - G[1, -1, -1, w] + G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) - G[0, -1, -1, -1, w] - 
     G[0, -1, -1, -1, z] + G[0, -1, -1, 1, w] + G[0, -1, -1, 1, z] - 
     G[0, -1, 1, -1, w] - G[0, -1, 1, -1, z] + G[0, -1, 1, 1, w] + 
     G[0, -1, 1, 1, z] + 2*G[0, -1, w^(-1), -1, z] - 
     2*G[0, -1, w^(-1), 1, z] + G[0, 1, -1, -1, w] + G[0, 1, -1, -1, z] - 
     G[0, 1, -1, 1, w] - G[0, 1, -1, 1, z] + G[0, 1, 1, -1, w] + 
     G[0, 1, 1, -1, z] - G[0, 1, 1, 1, w] - G[0, 1, 1, 1, z] - 
     2*G[0, 1, w^(-1), -1, z] + 2*G[0, 1, w^(-1), 1, z]) + 
   8*((-G[0, -1, z] - G[0, 1, z] + 2*G[0, w^(-1), z])*
      (G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[0, -1, -1, z] - G[0, -1, 1, z] + 
       G[0, 1, -1, z] - G[0, 1, 1, z] - 2*G[0, w^(-1), -1, z] + 
       2*G[0, w^(-1), 1, z]) - G[0, z]*(G[-1, -1, -1, w] - G[-1, -1, 1, w] - 
       G[-1, 1, -1, w] + G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) - G[0, -1, -1, -1, w] - 
     G[0, -1, -1, -1, z] + G[0, -1, -1, 1, w] + G[0, -1, -1, 1, z] + 
     G[0, -1, 1, -1, w] + G[0, -1, 1, -1, z] - G[0, -1, 1, 1, w] - 
     G[0, -1, 1, 1, z] - G[0, 1, -1, -1, w] - G[0, 1, -1, -1, z] + 
     G[0, 1, -1, 1, w] + G[0, 1, -1, 1, z] + G[0, 1, 1, -1, w] + 
     G[0, 1, 1, -1, z] - G[0, 1, 1, 1, w] - G[0, 1, 1, 1, z] + 
     2*G[0, w^(-1), -1, -1, z] - 2*G[0, w^(-1), -1, 1, z] - 
     2*G[0, w^(-1), 1, -1, z] + 2*G[0, w^(-1), 1, 1, z]) + 
   16*(G[0, 0, w]*(G[0, 0, z] - 2*G[0, w, z]) - G[0, z]*G[0, 0, 0, w] - 
     G[0, w]*(G[0, 0, 0, z] - 2*G[0, w, 0, z]) - G[0, 0, 0, 0, w] + 
     G[0, 0, 0, 0, z] - 2*G[0, w, 0, 0, z]) - 
   8*(G[0, 0, w]*(G[0, -1, z] + G[0, 1, z] - 2*G[0, w, z]) - 
     G[0, w]*(G[0, -1, 0, z] + G[0, 1, 0, z] - 2*G[0, w, 0, z]) - 
     G[0, z]*(-G[-1, 0, 0, w] + 2*G[0, 0, 0, w] - G[1, 0, 0, w]) + 
     G[0, -1, 0, 0, w] + G[0, -1, 0, 0, z] - 2*G[0, 0, 0, 0, w] + 
     G[0, 1, 0, 0, w] + G[0, 1, 0, 0, z] - 2*G[0, w, 0, 0, z]) + 
   8*((G[0, 0, z] - 2*G[0, w, z])*(G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + 
       G[1, 1, w]) - G[0, z]*(G[0, -1, -1, w] - G[0, -1, 1, w] - 
       G[0, 1, -1, w] + G[0, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[0, 0, -1, z] + G[0, 0, 1, z] + 2*G[0, w, -1, z] - 
       2*G[0, w, 1, z]) - G[0, 0, -1, -1, w] + G[0, 0, -1, -1, z] + 
     G[0, 0, -1, 1, w] - G[0, 0, -1, 1, z] + G[0, 0, 1, -1, w] - 
     G[0, 0, 1, -1, z] - G[0, 0, 1, 1, w] + G[0, 0, 1, 1, z] - 
     2*G[0, w, -1, -1, z] + 2*G[0, w, -1, 1, z] + 2*G[0, w, 1, -1, z] - 
     2*G[0, w, 1, 1, z]) - 
   16*(G[0, 0, w]*(G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z]) - 
     G[0, w]*(G[0, 0, 0, z] - G[0, w, 0, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 0, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, z]) - 
     G[0, z]*(G[-1, 0, 0, w]/2 + G[1, 0, 0, w]/2) - G[0, -1, 0, 0, w]/2 + 
     G[0, 0, 0, 0, z] - G[0, 1, 0, 0, w]/2 - G[0, w, 0, 0, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 0, 0, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 0, 0, z]) + 
   8*((-G[0, -1, w] + G[0, 1, w])*(-G[0, (-1 + w)/(1 + w), z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), z]) + 
     (G[-1, w] - G[1, w])*(((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 
         0, z] - G[0, -((1 + w)/(-1 + w)), 0, z]) - 
     G[0, z]*(G[-1, 0, -1, w] - G[-1, 0, 1, w] - G[1, 0, -1, w] + 
       G[1, 0, 1, w]) - G[0, -1, 0, -1, w] + G[0, -1, 0, 1, w] + 
     G[0, 1, 0, -1, w] - G[0, 1, 0, 1, w] - G[0, (-1 + w)/(1 + w), 0, -1, 
      z] + ((1 + w)^(-1) + w/(1 + w))*G[0, (-1 + w)/(1 + w), 0, 1, z] + 
     ((1 - w)^(-1) + w/(-1 + w))*G[0, -((1 + w)/(-1 + w)), 0, -1, z] - 
     G[0, -((1 + w)/(-1 + w)), 0, 1, z]) + 
   16*((-G[0, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[0, -((1 + w)/(-1 + w)), z])*(G[-1, 0, w]/2 - G[1, 0, w]/2) - 
     G[0, w]*((1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, z]) - 
     G[0, z]*(-G[-1, -1, 0, w]/2 + G[-1, 1, 0, w]/2 + G[1, -1, 0, w]/2 - 
       G[1, 1, 0, w]/2) + G[0, -1, -1, 0, w]/2 - G[0, -1, 1, 0, w]/2 - 
     G[0, 1, -1, 0, w]/2 + G[0, 1, 1, 0, w]/2 + 
     (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, 0, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, 0, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 0, z]) - 
   16*((G[0, 0, z] - G[0, w, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
        G[0, (-1 + w)/(1 + w), z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
        G[0, -((1 + w)/(-1 + w)), z])*(G[-1, -1, w] - G[-1, 1, w] - 
       G[1, -1, w] + G[1, 1, w]) + (G[-1, w] - G[1, w])*
      (-G[0, 0, -1, z] + G[0, 0, 1, z] + G[0, w, -1, z] - G[0, w, 1, z] + 
       (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, z] + 
       (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, z]) - 
     G[0, z]*(G[-1, -1, -1, w]/2 - G[-1, -1, 1, w]/2 - G[-1, 1, -1, w]/2 + 
       G[-1, 1, 1, w]/2 + G[1, -1, -1, w]/2 - G[1, -1, 1, w]/2 - 
       G[1, 1, -1, w]/2 + G[1, 1, 1, w]/2) - G[0, -1, -1, -1, w]/2 + 
     G[0, -1, -1, 1, w]/2 + G[0, -1, 1, -1, w]/2 - G[0, -1, 1, 1, w]/2 + 
     G[0, 0, -1, -1, z] - G[0, 0, -1, 1, z] - G[0, 0, 1, -1, z] + 
     G[0, 0, 1, 1, z] - G[0, 1, -1, -1, w]/2 + G[0, 1, -1, 1, w]/2 + 
     G[0, 1, 1, -1, w]/2 - G[0, 1, 1, 1, w]/2 - G[0, w, -1, -1, z] + 
     G[0, w, -1, 1, z] + G[0, w, 1, -1, z] - G[0, w, 1, 1, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, -1, z] + 
     (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), -1, 1, z] + 
     (1/(2*(1 + w)) + w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, -1, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[0, (-1 + w)/(1 + w), 1, 1, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, -1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), -1, 1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[0, -((1 + w)/(-1 + w)), 1, 1, z]) - 
   8*((G[-1, 0, z] - G[1, 0, z])*(G[-1, -1, w] - G[-1, 1, w] + G[1, -1, w] - 
       G[1, 1, w]) + (-G[-1, z] + G[1, z])*(-G[0, -1, -1, w] + 
       G[0, -1, 1, w] - G[0, 1, -1, w] + G[0, 1, 1, w]) + 
     (G[-1, w] - G[1, w])*(G[-1, 0, -1, z] + G[-1, 0, 1, z] - 
       2*G[-1, 0, w^(-1), z] - G[1, 0, -1, z] - G[1, 0, 1, z] + 
       2*G[1, 0, w^(-1), z]) - G[-1, 0, -1, -1, w] - G[-1, 0, -1, -1, z] + 
     G[-1, 0, -1, 1, w] + G[-1, 0, -1, 1, z] - G[-1, 0, 1, -1, w] - 
     G[-1, 0, 1, -1, z] + G[-1, 0, 1, 1, w] + G[-1, 0, 1, 1, z] + 
     2*G[-1, 0, w^(-1), -1, z] - 2*G[-1, 0, w^(-1), 1, z] + 
     G[1, 0, -1, -1, w] + G[1, 0, -1, -1, z] - G[1, 0, -1, 1, w] - 
     G[1, 0, -1, 1, z] + G[1, 0, 1, -1, w] + G[1, 0, 1, -1, z] - 
     G[1, 0, 1, 1, w] - G[1, 0, 1, 1, z] - 2*G[1, 0, w^(-1), -1, z] + 
     2*G[1, 0, w^(-1), 1, z]) + 
   8*((-G[0, -1, w] + G[0, 1, w])*(G[-1, 0, z] - 2*G[-1, w, z] - G[1, 0, z] + 
       2*G[1, w, z]) + (-G[-1, z] + G[1, z])*(-G[0, 0, -1, w] + 
       G[0, 0, 1, w]) + (G[-1, w] - G[1, w])*(-G[-1, 0, 0, z] + 
       2*G[-1, w, 0, z] + G[1, 0, 0, z] - 2*G[1, w, 0, z]) - 
     G[-1, 0, 0, -1, w] + G[-1, 0, 0, -1, z] + G[-1, 0, 0, 1, w] - 
     G[-1, 0, 0, 1, z] - 2*G[-1, w, 0, -1, z] + 2*G[-1, w, 0, 1, z] + 
     G[1, 0, 0, -1, w] - G[1, 0, 0, -1, z] - G[1, 0, 0, 1, w] + 
     G[1, 0, 0, 1, z] + 2*G[1, w, 0, -1, z] - 2*G[1, w, 0, 1, z]) + 
   16*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(G[-1, 0, z] - 2*G[-1, w, z] - 
       G[1, 0, z] + 2*G[1, w, z]) + (-G[-1, z] + G[1, z])*
      (G[0, -1, 0, w]/2 - G[0, 1, 0, w]/2) - 
     G[0, w]*(-G[-1, 0, -1, z]/2 + G[-1, 0, 1, z]/2 + G[-1, w, -1, z] - 
       G[-1, w, 1, z] + G[1, 0, -1, z]/2 - G[1, 0, 1, z]/2 - G[1, w, -1, z] + 
       G[1, w, 1, z]) + G[-1, 0, -1, 0, w]/2 - G[-1, 0, -1, 0, z]/2 - 
     G[-1, 0, 1, 0, w]/2 + G[-1, 0, 1, 0, z]/2 + G[-1, w, -1, 0, z] - 
     G[-1, w, 1, 0, z] - G[1, 0, -1, 0, w]/2 + G[1, 0, -1, 0, z]/2 + 
     G[1, 0, 1, 0, w]/2 - G[1, 0, 1, 0, z]/2 - G[1, w, -1, 0, z] + 
     G[1, w, 1, 0, z]) + 
   8*(G[0, 0, w]*(-G[-1, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[-1, -((1 + w)/(-1 + w)), z] + G[1, (-1 + w)/(1 + w), z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[1, -((1 + w)/(-1 + w)), z]) + 
     (-G[-1, z] + G[1, z])*(-G[-1, 0, 0, w] + G[1, 0, 0, w]) - 
     G[0, w]*(-G[-1, (-1 + w)/(1 + w), 0, z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[-1, -((1 + w)/(-1 + w)), 0, z] + G[1, (-1 + w)/(1 + w), 0, z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[1, -((1 + w)/(-1 + w)), 0, z]) - 
     G[-1, -1, 0, 0, w] + G[-1, 1, 0, 0, w] - G[-1, (-1 + w)/(1 + w), 0, 0, 
      z] + ((1 - w)^(-1) + w/(-1 + w))*G[-1, -((1 + w)/(-1 + w)), 0, 0, z] + 
     G[1, -1, 0, 0, w] - G[1, 1, 0, 0, w] + G[1, (-1 + w)/(1 + w), 0, 0, z] + 
     ((-1 + w)^(-1) - w/(-1 + w))*G[1, -((1 + w)/(-1 + w)), 0, 0, z]) - 
   16*((-G[0, -1, w] + G[0, 1, w])*(G[-1, 0, z] - G[-1, w, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[-1, (-1 + w)/(1 + w), z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[-1, -((1 + w)/(-1 + w)), z] - 
       G[1, 0, z] + G[1, w, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[1, (-1 + w)/(1 + w), z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[1, -((1 + w)/(-1 + w)), z]) + (-G[-1, z] + G[1, z])*
      (-G[-1, 0, -1, w]/2 + G[-1, 0, 1, w]/2 - G[1, 0, -1, w]/2 + 
       G[1, 0, 1, w]/2) + (G[-1, w] - G[1, w])*(-G[-1, 0, 0, z] + 
       G[-1, w, 0, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[-1, (-1 + w)/(1 + w), 0, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[-1, -((1 + w)/(-1 + w)), 0, z] + G[1, 0, 0, z] - G[1, w, 0, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[1, (-1 + w)/(1 + w), 0, z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[1, -((1 + w)/(-1 + w)), 0, z]) - 
     G[-1, -1, 0, -1, w]/2 + G[-1, -1, 0, 1, w]/2 + G[-1, 0, 0, -1, z] - 
     G[-1, 0, 0, 1, z] - G[-1, 1, 0, -1, w]/2 + G[-1, 1, 0, 1, w]/2 - 
     G[-1, w, 0, -1, z] + G[-1, w, 0, 1, z] + 
     (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[-1, (-1 + w)/(1 + w), 0, -1, z] + 
     (1/(2*(1 + w)) + w/(2*(1 + w)))*G[-1, (-1 + w)/(1 + w), 0, 1, z] + 
     (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[-1, -((1 + w)/(-1 + w)), 0, -1, z] + 
     (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*G[-1, -((1 + w)/(-1 + w)), 0, 1, z] + 
     G[1, -1, 0, -1, w]/2 - G[1, -1, 0, 1, w]/2 - G[1, 0, 0, -1, z] + 
     G[1, 0, 0, 1, z] + G[1, 1, 0, -1, w]/2 - G[1, 1, 0, 1, w]/2 + 
     G[1, w, 0, -1, z] - G[1, w, 0, 1, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
      G[1, (-1 + w)/(1 + w), 0, -1, z] + (-1/(2*(1 + w)) - w/(2*(1 + w)))*
      G[1, (-1 + w)/(1 + w), 0, 1, z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
      G[1, -((1 + w)/(-1 + w)), 0, -1, z] + (1/(2*(-1 + w)) - w/(2*(-1 + w)))*
      G[1, -((1 + w)/(-1 + w)), 0, 1, z]) - 
   32*((G[-1, 0, w]/2 - G[1, 0, w]/2)*(G[-1, 0, z] - G[-1, w, z] + 
       (-1/(2*(1 + w)) - w/(2*(1 + w)))*G[-1, (-1 + w)/(1 + w), z] + 
       (1/(2*(-1 + w)) - w/(2*(-1 + w)))*G[-1, -((1 + w)/(-1 + w)), z] - 
       G[1, 0, z] + G[1, w, z] + (1/(2*(1 + w)) + w/(2*(1 + w)))*
        G[1, (-1 + w)/(1 + w), z] + (-1/(2*(-1 + w)) + w/(2*(-1 + w)))*
        G[1, -((1 + w)/(-1 + w)), z]) + (-G[-1, z] + G[1, z])*
      (G[-1, -1, 0, w]/4 - G[-1, 1, 0, w]/4 + G[1, -1, 0, w]/4 - 
       G[1, 1, 0, w]/4) - G[0, w]*(-G[-1, 0, -1, z]/2 + G[-1, 0, 1, z]/2 + 
       G[-1, w, -1, z]/2 - G[-1, w, 1, z]/2 + (1/(4*(1 + w)) + w/(4*(1 + w)))*
        G[-1, (-1 + w)/(1 + w), -1, z] + (-1/(4*(1 + w)) - w/(4*(1 + w)))*
        G[-1, (-1 + w)/(1 + w), 1, z] + (-1/(4*(-1 + w)) + w/(4*(-1 + w)))*
        G[-1, -((1 + w)/(-1 + w)), -1, z] + (1/(4*(-1 + w)) - w/(4*(-1 + w)))*
        G[-1, -((1 + w)/(-1 + w)), 1, z] + G[1, 0, -1, z]/2 - 
       G[1, 0, 1, z]/2 - G[1, w, -1, z]/2 + G[1, w, 1, z]/2 + 
       (-1/(4*(1 + w)) - w/(4*(1 + w)))*G[1, (-1 + w)/(1 + w), -1, z] + 
       (1/(4*(1 + w)) + w/(4*(1 + w)))*G[1, (-1 + w)/(1 + w), 1, z] + 
       (1/(4*(-1 + w)) - w/(4*(-1 + w)))*G[1, -((1 + w)/(-1 + w)), -1, z] + 
       (-1/(4*(-1 + w)) + w/(4*(-1 + w)))*G[1, -((1 + w)/(-1 + w)), 1, z]) + 
     G[-1, -1, -1, 0, w]/4 - G[-1, -1, 1, 0, w]/4 - G[-1, 0, -1, 0, z]/2 + 
     G[-1, 0, 1, 0, z]/2 + G[-1, 1, -1, 0, w]/4 - G[-1, 1, 1, 0, w]/4 + 
     G[-1, w, -1, 0, z]/2 - G[-1, w, 1, 0, z]/2 + 
     (1/(4*(1 + w)) + w/(4*(1 + w)))*G[-1, (-1 + w)/(1 + w), -1, 0, z] + 
     (-1/(4*(1 + w)) - w/(4*(1 + w)))*G[-1, (-1 + w)/(1 + w), 1, 0, z] + 
     (-1/(4*(-1 + w)) + w/(4*(-1 + w)))*G[-1, -((1 + w)/(-1 + w)), -1, 0, 
       z] + (1/(4*(-1 + w)) - w/(4*(-1 + w)))*G[-1, -((1 + w)/(-1 + w)), 1, 
       0, z] - G[1, -1, -1, 0, w]/4 + G[1, -1, 1, 0, w]/4 + 
     G[1, 0, -1, 0, z]/2 - G[1, 0, 1, 0, z]/2 - G[1, 1, -1, 0, w]/4 + 
     G[1, 1, 1, 0, w]/4 - G[1, w, -1, 0, z]/2 + G[1, w, 1, 0, z]/2 + 
     (-1/(4*(1 + w)) - w/(4*(1 + w)))*G[1, (-1 + w)/(1 + w), -1, 0, z] + 
     (1/(4*(1 + w)) + w/(4*(1 + w)))*G[1, (-1 + w)/(1 + w), 1, 0, z] + 
     (1/(4*(-1 + w)) - w/(4*(-1 + w)))*G[1, -((1 + w)/(-1 + w)), -1, 0, z] + 
     (-1/(4*(-1 + w)) + w/(4*(-1 + w)))*G[1, -((1 + w)/(-1 + w)), 1, 0, z]) + 
   8*((G[-1, -1, w] - G[-1, 1, w] - G[1, -1, w] + G[1, 1, w])*
      (-G[-1, (-1 + w)/(1 + w), z] + ((1 - w)^(-1) + w/(-1 + w))*
        G[-1, -((1 + w)/(-1 + w)), z] + G[1, (-1 + w)/(1 + w), z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[1, -((1 + w)/(-1 + w)), z]) + 
     (-G[-1, z] + G[1, z])*(-G[-1, -1, -1, w] + G[-1, -1, 1, w] + 
       G[-1, 1, -1, w] - G[-1, 1, 1, w] + G[1, -1, -1, w] - G[1, -1, 1, w] - 
       G[1, 1, -1, w] + G[1, 1, 1, w]) + (G[-1, w] - G[1, w])*
      (((1 + w)^(-1) + w/(1 + w))*G[-1, (-1 + w)/(1 + w), -1, z] - 
       G[-1, (-1 + w)/(1 + w), 1, z] - G[-1, -((1 + w)/(-1 + w)), -1, z] + 
       ((1 - w)^(-1) + w/(-1 + w))*G[-1, -((1 + w)/(-1 + w)), 1, z] + 
       ((-1 - w)^(-1) - w/(1 + w))*G[1, (-1 + w)/(1 + w), -1, z] + 
       G[1, (-1 + w)/(1 + w), 1, z] + G[1, -((1 + w)/(-1 + w)), -1, z] + 
       ((-1 + w)^(-1) - w/(-1 + w))*G[1, -((1 + w)/(-1 + w)), 1, z]) - 
     G[-1, -1, -1, -1, w] + G[-1, -1, -1, 1, w] + G[-1, -1, 1, -1, w] - 
     G[-1, -1, 1, 1, w] + G[-1, 1, -1, -1, w] - G[-1, 1, -1, 1, w] - 
     G[-1, 1, 1, -1, w] + G[-1, 1, 1, 1, w] - G[-1, (-1 + w)/(1 + w), -1, -1, 
      z] + ((1 + w)^(-1) + w/(1 + w))*G[-1, (-1 + w)/(1 + w), -1, 1, z] + 
     ((1 + w)^(-1) + w/(1 + w))*G[-1, (-1 + w)/(1 + w), 1, -1, z] - 
     G[-1, (-1 + w)/(1 + w), 1, 1, z] + (-(-1 + w)^(-1) + w/(-1 + w))*
      G[-1, -((1 + w)/(-1 + w)), -1, -1, z] - G[-1, -((1 + w)/(-1 + w)), -1, 
      1, z] - G[-1, -((1 + w)/(-1 + w)), 1, -1, z] + 
     (-(-1 + w)^(-1) + w/(-1 + w))*G[-1, -((1 + w)/(-1 + w)), 1, 1, z] + 
     G[1, -1, -1, -1, w] - G[1, -1, -1, 1, w] - G[1, -1, 1, -1, w] + 
     G[1, -1, 1, 1, w] - G[1, 1, -1, -1, w] + G[1, 1, -1, 1, w] + 
     G[1, 1, 1, -1, w] - G[1, 1, 1, 1, w] + G[1, (-1 + w)/(1 + w), -1, -1, 
      z] + (-(1 + w)^(-1) - w/(1 + w))*G[1, (-1 + w)/(1 + w), -1, 1, z] + 
     (-(1 + w)^(-1) - w/(1 + w))*G[1, (-1 + w)/(1 + w), 1, -1, z] + 
     G[1, (-1 + w)/(1 + w), 1, 1, z] + ((-1 + w)^(-1) - w/(-1 + w))*
      G[1, -((1 + w)/(-1 + w)), -1, -1, z] + G[1, -((1 + w)/(-1 + w)), -1, 1, 
      z] + G[1, -((1 + w)/(-1 + w)), 1, -1, z] + ((-1 + w)^(-1) - w/(-1 + w))*
      G[1, -((1 + w)/(-1 + w)), 1, 1, z]), fE28[{0}, sij, sjk, sik] -> 0, 
 fE28[{1}, sij, sjk, sik] -> 0, fE28[{2}, sij, sjk, sik] -> 0, 
 fE28[{3}, sij, sjk, sik] -> 0, fE29[{0}, sij, sjk, sik] -> 0, 
 fE29[{1}, sij, sjk, sik] -> 0, fE29[{2}, sij, sjk, sik] -> 0, 
 fE29[{3}, sij, sjk, sik] -> 0
};

(*two-loop master integrals that contain square roots*)
(*They are expressed into iterated integrals over dlog forms*)
(*iint represents an iterated integral*)
(*dg[i] has been defined in eq.(3.7) in arXiv:2312.16966*)


twoloopmasterintegralIndlog={fE18[{3}, sij, sjk, sik] -> (-2*iint[{dg[7], dg[1], dg[1]}] - 
    16*iint[{dg[7], dg[5], dg[5]}] - iint[{dg[8], dg[1], dg[1]}] + 
    6*iint[{dg[8], dg[5], dg[5]}] - iint[{dg[9], dg[3], dg[1]}] + 
    2*iint[{dg[11], dg[12], dg[1]}] + 4*iint[{dg[11], dg[14], dg[5]}])/2, 
 fE18[{4}, sij, sjk, sik] -> (-2*iint[{dg[7], dg[1], dg[2], dg[1]}] + 
    3*iint[{dg[7], dg[1], dg[3], dg[1]}] + 
    3*iint[{dg[7], dg[3], dg[1], dg[1]}] + 
    6*iint[{dg[7], dg[3], dg[5], dg[5]}] - 
    6*iint[{dg[7], dg[4], dg[1], dg[1]}] - 
    12*iint[{dg[7], dg[4], dg[5], dg[5]}] - 
    16*iint[{dg[7], dg[5], dg[6], dg[5]}] + 
    12*iint[{dg[7], dg[10], dg[1], dg[1]}] + 
    12*iint[{dg[7], dg[10], dg[5], dg[5]}] - 
    6*iint[{dg[7], dg[13], dg[12], dg[1]}] - 
    12*iint[{dg[7], dg[13], dg[14], dg[5]}] - 
    iint[{dg[8], dg[1], dg[2], dg[1]}] + 
    2*iint[{dg[8], dg[1], dg[3], dg[1]}] + 
    iint[{dg[8], dg[3], dg[1], dg[1]}] + 
    6*iint[{dg[8], dg[4], dg[5], dg[5]}] + 
    6*iint[{dg[8], dg[5], dg[6], dg[5]}] + 
    iint[{dg[9], dg[1], dg[1], dg[1]}] - iint[{dg[9], dg[2], dg[3], dg[1]}] - 
    iint[{dg[9], dg[3], dg[2], dg[1]}] + iint[{dg[9], dg[3], dg[3], dg[1]}] - 
    2*iint[{dg[10], dg[7], dg[1], dg[1]}] - 
    16*iint[{dg[10], dg[7], dg[5], dg[5]}] - 
    iint[{dg[10], dg[8], dg[1], dg[1]}] + 
    6*iint[{dg[10], dg[8], dg[5], dg[5]}] - 
    iint[{dg[10], dg[9], dg[3], dg[1]}] + 
    2*iint[{dg[10], dg[11], dg[12], dg[1]}] + 
    4*iint[{dg[10], dg[11], dg[14], dg[5]}] + 
    2*iint[{dg[11], dg[12], dg[2], dg[1]}] - 
    2*iint[{dg[11], dg[12], dg[3], dg[1]}] - 
    4*iint[{dg[11], dg[13], dg[1], dg[1]}] - 
    4*iint[{dg[11], dg[13], dg[5], dg[5]}] + 
    4*iint[{dg[11], dg[14], dg[6], dg[5]}] + 
    2*iint[{dg[11], dg[15], dg[12], dg[1]}] + 
    4*iint[{dg[11], dg[15], dg[14], dg[5]}])/2, 
 fE19[{4}, sij, sjk, sik] -> ((2*Pi^2*iint[{dg[12], dg[1]}])/3 + 
    (4*Pi^2*iint[{dg[14], dg[5]}])/3 + 
    2*iint[{dg[11], dg[7], dg[1], dg[1]}] + 
    16*iint[{dg[11], dg[7], dg[5], dg[5]}] + 
    iint[{dg[11], dg[8], dg[1], dg[1]}] - 
    6*iint[{dg[11], dg[8], dg[5], dg[5]}] + 
    iint[{dg[11], dg[9], dg[3], dg[1]}] - 
    2*iint[{dg[11], dg[11], dg[12], dg[1]}] - 
    4*iint[{dg[11], dg[11], dg[14], dg[5]}] + 
    4*iint[{dg[12], dg[1], dg[1], dg[1]}] + 
    4*iint[{dg[12], dg[2], dg[2], dg[1]}] - 
    4*iint[{dg[12], dg[2], dg[3], dg[1]}] - 
    4*iint[{dg[12], dg[3], dg[2], dg[1]}] + 
    4*iint[{dg[12], dg[3], dg[3], dg[1]}] - 
    8*iint[{dg[13], dg[1], dg[2], dg[1]}] + 
    5*iint[{dg[13], dg[1], dg[3], dg[1]}] + 
    7*iint[{dg[13], dg[3], dg[1], dg[1]}] + 
    6*iint[{dg[13], dg[3], dg[5], dg[5]}] - 
    6*iint[{dg[13], dg[4], dg[1], dg[1]}] - 
    12*iint[{dg[13], dg[4], dg[5], dg[5]}] - 
    8*iint[{dg[13], dg[5], dg[6], dg[5]}] + 
    12*iint[{dg[13], dg[10], dg[1], dg[1]}] + 
    12*iint[{dg[13], dg[10], dg[5], dg[5]}] - 
    6*iint[{dg[13], dg[13], dg[12], dg[1]}] - 
    12*iint[{dg[13], dg[13], dg[14], dg[5]}] - 
    48*iint[{dg[14], dg[5], dg[5], dg[5]}] + 
    8*iint[{dg[14], dg[6], dg[6], dg[5]}] + 
    4*iint[{dg[15], dg[12], dg[2], dg[1]}] - 
    4*iint[{dg[15], dg[12], dg[3], dg[1]}] - 
    8*iint[{dg[15], dg[13], dg[1], dg[1]}] - 
    8*iint[{dg[15], dg[13], dg[5], dg[5]}] + 
    8*iint[{dg[15], dg[14], dg[6], dg[5]}] + 
    4*iint[{dg[15], dg[15], dg[12], dg[1]}] + 
    8*iint[{dg[15], dg[15], dg[14], dg[5]}])/4, 
 fE20[{4}, sij, sjk, sik] -> (iint[{dg[1], dg[1], dg[1], dg[1]}] - 
    iint[{dg[1], dg[2], dg[3], dg[1]}] - iint[{dg[1], dg[3], dg[2], dg[1]}] + 
    iint[{dg[1], dg[3], dg[3], dg[1]}] - iint[{dg[3], dg[1], dg[2], dg[1]}] + 
    iint[{dg[3], dg[3], dg[1], dg[1]}] - 
    2*iint[{dg[3], dg[4], dg[5], dg[5]}] - 
    2*iint[{dg[3], dg[5], dg[6], dg[5]}] + 
    2*iint[{dg[4], dg[1], dg[2], dg[1]}] - 
    2*iint[{dg[4], dg[3], dg[1], dg[1]}] + 
    4*iint[{dg[4], dg[4], dg[5], dg[5]}] + 
    4*iint[{dg[4], dg[5], dg[6], dg[5]}] + 
    2*iint[{dg[7], dg[7], dg[1], dg[1]}] + 
    16*iint[{dg[7], dg[7], dg[5], dg[5]}] + 
    iint[{dg[7], dg[8], dg[1], dg[1]}] - 
    6*iint[{dg[7], dg[8], dg[5], dg[5]}] + 
    iint[{dg[7], dg[9], dg[3], dg[1]}] - 
    2*iint[{dg[7], dg[11], dg[12], dg[1]}] - 
    4*iint[{dg[7], dg[11], dg[14], dg[5]}] - 
    4*iint[{dg[10], dg[1], dg[2], dg[1]}] + 
    iint[{dg[10], dg[1], dg[3], dg[1]}] + 
    3*iint[{dg[10], dg[3], dg[1], dg[1]}] + 
    2*iint[{dg[10], dg[3], dg[5], dg[5]}] - 
    2*iint[{dg[10], dg[4], dg[1], dg[1]}] - 
    8*iint[{dg[10], dg[4], dg[5], dg[5]}] - 
    4*iint[{dg[10], dg[5], dg[6], dg[5]}] + 
    4*iint[{dg[10], dg[10], dg[1], dg[1]}] + 
    4*iint[{dg[10], dg[10], dg[5], dg[5]}] - 
    2*iint[{dg[10], dg[13], dg[12], dg[1]}] - 
    4*iint[{dg[10], dg[13], dg[14], dg[5]}] + 
    2*iint[{dg[13], dg[12], dg[2], dg[1]}] - 
    2*iint[{dg[13], dg[12], dg[3], dg[1]}] - 
    4*iint[{dg[13], dg[13], dg[1], dg[1]}] - 
    4*iint[{dg[13], dg[13], dg[5], dg[5]}] + 
    4*iint[{dg[13], dg[14], dg[6], dg[5]}] + 
    2*iint[{dg[13], dg[15], dg[12], dg[1]}] + 
    4*iint[{dg[13], dg[15], dg[14], dg[5]}])/2, 
 fE25[{4}, sij, sjk, sik] -> (2*iint[{dg[11], dg[7], dg[1], dg[1]}] + 
    16*iint[{dg[11], dg[7], dg[5], dg[5]}] + 
    iint[{dg[11], dg[8], dg[1], dg[1]}] - 
    6*iint[{dg[11], dg[8], dg[5], dg[5]}] + 
    iint[{dg[11], dg[9], dg[3], dg[1]}] - 
    2*iint[{dg[11], dg[11], dg[12], dg[1]}] - 
    4*iint[{dg[11], dg[11], dg[14], dg[5]}] + 
    12*iint[{dg[12], dg[1], dg[1], dg[1]}] - 
    3*iint[{dg[13], dg[1], dg[3], dg[1]}] + 
    15*iint[{dg[13], dg[3], dg[1], dg[1]}] - 
    18*iint[{dg[13], dg[3], dg[5], dg[5]}] + 
    18*iint[{dg[13], dg[4], dg[1], dg[1]}] + 
    44*iint[{dg[13], dg[4], dg[5], dg[5]}] - 
    36*iint[{dg[13], dg[10], dg[1], dg[1]}] - 
    36*iint[{dg[13], dg[10], dg[5], dg[5]}] + 
    18*iint[{dg[13], dg[13], dg[12], dg[1]}] + 
    36*iint[{dg[13], dg[13], dg[14], dg[5]}])/4, 
 fE26[{4}, sij, sjk, sik] -> (-3*iint[{dg[1], dg[1], dg[1], dg[1]}] + 
    iint[{dg[3], dg[1], dg[3], dg[1]}] + 
    2*iint[{dg[3], dg[3], dg[1], dg[1]}] - 
    2*iint[{dg[4], dg[1], dg[3], dg[1]}] + 
    4*iint[{dg[4], dg[3], dg[1], dg[1]}] - 
    8*iint[{dg[4], dg[3], dg[5], dg[5]}] + 
    8*iint[{dg[4], dg[4], dg[1], dg[1]}] + 
    20*iint[{dg[4], dg[4], dg[5], dg[5]}] - 
    16*iint[{dg[4], dg[10], dg[1], dg[1]}] - 
    16*iint[{dg[4], dg[10], dg[5], dg[5]}] + 
    8*iint[{dg[4], dg[13], dg[12], dg[1]}] + 
    16*iint[{dg[4], dg[13], dg[14], dg[5]}] - 
    2*iint[{dg[7], dg[7], dg[1], dg[1]}] - 
    16*iint[{dg[7], dg[7], dg[5], dg[5]}] - 
    iint[{dg[7], dg[8], dg[1], dg[1]}] + 
    6*iint[{dg[7], dg[8], dg[5], dg[5]}] - 
    iint[{dg[7], dg[9], dg[3], dg[1]}] + 
    2*iint[{dg[7], dg[11], dg[12], dg[1]}] + 
    4*iint[{dg[7], dg[11], dg[14], dg[5]}] + 
    3*iint[{dg[10], dg[1], dg[3], dg[1]}] - 
    7*iint[{dg[10], dg[3], dg[1], dg[1]}] + 
    10*iint[{dg[10], dg[3], dg[5], dg[5]}] - 
    10*iint[{dg[10], dg[4], dg[1], dg[1]}] - 
    20*iint[{dg[10], dg[4], dg[5], dg[5]}] + 
    20*iint[{dg[10], dg[10], dg[1], dg[1]}] + 
    20*iint[{dg[10], dg[10], dg[5], dg[5]}] - 
    10*iint[{dg[10], dg[13], dg[12], dg[1]}] - 
    20*iint[{dg[10], dg[13], dg[14], dg[5]}])/2, 
 fE28[{4}, sij, sjk, sik] -> (16*iint[{dg[1], dg[1], dg[2], dg[1]}] - 
    5*iint[{dg[1], dg[1], dg[3], dg[1]}] - 
    8*iint[{dg[1], dg[2], dg[1], dg[1]}] + 
    15*iint[{dg[1], dg[3], dg[1], dg[1]}] - 
    6*iint[{dg[1], dg[3], dg[5], dg[5]}] + 
    6*iint[{dg[1], dg[4], dg[1], dg[1]}] + 
    20*iint[{dg[1], dg[4], dg[5], dg[5]}] - 
    12*iint[{dg[1], dg[10], dg[1], dg[1]}] - 
    12*iint[{dg[1], dg[10], dg[5], dg[5]}] + 
    6*iint[{dg[1], dg[13], dg[12], dg[1]}] + 
    12*iint[{dg[1], dg[13], dg[14], dg[5]}] + 
    2*iint[{dg[9], dg[7], dg[1], dg[1]}] + 
    16*iint[{dg[9], dg[7], dg[5], dg[5]}] + 
    iint[{dg[9], dg[8], dg[1], dg[1]}] - 
    6*iint[{dg[9], dg[8], dg[5], dg[5]}] + 
    iint[{dg[9], dg[9], dg[3], dg[1]}] - 
    2*iint[{dg[9], dg[11], dg[12], dg[1]}] - 
    4*iint[{dg[9], dg[11], dg[14], dg[5]}])/2, 
 fE29[{4}, sij, sjk, sik] -> (6*iint[{dg[1], dg[1], dg[1], dg[1]}] - 
    3*iint[{dg[3], dg[1], dg[3], dg[1]}] - 
    3*iint[{dg[3], dg[3], dg[1], dg[1]}] - 
    6*iint[{dg[3], dg[3], dg[5], dg[5]}] + 
    6*iint[{dg[3], dg[4], dg[1], dg[1]}] + 
    20*iint[{dg[3], dg[4], dg[5], dg[5]}] - 
    12*iint[{dg[3], dg[10], dg[1], dg[1]}] - 
    12*iint[{dg[3], dg[10], dg[5], dg[5]}] + 
    6*iint[{dg[3], dg[13], dg[12], dg[1]}] + 
    12*iint[{dg[3], dg[13], dg[14], dg[5]}] - 
    2*iint[{dg[4], dg[1], dg[3], dg[1]}] - 
    2*iint[{dg[4], dg[3], dg[1], dg[1]}] + 
    4*iint[{dg[4], dg[3], dg[5], dg[5]}] - 
    4*iint[{dg[4], dg[4], dg[1], dg[1]}] - 
    24*iint[{dg[4], dg[4], dg[5], dg[5]}] + 
    8*iint[{dg[4], dg[10], dg[1], dg[1]}] + 
    8*iint[{dg[4], dg[10], dg[5], dg[5]}] - 
    4*iint[{dg[4], dg[13], dg[12], dg[1]}] - 
    8*iint[{dg[4], dg[13], dg[14], dg[5]}] - 
    2*iint[{dg[8], dg[7], dg[1], dg[1]}] - 
    16*iint[{dg[8], dg[7], dg[5], dg[5]}] - 
    iint[{dg[8], dg[8], dg[1], dg[1]}] + 
    6*iint[{dg[8], dg[8], dg[5], dg[5]}] - 
    iint[{dg[8], dg[9], dg[3], dg[1]}] + 
    2*iint[{dg[8], dg[11], dg[12], dg[1]}] + 
    4*iint[{dg[8], dg[11], dg[14], dg[5]}] + 
    6*iint[{dg[10], dg[1], dg[3], dg[1]}] + 
    2*iint[{dg[10], dg[3], dg[1], dg[1]}] + 
    4*iint[{dg[10], dg[3], dg[5], dg[5]}] - 
    4*iint[{dg[10], dg[4], dg[1], dg[1]}] + 
    8*iint[{dg[10], dg[4], dg[5], dg[5]}] + 
    8*iint[{dg[10], dg[10], dg[1], dg[1]}] + 
    8*iint[{dg[10], dg[10], dg[5], dg[5]}] - 
    4*iint[{dg[10], dg[13], dg[12], dg[1]}] - 
    8*iint[{dg[10], dg[13], dg[14], dg[5]}])/2
};
